	function pgas(tx)

c	Returns amount of processed gas at time tx

	include 'recycle.dec'

c	Interpolate array (so,to) if possible
	if (tx.le.to(1).or.lgas.lt.1) then
		pgas=0.
	elseif (tx.lt.to(lgas)) then
		call locate(to,lgas,tx,i)
		a=(tx-to(i))/(to(i+1)-to(i))
		pgas=(1.-a)*so(i)+a*so(i+1)
	else
		pgas=so(lgas)
	endif
	return
	end

	Real*4 FUNCTION FMAG(z,kf,fmagAB,iwrite)

c	Returns magnitude in filter kf at redshift Z for pre-chosen cosmological model

c	Array declarations required also in calling program
	character file*128,filtid*64
	real k_corr_0,k_ABcorr_0,k_corr_z,k_ABcorr_z,xk_buff(2)
	common /mag/ file,icall,h,omega,omega_lambda,clambda,q,tu,tgal,tl,tz,zf,dm,filtid,
     *	f_ev,f_rf,f_ne,f_ne_0,ABf_ev,ABf_rf,ABf_ne,ABf_ne_0,k_corr_0,k_ABcorr_0,k_corr_z,k_ABcorr_z,
     *	ek_corr,ek_ABcorr,xk_buff

c	Meaning of variables in call to function fmag (see Tables 5 and 6 of bc03.ps for details):
c	  z		= redshift to compute apparent magnitude
c	  kf		= number of filter chosen to compute galaxy magnitude
c	  fmag		= apparent magnitude M_ev(z) + dm(z) in filter kf (Vega system)
c	  fmagAB	= apparent AB magnitude M_ev(z) + dm(z) in filter kf (AB system)
c	  iwrite	= print screen output (iwrite > 0)

c	Meaning of variables in common /mag/
c	  file		= BC GALAXEV *.ised model file name
c	  icall		= 0 when calling function for the first time
c	  h		= Hubble constant (Km/s/Mpc)
c	  omega		= density parameter
c	  omega_lambda	= density parameter associated to cosmological constant
c	  clambda     	= cosmological constant
c	  q		= deceleration parameter
c	  tu		= age of the universe in this cosmology
c	  tgal		= age of galaxies
c	  tl		= light travel time from z=0 to z
c	  tz		= age of galaxies at redshift z
c	  zf		= redshift of galaxy formation
c	  dm		= cosmological distance modulus in magnitude units
c	  filtid	= filter identification
c	  f_ev   	= M_ev(z) in filter kf (Vega system)
c	  f_rf   	= M_rf(z) in filter kf (Vega system)
c	  f_ne   	= M_ne(z) in filter kf (Vega system)
c	  f_ne_0 	= M_ne(0) in filter kf (Vega system)
c	  ABf_ev   	= AB M_ev(z) in filter kf (AB system)
c	  ABf_rf   	= AB M_rf(z) in filter kf (AB system)
c	  ABf_ne   	= AB M_ne(z) in filter kf (AB system)
c	  ABf_ne_0 	= AB M_ne(0) in filter kf (AB system)
c	  k_corr_z    	= k-correction in filter kf computed from sed at redshift z (Vega system)
c	  k_corr_0    	= k-correction in filter kf computed from sed at redshift 0 (Vega system)
c	  k_ABcorr_z  	= k-correction in filter kf computed from sed at redshift z (AB system)
c	  k_ABcorr_0  	= k-correction in filter kf computed from sed at redshift 0 (AB system)
c	  ek_corr   	= (e+k)-correction in filter kf (Vega system)
c	  ek_ABcorr 	= (e+k)-correction in filter kf (AB system)

c	Arrray declarations internal to fmag
	include 'read_ised.dec'
	include 'filter.dec'
	real yz(imw),y0(imw)
	save kl,last,y0
	data jcall/0/

c	Read *.ised file if first call to routine
	if (icall.eq.0) then
c		Read filter file
		write (6,*)
		write (6,*) 'Reading files and setting up zero points...'
		if (iread.eq.0) call filter0
c		Read galaxy sed
1		call read_ised(file,tgal,kl,kerr)
		if (kerr.ne.0) goto 2
		jcall=0
c		Compute evolution vs z
		call evol_ised(kl,0.,h,q,clambda,yz,jcall,last)
		write (6,*)
		icall=1
c		Store z=0 sed in array y0
		do i=1,iw
		y0(i)=yz(i)
		enddo
		goto 3
2		write (6,*)
c		Ask for *.ised file name
		write (6,'(x,3a,$)') 'BC_GALAXEV model sed in file [',file(1:largo(file)),'] = '
		read (5,'(a)',end=10) file
		call chaext(file,'ised',nn)
		goto 1
	endif

c	Compute cosmological distance modulus
3	dm=dismod(h,q,z)

c	Compute light travel time from z=0 to z
	tl=tu-t(h,q,z,clambda)
	tz=tgal*1.E-9-tl

c	Compute zero point in filter kf (Vega system)
	f0=vega_0p_n(kf)

c	Load filter id for filter kf
	filtid=fid(kf)

c	Get evolved sed at redshift z = yz
	call evol_ised(kl,z,h,q,clambda,yz,jcall,last)

c	Compute absolute magnitude in filter kf (Vega system)
c	  Magnitude of evolved sed at redshift z
	     f_ev   = f0 - 2.5*alog10(filter_n(kf,w,yz,iw,z,lerr))
c	  Magnitude of evolved sed at redshift 0
	     f_rf   = f0 - 2.5*alog10(filter_n(kf,w,yz,iw,0.,lerr))
c	  Magnitude of z = 0 sed at redshift z
	     f_ne   = f0 - 2.5*alog10(filter_n(kf,w,y0,iw,z,lerr))
c	  Magnitude of z = 0 sed at redshift 0
	     f_ne_0 = f0 - 2.5*alog10(filter_n(kf,w,y0,iw,0.,lerr))

c	Compute absolute AB magnitude in filter kf
c	  Magnitude of evolved sed at redshift z
	     ABf_ev   = AB_mag(kf,w,yz,iw,z)
c	  Magnitude of evolved sed at redshift 0
	     ABf_rf   = AB_mag(kf,w,yz,iw,0.)
c	  Magnitude of z = 0 sed at redshift z
	     ABf_ne   = AB_mag(kf,w,y0,iw,z)
c	  Magnitude of z = 0 sed at redshift 0
	     ABf_ne_0 = AB_mag(kf,w,y0,iw,0.)

c	Compute apparent magnitudes
	fmag    = f_ev   + dm
	fmagAB  = ABf_ev + dm

c	Compute k-corrections:
c	  For z=0 sed
	      k_corr_0   = f_ne   - f_ne_0
              k_ABcorr_0 = ABf_ne - ABf_ne_0
c	  For evolved sed
	      k_corr_z   = f_ev   - f_rf
              k_ABcorr_z = ABf_ev - ABf_rf

c	Compute (e+k)-corrections
	ek_corr   = f_ev   - f_ne_0
        ek_ABcorr = ABf_ev - ABf_ne_0

c	Print results if required
	if (iwrite.gt.0) then
		write (6,'(/x,a)') 'Meaning of printed variables (see Tables 5 and 6 of bc03.ps for details):'
		write (6,'(a)')    '  z       = redshift'
		write (6,'(a)')    '  ltt     = light travel time from z=0 to z in Gyr'
		write (6,'(a)')    '  tz      = age of galaxy at redshit = z'
		write (6,'(a)')    '  dm      = cosmological distance modulus in magnitude units'
		write (6,'(a)')    '  M_rf    = M_rf(z) in filter kf'
		write (6,'(a)')    '  M_ne    = M_ne(z) in filter kf'
		write (6,'(a)')    '  M_ev    = M_ev(z) in filter kf'
		write (6,'(a)')    '  m_ev    = apparent magnitude M_ev(z) + dm(z) in filter kf'
		write (6,'(a)')    '  e+kcor  = (e+k)-correction in filter kf'
		write (6,'(a)')    '  k_cor_z = k-correction in filter kf computed from sed at redshift z'
		write (6,'(a)')    '  k_cor_0 = k-correction in filter kf computed from sed at redshift 0'
		write (6,'(a)')    '  Z.P.    = Zeropoint definition, either Vega or AB system'
		write (6,'(/x,a,i4,2a)') 'In filter No.',kf,' = ',filtid(1:largo(filtid))
		write (6,'(3x,2a)') 'z   ltt(Gyr) tz(Gyr)   dm      M_rf     M_ne     M_ev     m_ev    e+kcor   k_cor_z  k_cor_0  Z.P.'
		write (6,101) z,tl,tz,dm,f_rf,f_ne,f_ev,fmag,ek_corr,k_corr_z,k_corr_0,ABf_rf,ABf_ne,ABf_ev,fmagAB,ek_ABcorr,k_ABcorr_z,k_ABcorr_0
101		format (f6.3,3f8.3,7f9.4,3x,'Vega'/30x,7f9.4,4x,'AB')
		write (6,'(x,140a)') ('-',i=1,61),'^',('-',i=1,37)
        endif
	return
10	stop
	end

	SUBROUTINE INTRP_ISED(NAME,AGE,X,Y,NW)

!	Interpolates .ised file at any arbitrary age entered by user

!	Variables
	include 'jb.dec'
	include 'csp.dec'
	character*1024 name,save
	real x(imw),y(imw)
	data iread/0/,save/''/

!	Open and read input file, if required
	if (name /= save) then
		close (777)
		open (777,file=name,form='unformatted',status='old',err=1)
!		Read basic parameters from input file
		read (777) nsteps,(tb(i),i=1,nsteps)	! ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,jo,tauo,id,tcut,ttt,ttt,ttt,id,id,igw,stelib
!		Read sed from file
		read (777) nw,(x(i),i=1,nw)
		do n=1,nsteps
		read (777) nw,(fl(i,n),i=1,nw)
		enddo
!		write (6,'(2a)') ' Reading file ',name(1:largo(name))
!		write (6,*) nw,' wavelength points per record'
!		write (6,*) nsteps,' time steps'
		close (777)
		save=name
	endif

!	Interpolate at required age
	if (age <= tb(1)) then
		do l=1,nw
		y(l) = fl(l,1)
		enddo
	elseif (age >= tb(nsteps)) then
		do l=1,nw
		y(l) = fl(l,nsteps)
		enddo
	else
		call locate(tb,nsteps,age,i)
		if (tb(i-1) > 0.) then
			a = alog10(age/tb(i-1))/alog10(tb(i)/tb(i-1))
		else
			a = age/tb(i)
		endif
		b=1.-a
		if (a == 0.) then
			do l=1,nw
			y(l) = fl(l,i-1)
			enddo
		elseif (a == 1.) then
			do l=1,nw
			y(l) = fl(l,i)
			enddo
		else
			do l=1,nw
			y(l) = b*fl(l,i-1) + a*fl(l,i)
			enddo
		endif
!		write (6,*) b,i-1,tb(i-1),a,i,tb(i)
	endif
	return
1	write (6,'(x,5a)') 'File ',name(1:largo(name)),' not found. Stopping code'
	stop
	end

	REAL*4 FUNCTION LX(X,Y,N)

	! Compute X ray luminosity in ergs/sec
	! Assumes X is in Angstroms and Y in Lo/Angstroms
	! Lx: between 0.5 and 8 keV (i.e. between 1.5498 and 24.7969 Å)

	! Variables
	real*4 x(n),y(n)
	real*8 lsun
	data x1/1.5498/, x2/24.7969/, lsun/3.846D33/

	! Check if SED extends to X ray region SED extends to X ray region (0.1 A)
	if (x(1) > 0.1) then
		lx = 0.
	else
		lx = trapz2(x,y,n,x1,x2,ierr)
	endif
	return
	end

	SUBROUTINE S500(T,A,X)

!	Stores in array S the variable A for later use

!	Variables
	character*(*) A,T*1,s(1000)*128
	common /save500/ k,s
	data k/0/

!	Store variable in array s
	if (t == 'c') then
!		Clean buffer
		do i=1,1000
		s(i)=' '
		enddo
	elseif (t == 'k') then
!		Reset pointer
		k = nint(x)
	elseif (t == 'f') then
!		Store floating point x
		k=k+1
		write (s(k),*) x
	elseif (t == 'a') then
!		Store alpha numeric a
		k=k+1
		write (s(k),'(a)') trim(a)
	elseif (t == 'r') then
!		Store SFR in file name.sfr
		s(k+1)=a
		call chext(a,'sfr')
		open (500,file=a)
		do i=8,k
		write (500,'(a)') trim(s(i))
		enddo
		close (500)
		a=s(k+1)
	endif
	return
	end

	SUBROUTINE R500(J,T,A,X)

!	Reads floating point or alpha numeric previously stored in array S

!	Variables
	character T*1,a*128,s(1000)*128
	common /save500/ k,s

!	Check range
	if (j > k) then
		j=-k
		return
	endif

!	Read variable
	if (t == 'f') then
!		Read floating point
		read (s(j),*) x
	elseif (t == 'a') then
!		Read alpha numeric
		read (s(j),'(a)') a
	endif
	return
	end

	PROGRAM ADD_BURSTS

	! Adds sed''s corresponding to 2 different bursts of star formation.
	! The sed for each burst must be computed previously.

	! Array declaration
	include 'SSP_4.dec'
	include 'SSP_13.dec'
	parameter (imw=30000) 		!	lower than in SSP_0.dec
	parameter (its=5000,maxbu=2)
	character*128 temp,argu*1024,atlas,shell*32
	logical stelib
	real tb1(its),tb2(its),tb3(maxbu*its),fi(40),fc(40),tx(3)
	real w(imw),h(imw),fl1(imw,its),fl2(imw,its),rsn(0:4)
	real  bflx1(its),  bflx2(its),  bflx3(maxbu*its)
	real  strm1(its),  strm2(its),  strm3(maxbu*its)
	real   sfr1(its),   sfr2(its),   sfr3(maxbu*its)
	real  evfl1(its),  evfl2(its),  evfl3(maxbu*its)
	real  snbr1(its),  snbr2(its),  snbr3(maxbu*its)
	real  pnbr1(its),  pnbr2(its),  pnbr3(maxbu*its)
	real  bhtn1(its),  bhtn2(its),  bhtn3(maxbu*its)
	real  sntn1(its),  sntn2(its),  sntn3(maxbu*its)
	real  wdtn1(its),  wdtn2(its),  wdtn3(maxbu*its)
	real  rmtm1(its),  rmtm2(its),  rmtm3(maxbu*its)
	real  toff1(its),  toff2(its),  toff3(maxbu*its)
	real bolms1(its), bolms2(its), bolms3(maxbu*its)
	real gasms1(its), gasms2(its), gasms3(maxbu*its)
	real galms1(its), galms2(its), galms3(maxbu*its)
	real   rml1(its),   rml2(its),   rml3(maxbu*its)
	real   rdp1(its),   rdp2(its),   rdp3(maxbu*its)
	real   sn11(its),   sn12(its),   sn13(maxbu*its)
	real   sn21(its),   sn22(its),   sn23(maxbu*its)
	real   sn31(its),   sn32(its),   sn33(maxbu*its)
	real   sn41(its),   sn42(its),   sn43(maxbu*its)

	real*8 td0(2),t2,tl,t(its),z(its)

	data ihrd/0/,atlas/' '/

	! Check filter file assignment
	j=ifilter()
	if (j == 0) then
		write (6,'(2a)') char(7),'Please assign correct filter file'
		write (6,'(2a)') char(7),'Use command: stdfilt'
		stop
	endif

	! Information message
	write (6,*)
	write (6,*) ' This program computes the combined sed for 2 bursts of star formation.'
	write (6,*) ' The sed corresponding to each burst must be computed first.'
	write (6,*) ' Each burst is characterized by the beginning time (in Gyr) and'
	write (6,*) ' the burst strength (absolute, NOT relative).'
	write (6,*) ' Each individual burst can follow an arbitrary star formation law.'
	write (6,*)
	
	! Ask for independent sed files
	write (6,'(x,a,$)') 'First BC_GALAXEV sed in file  = '
	read (5,'(a)',end=10) name1
	call chaext(name1,'ised',mm)
	write (6,'(x,a,$)') 'Second BC_GALAXEV sed in file = '
	read (5,'(a)',end=10) name2
	call chaext(name2,'ised',mm)

	! Ask for burst information
	st=0.
	do i=1,2
2	write (6,100) i
100	format(' Burst',i2,': Beginning time (Gyr), Burst amplitude = ',$)
	! Found a problem with gfortran in reading more arguments that have been actually entered.
	! Use function nargu(argu) to count how many arguments have been entered
	! read (5,'(3e20.0)',err=2,end=10) td0(i),s(i),tshift
	read (5,'(a)',end=10) argu
	ngu = nargu(argu)
	read (argu,*,err=2) (tx(j),j=1,ngu)
	if (ngu == 2) then
		td0(i)=tx(1)
		  s(i)=tx(2)
		tshift=0.
	elseif (ngu == 3) then
		td0(i)=tx(1)
		  s(i)=tx(2)
		tshift=tx(3)
	else
		goto 2
	endif
	td0(i)=td0(i)*1.E9
	tshift=tshift*1.E9
	enddo
	shift=td0(1)
	if (td0(2) < shift) shift=td0(2)
	if (tshift == 0.) tshift=shift
	td0(1)=td0(1)-shift
	td0(2)=td0(2)-shift
	t0(1)=td0(1)
	t0(2)=td0(2)

	! Read first burst file
	write (6,*)
	write (6,'(2a)') ' Reading file ',name1
	imx=irec_check(1,name1)
	open (1,file=name1,form='unformatted',status='old')
	read (1) nsteps,(tb1(i),i=1,nsteps),ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,jo,tauo,id,ttt,ttt,ttt,ttt,id,id,igw,stelib
	write (6,*) nsteps,' steps'
	read (1,err=15) inl,(w(i),i=1,inl),nbrite,kdef,sissa20
	! write (6,*) 'nbrite, kdef, sissa20 =',nbrite, kdef, sissa20
	goto 16
	! Old format model (nbrite = 0)
15	nbrite   = 0
	kdef    = 0
	sissa20 = .false.
16	write (6,*) inl,' lambda points'
	do n=1,nsteps
	if (imx > 0) then
		read (1) inl,(fl1(i,n),i=1,inl),inx,(fl1(i,n),i=inl+1,inl+inx)
	else
		read (1) inl,(fl1(i,n),i=1,inl)
		inx=0
	endif
	enddo
	mw=inl+imx
	write (6,*) inl,' wavelength points per record'
	write (6,*) inx,' spectral index points per record'
	write (6,*)  mw,' total points per record'
	read (1,end=21) nsteps,( bflx1(i), i=1,nsteps)
	read (1,end=21) nsteps,( strm1(i), i=1,nsteps)
	read (1,end=21) nsteps,(  sfr1(i), i=1,nsteps)
	read (1,end=21) nsteps,( evfl1(i), i=1,nsteps)
	read (1,end=21) nsteps,( snbr1(i), i=1,nsteps)
	read (1,end=21) nsteps,( pnbr1(i), i=1,nsteps)
	read (1,end=21) nsteps,( bhtn1(i), i=1,nsteps)
	read (1,end=21) nsteps,( sntn1(i), i=1,nsteps)
	read (1,end=21) nsteps,( wdtn1(i), i=1,nsteps)
	read (1,end=21) nsteps,( rmtm1(i), i=1,nsteps)
	read (1,end=21) nsteps,( toff1(i), i=1,nsteps)
	read (1,end=21) nsteps,(bolms1(i), i=1,nsteps)
	read (1,end=21) nsteps,(gasms1(i), i=1,nsteps)
	read (1,end=21) nsteps,(galms1(i), i=1,nsteps)
	read (1,end=21) nsteps,(  rml1(i), i=1,nsteps)
	read (1,end=21) nsteps,(  rdp1(i), i=1,nsteps)
	read (1,end=21) nsteps,(  sn11(i), i=1,nsteps)
	read (1,end=21) nsteps,(  sn21(i), i=1,nsteps)
	read (1,end=21) nsteps,(  sn31(i), i=1,nsteps)
	read (1,end=21) nsteps,(  sn41(i), i=1,nsteps)
21	close (1)

	! Read second burst file
	if (name1 == name2) then
		write (6,*)
		write (6,'(2a)') ' Copying file ',name2
		do n=1,nsteps
		tb2(n)    = tb1(n)
		bflx2(n)  = bflx1(n)
		strm2(n)  = strm1(n)
		 sfr2(n)  = sfr1(n)
		evfl2(n)  = evfl1(n)
		snbr2(n)  = snbr1(n)
		pnbr2(n)  = pnbr1(n)
		bhtn2(n)  = bhtn1(n)
		sntn2(n)  = sntn1(n)
		wdtn2(n)  = wdtn1(n)
		rmtm2(n)  = rmtm1(n)
		toff2(n)  = toff1(n)
		bolms2(n) = bolms1(n)
		gasms2(n) = gasms1(n)
		galms2(n) = galms1(n)
		rml2(n)   = rml1(n)
		rdp2(n)   = rdp1(n)
		sn12(n)   = sn11(n)
		sn22(n)   = sn21(n)
		sn32(n)   = sn31(n)
		sn42(n)   = sn41(n)
		do i=1,mw
		fl2(i,n) = fl1(i,n)
		enddo
		enddo
		ksteps=nsteps
	else
		write (6,*)
		write (6,'(2a)') ' Reading file ',name2
		im2=irec_check(2,name2)
		open (2,file=name2,form='unformatted',status='old')
		read (2) ksteps,(tb2(i),i=1,ksteps),ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,jo,tauo,id,ttt,ttt,ttt,ttt,id,id,igw,stelib
		read (2) iml,(w(i),i=1,iml)
		if (iml.ne.inl.or.im2.ne.imx) then
			write (6,*) 'Wavelength scales differ.',inl,iml,imx,iml
			stop
		endif
		write (6,*) ksteps,' steps'
		do n=1,ksteps
		if (imx > 0) then
			read (2) inl,(fl2(i,n),i=1,inl),inx,(fl2(i,n),i=inl+1,inl+inx)
		else
			read (2) inl,(fl2(i,n),i=1,inl)
			inx=0
		endif
		enddo
		write (6,*) inl,' wavelength points per record'
		write (6,*) inx,' spectral index points per record'
		write (6,*)  mw,' total points per record'
		read (2,end=22) ksteps,( bflx2(i), i=1,ksteps)
		read (2,end=22) ksteps,( strm2(i), i=1,ksteps)
		read (2,end=22) ksteps,(  sfr2(i), i=1,ksteps)
		read (2,end=22) ksteps,( evfl2(i), i=1,ksteps)
		read (2,end=22) ksteps,( snbr2(i), i=1,ksteps)
		read (2,end=22) ksteps,( pnbr2(i), i=1,ksteps)
		read (2,end=22) ksteps,( bhtn2(i), i=1,ksteps)
		read (2,end=22) ksteps,( sntn2(i), i=1,ksteps)
		read (2,end=22) ksteps,( wdtn2(i), i=1,ksteps)
		read (2,end=22) ksteps,( rmtm2(i), i=1,ksteps)
		read (2,end=22) ksteps,( toff2(i), i=1,ksteps)
		read (2,end=22) ksteps,(bolms2(i), i=1,ksteps)
		read (2,end=22) ksteps,(gasms2(i), i=1,ksteps)
		read (2,end=22) ksteps,(galms2(i), i=1,ksteps)
		read (2,end=22) ksteps,(  rml2(i), i=1,ksteps)
		read (2,end=22) ksteps,(  rdp2(i), i=1,ksteps)
		read (2,end=22) ksteps,(  sn12(i), i=1,ksteps)
		read (2,end=22) ksteps,(  sn22(i), i=1,ksteps)
		read (2,end=22) ksteps,(  sn32(i), i=1,ksteps)
		read (2,end=22) ksteps,(  sn42(i), i=1,ksteps)
22		close (2)
	endif

	! Build combined time scale for 2 bursts
	mix=0
	if (ksteps /= nsteps) then
		mix=1
	else
		do i=1,nsteps
		if (td0(1)+dble(tb1(i)).ne.td0(2)+dble(tb2(i))) mix=1
		enddo
	endif
	if (mix > 0) then
		k=0
		do i=1,nsteps
		k=k+1
		t(k)=td0(1)+dble(tb1(i))
		z(k)=1.
		enddo
		k1=k
		do i=1,ksteps
		k=k+1
		t(k)=td0(2)+dble(tb2(i))
		z(k)=2.
		enddo
		t2=t(k1+1)

		! Sort time scale
		call dsort2(k,t,z)

		! Suppress duplicate entries
		n=1
		tb3(n)=t(n)
		do i=2,k
		tl=0.
		if (t(i-1) <= 0.) then
			if (t(i) > 0.) then
				tl=1.
			else
				tl=0.
			endif
		else
			tl=dlog10(t(i))-dlog10(t(i-1))
		endif
		if (tl > 1.E-6) then
			n=n+1
			t(n)=t(i)
			z(n)=z(i)
			tb3(n)=t(n)
		else
			! write (6,*) 'Suppress t =',t(i)
		endif
		if (t(n) > tb1(nsteps)) then
			n=n-1
			goto 3
		endif
		enddo
3		msteps=n
		write (6,*)
		write (6,*) msteps,' different time steps in combined sed'
	
		! Find time steps for which first burst exists by itself
		do i=1,msteps
		if (t(i) > t2) then
			i1=i-1
			goto 4
		endif
		enddo
4		write (6,'(i12,a,1pe10.3,a)') i1,'  steps for first burst alone, up to age',t(i1),' yr'
		interp=1
	else
		msteps=nsteps
		interp=0
		do i=1,msteps
		tb3(i)=tb1(i)
		enddo
	endif

	! Ask for output file name
	io=5
	jdef=jjdef(name1)
	lun=-1
	ioption=99
	ldef=0
	call name_sed(lun,jun,0,ihrd,ioption,jdef,ldef,ml,mu,temp,atlas)

	! Open temporay file to store output file name and kdef (needed to build fits file)
	open (2020,file='csp_fits.tmp')
	if (index(shell(),'csh') > 0) then
		! csh in use
		write (2020,'(a)')    'setenv name0 ' // trim(temp) // '.ised'
		write (2020,'(a,i5)') 'setenv ioptn ',kdef
	else
		! zsh or bash in use
		write (2020,'(a)')      'export name0="' // trim(temp) //'.ised"'
		write (2020,'(a,i5,a)') 'export ioptn="',kdef,'"'
	endif
	close (2020)
	! Write in file fort.2001 current time scale (needed to build fits file)
	write (2001,'(a)') '# age-yr'
	do i=1,msteps
	write (2001,'(1pe12.5)') tb3(i)+tshift
	enddo
	close (2001)

	! Write time scale, IMF, and wavelength scale in output file
	write (lun) msteps,(tb3(i)+tshift,i=1,msteps),ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,io,tau,id,t0,s,name1,name2,igw,stelib
	write (lun) inl,(w(i),i=1,inl),nbrite,kdef,sissa20
	if (nbrite > 0 .and. sissa20) then
		! SISSA20 tracks with zero flux in first time steps
		! Here nbrite = ndark + 1 = first luminous record. Write ndark + 1 zero flux records, extra one for t = 0.
		do lb=1,nbrite
		call dark_galaxy(lun,tb3(lb)+tshift)
		enddo
	endif
	do n=1,msteps
	if (interp == 0) then
		! Add bursts without interpolation in time
		do i=1,mw
		h(i)=s(1)*fl1(i,n)+s(2)*fl2(i,n)
		enddo
		tb3(n)    = tb1(n)
		bflx3(n)  = s(1)*bflx1(n)  + s(2)*bflx2(n)
		strm3(n)  = s(1)*strm1(n)  + s(2)*strm2(n)
		sfr3(n)   = s(1)* sfr1(n)  + s(2)* sfr2(n)
		evfl3(n)  = s(1)*evfl1(n)  + s(2)*evfl2(n)
		snbr3(n)  = s(1)*snbr1(n)  + s(2)*snbr2(n)
		pnbr3(n)  = s(1)*pnbr1(n)  + s(2)*pnbr2(n)
		bhtn3(n)  = s(1)*bhtn1(n)  + s(2)*bhtn2(n)
		sntn3(n)  = s(1)*sntn1(n)  + s(2)*sntn2(n)
		wdtn3(n)  = s(1)*wdtn1(n)  + s(2)*wdtn2(n)
		rmtm3(n)  = s(1)*rmtm1(n)  + s(2)*rmtm2(n)
		toff3(n)  = s(1)*toff1(n)  + s(2)*toff2(n)
		bolms3(n) = s(1)*bolms1(n) + s(2)*bolms2(n)
		gasms3(n) = s(1)*gasms1(n) + s(2)*gasms2(n)
		galms3(n) = s(1)*galms1(n) + s(2)*galms2(n)
		rml3(n)   = s(1)*rml1(n)   + s(2)*rml2(n)
		rdp3(n)   = s(1)*rdp1(n)   + s(2)*rdp2(n)
		sn13(n)   = s(1)*sn11(n)   + s(2)*sn12(n)
		sn23(n)   = s(1)*sn21(n)   + s(2)*sn22(n)
		sn33(n)   = s(1)*sn31(n)   + s(2)*sn32(n)
		sn43(n)   = s(1)*sn41(n)   + s(2)*sn42(n)
	else
		if (n <= i1) then
			! First burst alone
			do i=1,mw
			h(i)=s(1)*fl1(i,n)
			enddo
			bflx3(n)  = s(1)*bflx1(n)
			strm3(n)  = s(1)*strm1(n)
			sfr3 (n)  = s(1)*sfr1 (n)
			evfl3(n)  = s(1)*evfl1(n)
			snbr3(n)  = s(1)*snbr1(n)
			pnbr3(n)  = s(1)*pnbr1(n)
			bhtn3(n)  = s(1)*bhtn1(n)
			sntn3(n)  = s(1)*sntn1(n)
			wdtn3(n)  = s(1)*wdtn1(n)
			rmtm3(n)  = s(1)*rmtm1(n)
			toff3(n)  = s(1)*toff1(n)
			bolms3(n) = s(1)*bolms1(n)
			gasms3(n) = s(1)*gasms1(n)
			galms3(n) = s(1)*galms1(n)
			rml3(n)   = s(1)*rml1(n)
			rdp3(n)   = s(1)*rdp1(n)
			sn13(n)   = s(1)*sn11(n)
			sn23(n)   = s(1)*sn21(n)
			sn33(n)   = s(1)*sn31(n)
			sn43(n)   = s(1)*sn41(n)
		else
			! Combine both seds by linear interpolation in log t
			if (z(n) == 2.) then
				! Interpolate first sed
				! Locate sed at this age in first model and compute interpolatation coefficient
				to=t(n)-td0(1)
				call locate(tb1,nsteps,to,i)
				if (tb1(i) > 0.) then
					a=alog10(to/tb1(i))/alog10(tb1(i+1)/tb1(i))
				else
					a=to/tb1(i+1)
				endif
				! Locate sed at this age in second model
				to=t(n)-td0(2)
				call locate(tb2,ksteps,to,j)
				! Compute combined sed
				b=s(1)*(1.-a)
				a=s(1)*a
				c=s(2)
				do l=1,mw
				h(l)=b*fl1(l,i)+a*fl1(l,i+1)+c*fl2(l,j+1)
				enddo
				bflx3(n)  = b*bflx1(i)  + a*bflx1(i+1)  + c*bflx2(j+1)
				strm3(n)  = b*strm1(i)  + a*strm1(i+1)  + c*strm2(j+1)
				sfr3(n)   = b*sfr1(i)   + a*sfr1(i+1)   + c*sfr2(j+1)
				evfl3(n)  = b*evfl1(i)  + a*evfl1(i+1)  + c*evfl2(j+1)
				snbr3(n)  = b*snbr1(i)  + a*snbr1(i+1)  + c*snbr2(j+1)
				pnbr3(n)  = b*pnbr1(i)  + a*pnbr1(i+1)  + c*pnbr2(j+1)
				bhtn3(n)  = b*bhtn1(i)  + a*bhtn1(i+1)  + c*bhtn2(j+1)
				sntn3(n)  = b*sntn1(i)  + a*sntn1(i+1)  + c*sntn2(j+1)
				wdtn3(n)  = b*wdtn1(i)  + a*wdtn1(i+1)  + c*wdtn2(j+1)
				rmtm3(n)  = b*rmtm1(i)  + a*rmtm1(i+1)  + c*rmtm2(j+1)
				toff3(n)  = b*toff1(i)  + a*toff1(i+1)  + c*toff2(j+1)
				bolms3(n) = b*bolms1(i) + a*bolms1(i+1) + c*bolms2(j+1)
				gasms3(n) = b*gasms1(i) + a*gasms1(i+1) + c*gasms2(j+1)
				galms3(n) = b*galms1(i) + a*galms1(i+1) + c*galms2(j+1)
				rml3(n)   = b*rml1(i)   + a*rml1(i+1)   + c*rml2(j+1)
				rdp3(n)   = b*rdp1(i)   + a*rdp1(i+1)   + c*rdp2(j+1)
				sn13(n)   = b*sn11(i)   + a*sn11(i+1)   + c*sn12(j+1)
				sn23(n)   = b*sn21(i)   + a*sn21(i+1)   + c*sn22(j+1)
				sn33(n)   = b*sn31(i)   + a*sn31(i+1)   + c*sn32(j+1)
				sn43(n)   = b*sn41(i)   + a*sn41(i+1)   + c*sn42(j+1)
			elseif (z(n) == 1.) then
				! Interpolate second sed
				! Locate sed at this age in second model and compute interpolatation coefficient
				to=t(n)-td0(2)
				call locate(tb2,ksteps,to,i)
				if (tb2(i) > 0.) then
					a=alog10(to/tb2(i))/alog10(tb2(i+1)/tb2(i))
				else
					a=to/tb2(i+1)
				endif
				! Locate sed at this age in first model
				to=t(n)-td0(1)
				call locate(tb1,nsteps,to,j)
				! Compute combined sed
				b=s(2)*(1.-a)
				a=s(2)*a
				c=s(1)
				do l=1,mw
				h(l)=b*fl2(l,i)+a*fl2(l,i+1)+c*fl1(l,j+1)
				enddo
				bflx3(n)  = b*bflx2(i)  + a*bflx2(i+1)  + c*bflx1(j+1)
				strm3(n)  = b*strm2(i)  + a*strm2(i+1)  + c*strm1(j+1)
				sfr3(n)   = b*sfr2 (i)  + a*sfr2 (i+1)  + c*sfr1 (j+1)
				evfl3(n)  = b*evfl2(i)  + a*evfl2(i+1)  + c*evfl1(j+1)
				snbr3(n)  = b*snbr2(i)  + a*snbr2(i+1)  + c*snbr1(j+1)
				pnbr3(n)  = b*pnbr2(i)  + a*pnbr2(i+1)  + c*pnbr1(j+1)
				bhtn3(n)  = b*bhtn2(i)  + a*bhtn2(i+1)  + c*bhtn1(j+1)
				sntn3(n)  = b*sntn2(i)  + a*sntn2(i+1)  + c*sntn1(j+1)
				wdtn3(n)  = b*wdtn2(i)  + a*wdtn2(i+1)  + c*wdtn1(j+1)
				rmtm3(n)  = b*rmtm2(i)  + a*rmtm2(i+1)  + c*rmtm1(j+1)
				toff3(n)  = b*toff2(i)  + a*toff2(i+1)  + c*toff1(j+1)
				bolms3(n) = b*bolms2(i) + a*bolms2(i+1) + c*bolms1(j+1)
				gasms3(n) = b*gasms2(i) + a*gasms2(i+1) + c*gasms1(j+1)
				galms3(n) = b*galms2(i) + a*galms2(i+1) + c*galms1(j+1)
				rml3(n)   = b*rml2(i)   + a*rml2(i+1)   + c*rml1(j+1)
				rdp3(n)   = b*rdp2(i)   + a*rdp2(i+1)   + c*rdp1(j+1)
				sn13(n)   = b*sn12(i)   + a*sn12(i+1)   + c*sn11(j+1)
				sn23(n)   = b*sn22(i)   + a*sn22(i+1)   + c*sn21(j+1)
				sn33(n)   = b*sn32(i)   + a*sn32(i+1)   + c*sn31(j+1)
				sn43(n)   = b*sn42(i)   + a*sn42(i+1)   + c*sn41(j+1)
			endif
		endif
	endif

	! Write results
	! Standard model colors
	rsn(0) = snbr3(n)
	rsn(1) = sn13(n)
	rsn(2) = sn23(n)
	rsn(3) = sn33(n)
	rsn(4) = sn43(n)
	write (lun) inl,(h(i),i=1,inl),inx,(h(i),i=inl+1,inl+inx)
	call rf_color(10,tb3(n)+tshift,w,h,inl,lun,bflx3(n),strm3(n),sfr3(n),evfl3(n),rsn,pnbr3(n),bhtn3(n),sntn3(n),wdtn3(n),rmtm3(n),toff3(n),bolms3(n),gasms3(n),galms3(n),rml3(n),rdp3(n),sissa20)
	if (n > 1) call percent(6,n,msteps,'ADD_BURSTS ' // temp(1:nargo(temp)))
	! Guy Worthey Spectral indices
	inx2=inx/2
	do i=1,inx2
	fi(i)=h(inl+i)
	fc(i)=h(inl+inx2+i)
	enddo
	igw=0
	call gw_indices(tb3(n),fi,fc,lun,igw)
	enddo
	write (lun) msteps,(bflx3(i),i=1,msteps)
	write (lun) msteps,(strm3(i),i=1,msteps)
	write (lun) msteps,(sfr3(i),i=1,msteps)
	write (lun) msteps,(evfl3(i),i=1,msteps)
	write (lun) msteps,(snbr3(i),i=1,msteps)
	write (lun) msteps,(pnbr3(i),i=1,msteps)
	write (lun) msteps,(bhtn3(i),i=1,msteps)
	write (lun) msteps,(sntn3(i),i=1,msteps)
	write (lun) msteps,(wdtn3(i),i=1,msteps)
	write (lun) msteps,(rmtm3(i),i=1,msteps)
	write (lun) msteps,(toff3(i),i=1,msteps)
	write (lun) msteps,(bolms3(i),i=1,msteps)
	write (lun) msteps,(gasms3(i),i=1,msteps)
	write (lun) msteps,(galms3(i),i=1,msteps)
	write (lun) msteps,(rml3(i),i=1,msteps)
	write (lun) msteps,(rdp3(i),i=1,msteps)
	write (lun) msteps,(sn13(i),i=1,msteps)
	write (lun) msteps,(sn23(i),i=1,msteps)
	write (lun) msteps,(sn33(i),i=1,msteps)
	write (lun) msteps,(sn43(i),i=1,msteps)

	! Write command file to delete unwnated files
	call delete_files(temp,inl,1)
	close (3)
	close (4)
	close (lun)
	close (lun+1)
	close (lun+2)
	close (lun+3)
	close (lun+4)
	close (lun+5)
	close (lun+8)
	close (lun+9)
	close (lun+10)
	close (lun+11)
	close (lun+12)
	close (lun+13)
	close (lun+14)
	close (lun+55)

10	end

	FUNCTION GAL_MASS(IO,T,SFR)

c	Computes the galaxy mass up to time t as the integral of the SFR

c	Array declaration
	real*8 glast,trapz8,tg(20000),sf(20000)
	data ic,ig,tg,sf/0,0,40000*0./,glast/0./

c	Zero arrays on first call
	if (ic.eq.0) then
		do i=1,10000
		tg(i)=0.
		sf(i)=0.
		enddo
		gal_mass=0.
		ic=1
		ig=0
	endif

c	Check if SSP (IO=0)
	if (io.eq.0) then
c		SSP, 1 Mo of stars formed at t = 0
		gal_mass=1.
	else
c		Store SFR and compute integral
		ig=ig+1
		tg(ig)=t
		sf(ig)=sfr
		if (sfr > 0.) then
			glast =trapz8(tg,sf,ig)
			if (ig == 1) glast = sfr*t
		endif
		gal_mass=glast
	endif
!	if (t.gt.19.9E9) ic=0
	if (t >= 20.0E9) ic=0
	return
	end

	REAL*8 FUNCTION TRAPZ8(X,Y,N)
	REAL*8 X(N),Y(N)
	TRAPZ8=0.
	IF (N.LE.1) RETURN
	DO J=2,N
	TRAPZ8= TRAPZ8 + ABS(X(J)-X(J-1))*(Y(J)+Y(J-1))/2.
	ENDDO
	RETURN
	END

	SUBROUTINE INTERPOLATE_SSP(NAME)

!	Interpolates BC03 model SSP at metallicity Z/Zo indicated in name (after character ',')

!	Variables
	parameter (jb=10)
	parameter (mmod=16)
	include 'csp.dec'
	integer bcopt
	real w(imw),h(imw)
        logical stelib
	character*(*) name,files(mmod)*128
	real zmod(mmod),zx(mmod)
!	data zmod/0.0001, 0.0004,  0.004, 0.008,  0.02,  0.05,  0.10/   						! BC03
!	data zmod/0.0001, 0.0002, 0.0005, 0.001, 0.002, 0.004, 0.006, 0.008, 0.010, 0.014, 0.017, 0.02, 0.03, 0.04/	! CB13

!	Check if interpolation has been requested
	i = index(name,',')
	call s500('c','',0.)
	if (i <= 0) then
!		write (501,*) 0.
!		write (501,*) 1.
!		write (501,*) name(:largo(name))
!		write (501,*) 0.
!		write (501,*) 'empty'
		call s500('f','',0.)
		call s500('f','',1.)
		call s500('a',name(:largo(name)),0.)
		call s500('f','',0.)
		call s500('a','empty',0.)
		return
	endif
	name = name(i+1:)
	ngu = nargu(name)
	if (ngu == 1) then
                read (name,*) z
		idth=0
	elseif (ngu == 2) then
                read (name,*) z,idth
	endif
	call s500('f','',z)

!	Check models in use. Define file names
	bcopt = 0
	call system('/bin/ls *ssp.ised > fort.202')
	read (202,'(a)') files(1)
	read (files(1),'(2x,i4)') bcopt
	close (202)
	call system('/bin/rm fort.202')
	if (bcopt == 2003) then
!		Use BC 2003 models
		nmod      = 6
		zsun      = 0.02
		zmod( 1)  = 0.0001
		zmod( 2)  = 0.0004
		zmod( 3)  = 0.004
		zmod( 4)  = 0.008
		zmod( 5)  = 0.02
		zmod( 6)  = 0.05
!		zmod( 7)  = 0.10
		if (index(files(1),'_stelib_') > 1) then
			files( 1) = 'bc2003_z0001_chab_hr_stelib_ssp.ised'	! = bc2003_hr_stelib_m22_chab_ssp.ised = bc2003_hr_m22_chab_ssp.ised
			files( 2) = 'bc2003_z0004_chab_hr_stelib_ssp.ised'	! = bc2003_hr_stelib_m32_chab_ssp.ised = bc2003_hr_m32_chab_ssp.ised
			files( 3) = 'bc2003_z004_chab_hr_stelib_ssp.ised'	! = bc2003_hr_stelib_m42_chab_ssp.ised = bc2003_hr_m42_chab_ssp.ised
			files( 4) = 'bc2003_z008_chab_hr_stelib_ssp.ised'	! = bc2003_hr_stelib_m52_chab_ssp.ised = bc2003_hr_m52_chab_ssp.ised
			files( 5) = 'bc2003_z020_chab_hr_stelib_ssp.ised'	! = bc2003_hr_stelib_m62_chab_ssp.ised = bc2003_hr_m62_chab_ssp.ised
			files( 6) = 'bc2003_z050_chab_hr_stelib_ssp.ised'	! = bc2003_hr_stelib_m72_chab_ssp.ised = bc2003_hr_m72_chab_ssp.ised
!			files( 7) = 'bc2003_z100_chab_hr_stelib_ssp.ised'	! = bc2003_hr_stelib_m82_chab_ssp.ised = bc2003_hr_m82_chab_ssp.ised
			bcopt     = 1
		elseif (index(files(1),'_xmilesi_') > 1) then
			files( 1) = 'bc2003_z0001_chab_hr_xmilesi_ssp.ised'
			files( 2) = 'bc2003_z0004_chab_hr_xmilesi_ssp.ised'
			files( 3) = 'bc2003_z004_chab_hr_xmilesi_ssp.ised'
			files( 4) = 'bc2003_z008_chab_hr_xmilesi_ssp.ised'
			files( 5) = 'bc2003_z020_chab_hr_xmilesi_ssp.ised'
			files( 6) = 'bc2003_z050_chab_hr_xmilesi_ssp.ised'
!			files( 7) = 'bc2003_z100_chab_hr_xmilesi_ssp.ised'
			bcopt     = 2
		elseif (index(files(1),'_mastar_') > 1) then
			files( 1) = 'bc2003_z0001_chab_hrx_mastar_ssp.ised'
			files( 2) = 'bc2003_z0004_chab_hrx_mastar_ssp.ised'
			files( 3) = 'bc2003_z004_chab_hrx_mastar_ssp.ised'
			files( 4) = 'bc2003_z008_chab_hrx_mastar_ssp.ised'
			files( 5) = 'bc2003_z020_chab_hrx_mastar_ssp.ised'
			files( 6) = 'bc2003_z050_chab_hrx_mastar_ssp.ised'
!			files( 7) = 'bc2003_z100_chab_hrx_mastar_ssp.ised'
			bcopt     = 3
		else
			write (6,*) 'Unknown series of models: ',files(1)(:largo(files(1)))
			stop
		endif
	elseif (bcopt > 2010) then
!		Use CB 201X models
		nmod      = 16
		zsun      = 0.017
		zmod( 1)  = 0.0000
		zmod( 2)  = 0.0001
		zmod( 3)  = 0.0002
		zmod( 4)  = 0.0005
		zmod( 5)  = 0.001
		zmod( 6)  = 0.002
		zmod( 7)  = 0.004
		zmod( 8)  = 0.006
		zmod( 9)  = 0.008
		zmod(10)  = 0.010
		zmod(11)  = 0.014
		zmod(12)  = 0.017
		zmod(13)  = 0.020
		zmod(14)  = 0.030
		zmod(15)  = 0.040
		zmod(16)  = 0.060
		if (index(files(1),'_stelib_') > 1) then
			files( 1) = 'cb2019_z0000_chab_hr_stelib_ssp.ised'	! = cb2013_s2_z0000y230n_chab_hr_stelib_ssp.ised
			files( 2) = 'cb2019_z0001_chab_hr_stelib_ssp.ised'	! = cb2013_s2_z0001y249n_chab_hr_stelib_ssp.ised
			files( 3) = 'cb2019_z0002_chab_hr_stelib_ssp.ised'	! = cb2013_s2_z0002y249n_chab_hr_stelib_ssp.ised
			files( 4) = 'cb2019_z0005_chab_hr_stelib_ssp.ised'	! = cb2013_s2_z0005y249n_chab_hr_stelib_ssp.ised
			files( 5) = 'cb2019_z001_chab_hr_stelib_ssp.ised' 	! = cb2013_s2_z001y250n_chab_hr_stelib_ssp.ised
			files( 6) = 'cb2019_z002_chab_hr_stelib_ssp.ised' 	! = cb2013_s2_z002y252n_chab_hr_stelib_ssp.ised
			files( 7) = 'cb2019_z004_chab_hr_stelib_ssp.ised' 	! = cb2013_s2_z004y256n_chab_hr_stelib_ssp.ised
			files( 8) = 'cb2019_z006_chab_hr_stelib_ssp.ised' 	! = cb2013_s2_z006y259n_chab_hr_stelib_ssp.ised
			files( 9) = 'cb2019_z008_chab_hr_stelib_ssp.ised' 	! = cb2013_s2_z008y263n_chab_hr_stelib_ssp.ised
			files(10) = 'cb2019_z010_chab_hr_stelib_ssp.ised' 	! = cb2013_s2_z010y267n_chab_hr_stelib_ssp.ised
			files(11) = 'cb2019_z014_chab_hr_stelib_ssp.ised' 	! = cb2013_s2_z014y273n_chab_hr_stelib_ssp.ised
			files(12) = 'cb2019_z017_chab_hr_stelib_ssp.ised' 	! = cb2013_s2_z017y279n_chab_hr_stelib_ssp.ised
			files(13) = 'cb2019_z020_chab_hr_stelib_ssp.ised' 	! = cb2013_s2_z020y284n_chab_hr_stelib_ssp.ised
			files(14) = 'cb2019_z030_chab_hr_stelib_ssp.ised' 	! = cb2013_s2_z030y302n_chab_hr_stelib_ssp.ised
			files(15) = 'cb2019_z040_chab_hr_stelib_ssp.ised' 	! = cb2013_s2_z040y321n_chab_hr_stelib_ssp.ised
			files(16) = 'cb2019_z060_chab_hr_stelib_ssp.ised' 	! = cb2013_s2_z060y356n_chab_hr_stelib_ssp.ised
			bcopt     = 4
		elseif (index(files(1),'_xmilesi_') > 1) then
			files( 1) = 'cb2019_z0000_chab_hr_xmilesi_ssp.ised'	! = cb2013_s2_z0000y230n_chab_hr_xmilesi_ssp.ised
			files( 2) = 'cb2019_z0001_chab_hr_xmilesi_ssp.ised'	! = cb2013_s2_z0001y249n_chab_hr_xmilesi_ssp.ised
			files( 3) = 'cb2019_z0002_chab_hr_xmilesi_ssp.ised'	! = cb2013_s2_z0002y249n_chab_hr_xmilesi_ssp.ised
			files( 4) = 'cb2019_z0005_chab_hr_xmilesi_ssp.ised'	! = cb2013_s2_z0005y249n_chab_hr_xmilesi_ssp.ised
			files( 5) = 'cb2019_z001_chab_hr_xmilesi_ssp.ised' 	! = cb2013_s2_z001y250n_chab_hr_xmilesi_ssp.ised
			files( 6) = 'cb2019_z002_chab_hr_xmilesi_ssp.ised' 	! = cb2013_s2_z002y252n_chab_hr_xmilesi_ssp.ised
			files( 7) = 'cb2019_z004_chab_hr_xmilesi_ssp.ised' 	! = cb2013_s2_z004y256n_chab_hr_xmilesi_ssp.ised
			files( 8) = 'cb2019_z006_chab_hr_xmilesi_ssp.ised' 	! = cb2013_s2_z006y259n_chab_hr_xmilesi_ssp.ised
			files( 9) = 'cb2019_z008_chab_hr_xmilesi_ssp.ised' 	! = cb2013_s2_z008y263n_chab_hr_xmilesi_ssp.ised
			files(10) = 'cb2019_z010_chab_hr_xmilesi_ssp.ised' 	! = cb2013_s2_z010y267n_chab_hr_xmilesi_ssp.ised
			files(11) = 'cb2019_z014_chab_hr_xmilesi_ssp.ised' 	! = cb2013_s2_z014y273n_chab_hr_xmilesi_ssp.ised
			files(12) = 'cb2019_z017_chab_hr_xmilesi_ssp.ised' 	! = cb2013_s2_z017y279n_chab_hr_xmilesi_ssp.ised
			files(13) = 'cb2019_z020_chab_hr_xmilesi_ssp.ised' 	! = cb2013_s2_z020y284n_chab_hr_xmilesi_ssp.ised
			files(14) = 'cb2019_z030_chab_hr_xmilesi_ssp.ised' 	! = cb2013_s2_z030y302n_chab_hr_xmilesi_ssp.ised
			files(15) = 'cb2019_z040_chab_hr_xmilesi_ssp.ised' 	! = cb2013_s2_z040y321n_chab_hr_xmilesi_ssp.ised
			files(16) = 'cb2019_z060_chab_hr_xmilesi_ssp.ised' 	! = cb2013_s2_z060y356n_chab_hr_xmilesi_ssp.ised
			!files( 1) = 'cb2019_z0000_salp_hr_xmilesi_ssp.ised'
			!files( 2) = 'cb2019_z0001_salp_hr_xmilesi_ssp.ised'
			!files( 3) = 'cb2019_z0002_salp_hr_xmilesi_ssp.ised'
			!files( 4) = 'cb2019_z0005_salp_hr_xmilesi_ssp.ised'
			!files( 5) = 'cb2019_z001_salp_hr_xmilesi_ssp.ised'
			!files( 6) = 'cb2019_z002_salp_hr_xmilesi_ssp.ised'
			!files( 7) = 'cb2019_z004_salp_hr_xmilesi_ssp.ised'
			!files( 8) = 'cb2019_z006_salp_hr_xmilesi_ssp.ised'
			!files( 9) = 'cb2019_z008_salp_hr_xmilesi_ssp.ised'
			!files(10) = 'cb2019_z010_salp_hr_xmilesi_ssp.ised'
			!files(11) = 'cb2019_z014_salp_hr_xmilesi_ssp.ised'
			!files(12) = 'cb2019_z017_salp_hr_xmilesi_ssp.ised'
			!files(13) = 'cb2019_z020_salp_hr_xmilesi_ssp.ised'
			!files(14) = 'cb2019_z030_salp_hr_xmilesi_ssp.ised'
			!files(15) = 'cb2019_z040_salp_hr_xmilesi_ssp.ised'
			!files(16) = 'cb2019_z060_salp_hr_xmilesi_ssp.ised'
			bcopt     = 5
		elseif (index(files(1),'_mastar_') > 1) then
			files( 1) = 'cb2019_z0000_chab_hrx_mastar_ssp.ised'
			files( 2) = 'cb2019_z0001_chab_hrx_mastar_ssp.ised'
			files( 3) = 'cb2019_z0002_chab_hrx_mastar_ssp.ised'
			files( 4) = 'cb2019_z0005_chab_hrx_mastar_ssp.ised'
			files( 5) = 'cb2019_z001_chab_hrx_mastar_ssp.ised'
			files( 6) = 'cb2019_z002_chab_hrx_mastar_ssp.ised'
			files( 7) = 'cb2019_z004_chab_hrx_mastar_ssp.ised'
			files( 8) = 'cb2019_z006_chab_hrx_mastar_ssp.ised'
			files( 9) = 'cb2019_z008_chab_hrx_mastar_ssp.ised'
			files(10) = 'cb2019_z010_chab_hrx_mastar_ssp.ised'
			files(11) = 'cb2019_z014_chab_hrx_mastar_ssp.ised'
			files(12) = 'cb2019_z017_chab_hrx_mastar_ssp.ised'
			files(13) = 'cb2019_z020_chab_hrx_mastar_ssp.ised'
			files(14) = 'cb2019_z030_chab_hrx_mastar_ssp.ised'
			files(15) = 'cb2019_z040_chab_hrx_mastar_ssp.ised'
			files(16) = 'cb2019_z060_chab_hrx_mastar_ssp.ised'
			bcopt     = 6
		else
			write (6,*) 'Unknown series of models: ',files(1)(:largo(files(1)))
			stop
		endif
	else
		write (6,*) 'Unknown model set:',bcopt
		stop
	endif

!	Express Z's in solar units
	if (z < 0.) then
		! If z is negative it needs to be expressed in solar units
		zs = -z
		z  = -z/zsun
	else
		zs = z*zsun
	endif
	do i=1,nmod
	zx(i)=zmod(i)/zsun
	if (z == zx(i)) then
		name = files(i)
!		write (501,*) 1.
!		write (501,*) name(:largo(name))
!		write (501,*) 0.
!		write (501,*) 'empty'
		call s500('f','',1.)
		call s500('a',name(:largo(name)),0.)
		call s500('f','',0.)
		call s500('a','empty',0.)
		return
	endif
	enddo

!	Check extreme values
	if ( z <= zx(1) ) then
		name = files(1)
!		write (501,*) 1.
!		write (501,*) name(:largo(name))
!		write (501,*) 0.
!		write (501,*) 'empty'
		call s500('f','',1.)
		call s500('a',name(:largo(name)),0.)
		call s500('f','',0.)
		call s500('a','empty',0.)
		return
	elseif ( z >= zx(nmod) ) then
		name = files(nmod)
!		write (501,*) 1.
!		write (501,*) name(:largo(name))
!		write (501,*) 0.
!		write (501,*) 'empty'
		call s500('f','',1.)
		call s500('a',name(:largo(name)),0.)
		call s500('f','',0.)
		call s500('a','empty',0.)
		return
	endif

!	Find bracketing Z's
	do i=1,nmod-1
	if ( z > zx(i) .and. z <= zx(i+1) ) then
		write (6,*) 'Using z:',i,z,zx(i),zx(i+1)
		z1 = alog10(zx(i))
		z2 = alog10(zx(i+1))
		zo = alog10(z)
		w1 = (z2-zo)/(z2-z1)
		w2 = 1. - w1
		i1 = i
		i2 = i+1
!		write (501,*) w1
!		write (501,*) files(i1)(:largo(files(i1)))
!		write (501,*) w2
!		write (501,*) files(i2)(:largo(files(i2)))
		call s500('f','',w1)
		call s500('a',files(i1)(:largo(files(i1))),0.)
		call s500('f','',w2)
		call s500('a',files(i2)(:largo(files(i2))),0.)
	endif
	enddo

!	Build filename of temporary .ised file
	if (bcopt == 1) then
		name = 'bc2003_Zxxxx_chab_hr_stelib_ssp.ised'
	elseif (bcopt == 2) then
		name = 'bc2003_Zxxxx_chab_hr_xmilesi_ssp.ised'
	elseif (bcopt == 3) then
		name = 'bc2003_Zxxxx_chab_hrx_mastar_ssp.ised'
	elseif (bcopt == 4) then
		name = 'cb2019_Zxxxx_chab_hr_stelib_ssp.ised'
	elseif (bcopt == 5) then
		name = 'cb2019_Zxxxx_chab_hr_xmilesi_ssp.ised'
	elseif (bcopt == 6) then
		name = 'cb2019_Zxxxx_chab_hrx_mastar_ssp.ised'
	else
		write (6,*) 'Stopping on bcopt =',bcopt
	endif
	!all gen_file_name(name,z*zsun,idth)
	call gen_file_name(name,zs,idth)
	write (6,*) 'Opening output file: ',trim(name)
	open  (3,file=name,form='unformatted',status='unknown')

!	Perform interpolation
	write (6,*) 'Reading file: ',files(i1)
	open  (1,file=files(i1),form='unformatted',status='old')
!	Read basic parameters from SSP file
	read  (1) nsteps,(tb(i),i=0,nsteps-1),ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,jo,tauo,id,tcut,ttt,ttt,ttt,id,id,igw,stelib
!	Modify id record
	i=index(id,'X=')
	write (id(i:),'(a,f6.3)') 'SSP interpolated to Z/Zo = ',z
	write (3) nsteps,(tb(i),i=0,nsteps-1),ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,jo,tauo,id,tcut,ttt,ttt,ttt,id,id,igw,stelib
	read  (1) inl,(w(i),i=1,inl)
	write (3) inl,(w(i),i=1,inl)
	write (6,*) 'Reading file: ',files(i2)
	write (6,*) 'Weights =',w1,w2
	write (6,*) 'Writing file: ',name(:largo(name))
	open  (2,file=files(i2),form='unformatted',status='old')
!	Read basic parameters from SSP file
	read  (2)
	read  (2)
	do n=0,nsteps-1
	read  (1) inl,(w(i),i=1,inl)
	read  (2) inl,(h(i),i=1,inl)
	write (3) inl,(w1*w(i)+w2*h(i),i=1,inl)
	enddo
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
	read  (1,end=1) nsteps,(w(i),i=1,nsteps)
	read  (2,end=1) nsteps,(h(i),i=1,nsteps)
	write (3)       nsteps,(w1*w(i)+w2*h(i),i=1,nsteps)
1	close (1)
	close (2)
	close (3)
	return
	end

	subroutine gen_file_name(name,z,idth)

!	Generates unique and new output file name 

	character*(*) name,aux*4		! ,bux*128

	! i = index(name,'mxx')+3
	! write (bux,'(a,i2,a)') '_t',idth,'_' // name(i+1:largo(name))
	! if (bux(3:3) == ' ') bux(3:3) = '0'
	! do j=0,10000
	! write (aux,'(a,i5)') 'Z',int(z*10**4)+j
	! do k=1,6
	! if (aux(k:k) == ' ') aux(k:k) ='0'
	! enddo
	i = index(name,'Zxxxx')
	j = 0
	write (aux(1:4),'(i4)') int(z*10**4)
	do k=1,4
	if (aux(k:k) == ' ') aux(k:k) ='0'
	if (aux(k:k) /= '0') j = k
	enddo
	name = name(:i) // aux(:j) // name(i+5:)
	open(99,file=name,status='new',iostat=iopenstatus)
	if (iopenstatus == 0) then
		close (99)
		return
	endif
	return
	end

	Program sun_color

c	Computes color of Kurucz solar spectrum in filter pair (I,J)

	write (6,*) 'Returns color of Kurucz solar spectrum model in a given filter pair'
	write (6,*)

1	write (6,'(x,a,$)') 'Enter filter pair = i,j = '
	read (5,*,end=2,err=1) i,j
	sc=sun_color_n(i,j)
	write (6,100) sc
	goto 1
100	format (35x,'Sun color = ',f8.5/)
2	end

	REAL FUNCTION LINEAR (X0,X,Y,N,I)

!	Interpolates linearly the function y(x) at x=x0.
!	Re written by GBA June 8, 2012

!	Variables
	real x(n),y(n)

!	Several options
	if ( i >= 0 ) then
		i = iplace(x0,x,max0(1,i),n)
	else
		i = -i
	endif
	if ( i == 0 ) then
		linear = 0.
!		linear = -1.e10
!		ierr = linerr(x0,x(1),x(n),n)
	elseif ( x0 == x(n) ) then
		linear = y(n)
	else
		linear = y(i) + (y(i+1)-y(i))*(x0-x(i))/(x(i+1)-x(i))
	endif
	return
	end

	FUNCTION LINERR(X0,X1,XN,N)
!	Reports error in interpolation
	data ierr/0/
	if (ierr.eq.0) then
		ierr=1
		linerr=1
		write (6,'(10x,a)') ' ---------------------------------------------------------------------------------'
		write (6,1) X0,X1,XN,N
		write (6,'(10x,a)') ' ----------- Error reported only once, but it may occur more than once. ----------'
1		format (10x,' --- LINEAR:  X0 = ',1PE10.3,' is outside X range ---',2E10.3,I10)
!		stop
	endif
	return
	end

!      REAL FUNCTION LINEAR (X0,X,Y,N,I0)
!c     INTERPOLATES LINEARLY THE FUNCTION Y(X) AT X=X0.
!      REAL X(N),Y(N)
!	data ierr/0/
!      IF (I0) 21,20,20
!   20 I=IPLACE(X0,X,MAX0(1,I0),N)
!      GOTO 22
!   21 I=-I0
!   22 I0=I
!      IF (I.EQ.0) GOTO 2
!      IF (X0.EQ.X(I).OR.X(I).EQ.X(I+1)) GOTO 1
!      LINEAR=Y(I) + (Y(I+1)-Y(I))*(X0-X(I))/(X(I+1)-X(I))
!      RETURN
!    1 LINEAR=Y(I)
!      RETURN
!    2 if (ierr.eq.0) then
!	ierr=1
!c	write (6,*) 'I,I0 =',i,i0
!	write (6,3) X0,X(1),X(N),N
!	write (6,*) '---   Error reported only once. It may occur more than once. ---'
!      endif
!    3 FORMAT (' --- LINEAR:  X0 = ',1PE10.3,' is outside X range ---',2E10.3,I10)
!      LINEAR=0.
!      RETURN
!      END

	SUBROUTINE NREAD(X,NA,*,*)

c	This routine is useful when reading several parameters separated by
c	commas (not supported by current version of f77 in Sun 4/110).

c	Returns NA arguments in array X (read from the screen).
c	RETURN 1: Statement to execute if error while reading.
c	RETURN 2: Statement to execute if EOF detected.

	parameter (npar=24)
	character b*132
	real x(npar)

c	Clear buffer
	do i=1,npar
	x(i)=0.
	enddo

c	Read string b
	read (5,'(a)',end=2) b

c	Number of characters read into b
c	na=index(b,' ')-1
	na=largo(b)
	if (na.eq.0) return

c	Adds "," at the end of string b to guarantee extraction of last value
	b(na+1:na+1)=','

c	Extract numbers from b
	n=0
	l1=0
	do i=1,100
	l1=l1+n+1
	n=index(b(l1:),',')-1
	if (n.eq.0) then
		x(i)=0.
	elseif (n.gt.0) then
      		read(b(l1:l1+n-1),'(G132.0)',err=1) x(i)
	else
		na=i-1
		return
	endif
	enddo
1	return 1
2	return 2

	ENTRY QREAD(V,K,*,*)

c	Emulates q format of VMS/Fortran

c	V = required value
c	K = number of characters typed
c	RETURN 1: Statement to execute if error while reading.
c	RETURN 2: Statement to execute if EOF detected.

c	Read string b and assign value to v
	read (5,'(a)',end=4) b
c	k = index(b,' ') - 1
	k=largo(b)
	v=0.
	if (k.gt.0) then
      		read(b(:k),'(G132.0)',err=3) v
	endif
	return
3	return 1
4	return 2
	end

	SUBROUTINE CONVOLVE_TX(Y,AGE,BOL,STR,EVF,SNR,PNR,BH,SN,WD,RM,GS,GL,DR,DP)

!	Modified by G. Bruzual on 01-Aug-2013
!	In this version of the routine the AGE in yr is entered in the arguments
!	The values of IC is found below

c	Written by G. Bruzual on 25-March-1999

c	Uses different approach from previous versions. The SFR is
c	used as given (from t=0 to t=age) and the SSP spectra are
c	interpolated at required age. This allows for arbitrarily
c	short bursts to be described correctly.

c	Computes sed at age tb(k) by performing convolution integral
c	of the sed for a SSP and the chosen SFR using trapezoidal rule

c	Convolution integral according to trapezoidal rule

c	BOL = convolved bolometric flux at age tb(k)
c	STR = convolved total mass in stars at age tb(k)
c	EVF = convolved evolutionary flux at age tb(k)
c	SNR = convolved Super Nova rate at age tb(k)
c	PNR = convolved PN birth rate at age tb(k)
c	BH  = convolved total number of BH at age tb(k)
c	SN  = convolved total number of NS at age tb(k)
c	WD  = convolved total number of WD at age tb(k)
c	RM  = convolved total mass in Remnants at age tb(k)

c	Array declaration
	include 'jb.dec'
	include 'csp.dec'
	real y(imw),taux(1000000)
	real fxu(0:jts),fxb(0:jts),fxi(0:jts),fxk(0:jts)
	real ufwa,bfwa,ifwa,kfwa,mwa,ufwla,bfwla,ifwla,kfwla,mwla
	common /w_ages/ fxu,fxb,fxi,fxk,ufwa,bfwa,ifwa,kfwa,mwa,ufwla,bfwla,ifwla,kfwla,mwla

c	Modified by G. Bruzual on 24/9/93 to include common /totgas/ where
c	the total mass in gas (new + recycled) vs time is stored. This
c	quantity is used in models with SFR which recycles gas.
	include 'recycle.dec'

c	Clear buffers
	bol=0.
	str=0.
	evf=0.
	snr=0.
	pnr=0.
	bh=0.
	sn=0.
	wd=0.
	rm=0.
	gs=0.
	gl=0.
	ufwa=0.
	bfwa=0.
	ifwa=0.
	kfwa=0.
	mwa=0.
	duwa=0.
	dbwa=0.
	diwa=0.
	dkwa=0.
	dmwa=0.
	do j=1,inw
	y(j)=0.
	enddo

c	Build time scale for accurate integration
	kt=0
!	age=tb(ic)		! age entered as a calling argument
!	Find corresponding value of ic
	ic=0
	do while (tb(ic) < age)
	ic=ic+1
	enddo
!	Preform convolution integral at t=age
	do k=0,ic
	kt=kt+1
	taux(kt)=max(0.,age-tb(k))
	kt=kt+1
	taux(kt)=tb(k)
	enddo
c	Add more time steps under option 7 (user sfr entered in table)
	if (io.eq.7) then
		do i=1,isfrc
		if (age.ge.time(i)) then
			kt=kt+1
			taux(kt)=age-time(i)
		endif
		kt=kt+1
		taux(kt)=time(i)
		enddo
	endif
c       Add more steps if tcut.lt.20.E9
	if (age.gt.tcut.and.tcut.lt.20.E9) then
		do k=0,ic
		if (tb(k).le.tcut) last=k
		enddo
		tlast=tb(last)
		tnext=tb(last+1)
        	dt=0.0005*tcut
        	do i=1,100000
	        tlast=tlast+dt
		if (tlast.gt.tnext) goto 2
		kt=kt+1
		taux(kt)=age-tlast
		kt=kt+1
		taux(kt)=tlast
		enddo
	endif
2	call sort(kt,taux)
c	Suppress duplicate entries below tb(ic)
	kn=1
	do k=2,kt
	if (taux(k).le.tb(ic).and.taux(k).gt.taux(k-1)) then
		kn=kn+1
		taux(kn)=taux(k)
	endif
	enddo
	if (kn.eq.1) return
c	Suppress duplicate entries
	call usort(kn,taux)
c	Write in reverse order
	call xreverse(taux,kn)

c	Compute weights to assign to each sed and compute convolution integral
c	do k=0,ic
	do k=1,kn
c	sr=sfr(tb(k))
	sr=sfr(max(0.,age-taux(k)))
	if (sr.gt.0.) then
		if (k.eq.1) then
c			dt=tb(k+1)-tb(k)
			dt=taux(1)-taux(2)
		elseif (k.eq.kn) then
c			dt=tb(ic)-tb(ic-1)
			dt=taux(kn-1)-taux(kn)
		else
c			dt=tb(k+1)-tb(k-1)
			dt=taux(k-1)-taux(k+1)
		endif
		w=sr*dt/2.
		if (io.eq.0) w=1.
c		tx=age-tb(k)
		tx=taux(k)
		do j1=0,ic
		if (tx.eq.tb(j1)) then
c			Used sed and other quantities at tx = age-tb(k)
			do m=1,inw
			y(m)=y(m)+w*fl(m,j1)
			enddo
			bol=bol+w*bflx(j1)
			str=str+w*strm(j1)
			evf=evf+w*evfl(j1)
			snr=snr+w*snbr(j1)
			pnr=pnr+w*pnbr(j1)
			sn =sn +w*sntn(j1)
			bh =bh +w*bhtn(j1)
			wd =wd +w*wdtn(j1)
			rm =rm +w*rmtm(j1)
			gs =gs +w*gasms(j1)
			gl =gl +w*galms(j1)
			ufwa = ufwa + w*fxu(j1)*tb(j1)
			bfwa = bfwa + w*fxb(j1)*tb(j1)
			ifwa = ifwa + w*fxi(j1)*tb(j1)
			kfwa = kfwa + w*fxk(j1)*tb(j1)
			mwa  = mwa  + w*tb(j1)
			duwa = duwa + w*fxu(j1)
			dbwa = dbwa + w*fxb(j1)
			diwa = diwa + w*fxi(j1)
			dkwa = dkwa + w*fxk(j1)
			dmwa = dmwa + w
			goto 1
		endif
		if (tx.ge.tb(j1).and.tx.lt.tb(j1+1)) then
			j2=j1+1
			if (tb(j1).gt.0.) then
				a=alog10(tx/tb(j1))/alog10(tb(j2)/tb(j1))
			else
				a=tx/tb(j2)
			endif
			b=1.-a
			wa=w*a
			wb=w*b
c			Interpolate sed and other quantities at tx = age-tb(k)
			do m=1,inw
			y(m)=y(m)+wb*fl(m,j1)+wa*fl(m,j2)
			enddo
			bol=bol+wb*bflx(j1)+wa*bflx(j2)
			str=str+wb*strm(j1)+wa*strm(j2)
			evf=evf+wb*evfl(j1)+wa*evfl(j2)
			snr=snr+wb*snbr(j1)+wa*snbr(j2)
			pnr=pnr+wb*pnbr(j1)+wa*pnbr(j2)
			sn =sn +wb*sntn(j1)+wa*sntn(j2)
			bh =bh +wb*bhtn(j1)+wa*bhtn(j2)
			wd =wd +wb*wdtn(j1)+wa*wdtn(j2)
			rm =rm +wb*rmtm(j1)+wa*rmtm(j2)
			gs =gs +wb*gasms(j1)+wa*gasms(j2)
			gl =gl +wb*galms(j1)+wa*galms(j2)
			ufwa = ufwa + wb*fxu(j1)*tb(j1) + wa*fxu(j2)*tb(j2)
			bfwa = bfwa + wb*fxb(j1)*tb(j1) + wa*fxb(j2)*tb(j2)
			ifwa = ifwa + wb*fxi(j1)*tb(j1) + wa*fxi(j2)*tb(j2)
			kfwa = kfwa + wb*fxk(j1)*tb(j1) + wa*fxk(j2)*tb(j2)
			mwa  = mwa  + wb*tb(j1)         + wa*tb(j2)
			duwa = duwa + wb*fxu(j1)        + wa*fxu(j2)        
			dbwa = dbwa + wb*fxb(j1)        + wa*fxb(j2)        
			diwa = diwa + wb*fxi(j1)        + wa*fxi(j2)        
			dkwa = dkwa + wb*fxk(j1)        + wa*fxk(j2)        
			dmwa = dmwa + wb                + wa
			goto 1
		endif
		enddo
		write (6,*) 'Problem interpolating tx,j1 = ',tx,j1
		stop
	endif
1	continue
	enddo

c	Compute flux weighted age returned in common
	ufwa = ufwa/duwa
	bfwa = bfwa/dbwa
	ifwa = ifwa/diwa
	kfwa = kfwa/dkwa
	mwa  = mwa /dmwa

c	Store amount of processed gas
	if (io.eq.1) then
		str=amin1(1.,str)
c		unprocessed gas so far
		ugas=exp(-age/tau)
c		processed gas = gas formed into stars - mass in stars - remnants
		prgas = 1. - ugas - str - rm
		if (prgas.lt.0.) prgas=0.
c		lgas=ic+1
		lgas=lgas+1
		so(lgas)=prgas
		to(lgas)=age
	endif
	return
	end

	SUBROUTINE FILE_W_AGES(IO,NAME,Z,T,X,Y,N,UFWA,GFWA,RFWA,IFWA,ZFWA,KFWA,MWA,UFWLA,GFWLA,RFWLA,IFWLA,ZFWLA,KFWLA,MWLA)

c	Open file to write flux weighted age

c	Variables
	character*(*) name		!	,aux*10
	real x(n),y(n),ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,mwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwla
	data ifile/0/

c	Check kind of CSP
	if (io <= 0) then
		ifile=0
		close (2002)
		return
	endif

c	Check first time step
	if (t <= 0) then
		! ifile=0
		return
	endif

c	Build file name
	if (ifile == 0) then
c		Modify filename if z > 0.
		if (z > 0) then
			name = trim(name) // '.w_age_of'
		else
			name = trim(name) // '.w_age_rf'
		endif
		open (2002,file=name,form='formatted')
		call file_header(2002,name,0)
		write (2002,'(a)') '#            <---- z = 0 ---->  <---------------------------------------------------------------- computed after red shifting sed''s --------------------------------------------------------------------->'
		write (2002,'(a)') '# log t(yr)  B4000_N  Hdelta_A   MWA (yr)    uFWA(yr)    gFWA(yr)    rFWA(yr)    iFWA(yr)    zFWA(yr)    KFWA(yr)    MWLA(yr)  uFWLA(yr)  gFWLA(yr)  rFWLA(yr)  iFWLA(yr)  zFWLA(yr)  KFWLA(yr)      z'
		write (2002,'(a)') '#   (1)        (2)       (3)       (4)         (5)         (6)         (7)         (8)         (9)        (10)         (11)       (12)       (13)       (14)       (15)       (16)       (17)       (18)'
		ifile=1
		return
	endif

c	Compute B_4000 and Hdelta_A
        b4=b4000vn(x,y,n)
        hd=gw_ix_sed(22,x,y,n,0)

c	Report flux and mass weighted age for the composite population
	tl=alog10(t)
        write (2002,100) tl,b4,hd,mwa,ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,mwla,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,z
100    	format (f10.6,2f10.5,1p7e12.4,0p8f11.5)
	return
	end

	SUBROUTINE ke_2filt_correction(kf,x,y,n,z,h0,q0,lun,imag)

c	Compute k and e correction in filter NF

c	Array declarations
	include 'filter.dec'
	include 'cosmo.dec'
	include 'SSP_0.dec'
	integer kf(2)
	real k1_corr_z,k1_ABcorr_z,k2_corr_z,k2_ABcorr_z,k12_corr_0,k12_ABcorr_0
	real k1_corr_0,k1_ABcorr_0,k2_corr_0,k2_ABcorr_0,k12_corr_z,k12_ABcorr_z
	real x(n),y(n),y0(imw)
	data icall/0/
	save f1,f2,y0

c	Report cosmology, selected filters, etc.
	if (icall.eq.0) then
		icall=1
		write (lun,100) h,omega,omega_lambda,q,clambda,tu,ttg,zf
		call meaning(1,lun,kf(1))
		write (lun,'(a,19x,2(3x,4i9),3x,3i9)') '# Filter:',(kf(1),i=1,11)
		write (lun,101)
		write (lun,102)
		write (lun,103)
		if (imag.eq.2) then
			write (lun+1,100) h,omega,omega_lambda,q,clambda,tu,ttg,zf
			call meaning(1,lun+1,kf(2))
       			write (lun+1,'(a,19x,2(3x,4i9),3x,3i9)') '# Filter:',(kf(2),i=1,11)
			write (lun+1,101)
			write (lun+1,102)
			write (lun+1,103)

			write (lun+2,100) h,omega,omega_lambda,q,clambda,tu,ttg,zf
			call meaning(2,lun+2,kf(2))
			write (lun+2,107) '# Filters:',(kf(1),kf(2),i=1,9)
			write (lun+2,104)
			write (lun+2,105)
			write (lun+2,106)
		endif
100     format ('# Cosmology: Ho = ',f4.0,2x,'Omega =',f5.2,2x,'Omega_lambda =',f5.2,2x,'qo = ',f7.4,2x,
     *          'Lambda =',1pE10.3,2x,'tu = ',0pf5.2,' Gyr',2x,'tg = ',f5.2,' Gyr', 2x,' zf = ',f6.2/'#')
101	format ('#  z      LTT     tz      dm         M_rf     M_ne     M_ev     m_ev',
     *          '      M_AB_rf  M_AB_ne  M_AB_ev  m_AB_ev     e+k_cor  k_cor_ev k_cor_ne')
102	format ('#         Gyr     Gyr     mag        mag      mag      mag      mag',
     *          '        AB_mag   AB_mag   AB_mag   AB_mag       mag      mag      mag')
103	format ('# (1)     (2)     (3)     (4)        (5)      (6)      (7)      (8)',
     *          '         (9)      (10)     (11)     (12)        (13)     (14)     (15)')
104	format ('#  z      LTT     tz      dm         C_rf     C_ne     C_ev',
     *          '      C_AB_rf  C_AB_ne  C_AB_ev     e+k_cor  k_cor_ev k_cor_ne')
105	format ('#         Gyr     Gyr     mag        mag      mag      mag',
     *          '        AB_mag   AB_mag   AB_mag       mag      mag      mag')
106	format ('# (1)     (2)     (3)     (4)        (5)      (6)      (7)',
     *          '         (8)      (9)      (10)        (11)     (12)     (13)')
107	format (a,23x,3(2x,i3,'-',i3),3x,3(2x,i3,'-',i3),3x,3(2x,i3,'-',i3))
	endif

c	Compute cosmological distance modulus.
	dm=dismod(h0,q0,z)

c	Compute light travel time from z=0 to z
	tl=tu-t(h0,q0,z,clambda)
	tz=ttg-tl

c	If z=0, store sed to compute e+k and k-corrections
	if (z.eq.0.) then
		do i=1,n
		y0(i)=y(i)
		enddo
c		Compute zero points in filters kf(1) and kf(2) in the Vega system
		f1=vega_0p_n(kf(1))
		if (imag.eq.2) f2=vega_0p_n(kf(2))
	endif

c	Compute absolute magnitude in filter kf(1) (Vega system)
	f1_ev   = f1 - 2.5*alog10(filter_n(kf(1),x,y ,n,z,kerr))
	f1_rf   = f1 - 2.5*alog10(filter_n(kf(1),x,y ,n,0.,kerr))
	f1_ne   = f1 - 2.5*alog10(filter_n(kf(1),x,y0,n,z,kerr))
	f1_ne_0 = f1 - 2.5*alog10(filter_n(kf(1),x,y0,n,0.,kerr))
	f1_ev_0 = f1_rf

c	Compute absolute AB magnituds in filter kf(1)
	ABf1_ev   = AB_mag(kf(1),x,y ,n,z)
	ABf1_rf   = AB_mag(kf(1),x,y ,n,0.)
	ABf1_ne   = AB_mag(kf(1),x,y0,n,z)
	ABf1_ne_0 = AB_mag(kf(1),x,y0,n,0.)
	ABf1_ev_0 = ABf1_rf

c	Compute apparent magnitude
	f1mag    = f1_ev   + dm
	f1magAB  = ABf1_ev + dm

c	Compute k-correction
c	   For z=0 sed
	      k1_corr_0   = f1_ne   - f1_ne_0
	      k1_ABcorr_0 = ABf1_ne - ABf1_ne_0
c	   For evolved sed
	      k1_corr_z   = f1_ev   - f1_rf
	      k1_ABcorr_z = ABf1_ev - ABf1_rf

c	Compute (e+k)-correction
	ek1_corr   = f1_ev   - f1_ne_0
	ek1_ABcorr = ABf1_ev - ABf1_ne_0

c	Verify if second filter has been entered
	if (imag.eq.2) then
c		Compute absolute magnitude in filter kf(2) (Vega system)
		f2_ev   = f2 - 2.5*alog10(filter_n(kf(2),x,y ,n,z,kerr))
		f2_rf   = f2 - 2.5*alog10(filter_n(kf(2),x,y ,n,0.,kerr))
		f2_ne   = f2 - 2.5*alog10(filter_n(kf(2),x,y0,n,z,kerr))
		f2_ne_0 = f2 - 2.5*alog10(filter_n(kf(2),x,y0,n,0.,kerr))
		f2_ev_0 = f2_rf

c		Compute absolute AB magnituds in filter kf(2)
		ABf2_ev   = AB_mag(kf(2),x,y ,n,z)
		ABf2_rf   = AB_mag(kf(2),x,y ,n,0.)
		ABf2_ne   = AB_mag(kf(2),x,y0,n,z)
		ABf2_ne_0 = AB_mag(kf(2),x,y0,n,0.)
		ABf2_ev_0 = ABf2_rf

c		Compute apparent magnitude
		f2mag    = f2_ev   + dm
		f2magAB  = ABf2_ev + dm
	
c		Compute k-correction
c		   For z=0 sed
		      k2_corr_0   = f2_ne   - f2_ne_0
		      k2_ABcorr_0 = ABf2_ne - ABf2_ne_0
c		   For evolved sed
		      k2_corr_z   = f2_ev   - f2_rf
		      k2_ABcorr_z = ABf2_ev - ABf2_rf

c		Compute (e+k)-correction
		ek2_corr   = f2_ev   - f2_ne_0
		ek2_ABcorr = ABf2_ev - ABf2_ne_0

c		Compute color kf(1) - kf(2) in Vega system
		c12_ev   = f1_ev   - f2_ev
		c12_rf   = f1_rf   - f2_rf
		c12_ne   = f1_ne   - f2_ne
		c12_ne_0 = f1_ne_0 - f2_ne_0
		c12_ev_0 = f1_ev_0 - f2_ev_0

c		Compute color kf(1) - kf(2) in AB system
		ABc12_ev   = ABf1_ev   - ABf2_ev
		ABc12_rf   = ABf1_rf   - ABf2_rf
		ABc12_ne   = ABf1_ne   - ABf2_ne
		ABc12_ne_0 = ABf1_ne_0 - ABf2_ne_0
		ABc12_ev_0 = ABf1_ev_0 - ABf2_ev_0

c		Compute color k-correction
		k12_corr_0   = c12_ne   - c12_ne_0
		k12_corr_z   = c12_ev   - c12_ev_0
		k12_ABcorr_0 = ABc12_ne - ABc12_ne_0
		k12_ABcorr_z = ABc12_ev - ABc12_ev_0

c		Compute color (e+k)-corrections
		ek12_corr   = c12_ev   - c12_ne_0
		ek12_ABcorr = ABc12_ev - ABc12_ne_0
	endif

c	Write results
	if (z.eq.0.) then
		write (lun,108) z,tl,tz,dm,f1_rf,f1_ne,f1_ev,f1mag,
     *                          ABf1_rf,ABf1_ne,ABf1_ev,f1magAB,ek1_ABcorr,k1_ABcorr_z,k1_ABcorr_0
		if (imag.eq.2) then
			write (lun+1,108) z,tl,tz,dm,f2_rf,f2_ne,f2_ev,f2mag,
     *                          ABf2_rf,ABf2_ne,ABf2_ev,f2magAB,ek2_ABcorr,k2_ABcorr_z,k2_ABcorr_0
			write (lun+2,109) z,tl,tz,dm,c12_rf,c12_ne,c12_ev,
     *                          ABc12_rf,ABc12_ne,ABc12_ev,ek12_ABcorr,k12_ABcorr_z,k12_ABcorr_0
		endif
	else
		write (lun,110) z,tl,tz,dm,f1_rf,f1_ne,f1_ev,f1mag,
     *                          ABf1_rf,ABf1_ne,ABf1_ev,f1magAB,ek1_ABcorr,k1_ABcorr_z,k1_ABcorr_0
		if (imag.eq.2) then
			write (lun+1,110) z,tl,tz,dm,f2_rf,f2_ne,f2_ev,f2mag,
     *                          ABf2_rf,ABf2_ne,ABf2_ev,f2magAB,ek2_ABcorr,k2_ABcorr_z,k2_ABcorr_0
			write (lun+2,111) z,tl,tz,dm,c12_rf,c12_ne,c12_ev,
     *                          ABc12_rf,ABc12_ne,ABc12_ev,ek12_ABcorr,k12_ABcorr_z,k12_ABcorr_0
		endif
	endif
108	format ('#',f5.3,3f8.3,3x,4f9.4,3x,4f9.4,3x,3f9.4)
109	format ('#',f5.3,3f8.3,3x,3f9.4,3x,3f9.4,3x,3f9.4)
110	format (f6.3,3f8.3,3x,4f9.4,3x,4f9.4,3x,3f9.4)
111	format (f6.3,3f8.3,3x,3f9.4,3x,3f9.4,3x,3f9.4)
	return
	end

	SUBROUTINE MEANING(IFILE,LUN,NF)

c	Prints meaning of different quantities in output files
	if (ifile.eq.1) then
		write (lun,'( a)')     '# Meaning of printed variables (see Tables 5 and 6 of bc03.ps for details):'
		write (lun,'( a)')     '#   z        = redshift (z=0 entry in table corresponds to a distance of 10 pc)'
		write (lun,'( a)')     '#   ltt      = light travel time from z=0 to z in Gyr'
		write (lun,'( a)')     '#   tz       = age of galaxy at redshit = z'
		write (lun,'( a)')     '#   dm       = cosmological distance modulus in magnitude units'
		write (lun,'(a,i3,a)') '#   M_rf     = M_rf(z) in filter ',nf,' (Vega system)'
		write (lun,'(a,i3,a)') '#   M_ne     = M_ne(z) in filter ',nf,' (Vega system)'
		write (lun,'(a,i3,a)') '#   M_ev     = M_ev(z) in filter ',nf,' (Vega system)'
		write (lun,'(a,i3,a)') '#   m_ev     = apparent magnitude M_ev(z) + dm(z) in filter ',nf,' (Vega system)'
		write (lun,'(a,i3,a)') '#   M_AB_rf  = AB M_rf(z) in filter ',nf,' (AB system)'
		write (lun,'(a,i3,a)') '#   M_AB_ne  = AB M_ne(z) in filter ',nf,' (AB system)'
		write (lun,'(a,i3,a)') '#   M_AB_ev  = AB M_ev(z) in filter ',nf,' (AB system)'
		write (lun,'(a,i3,a)') '#   m_AB_ev  = apparent AB magnitude M_ev(z) + dm(z) in filter ',nf,' (AB system)'
		write (lun,'(a,i3,a)') '#   e+k_cor  = (e+k)-correction in filter ',nf
		write (lun,'(a,i3,a)') '#   k_cor_ev = k-correction computed for sed at redshift z in filter ',nf
		write (lun,'(a,i3,a)') '#   k_cor_ne = k-correction computed for sed at redshift 0 in filter ',nf
		write (lun,'( a)')     '#'
	elseif (ifile.eq.2) then
		write (lun,'( a)')     '# Meaning of printed variables (see Tables 5 and 6 of bc03.ps for details):'
		write (lun,'( a)')     '#   z        = redshift (z=0 entry in table corresponds to a distance of 10 pc)'
		write (lun,'( a)')     '#   ltt      = light travel time from z=0 to z in Gyr'
		write (lun,'( a)')     '#   tz       = age of galaxy at redshit = z'
		write (lun,'( a)')     '#   dm       = cosmological distance modulus in magnitude units'
		write (lun,'( a)')     '#   C_rf     = color M1_rf(z) - M2_rf(z) (Vega system)'
		write (lun,'( a)')     '#   C_ne     = color M1_ne(z) - M2_ne(z) (Vega system)'
		write (lun,'( a)')     '#   C_ev     = color M1_ev(z) - M2_ev(z) (Vega system)'
		write (lun,'( a)')     '#   C_AB_rf  = AB color M1_rf(z) - M2_rf(z) (AB system)'
		write (lun,'( a)')     '#   C_AB_ne  = AB color M1_ne(z) - M2_ne(z) (AB system)'
		write (lun,'( a)')     '#   C_AB_ev  = AB color M1_ev(z) - M2_ev(z) (AB system)'
		write (lun,'( a)')     '#   e+k_cor  = color (e+k)-correction'
		write (lun,'(a,i3,a)') '#   k_cor_ev = color k-correction computed for sed at redshift z'
		write (lun,'(a,i3,a)') '#   k_cor_ne = color k-correction computed for sed at redshift 0'
		write (lun,'( a)')     '#'
	endif
	return
	end

	FUNCTION GW_IX_SED(J,X,F,N,IGW)

c	Computes value of Guy Worthey index J directly from sed
c	Follows procedure outlined by Trager at el. (1998, ApJS 116, 1)
c	See their eq. 1-3, pag. 5.

c	See comments at the end of this file.

c	J = Index identification
c	X = wavelength scale
c	F = flux scale (sed)
c	N = dimension of X, F
c	GW_IX = index measured directly from sed (no formula)

c	Array declaration
	parameter (jid=35)
	real x(n),f(n)
	real u(10000),z(10000)
	include 'gwparam.dec'
c	Common to store fluxes
	integer iim(jid)
	real ffb(jid),ffr(jid),ffc(jid),ffl(jid)
	common /fluxes/ iim,ffb,ffr,ffc,ffl

c	Equation of straight line joining (wb,fb) and (wr,fr)
	fc(v) = ( (wr-v)*fb + (v-wb)*fr ) / (wr-wb)

	if (j.eq.31) then
c		Return B4000VN index
		gw_ix_sed = b4000vn(x,f,n)
	elseif (j.eq.30) then
c		Returns Gorgas and Cardiel D4000 index
		gw_ix_sed = gc_d4000_obs(x,f,n)
	elseif (j.eq.35) then
c		Returns Brodie and Hanes HK index
		gw_ix_sed = bh_ix_sed(6,x,f,n)
	else
c		Find wavelength points everytime to allow calls to this routine in
c		the same program using different wavelength arrays.
c		Get Parameters
		if (igw.eq.0) then
			call gw_etal_dat(j)
		else
			call gw_thesis_dat(j)
		endif

c       	Compute mean height inside blue pseudo continuum band
        	fb=trapz3(x,f,n,w(1),w(2),ierr)/(w(2)-w(1))
		if (ierr.ne.0) then
			gw_ix_sed = 999.
			return
		endif
		wb=(w(1)+w(2))/2.
c		write (6,*)  j,wb,fb
c		write (66,*) j,wb,fb

c       	Compute mean height inside red pseudo continuum band
       		fr=trapz3(x,f,n,w(3),w(4),ierr)/(w(4)-w(3))
		if (ierr.ne.0) then
			gw_ix_sed = 888.
			return
		endif
		wr=(w(3)+w(4))/2.
c		write (6,*)  j,wr,fr
c		write (66,*) j,wr,fr

c		Compute equivalent width according to eq. (2) of
c		Trager at el. (1998, ApJS 116, 1)
c       	Locate central band in array x: w(5) and w(6)
        	call locate (x,n,w(5),i1)
        	call locate (x,n,w(6),i2)
c		Fill in auxiliary array from i1-5 to i2+5 with ratio f/fc
		nu=0
		do i=i1-5,i2+5
		nu=nu+1
		u(nu)=x(i)
		z(nu)=f(i)/fc(x(i))
c 		write (6,*)  j,i,nu,u(nu),fc(x(i)),z(nu)
c		write (66,*) j,i,nu,u(nu),fc(x(i)),z(nu)
		enddo
c       	Compute integral of ratio f(i)/fc(x(i)) from w(5) to w(6)
       		fm=trapz3(u,z,nu,w(5),w(6),ierr)
		if (ierr.ne.0) then
			gw_ix_sed = 777.
			return
		endif

c		Compute index
		if (im.eq.0) then
			gw_ix_sed = w(6) - w(5) - fm
		else
			fm=fm / (w(6) - w(5))
			gw_ix_sed = -2.5*alog10(fm)
			fm=fm * (w(6) - w(5))
		endif

c		Store flux values:
		iim(j)=im
		ffb(j)=fb
		ffr(j)=fr
c		Compute central pseudo continuum flux fc = gw_fc
c		according to G Worthey definition
		wc=(w(5)+w(6))/2.
		cc=(wc-wb)/(wr-wb)
		ffc(j)=(1.-cc)*fb + cc*fr
		ffl(j)=trapz3(x,f,n,w(5),w(6),ierr)
c		Implemented by SC 1/10/03: the above appears to
c		correspond to the old Burstein et al.definition
c	        Eqs (2) and (3) of Worthey et al. (1994) do perform
c		the integration. Store equivalent continuum level
c		write (*,*) j,im,ffc(j),ffl(j)/fm
		ffc(j)=ffl(j)/fm
	endif
	return
	end

c	From gustavo@MPA-Garching.MPG.DE Wed Oct  2 16:20:24 2002
c	Date: Thu, 3 Oct 2002 10:12:54 +0200
c	From: Gustavo Bruzual <gustavo@MPA-Garching.MPG.DE>
c	To: bruzual@cida.ve
c	Subject: [charlot@MPA-Garching.MPG.DE: 2 updates]
c	
c	Forwarded message from Stephane Charlot <charlot@MPA-Garching.MPG.DE>
c	
c	Date: Wed, 2 Oct 2002 02:32:22 +0200
c	From: Stephane Charlot <charlot@MPA-Garching.MPG.DE>
c	To: bruzual@cida.ve
c	Subject: 2 updates
c	User-Agent: Mutt/1.2i
c	
c	Hi Gustavo!
c	You must be arriving just about now!
c	I am working on this last analysis about line indices. I realized
c	the fluxes you stored are from the old Burstein definition, while
c	Worthey et al. 1994 (eq. 2-3) do include an integral. Of course
c	we cannot store the integrls, but I stored something which is
c	closer to it than what you had, for the continuum. I attach
c	the updated gw_ix_sed.f routine.
c	I also attach the updated vel_disp.f program, in which I also
c	store these fluxes in .8lsindx_sed_fluxes
c	
c	cheers!!
c	stephane

	FUNCTION LARGO(A)
!	Returns significant length of string a
	character*(*) a
!	largo=index(a,' ')-1
	largo=0
	do i=1,len(a)
	if (a(i:i).ne.' ') largo=i
	enddo
	return
	end
	FUNCTION MARGO(A)
!	Returns max(1,largo(a)) to avoid error in DEC fortran
	character*(*) a
	margo=max(1,largo(a))
	return
	end
	FUNCTION NARGO(A)
!	Returns position where first dot occurs
	character*(*) a
	nargo=largo(a)
	do i=1,nargo
	if (a(i:i).eq.'.') then
		nargo=i-1
		return
	endif
	enddo
	return
	end
	FUNCTION LASTD(A)
!	Returns position of last dot
	character*(*) a
	lastd=0
	lastd=len(a)
	do i=1,len(a)
	if (a(i:i) == '.') lastd=i
	enddo
	return
	end

	FUNCTION FILTER_N(I,X,Y,N,Z,KERR)

!	Use FILTR_MASTER function to compute required quantity

!	Array declaration
	real x(n),y(n)

!	Returns number of photons through Ith filter.
	filter_n = filtr_master(i,x,y,n,z,0,kerr)
	return

	ENTRY FILTER(I,X,Y,N,Z,KERR)
!	Returns total flux through Ith filter.
	filter   = filtr_master(i,x,y,n,z,1,kerr)
	return

	ENTRY F_MEAN(I,X,Y,N,Z,KERR)
!	Returns mean flux >>> (Fnu) <<< in ith filter (/Hz) as required by AB mags
!	Use FILTR_MASTER function to compute required quantity
	f_mean  = filtr_master(i,x,y,n,z,2,kerr)
	return

	ENTRY F_MEANL(I,X,Y,N,Z,KERR)
!	Returns mean flux >>> (Fnu) <<< in ith filter (/A)  as required by ST mags
!	Use FILTR_MASTER function to compute required quantity
	f_meanl = filtr_master(i,x,y,n,z,3,kerr)
	return
	end

	FUNCTION FILTR_MASTER(I,X,Y,N,Z,IK,KERR)

!	Optimized in memory usage by G. Bruzual. 03-NOV-2008, Merida
!	Adapted and revised by G. Bruzual.       11-AUG-2003, Merida
!	Last version written by G. Bruzual.      10-May-1999, Merida
!	Original version written by G. Bruzual.  21-May-1983, Durham

!	Returns number of photons through I filter.
!	The s.e.d. is Y(X) with N data points, assumed flambda vs lambda.
!	Z is the redshift to be applied to the s.e.d.

!	Improved version that samples correctly the s.e.d. and the
!	filter response function at all points available in these arrays.

!	The new version of the F_MEAN routine requires the filter
!	response function to be interpolated at each point in the
!	sed which is not a point in the filter response. All points in
!	the filter response are also used. The format of the binary
!	file was changed to reduce its size. Filters are stored
!	sequentially in r(i,k), k=1 => wavelength, k=2 => response
!	function. Information about starting point and number of
!	points per filter is kept in file, as well as filter id label.

!	For a flat = 1 filter response function, and Y in the standard Lo/A
!	units used by bc_galaxev, the actual number of photons is 1.926E41xfilter_n

	INCLUDE 'filter.dec'
	real x(n),y(n),LINEAR,rfa(naux),rfb(naux)

!	Extract filter I from binary filter file
        if (i <= 0) then
!		Introduced to allow computation of K-correction with routine ~/is/k_correct.f
		filtr_master=1.
                return
	endif

!	Extract Ith filter in position K of filter arrays
	call build_filter_array(i,x,y,n,z,k)

!	Interpolate sed at shifted wavelength of filter
!	Select quantity to compute
	filtr_master=0.
	kerr=0.
	z1=1.+z
	m=0
	l=0
	do j=pos_i(k),pos_f(k)
	m=m+1
	if (ik <= 0) then
		! Compute filter_n = number of photons through filter
		! Compute number of photons, instead of total flux (Fukugita et al. 1996)
		xf(m)=xlam(j)
		rf(m)=z1*xlam(j)*rlam(j)*LINEAR(xf(m),x,y,n,l)

	elseif (ik <= 1) then
		! Compute filter = flux through filter
		xf(m)=xlam(j)
		rf(m)=rlam(j)*LINEAR(xf(m),x,y,n,l)

	elseif (ik <= 2) then
		! Compute f_mean = mean flux Fnu through filter (as required by AB mags)
		! Returns mean flux >>> (Fnu) <<< in ith filter (/Hz)
		! As: f_nu=int(dnu Fnu Rnu/h*nu)/int(dnu Rnu/h*nu)
		! ie: f_nu=int(dlm Flm Rlm lm / c)/int(dlm Rlm/lm)
		xf(m) =xlam(j)*z1	! wavelength in detector''s frame
		rfa(m)=rlam(j)*xf(m)*LINEAR(xlam(j),x,y,n,l)
		rfb(m)=rlam(j)/xf(m)

	elseif (ik <= 3) then
		! Compute f_meanl = mean flux Flambda through filter (as required by ST mags)
		! Returns mean flux >>> (Flambda) <<< in ith filter (/A)
		! As: f_lm=int(dlm Flm Rlm lm/h*c)/int(dlm Rlm lm/h*c)
		! ie: f_lm=int(dlm Flm Rlm lm)/int(dlm Rlm lm)
		xf(m) =xlam(j)*z1	! wavelength in detector''s frame
		rfa(m)=rlam(j)*xf(m)*LINEAR(xlam(j),x,y,n,l)
		rfb(m)=rlam(j)*xf(m)

	else
		write (6,*) 'FILTR_MASTER: unknown option:',ik
		stop
	endif
	enddo

!	Compute integral below filter.
	if (ik <= 1) then
		! Factor (1+z) already included in lambda scale.
		filtr_master=TRAPZ1(xf,rf,m)
		! write (6,*) i,m,xf(1),xf(m),filtr_master
	elseif (ik <= 2) then
		f_mean=TRAPZ1(xf,rfa,m)/TRAPZ1(xf,rfb,m)
		f_mean=f_mean/2.997925e+18		! speed of light in A/sec
!		F(lambda)*dlambda = F[lambda/(1+z)]*dlambda/(1+z)
		f_mean=f_mean/z1
		filtr_master=f_mean
	elseif (ik <= 3) then
		f_meanl=TRAPZ1(xf,rfa,m)/TRAPZ1(xf,rfb,m)
		f_meanl=f_meanl/z1
		filtr_master=f_meanl
	endif

!	Check result
	if (filtr_master <= 0.) then
		kerr=1
!		write (6,*) '--- Negative or zero flux through filter',i,filtr_master,' ---'
		if (ierr(i).eq.0) then
			ierr(i)=1
!			write (6,*) '--- Negative or zero flux through filter',i,filtr_master,' ---'
!			write (6,*) '---   Error reported only once. It may occur more than once. ---'
!			write (6,*) '--- Negative or zero flux through filter',i,filtr_master,' Error reported only once. ---'
      		endif
	endif
	return
	end

	SUBROUTINE BUILD_FILTER_ARRAY(I,X,Y,N,Z,K)

!	Extract filter I from binary filter file and adds points
!	corresponding to wavelength points in sed.

	INCLUDE 'filter.dec'
	real x(n),y(n),linear
        data iread/0/,jread/0/,ireset/1/,zlast/-100./
        data ierr/mxft*0/,zzlast/-100./,nlast/0/

!	Read filter file
	if (iread.eq.0) Call FILTER0

!	Check filter number
	if (i.gt.mxft) then
		write (6,*) 'Filter No.',i,' not available.'
		stop
	endif

!	Check z value
	z1=1.+z
	if (z.ne.zzlast.or.ireset.gt.0.or.n.ne.nlast) then
!		write (6,*)
! 		write (6,*) '--- Reset filter arrays...z,zzlast,ireset,n,nlast =',z,zzlast,ireset,n,nlast
! 		write (6,*) '--- Wavelength array in use: n, w(1), w(n)        =',n,x(1),x(n)
		ireset=0
		zzlast=z
		nlast=n
		nfilt=0
		ntot=0
		pos_i(1)=1
		do k=1,mxft
		ifilt(k)=-10
		ierr(k) =0
		enddo
	endif

!	Extract filter
!	Check if filter has been stored already
	do k=1,nfilt
	if (ifilt(k).eq.i) return
	enddo

!	Extract ith-filter. Shift by (1+z)
	m=0
	do k=ni(i),nl(i)
	m=m+1
	xf(m)=r(k,1)/z1
	rf(m)=r(k,2)
	enddo

!	Add wavelength points in the sed (x,y) in the galaxy restframe
	l=0
	do k=1,n
!	xz=x(k)/z1	! This statement is wrong. x(i) is already in the galaxy rest frame
	xz=x(k)		! This is correct. Emma C. Lake noticed this error in March 2017. !!!!!!!!!!!
	if (xz >= xf(np(i))) then
		goto 1
	elseif (xz >= xf(1)) then
		m=m+1
		xf(m)=xz
!		Interpolate shifted filter at shifted wavelength of sed
		rf(m)=LINEAR(xz,xf,rf,np(i),l)
	endif
	enddo

!	Sort (xf,rf) arrays according to xf
1	call sort2(m,xf,rf)
!	write (6,*) '                      ',m,' total points filters + SED shifted to z =',z
!	write (6,*)
!	write (6,*)   '--- Rebuilding filter array for filter number:',i,nl(i)-ni(i)+1,ni(i),nl(i),m,xf(1),xf(m)

!	Store sorted arrays
	do k=1,m
	ntot=ntot+1
	if (ntot.gt.nbuff) then
		write (6,*) 'STOP. Size of filter buffer exceeded:',ntot,nbuff
		stop
	endif
	xlam(ntot)=xf(k)
	rlam(ntot)=rf(k)
	enddo

!	Store filter No. and ending point in sorted arrays
	nfilt=nfilt+1
	ifilt(nfilt)=i
	pos_f(nfilt)=ntot
	pos_i(nfilt+1)=ntot+1
	k=nfilt
	kt=pos_f(k)-pos_i(k)+1
	if (kt.gt.naux) then
		write (6,*) 'STOP. Size of filter buffer exceeded:',kt,naux
		stop
	endif
!	write (6,'(i2,i4,3i8,3x,a)') nfilt,i,kt,pos_i(k),pos_f(k),(fid(i)(1:57))
	return
	end

	SUBROUTINE FILTER0

!	Reads filter response functions from file FILTERBIN.RES

	INCLUDE 'filter.dec'
	character filtfile*256
	close (81)

!	SUN Unixf77: Get file name from environment variable FILTERS
	call getenv('FILTERS',filtfile)
	open (81,file=filtfile,form='unformatted',status='old')

!	VAX VMS Fortran: Read file assigned to FILTERS
!	open (81,name='FILTERS',form='unformatted',status='old')

	l=largo(filtfile)
	write (6,'(/x,2a)') 'Reading Filter File: ',filtfile(1:l)
!	read (81,err=1) nf,np,r
!	New format
	read (81,err=1) nf,(ni(i),i=1,nf),(nl(i),i=1,nf),(np(i),i=1,nf),
     &		(fid(i),i=0,nf),ltot,(r(i,1),i=1,ltot),(r(i,2),i=1,ltot)
	close (81)
	iread=1
	write (6,'(i4,a,i3,a,$)') nf,' filters defined, out of ',mxft,' maximum'
!'
	write (6,'(x,a)') '    ...done'
	return
1	stop 'Program exits because of error reading file FILTERBIN.RES'
	end

	FUNCTION COLOR_N(I,J,X,Y,N,Z)

!	Uses number of photons inside filter (Fukugita et al. 1996)

!	Returns color for filter pair (I,J) for s.e.d. in (X,Y) with N
!	data points observed at redshift Z. The zeropoint is not added
!	and must be added in the calling program.

	INCLUDE 'filter.dec'
	dimension a(2),iz(2),x(n),y(n)
	iz(1)=i
	iz(2)=j
	do k=1,2
	a(k)=filter_n(iz(k),x,y,n,z,kerr)
	if (a(k).le.0.) goto 1
	enddo
	color_n=-2.5*alog10(a(1)/a(2))
	return
1	color_n=990.
	return
	end

	FUNCTION ZEROP_N(I,J)

!	Uses number of photons inside filter (Fukugita et al. 1996)

!	Returns zeropoint for filter pair (I,J). The A0 V stellar s.e.d.
!	is read from formatted file whose name is A0VSED the first time
!	the function is used.

	INCLUDE 'filter.dec'
	if (jread.eq.0) call readA0V
	zerop_n=-COLOR_N(i,j,xa0v,ya0v,jread,0.)
!	ireset=1
	return
	end

	SUBROUTINE readA0V

!	Reads A0V sed in file A0VSED

	INCLUDE 'filter.dec'
	character sedfile*80
	data xa0v,ya0v,za0v/ma0v*1.,ma0v*1.,ma0v*1./

!	Get file name from environment variable A0VSED
	if (jread.gt.0) return
	call getenv('A0VSED',sedfile)
	open (81,file=sedfile,form='formatted',status='old')
!	write (6,'(/x,2a)') 'Reading A0V Reference SED: ',sedfile(1:largo(sedfile))
	read (81,'(a)',err=3) sedfile
!	write (6,'(x,a)') sedfile (1:78)
	do n=1,10000
	read (81,*,end=1,err=3) xa0v(n),ya0v(n)
	enddo
1	close (81)
	jread=n-1
!	write (6,'(i5,a,$)') jread,' data points'
!	write (6,'(x,a)') '    ...done'
	return
3	stop 'Program exits because of error reading A0 V s.e.d. file'
	end

	FUNCTION VEGA_0P_N(MF)

!	Uses number of photons inside filter (Fukugita et al. 1996)

!	Returns zero point with respect to VEGA sed
!	Vega sed is first expressed in units of Lsun/A, as in the *.ised files
!	The A0 V stellar s.e.d. is read from file A0VSED the first time the function is used.

	INCLUDE 'filter.dec'
	real yaux5(1250)
	data kread5/0/,yaux5/1250*0./

!	Vega apparent V magnitude
	vmag=0.03
!	Vega bolometric correction (old value)
!	bc=-0.1164
!	Vega bolometric correction (from Lang, Astrophysical Data, Table 9.3, p. 118)
	bc=-0.25
!	Vega bolometric magnitude
	vegabol=vmag+bc
!	write (6,*) 'vmag,bc,vegabol =', vmag,bc,vegabol

	if (jread.eq.0) call readA0V

	if (kread5.eq.0) then
		kread5=1
!		Compute total flux below Vega sed
		tot=trapz1(xa0v,ya0v,jread)
!		Desired total flux corresponding to mbol = vegabol in units of Lsun
		stot=10.**(-0.4*(vegabol-4.75))
!		Scale sed to desired stot, final sed in units of Lsun/A as *.ised files
		scl=stot/tot
		do i=1,jread
		yaux5(i)=scl*ya0v(i)
!		write (95,*) xa0v(i),yaux5(i)
		enddo
	endif

!	Compute vega zero for filter mf
	vega_0p_n=2.5*alog10(filter_n(mf,xa0v,yaux5,jread,0.,kerr))
!	write (6,*) 'VEGA in filter',mf,vega_0p_n
!	ireset=1
	return
	end

	FUNCTION VEGA_0P_F(MF)

!	Uses flux through filter MF

!	Returns zero point with respect to VEGA sed
!	Vega sed is first expressed in units of Lsun/A, as in the *.ised files
!	The A0 V stellar s.e.d. is read from file A0VSED the first time the function is used.

	INCLUDE 'filter.dec'
	real yaux5(1250)
	data kread5/0/,yaux5/1250*0./

!	Vega apparent V magnitude
	vmag=0.03
!	Vega bolometric correction (old value)
!	bc=-0.1164
!	Vega bolometric correction (from Lang, Astrophysical Data, Table 9.3, p. 118)
	bc=-0.25
!	Vega bolometric magnitude
	vegabol=vmag+bc
!	write (6,*) 'vmag,bc,vegabol =', vmag,bc,vegabol

	if (jread.eq.0) call readA0V

	if (kread5.eq.0) then
		kread5=1
!		Compute total flux below Vega sed
		tot=trapz1(xa0v,ya0v,jread)
!		Desired total flux corresponding to mbol = vegabol in units of Lsun
		stot=10.**(-0.4*(vegabol-4.75))
!		Scale sed to desired stot, final sed in units of Lsun/A as *.ised files
		scl=stot/tot
		do i=1,jread
		yaux5(i)=scl*ya0v(i)
!		write (95,*) xa0v(i),yaux5(i)
		enddo
	endif

!	Compute vega zero for filter mf
	vega_0p_f=2.5*alog10(filter(mf,xa0v,yaux5,jread,0.,kerr))
!	write (6,*) 'VEGA in filter',mf,vega_0p_n
	ireset=1
	return
	end

	FUNCTION VEGA_ABMAG(MF)

!	Uses number of photons inside filter (Fukugita et al. 1996)

!	Returns ABmag of star Vega in filter MF
!	The A0 V stellar s.e.d. is read from file A0VSED the first time the function is used.
!	Vega sed is first expressed in inits of Lsun/A, as in the *.ised files

	INCLUDE 'filter.dec'
	real yaux5(1250)
	data kread5/0/,yaux5/1250*0./

!	Vega apparent V magnitude
	vmag=0.03
!	Vega bolometric correction (old value)
!	bc=-0.1164
!	Vega bolometric correction (from Lang, Astrophysical Data, Table 9.3, p. 118)
	bc=-0.25
!	Vega bolometric magnitude
	vegabol=vmag+bc
!	write (6,*) 'vmag,bc,vegabol =', vmag,bc,vegabol

	if (jread.eq.0) call readA0V

	if (kread5.eq.0) then
		kread5=1
!		Compute total flux below Vega sed
		tot=trapz1(xa0v,ya0v,jread)
!		Desired total flux corresponding to mbol = vegabol in units of Lsun
		stot=10.**(-0.4*(vegabol-4.75))
!		Scale sed to desired stot, final sed in units of Lsun/A as *.ised files
		scl=stot/tot
		do i=1,jread
		yaux5(i)=scl*ya0v(i)
!		write (95,*) xa0v(i),yaux5(i)
		enddo
	endif

!	Compute vega zero for filter mf
	vega_vega  = vega_mag(mf,xa0v,yaux5,jread,0.)
	vega_abmag =   ab_mag(mf,xa0v,yaux5,jread,0.)
	write (6,*) 'VEGA in filter',mf,vega_vega,vega_abmag
!	ireset=1
	return
	end

	FUNCTION AB_MAG(MF,X,Y,MP,Z)

!	Compute absolute AB magnitude in filter MF (via S. Charlot)

!	Array declarations
	real x(mp),y(mp)

!	dl = 10 pc in units of Mpc
        dl = 1.e-5

!	This factor is SQRT(4*pi*(3.0856E24)^2/Lsun)
        AB0 = 5. * alog10(1.7684e+08 * dl)

!	Compute AB absolute magnitude
        AB_mag = AB0 - 2.5*alog10(f_mean(mf,x,y,mp,z,kerr)) - 48.6

	return
	end

	FUNCTION AB_FLUX(AB_MAG)

	! Returns flux f_mean corresponding to a given AB_mag

	! dl = 10 pc in units of Mpc
	dl = 1.e-5

	! This factor is SQRT(4*pi*(3.0856E24)^2/Lsun)
	AB0 = 5. * alog10(1.7684e+08 * dl)

	! Compute AB_flux = f_mean
	ab_flux = 10.**(-0.40*(AB_mag-AB0+48.6))
	return
	end

!	FUNCTION AB_FLUX(AB_MAG,Z)			! Use version above
!
!	Returns monochromatic flux f_mean corresponding to a given AB_mag in filter MF
!
!	data abc/0./
!	if (abc == 0.) then
!		! dl = 10 pc in units of Mpc
!		dl = 1.e-5
!
!		! This factor is SQRT(4*pi*(3.0856E24)^2/Lsun)
!		AB0 = 5. * alog10(1.7684e+08 * dl)
!		abc = AB0 - 48.6
!	endif
!
!	Compute flux = f_mean
!	! ab_flux = 10.**(-0.40*(AB_mag-AB0+48.6))		! Mean Fnu inside filter weighted by 1/hnu
!	ab_flux = (1.+z)*10.**(-0.40*(AB_mag-ABC))		! Mean Fnu inside filter weighted by 1/hnu
!	ab_flux =        10.**(-0.40*(AB_mag-ABC))		! ojo ojo check if the factor of (1+z) goes here
!	return
!	end

!	FUNCTION AB_FLUX(MF,AB_MAG,Z,XEFF)		! Use version above
!
!	Returns monochromatic flux corresponding to a given AB_mag in filter MF
!
!	dl = 10 pc in units of Mpc
!	dl = 1.e-5
!
!	This factor is SQRT(4*pi*(3.0856E24)^2/Lsun)
!	AB0 = 5. * alog10(1.7684e+08 * dl)
!
!	Compute flux = f_mean
!	fnu = 10.**(-0.40*(AB_mag-AB0+48.6))		! Mean Fnu inside filter weighted by 1/hnu
!
!	Filter area
!	area = areafilt(mf,xeff)/(1.+z)			! Factor (1.+z) added by GBA. May 2016
!
!	Convert to Flambda				! Not clear what this means. See version above.
!	c = 2.99792458E+10				! cm/s
!	f = c*1.E8/xeff**2				! 1/s/A
!	ab_flux = f*fnu					! erg/s/A
!	return
!	end

	FUNCTION VEGA_MAG(MF,X,Y,MP,Z)

!	Compute absolute VEGA magnitude in filter MF

!	Array declarations
	real x(mp),y(mp)
	data v0/0./,vmag/-99./,fv/0./

!	Compute V magnitude Vega zero point
	if (v0 <=0.) then
		v0=vega_0p_n(15)
	endif

!	Compute Vmag only if MF>0
	if (mf > 0) then
		fv = filter_n(15,x,y,mp,0.,kerr)	! flux through filters V (15)
		if (fv > 0.) then
			fv   = 2.5*alog10(fv)		! log V flux
			vmag = v0 - fv			! Vmag for this sed
		else
			vega_mag = -99.
			return
		endif
	endif

!	Compute flux through filters MF
	nf = abs(mf)
	fx = filter_n(nf,x,y,mp,0.,kerr)
!	Compute magnitude
	if (fx >0.) then
!		Compute V-MF zero point
		zp = zerop_n(15,nf)
!		Compute V-MF color
		color = zp - fv + 2.5*alog10(fx)
!		Compute Vega_mag in filter mf
		vega_mag = vmag - color
	else
		vega_mag = 99.99
	endif
	return
	end

	FUNCTION VEGA_FLUX(MF,VEGA_MAG,Z,XEFF)

!	Returns monochromatic flux corresponding to a given Vega magnitude in filter MF

!	Filter area
	area = areafilt(mf,xeff)/(1.+z)			! Factor (1.+z) added by GBA. May 2016

!	Monochromatic flux of Vega SED through filter mf
	xmag = vega_0p_f(mf)
	flux = 10.**(0.40*xmag)
	flux = flux/area

!	Flux corresponding to magnitude VEGA_MAG
	vega_flux = 10.**(-0.40*vega_mag) * flux
	return
	end

	FUNCTION ST_MAG(I,X,Y,N,Z,FLUX)

!	Compute absolute ST magnitude in filter I

!	Source: http://www.stsci.edu/hst/acs/analysis/zeropoints

!	STmag and ABmag: Both systems define the absolute physical flux density for a point source.
!	The conversion is chosen so that the magnitude at V corresponds roughly to that in the Johnson system.
!	In the STmag system, the flux density is expressed per unit wavelength, while
!	in the ABmag system, the flux density is expressed per unit frequency.
!	The definitions are:
!	        STmag = -2.5 Log F_lam -21.10
!	        ABmag = -2.5 Log F_nu - 48.60 
!	where F_nu is expressed in erg cm-2 s-1 Hz-1, and F_lam in erg cm-2 s-1 Ang-1.
!	An object with a constant flux distribution F_nu = 3.63 x 10-20 erg cm-2 s-1 Hz-1 at all wavelengths
!	will have ABmag=0 at all wavelengths, and similarly an object with F_lam = 3.63 x 10-9 erg cm-2 s-1 Ang-1 will have STmag=0.

!	Conversion from BC03 flux units:
!	  The stellar sed''s in BC03 are in units of Lsun/A.
!	  To obtain fluxes in ergs/sec/cm**2/A, multiply by Lsun = 3.826E33 ergs/sec, and divide by
!	  the surface area of a sphere of radius 10 pc =  area(10pc) = 1.19E40 cm2. Then, use the
!	  conversion factor:
!		 f = (3.826/1.19)*10.**(33-40) = 3.215E-07, and
!		fm = -2.5 log10 (f) = 16.232

!	Array declarations
	real x(n),y(n)
	data fm/16.232/

!	Compute effective flux in filter MF
        Flux   = effective_flux(i,x,y,n,z,xeff)
	if (flux > 0.) then
        	ST_mag = fm - 2.5*alog10(Flux) - 21.10
	else
        	ST_mag = -99.
	endif
	return
	end

	FUNCTION AREAFILT(N,XEFF)

!	Returns area below filter number n and effective wavelength

	INCLUDE 'filter.dec'

	real x(naux),y(naux),z(naux)
	if (iread.eq.0) Call FILTER0
	m=0
	do i=ni(n),nl(n)
	m=m+1
	x(m)=r(i,1)
	y(m)=r(i,2)
	z(m)=y(m)*x(m)
	enddo
	areafilt=trapz1(x,y,np(n))
	xeff=trapz1(x,z,np(n))/areafilt
	return
	end

	SUBROUTINE FILTERID(USERID)

!	Returns array with filter identification
	include 'filter.dec'
	character*64 userid(0:mxft)

!	Read filter file
	if (iread.eq.0) Call FILTER0
	do i=0,nf
	userid(i)=fid(i)
	enddo
	return
	end

	FUNCTION IFILTER()
!	Checks which filter file is in use.
	character filtfile*1024
	call getenv('FILTERS',filtfile)
	ifilter=index(filtfile,'FILTERBIN.RES')
!	write (6,*) filtfile
	return
	end

	SUBROUTINE YNORM(I,X,Y,N,Z,Y0)

!	Normalizes Y(X) such that the flux seen through the Ith filter at
!	redshift Z is = Y0

	INCLUDE 'filter.dec'
	real x(n),y(n),a(4000)
	data a/4000*1./
	aflux=filter(i,x,y,n,z,kerr)
	area =filter(i,x,a,n,z,kerr)
	ya=aflux/area
!	write (6,*) 'ya = ',ya
	ya=y0/ya
	do j=1,n
	y(j)=ya*y(j)
	enddo
	return
	end

	FUNCTION EFFECTIVE_FLUX(I,X,Y,N,Z,XEFF)

!	Computes effective flux seen through the Ith filter at redshift Z (monochormatic flux)

	real x(n),y(n)
       	aflux=filter(i,x,y,n,z,kerr)
!      	area =areafilt(i,xeff)
       	area =areafilt(i,xeff)/(1.+z)		! Factor (1.+z) added by GBA. May 2016
       	effective_flux=aflux/area
       	return
       	end

	FUNCTION EFFECTIVE_NPHOT(I,X,Y,N,Z,XEFF)

!	Computes effective flux seen through the Ith filter at redshift Z (monochormatic flux)

	real x(n),y(n)
	anphot=filter_n(i,x,y,n,z,kerr)
!	area  =areafilt(i,xeff)
	area  =areafilt(i,xeff)/(1.+z)		! Factor (1.+z) added by GBA. May 2016
	effective_nphot=anphot/area
       	return
	end

	FUNCTION SUN_COLOR_N(I,J)

!	Returns color of solar spectrum for filter pair (I,J)

!	Variables
	parameter (msun=1238)
	character sedfile*80
	real xsun(msun),ysun(msun)
	data xsun,ysun,nsun/msun*0.,msun*0.,0/

!	Read solar spectrum
	if (nsun.eq.0) then
!		Get file name from environment variable A0VSED
		call getenv('SUNSED',sedfile)
		open (81,file=sedfile,form='formatted',status='old')
		write (6,'(/x,2a)') 'Reading solar spectrum: ',sedfile(1:largo(sedfile))
		read (81,'(a)',err=3) sedfile
		write (6,'(x,a)') sedfile (1:78)
		do n=1,10000
		read (81,*,end=1,err=3) xsun(n),ysun(n)
		enddo
1		close (81)
		nsun=n-1
		write (6,'(i5,a,$)') nsun,' data points'
		write (6,'(x,a)') '    ...done'
	endif

!	Compute color in desired bands
	SUN_COLOR_N = ZEROP_N(I,J) + COLOR_N(I,J,XSUN,YSUN,NSUN,0.)

	return
3	stop 'Program exits because of error reading solar spectrum file'
	end

      real*4 function t(h, q, z, lamb)
c...... Returns age of universe at redshift z
      implicit none
      real*4 h, q, z, a, b, c, hh0, cosh, x, lamb
c... for lambda
      real*4 aa, bb, epsr, s0, s, funq, omega0
      integer npts
      logical success
      external funq
      common /cosm/ omega0

c	H = Ho in km/sec/Mpc
c	Q = qo  (if problems with qo = 0, try 0.0001)

      a(q,z) = (sqrt(1. + ((2. * q) * z)) / (1. - (2. * q))) / (1. + z)
      b(q) = q / (abs((2. * q) - 1.) ** 1.5)
      c(q,z) = ((1. - (q * (1. - z))) / q) / (1. + z)

      cosh(x) = alog(x + sqrt((x ** 2) - 1.))
      hh0 = h * 0.001022
c     in (billion years)**(-1)

      if (lamb .ne. 0.0) then
         	omega0 = (2. * (q + 1.)) / 3.
         	aa = 0.
         	bb = 1. / (1. + z)
	        success=.false.
		s0=1.e-10
		npts=0
		do while (.not.success)
		  npts=npts+1
		  callmidpnt(funq,aa,bb,s,npts)
		  epsr=abs(s-s0)/s0
		  if (epsr.lt.1.e-4) then
			success=.true.
		  else
			s0=s
		  endif
		enddo
		t=s
      else if (q .eq. 0.0) then
      	t = 1. / (1. + z)
      else if (q .lt. 0.5) then
      	t = a(q,z) - (b(q) * cosh(c(q,z)))
      else if (q .eq. 0.5) then
      	t = (2. / 3.) / ((1. + z) ** 1.5)
      else
      	t = a(q,z) + (b(q) * cos(c(q,z)))
      end if

      t = t / hh0

      return
      end
c=======================================================================
      real*4 function funq(x)
c.... For non-zero cosmological constant
      real*4 x, omega0, omegainv
      common /cosm/ omega0
      omegainv = 1. / omega0
      funq = sqrt(omegainv) / (x*sqrt((omegainv-1.)+(1./(x**3.))))
      return
      end

	SUBROUTINE SDSS_COLOR(T,X,Y,INW,LUN,BOLFLUX,SISSA20)

	! computes magnitude and colors in AB system

	! Array declarations
	parameter (nc=70,lb=2*nc,mxft=300)
	character genfile*96,envfile*96,rfcolorfile*96,fid(0:mxft)*64
	integer no(lb),n1(nc),n2(nc),kerr(nc)
	real x(inw),y(inw),col(nc),fx(lb),ab(0:nc)
	real gmag
	common /kpercent/ ipcall,iplast,iphead,jc
	common /r_filter/ iread,jread,ireset
	data icall/0/,jcall/0/,last/0/,nb/0/
	data nb,no,n1,n2,ng,nv,mc,kb,v0/0,lb*0,nc*0,nc*0,4*0,0./
	data kerr/nc*0/
	! Add V and g filters to list of desired filters
	logical sissa20
	integer glog
	data glog/121/			! SDSS g filter
	common /f1001/ mc,ab

	! Check for zero flux sed
	if (t.eq.0..or.bolflux.le.0.) return

	! Check if number of points has changed
	if (inw.ne.last) then
		! icall=0
		! write (6,*) 'Resetting sdss:',inw,last
		! ireset=1
		last=inw
	endif

	if (icall.eq.0) then
		icall=1

		! Format of file modified 07/01/2003:
		! To avoid recompiling this routine the arrays n1,n2 of up to nc elements each are now read from a file.
		! Get file name from environment variable RF_COLORS_ARRAYS
		envfile='RF_COLORS_ARRAYS'
		call getenv(envfile,rfcolorfile)
		close (1)
		open (1,file=rfcolorfile,status='old',form='formatted',err=2)
		! write (6,*)
		! write (6,*) 'List of filters in file: ',rfcolorfile(1:largo(rfcolorfile))
		! Skip first lines
		do i=1,100
		read (1,'(a)') genfile
		if (index(genfile,'AB system').gt.0) goto 5
		enddo
5		kb = 0
		jb = 0
		! Read filter pairs
		do i=1,100
		read (1,'(a)',end=10) genfile
		if (genfile(1:1) /= '#') then
			jb = jb+1
			read (genfile,*) n1(jb),n2(jb)
			kb=kb+1
			fx(kb)=n1(jb)
			kb=kb+1
			fx(kb)=n2(jb)
		endif
		enddo
10		mc=jb
		close (1)
		! Make sure that SDSS g filter = filter glog in filter file, are included
		kb=kb+1
		fx(kb)=glog
		! Sort filters in numerical order
		call sort(kb,fx)
		! Find independent filters in arrays n1 and n2 and store in array no
		nb=1
		no(1)=fx(1)
		do i=2,kb
		if (fx(i).gt.fx(i-1)) then
			nb=nb+1
			no(nb)=nint(fx(i))
		endif
		enddo
		! Write filter ID
		  call filterid(fid)
		! nun = 1002
		! nun = 6
		! write (nun,'(/x,a)') 'Selected filters (AB mag):'
		! do i=1,nb
		! write (nun,'(i4,'': '',i4,3x,a)') i,no(i),fid(no(i))
		! enddo
		! write (nun,'(i3,a)') mc,' colors selected (AB mag):'
		! do i=1,mc
		! write (nun,'(3i4,3x,3a)') i,n1(i),n2(i),trim(fid(n1(i))),' - ',trim(fid(n2(i)))
		! enddo

		! Fill arrays with filter numbers
		do i=1,mc
		do j=1,nb
		if (n1(i).eq.no(j)) n1(i) = j
		if (n2(i).eq.no(j)) n2(i) = j
		if (no(j).eq.glog)  ng    = j
		enddo
		enddo
	endif

	! Compute flux through each of nb filters
	do i=1,nb
	if (kerr(i).eq.0) then
		fx(i)=f_mean(no(i),x,y,inw,0.,kerr(i))
	else
		fx(i)=0.
	endif
	enddo

	! Compute colors in file RF_COLORS in the AB mag system
	do i=1,mc
	col(i)=-2.5*alog10(fx(n1(i))/fx(n2(i)))
	enddo

	! Compute absolute g AB magnitude for a 1 Mo galaxy
	! It is -27.5 magnitudes brighter for a 1E11 Mo galaxy
	! 10 pc in units of Mpc
	dl=1.e-5
	gmag=-2.5*alog10(fx(ng))-48.6
	gmag=gmag+(5. * alog10(1.7684e+08 * dl))	! this factor is SQRT(4*pi*(3.0856E24)^2/Lsun)

	! Compute flux inside GALEX filters
	nfuv = 139	! FUV Galex filter
	ffuv = f_mean(nfuv,x,y,inw,0.,kerruv)
	nnuv = 140	! NUV Galex filter
	fnuv = f_mean(nnuv,x,y,inw,0.,kerruv)

	! Compute flux inside a 100 A square filtered centered at 1500 A
	n1500 = 235     ! filter number
	f1500 = f_mean(n1500,x,y,inw,0.,kerruv)

	! Write magnitudes to file
	! Bands 01:18 go to file lun+13 = *.1ABmag
	! Bands 39:50, 30:38, 19:29 go to file lun+88 = *.2ABmag

	! Write results
	if (jcall == 0 .and. .not. sissa20) then
		! Write a record corresponding to t = 0 (use tl = 0 => 1 yr) for compatibility with number of time steps on SED
		! This record is a duplicate of next record
		jcall = 1
		write (lun+13,101) 0.,gmag-col(1),gmag,(gmag-col(i),i=2,18),ffuv,fnuv,f1500
		write (lun+88,102) 0.,(gmag-col(i),i=39,50),(gmag-col(i),i=30,38),(gmag-col(i),i=19,29)
	endif
	tl=alog10(t)
	write (lun+13,101) tl,gmag-col(1),gmag,(gmag-col(i),i=2,18),ffuv,fnuv,f1500
	write (lun+88,102) tl,(gmag-col(i),i=39,50),(gmag-col(i),i=30,38),(gmag-col(i),i=19,29)
101	format (f10.6,5f10.4,3x,10f10.4,3x,2f10.4,3x,2f10.4,1p3e13.4)
102	format (f10.6,40f10.4)

	! Store AB mags
	ab(0) = gmag-col(1)
	ab(1) = gmag
	do i=2,mc
	ab(i) = gmag-col(i)
	enddo

	return
2	write (6,*) 'Error opening file: ',rfcolorfile(1:largo(rfcolorfile))
	stop
	end

	! Prepare filters for next call to filter_n
	! ireset=1

	! Bands 19:29 go to file lun+86 = *.acs_wfc_ABmag
	! Bands 30:38 go to file lun+84 = *.wfc3_ABmag
	! Bands 39:50 go to file lun+88 = *.wfc3_uvis1_legus_ABmag
	! Bands 51:64 go to file lun+85 = *.wfc3_uvis1_ABmag

		! write (lun+86,102) 0.,(gmag-col(i),i=19,29)
		! write (lun+84,102) 0.,(gmag-col(i),i=30,38)
		! write (lun+88,102) 0.,(gmag-col(i),i=39,50)
		! write (lun+85,102) 0.,(gmag-col(i),i=51,64)

	! write (lun+86,102) tl,(gmag-col(i),i=19,29)
	! write (lun+84,102) tl,(gmag-col(i),i=30,38)
	! write (lun+88,102) tl,(gmag-col(i),i=39,50)
	! write (lun+85,102) tl,(gmag-col(i),i=51,64)

	FUNCTION CHELIUM(X,Y,N,CHE2)

c	Compute number of Helium ionizing photons in sed Y(X).
c	Assumes X is in Angstroms and Y in ergs/sec/Angstroms (physical flux)

	real x(n),y(n),w(100000),f(100000)
	save c,h,const
	data icall/0/,const/0./

c	compute proportionality constant
	if (icall.eq.0) then
		c=2.997925E10
		h=6.6262E-27
		const=1.0E-8/h/c
		icall=1
	endif

c	Find Helium limit in sed and log(number of photons)
c	First electron, all photons shortward of whelium = 504.4 A
	whelium = 504.4
	if (x(1).ge.whelium) then
		chelium=0.
		che2=0.
		return
	endif
	do i=1,n
	if (x(i).lt.whelium) then
		w(i)=x(i)
		f(i)=w(i)*y(i)
	elseif (x(i).eq.whelium) then
		w(i)=x(i)
		f(i)=w(i)*y(i)
		goto 1
	elseif (x(i).gt.whelium) then
		w(i)=whelium
		f(i)=y(i-1)+(w(i)-x(i-1))*(y(i)-y(i-1))/(x(i)-x(i-1))
		f(i)=w(i)*f(i)
		goto 1
	endif
	enddo
1	chelium=const*trapz1(w,f,i)

!	Second electron, all photons shortward of whelium = 228. A
	whelium = 228.
	if (x(1).ge.whelium) then
		che2=0.
		return
	endif
	do i=1,n
	if (x(i).lt.whelium) then
		w(i)=x(i)
		f(i)=w(i)*y(i)
	elseif (x(i).eq.whelium) then
		w(i)=x(i)
		f(i)=w(i)*y(i)
		goto 2
	elseif (x(i).gt.whelium) then
		w(i)=whelium
		f(i)=y(i-1)+(w(i)-x(i-1))*(y(i)-y(i-1))/(x(i)-x(i-1))
		f(i)=w(i)*f(i)
		goto 2
	endif
	enddo
2	che2=const*trapz1(w,f,i)
	return
	end

	FUNCTION SFR(TP)

c	Returns SFR at time TP

	include 'SSP_13.dec'
	include 'recycle.dec'

	sfr=0.
	if (tp.gt.tcut) return
	if (tp.lt.0.) then
		write (6,'(x,a,1pe12.4)') 'SFR called with tp < 0',tp
		return
	endif

c	Check for tcut
	if (io.eq.0) then
		if (tp.eq.0.) sfr=1.
	elseif (io.eq.1) then
		if (tau.gt.0.) then
			sfr=(1. + epsilon*pgas(tp))*exp(-tp/tau)/tau
		elseif (tau.lt.0.) then
			sfr=(1./(1.-exp(1.)) + epsilon*pgas(tp))*exp(-tp/tau)/tau
		endif
	elseif (io.eq.2) then
		if (tp.le.tau) sfr=1./tau
	elseif (io.eq.3) then
		sfr=tau
	elseif (io.eq.4) then
		if (tau.gt.0.) then
			sfr = exp(-tp/tau)/tau
		elseif (tau.lt.0.) then
!			sfr = exp(-tp/tau)/tau/(1.-exp(1.))
!			Modified on June 6, 2017 to normalize to total mass = 1 at t = 13.6 Gyr
!			epsilon assumed to be = 0.
			tu = 13.6E9
			sfr = (exp(-tp/tau)-1.) / ( (1.-exp(-tu/tau))*tau - tu )
		endif
	elseif (io.eq.6) then
		sfr=tp*exp(-tp/tau)/tau**2
	elseif (io.eq.7) then
		sfr=usrsfr(tp)
	elseif (io.eq.8) then
		sfr=2./tau*(1.-tp/tau)
		if (sfr.lt.0.) sfr=0.
	elseif (io.eq.9) then
		if (ampl > 0.) then
!			If burst has been added to double exponential SFR, use
			sfr=usrsfr(tp)
		else
!			Use analytic double exponential, joined at t = tauj
			if (tp < = tauj) then
				sfr = exp(-tp/tau1)/tau1
			else
				sfr = con2*exp(-tp/tau2)
			endif
		endif
	endif
	return
	end

	INTEGER FUNCTION IPLACE(X0,XX,N1,N2)

!	Finds L such that XX(L) < X0 < XX(L+1)
!       Re written by GBA June 8, 2012

!       Variables
	real xx(n2)

!	Procedure
	x(i)=xx(n1+i-1)
	n=n2-n1+1
	if ( x(1) > x(2) ) then
		i=2
	else
		i=1
	endif
	l=0
	do while ( l < n-1 )
	l = l + 1
	if ( i == 1 ) then
		if ( x(l) <= x0 .and. x0 < x(l+1) ) then
			iplace=l+n1-1
			return
		endif
	else
		if ( x(l) >= x0 .and. x0 > x(l+1) ) then
			iplace=l+n1-1
			return
		endif
	endif
	enddo
	if ( x0 == x(n) ) then
		iplace=l+n1-1
	else
		iplace=0
	endif
	return
	end

!      INTEGER FUNCTION IPLACE(X0,XX,N1,N2)
!c     FINDS L SUCH THAT   XX(L).LT.X0.LT.XX(L+1)
!      DIMENSION XX(N2)
!      X(I)=XX(N1+I-1)
!      N=N2-N1+1
!      I=1
!      IF (X(1).GT.X(2)) I=2
!      L=0
!    1 L=L+1
!      IF (L.EQ.N) GOTO 4
!      GOTO (2,3),I
!    2 IF (X(L).LE.X0.AND.X0.LT.X(L+1)) GOTO 5
!      GOTO 1
!    3 IF (X(L).GE.X0.AND.X0.GT.X(L+1)) GOTO 5
!      GOTO 1
!    4 IF (X0.NE.X(N)) GOTO 6
!    5 IPLACE=L+N1-1
!      RETURN
!    6 IPLACE=0
!c	write (6,*) 'IPLACE: X0,N1,N2,X(1),X(N)',x0,n1,n2,x(1),x(n)
!c	write (6,*) 'x(2) =',x(2)
!      RETURN
!      END

	FUNCTION TRAPZ_LR(X,Y,N,X1,X2,IERR)

c	Finds area below y(x) from x=X1 to x =X2
c	X1 and X2 are not necessarily values of x(i)
c	but must fulfill X1>=x(1) and X2<=x(n)

c	This routine was especially written for coarse X arrays
c	where there are few points (or none) from X1 to X2 (like in Kurucz
c	model atmospheres). Interpolates Y(X) every unit in X.

c	Array declaration
	real x(n),y(n),xa(1000),ya(1000),linear

c       Check for values outside valid range
        TRAPZ_LR=0.
        ierr=0.
        if (n.le.1) return
        if (x1.lt.x(1)) then
                write (6,*) 'TRAPZ_LR: X1 outside valid range:',x1,x(1),1
                ierr=1
                return
c               stop
        endif
        if (x2.gt.x(n)) then
                write (6,*) 'TRAPZ_LR: X2 outside valid range:',x2,x(n),n
                ierr=2
                return
c               stop
        endif

c	Build auxiliary arrays (xa,ya) by linear interpolation
	j=0
	icall=0
	w1=x1-1.
	do i=1,n
	w1=w1+1
	if (w1.gt.x2) goto 1
	j=j+1
	xa(j)=w1
	ya(j)=linear(w1,x,y,n,icall)
	enddo
1	j=j+1
	xa(j)=x2
	ya(j)=linear(x2,x,y,n,icall)
	trapz_lr=trapz1(xa,ya,j)
	return
	end

	SUBROUTINE FILE_HEADER(IUN,NAME,LISTED)

	! Writes header information in file iun

	include 'SSP_4.dec'
	include 'SSP_13.dec'
	include 'cosmo.dec'
	character name*(*),und,buffer*96,blank*32
	real*8 cux
        common /vazdekis/ jvaz,xmu
	data und/'-'/,blank/'                                '/

	! Date file
	call dattim(iun,0,'L')

	! Clear file name
	ldot=index(name,'.')-1
	buffer(1:ldot)=name(1:ldot)
	buffer(ldot+1:64)=blank(ldot+1:32)

	! Check if model is for Vazdekis et al. (1996) IMF
	if (jvaz == 0) then
		i = index(buffer,'_v')
		if (i > 0 .and. buffer(i+3:i+3) == 'p' .and. buffer(i+6:i+6) == '_') jvaz =1
	endif

	! Write top lines of header
	write (iun,200) (und,i=1,120)
200	format ('#',10x,'I',120a,'I')
	write (iun,201)
201	format ('#',10x,'I',120x,'I')
	write (iun,202) buffer(1:42)
202	format ('#',10x,'I      BC_GALAXEV  ---  MODEL PARAMETERS:   Generic file name for this model = ',a,    'I')
	write (iun,201)
	write (iun,203) id
203	format ('#',10x,'I      TRACKS: ',a,26X,'I')
	write (iun,201)

	! Write information about SFR:
	if (io.eq.0) then
		write (iun,204)
204		format ('#',10x,'I      S.F.R.: SSP = Zero Length Burst at t = 0',74X,'I')
		write (iun,201)
	elseif (io.eq.1) then
		t9=tau*1.e-9
		tmu=1.-exp(-1./t9)
		write (iun,205) tmu,t9
205		format ('#',10x,'I      S.F.R.: Exponential with MU9 = ',F5.3,'/Gyr',6X,'TAU = ',F7.3,' Gyr',
     *                  ' (includes processed gas recycling)',16X,'I')
		write (iun,201)
	elseif (io.eq.2) then
		write (iun,206) tau
206		format ('#',10x,'I      S.F.R.: Finite Burst of Duration = ',1pe9.3,' yr',67X,'I')
		write (iun,201)
	elseif (io.eq.3) then
		write (iun,207) tau
207		format ('#',10x,'I      S.F.R.: Constant = ',1pe10.3,' Mo/yr',79X,'I')
		write (iun,201)
	elseif (io.eq.4) then
		t9=tau*1.e-9
		tmu=1.-exp(-1./t9)
		write (iun,208) tmu,t9
208		format ('#',10x,'I      S.F.R.: Exponential with MU9 = ',F5.3,'/Gyr',6X,'TAU = ',F7.3,' Gyr',
     *                  ' (does not include processed gas recycling)', 8X,'I')
		write (iun,201)
	elseif (io.eq.5) then
		ldot=index(name1,' ')-1
		buffer(1:ldot)=name1(1:ldot)
		buffer(ldot+1:32)=blank(ldot+1:32)
		write (iun,209) t0(1)*1.E-9,s(1),buffer(1:32)
209		format ('#',10x,'I      S.F.R.: 2 Bursts: Burst 1 at ',F6.3,'/Gyr, Strength = ',F8.5,', in file = ',a,10x,'I')
		ldot=index(name2,' ')-1
		buffer(1:ldot)=name2(1:ldot)
		buffer(ldot+1:32)=blank(ldot+1:32)
		write (iun,210) t0(2)*1.E-9,s(2),buffer(1:32)
210		format ('#',10x,'I                        Burst 2 at ',F6.3,'/Gyr, Strength = ',F8.5,', in file = ',a,10x,'I')
	elseif (io.eq.9 .or. isingle > 0) then
		write (iun,2091) tau1*1.E-9
		write (iun,2092) tau2*1.E-9
		write (iun,2093) tauj*1.E-9
		write (iun,2094) tauf*1.E-9
		write (iun,2095) ampr
		write (iun,2096) taui*1.E-9
		write (iun,2097) tdur*1.E-9
2091		format ('#',10x,'I      S.F.R.: Double Exponential with TAU_1 = ',F7.3,' Gyr (after Chen et al., does not include processed gas recycling) I')
2092		format ('#',10x,'I                                      TAU_2 = ',F7.3,' Gyr                                                               I')
2093		format ('#',10x,'I               which join smoothly at TAU_J = ',f7.3,' Gyr                                                               I')
2094		format ('#',10x,'I                    Look-back-time = Tform  = ',f7.3,' Gyr                                                               I')
2095		format ('#',10x,'I                            Burst amplitude = ',f7.3,'     ( = ratio of mass in burst / subyacent mass at t = Tform)     I')
2096		format ('#',10x,'I                            Burst starts at = ',f7.3,' Gyr                                                               I')
2097		format ('#',10x,'I                             Burst duration = ',f7.3,' Gyr                                                               I')
	else
		write (iun,201)
		write (iun,201)
	endif
	write (iun,201)

	! Write information about IMF
	if (iseg == 0) then
	   jseg=2
	   write (iun,221)
221	   format ('#',10x,'I      I.M.F.: Lognormal + power law   ',82X,'I')
	   write (iun,222)
222	   format ('#',10x,'I                                                                      mass in      number',31x,'I')
	   write (iun,223)
223	   format ('#',10x,'I                                                  from m     to m     segment    of stars',31x,'I')
	   aux=1.
	   if (xhmend == 0.) xhmend = 1.30		! This was introduced for the csp_galaxev header to be correct. xhmend should be stored to file in ssp models. FIX
           bux=chabimf(ml,mu,dble(ml),dble(aux),cux,xhmend)
           write (iun,224) ml,aux,cux,bux
           bux=chabimf(ml,mu,dble(aux),dble(mu),cux,xhmend)
           !write (iun,225) aux,mu,cux,bux
           write (iun,225) xhmend,aux,mu,cux,bux
224        format ('#',10x,'I',40x,'lognormal',f7.2,f9.2,2f12.4,31x,'I')
225        format ('#',10x,'I',40x,'  x=',f3.1,f9.2,f9.2,2f12.4,31x,'I')
	elseif (jvaz > 0) then
	   jseg=3
	   write (iun,321)
321	   format ('#',10x,'I      I.M.F.: Vazdekis et al. (1996) bimodal IMF',72x,'I')
	   write (iun,322)
322	   format ('#',10x,'I                                                                     fraction      number    fraction',19x,'I')
	   write (iun,323)
323	   format ('#',10x,'I                                                  from m     to m     by mass    of stars   by number',19x,'I')
	   write (iun,324) lm(1),um(1),baux(1),cc(1),cn(1)
324	   format ('#',10x,'I                                           flat',2f9.2,3f12.4,19x,'I')
	   write (iun,325) lm(2),um(2),baux(2),cc(2),cn(2)
325	   format ('#',10x,'I                                         spline',2f9.2,3f12.4,19x,'I')
           write (iun,326) xx(3),lm(3),um(3),baux(3),cc(3),cn(3)
326        format ('#',10x,'I',40x,'  x=',f3.1,2f9.2,3f12.4,19x,'I')
	else
	   jseg=iseg
	   write (iun,211) iseg
211	   format ('#',10x,'I      I.M.F.: Power law (',I2,' segments):',82X,'I')
	   write (iun,212)
212	   format ('#',10x,'I                                                                      mass in      number',31x,'I')
	   write (iun,213)
213	   format ('#',10x,'I                                              x   from m     to m     segment    of stars      c',24x,'I')
           do i=1,iseg
           write (iun,214) xx(i),lm(i),um(i),baux(i),cn(i),cc(i)
214        format ('#',10x,'I',40x,f7.2,f9.2,f9.2,2f12.4,1pe12.4,19x,'I')
           enddo
	endif
	write (iun,201)
        write (iun,215) totm,totn,avs
215     format ('#',10x,'I',59x,'totals',2f12.4,'  (',f7.4,' Mo/star)',12x,'I')
	do i=1,6-jseg
	write (iun,201)
	enddo
	if (listed.eq.0) then
		write (iun,216)
216		format ('#',10x,'I      LISTED: Rest frame properties',85X,'I')
		write (iun,201)
	else
                write (iun,217) h,omega,omega_lambda,q,clambda,tu,ttg,zf
217		format ('#',10x,'I      LISTED: Observer frame properties for the following cosmology:',52x,'I'/,
     *                  '#',10x,'I',14x,'Ho=',f4.0,2x,'Omega=',f4.2,2x,'Omega_lambda=',f4.2,2x,'qo=',f5.2,2x,
     *                  'Lambda=',1pE9.2,2x,'tu=',0pf5.2,' Gyr',2x,'tg=',f5.2,' Gyr',2x,'zf=',f5.2,2x,'I')
	endif
	write (iun,201)
	write (iun,218)
218	format ('#',10x,'I',30X,'(C) 1995-2020 G. Bruzual A. & S. Charlot - All Rights Reserved',28x,'I')
	write (iun,200) (UND,I=1,120)
	write (iun,301)
301	format ('#')
	return
	end

	FUNCTION TRAPZQ(X,Y,N,X1,X2,IERR)

c	Finds area below y(x) from x=X1 to x =X2
c	X1 and X2 are not necessarily values of x(i)
c	but must fulfill X1>=x(1) and X2<=x(n)

c	Starts search for X1 at last point found

c	Array declaration
	real x(n),y(n)
	data i1/1/

	trapzq=0.
	ierr=0.
c	Check for values outside valid range
	if (x1.lt.x(1)) then
		write (6,*) 'TRAPZQ: X1 outside valid range:',x1,x(1)
		ierr=1
		return
c		stop
	endif
	if (x2.gt.x(n)) then
		write (6,*) 'TRAPZQ: X2 outside valid range:',x2,x(n)
		ierr=2
		return
c		stop
	endif

c	Search array from last value of i1
c	Reset i1
	if (x1.lt.x(i1)) i1=1

c	Find first element in array X above X1
	do i=i1,n
	if (x(i).ge.x1) then
		i1=i
c		Find by interpolation values of Y1=y(X1)
		Y1 = ( (x(i1)-x1)*y(i1-1) + (x1-x(i1-1))*y(i1) ) / (x(i1)-x(i1-1))
c		Add area from x(i1-1) to X1
		trapzq=trapzq+(x(i1)-x1)*(Y1+y(i1))/2.
		goto 1
	endif
	enddo

c	Find last element in array X below X2
1	do i=i1,n
	if (x(i).ge.x2) then
		i2=i-1
c		Find by interpolation values of Y2=y(X2)
		Y2 = ( (x(i2+1)-x2)*y(i2) + (x2-x(i2))*y(i2+1) ) / (x(i2+1)-x(i2))
c		Add area from x(i2) to X2
		trapzq=trapzq+(x2-x(i2))*(Y2+y(i2))/2.
		goto 2
	endif
	enddo

c	Compute area from x(i1) to x(i2)
2	do i=i1+1,i2
	trapzq=trapzq+(x(i)-x(i-1))*(y(i)+y(i-1))/2.
	enddo 

	return
	end

	SUBROUTINE USORT(N,RA)

c	Sorts array RA(N) and suppreses duplicate entries

	DIMENSION RA(N)

	if (n.le.1) return
	call sort(n,ra)
	j=1
	do i=2,n
	if (ra(i).gt.ra(i-1)) then
		j=j+1
		ra(j)=ra(i)
	endif
	enddo
	n=j
	return
	end

	SUBROUTINE UISORT(N,RA)

c	Sorts array RA(N) and suppreses duplicate entries

	INTEGER RA(N)

	if (n.le.1) return
	call isort(n,ra)
	j=1
	do i=2,n
	if (ra(i).gt.ra(i-1)) then
		j=j+1
		ra(j)=ra(i)
	endif
	enddo
	n=j
	return
	end

	SUBROUTINE UDSORT(N,RA)

c	Double precision version
c	Sorts array RA(N) and suppreses duplicate entries

	Integer*8 N
	Real*8 RA(N)

	if (n.le.1) return
	call dsort(n,ra)
	j=1
	do i=2,n
	if (ra(i).gt.ra(i-1)) then
		j=j+1
		ra(j)=ra(i)
	endif
	enddo
	n=j
	return
	end

	SUBROUTINE REL_SORT(N,RA,EPS)

c	Sorts array RA(N) and suppreses entries that differ in less than eps %

	DIMENSION RA(N)

	if (n.le.1) return
	call sort(n,ra)
	j=2
	do i=3,n
	if ( (ra(i)-ra(i-1))/ra(i-1).gt.eps) then
		j=j+1
		ra(j)=ra(i)
	endif
	enddo
	n=j
	return
	end

	SUBROUTINE SFR_0_B(IDEF,ZOBS)

!	Selects parameters for SFR

	include 'jb.dec'
	include 'csp.dec'
	character ans*1,aux*128,bux*128

!	Ask for selection
	io=0
	tcut=20.E9
	isingle=0.
	if (idef.ne.0) then
		write (6,*)
		write (6,'(x,a)') 'Choose SFR: 0 = SSP (Delta Burst = zero length burst)'
		write (6,'(x,a)') '            1 = Exponential (enter Tau)'
		write (6,'(x,a)') '           -1 = Exponential (enter mu_SFR parameter)'
		write (6,'(x,a)') '            2 = Single Burst of finite length'
		write (6,'(x,a)') '            3 = Constant'
		write (6,'(x,a)') '            4 = Delayed'
		write (6,'(x,a)') '            5 = Linearly decreasing'
		write (6,'(x,a)') '            6 = Read SFR(t) from ASCII file'
		write (6,'(x,a)') '            7 = Single or double exponential + burst (after Chen et al.)'
20		write (6,'(x,a,$)') '   Choice = '
		read (5,'(i10)',err=20,end=6) io
		if (io.eq.7) io=9
		if (io.eq.6) io=7
		if (io.eq.5) io=8
		if (io.eq.4) io=6
	endif
	if (io.eq.1) then
!		Exponential SFR (enter tau)
1		write (6,'(x,a,$)') 'Exponential with e-folding time TAU (Gyr) = '
		read (5,'(f10.0)',err=1,end=6) tau
		tmu=1.-exp(-1./tau)
		write (6,'(x,a,f10.4,5x,a,f10.4)') 'mu_SFR =',tmu,'tau =',tau
		tau=1.e9*tau
		write (6,'(x,a,$)') 'Recycle gas ejected by stars Y/[N] = '
		read (5,'(a)',end=6) ans
		if (ans.eq.'Y'.or.ans.eq.'y') then
			call get_epsilon(io)
		else
			io=4
		endif
	elseif (io.eq.-1) then
!		Exponential SFR (enter mu)
2		write (6,'(x,a,$)') 'Exponential with mu_SFR parameter = '
		read (5,'(f10.0)',err=2,end=6) tmu
		tau=-1.e9/alog(1.-tmu)
		write (6,'(x,a,f10.4,5x,a,f10.4)') 'mu_SFR =',tmu,'tau =',tau*1.E-9
		write (6,'(x,a,$)') 'Recycle gas ejected by stars Y/[N] = '
		read (5,'(a)',end=6) ans
		if (ans.eq.'Y'.or.ans.eq.'y') then
			io=1
			call get_epsilon(io)
		else
			io=4
		endif
	elseif (io.eq.2) then
!		Long Burst SFR (enter duration of burst)
3		write (6,'(x,a,$)') 'Duration of burst (Gyr) = '
		read (5,'(f10.0)',err=3,end=6) tau
		tau=1.e9*tau
		tcut=tau
	elseif (io.eq.3) then
!		Constant SFR (enter constant value)
		tau=1.
5		write (6,'(x,a,$)') 'Enter SFR in Mo/yr [1] = '
		read (5,'(f10.0)',err=5,end=6) str
		if (str.gt.0.) tau=str
	elseif (io.eq.6) then
!		Delayed SFR (enter time at which maximum SFR occurs)
 		write (6,'(x,a  )') 'Delayed SFR as defined in Bruzual (1983)'
7		write (6,'(x,a,$)') 'Maximum in SFR at time TAU (Gyr) = '
		read (5,'(f10.0)',err=7,end=6) tau
		tau=1.e9*tau
	elseif (io.eq.7) then
!		Function SFR(t) read 2 column from ASCII file
 		write (6,'(x,a)') 'SFR(t) read from disk file.'
 		write (6,'(x,a)') 't(yr), SFR(t) in Mo/yr read from 2 column ascii file.'
 		write (6,'(x,a)') 'Linear interpolation between listed points.'
 		write (6,'(x,a)') 'Skip lines starting with #'
8 		write (6,'(x,a,$)') 'SFR in file name = '
		tau=usrsfr(-1.)
		if (tau.lt.0) goto 8
	elseif (io.eq.8) then
!		Linear SFR (enter time at which SFR  = 0)
 		write (6,'(x,a  )') 'Linearly decreasing SFR'
9		write (6,'(x,a,$)') 'SFR = 0 at time TAU (Gyr) = '
		read (5,'(f10.0)',err=9,end=6) tau
		tau=1.e9*tau
	elseif (io.eq.9) then
		write (6,*)
10		write (6,'(x,a,$)') 'For t <= Tj, use exponential SFR with e-folding time TAU_1 (Gyr)   = '
		read (5,'(f20.0)',err=10,end=6) tau1
		tau1 = 1.e9*tau1
		con1 = 1./tau1
11		write (6,'(x,a,$)') 'For t >  Tj, use exponential SFR with e-folding time TAU_2 (Gyr)   = '
		read (5,'(f20.0)',err=11,end=6) tau2
		if (tau2 /= 0.) then
			tau2 = 1.e9*tau2
!12			write (6,'(x,a,$)') '                  Join continuously both SFR''s at time T_J (Gyr)   = '
12			write (6,'(x,a,$)') '        Join continuously both SFR''s at look back time T_J (Gyr)   = '
			read (5,'(f20.0)',err=12,end=6) tauj
			tauj = 1.e9*tauj
		endif
13		write (6,'(x,a,$)') '   Look back time for this galaxy from z = 0, a.k.a. Tform (Gyr)   = '
		read (5,'(f20.0)',err=13,end=6) tauf
		tauf = 1.e9*tauf
		if (tau2 /= 0.) then
!		    Next instruction added at Alfredo and Gladis request (Jan-23-2015):
!			Ayer Gladis y yo encontramos una inconsistencia entre la SFR que calculas con el programa para
!			correr las SFH a un z dado y los parámetros de la SSAG. El problema parece ser la interpretación
!			del tiempo de truncado (tcut, cuando comienza a decaer más rápidamente la SFR). Ivan calcula estas
!			cosas en look-back-time, lo que quiere decir que si él dice que una galaxia que se formó hace 8Gaños
!			tiene un tiempo de truncado de 1Gaño, quiere decir que comenzó a truncarse hace 1Gaño a partir del
!			presente. Mientras en tus SFR aparecería el tiempo de truncado como 8-1Gaños. Afortunadamente esto solo
!			afecta a las galaxias con truncado, solo 6 (+1 a z>0) en la muestra y puedo continuar sin estas galaxias.
			tauj = tauf - tauj	! added 03-Jun-2015
			if (tauj/tau2 < 100.) then
				con2 = con1 * exp(-tauj/tau1) / exp(-tauj/tau2)
			else
				con2 = 0.
			endif
		else
			tau2 = tau1
			tauj = tauf
			con2 = con1
		endif

!		Mass formed up to t = tauf
!		if (tauf <= tauj) then
!			xm1 = 1. - exp(-tauf/tau1)
!			xm2 = 0.
!		else
!			xm1  = 1. - exp(-tauj/tau1)
!			xm2  = con2*tau2*(exp(-tauj/tau2) - exp(-tauf/tau2))
!		endif

!		Compute SFR for both exponentials plus burst
		isfrc = 0
		do i=0,nsteps-1
		if (tb(i) <= tauf) then
			isfrc = isfrc + 1
			time(isfrc) = tb(i)
		endif
		enddo
!		Ask for burst parameters
14		write (6,'(x,a,$)') 'Add burst of fractional amplitude A = mass in burst/subyacent mass = '
		read (5,'(f20.0)',err=14,end=6) ampl
		if (ampl > 0.) then
15			write (6,'(x,a,$)') '                                      Burst starts at time (Gyr)   = '
			read (5,'(f20.0)',err=15,end=6) taui
			taui = 1.e9*taui
16			write (6,'(x,a,$)') '                                         Duration of burst (Gyr)   = '
			read (5,'(f20.0)',err=16,end=6) tdur
			tdur = 1.e9*tdur
			isfrc = isfrc + 1
			time(isfrc) = 0.9999*taui
			isfrc = isfrc + 1
			time(isfrc) = 0.99999*taui
			if (taui+tdur < tauf) then
				isfrc = isfrc + 1
				time(isfrc) = 1.0001*(taui+tdur)
				isfrc = isfrc + 1
				time(isfrc) = 1.00001*(taui+tdur)
!			else
!				isfrc = isfrc + 1
!				time(isfrc) = 1.0001*tauf
!				isfrc = isfrc + 1
!				time(isfrc) = 1.00001*tauf
			endif
			nbr=25
			dtbr=tdur/nbr
			do i=1,nbr+1
			if (taui+(i-1)*dtbr < tauf) then
				isfrc = isfrc + 1
				time(isfrc) = taui+(i-1)*dtbr
			endif
			enddo
			isfrc = isfrc + 1
			time(isfrc) = taui+tdur
		else
			ampl = 0.
			tburst=0.
		endif
		ampr=ampl

!		Store t = tauf
		isfrc = isfrc + 1
		time(isfrc) = tauf				! tauf = age of model galaxy requested by user
!		Store t = tobs in time array.
		tobs=age_model(tauf,0.,znew,zform,tlt1,tlt2)	! tobs = age in SSP model closest to tauf at z = 0
		isfrc = isfrc + 1
		time(isfrc) = tobs
!		Store t = tzob in time array.
		tzob=age_model(tobs,zobs,znew,zfor2,tlt1,tlt2)! tzob = age in SSP model closest to tauf-LTT(0:zobs); znew = z corresponding to age tzob, may differ slightly from zobs
		isfrc = isfrc + 1
		time(isfrc) = tzob
		tsng = tzob

!		Fill in SFR array
		do i=1,isfrc
		if (time(i) <= tauj) then
			usr_sfr(i) = con1*exp(-time(i)/tau1)
		else
			usr_sfr(i) = con2*exp(-time(i)/tau2)
		endif
		enddo
!		Sort and suppress duplicate entries in SFR
		call sort2(isfrc,time,usr_sfr)
		j=1
		do i=2,isfrc
		if (time(i) > time(i-1)) then
			j=j+1
			time(j)=time(i)
			usr_sfr(j)=usr_sfr(i)
			if (time(j) == tauf) jsfrc=j
			if (time(j) == tobs) jsfro=j
			if (time(j) == tzob) jsfrz=j
		endif
		enddo
		isfrc=j
!		Compute mass of subyacent population at t = tform
		tsubya=trapz1(time,usr_sfr,jsfrc)
!		Scale burst amplitude to obtain required fraction
!		Compute mass of stars formed in burst
		if (ampr > 0.) then
			if (taui+tdur <= tauf) then
				ampl   = ampr*tsubya/tdur
				tburst = ampl*tdur
			else
				ampl   = ampr*tsubya/(tauf-taui)
				tburst = ampl*(tauf-taui)
			endif
!			Add burst population
			do i=1,isfrc
			if (time(i) >= taui .and. time(i) <= taui+tdur) then
				usr_sfr(i) = usr_sfr(i) + ampl
			endif
			enddo
		endif
!		Compute total mass in stars at t = tform
		tstelm=trapz1(time,usr_sfr,jsfrc)
!		Compute total mass in stars at t = tobs (at z = 0)
		tstelo=trapz1(time,usr_sfr,jsfro)
!		Compute total mass in stars at t = tzob (at z = zobs)
		tstelz=trapz1(time,usr_sfr,jsfrz)
!		Compute mass of stars formed during last Gyr
		tlast1=trapz2(time,usr_sfr,isfrc,tauf-1.e9,tauf,ierr)
!		Write ascii file with SFR
!		close (501)
		write (aux,'(a)') '# SFR parameters after Chen et al. (2012)'
		call s500('a',aux,0.)
		write (aux,'(a)') '#'
		call s500('a',aux,0.)
!		read  (501,*) zx
		call r500(1,'f',aux,zx)
		if (zx == 0.) then
			write (aux,101)   'Z/Zsun'
			call s500('a',aux,0.)
		else
			write (aux,101)   'Z/Zsun',zx
			call s500('a',aux,0.)
		endif
!		read  (501,*) w1
		call r500(2,'f',aux,w1)
!		read  (501,*) aux
		call r500(3,'a',bux,zap)
		if (w1 > 0.) then
			write (aux,104)   'SSP-1:','   '//bux(1:largo(bux)),'   weight =',w1
			call s500('a',aux,0.)
		endif
!		read  (501,*) w2
		call r500(4,'f',aux,w2)
!		read  (501,*) aux
		call r500(5,'a',bux,zap)
		if (w2 > 0.) then
			write (aux,104)   'SSP-2:','   '//bux(1:largo(bux)),'   weight =',w2
			call s500('a',aux,0.)
		endif
!		read  (501,*) vtau,vmud
		call r500(6,'f',aux,vtau)
		call r500(7,'f',aux,vmud)
!		close (501)
		write (aux,101)   'tau_v ',vtau
		call s500('a',aux,0.)
		write (aux,101)   'mu_d  ',vmud
		call s500('a',aux,0.)
		write (aux,'(a)') '#'
		call s500('a',aux,0.)
		write (aux,100)   'Tform ',tauf*1.E-9
		call s500('a',aux,0.)
		if (tau1 < 1.E11) then
			write (aux,100)   'tau1  ',tau1*1.E-9
		else
			write (aux,107)   'tau1  ',tau1*1.E-9
		endif
		call s500('a',aux,0.)
		if (tau2 < 1.E11) then
			write (aux,100)   'tau2  ',tau2*1.E-9
		else
			write (aux,107)   'tau2  ',tau2*1.E-9
		endif
		call s500('a',aux,0.)
		write (aux,100)   'tauj  ',tauj*1.E-9
		call s500('a',aux,0.)
		write (aux,'(a)') '#'
		call s500('a',aux,0.)
		write (aux,101)   'Burst amplitude',ampr
		call s500('a',aux,0.)
		write (aux,100)   'Burst starts at',taui*1.e-9
		call s500('a',aux,0.)
		write (aux,100)   'Burst lasts    ',tdur*1.e-9
		call s500('a',aux,0.)
		write (aux,'(a)') '#'
		call s500('a',aux,0.)
!		Report stellar mass
		write (6,*)
		write (6,*) '              Mass computed numerically form SFR:'
		write (6,*)
		write (6,*) '              Mass of stars in subyacent population = ',tsubya
		write (6,*) '              Mass of stars formed in burst         = ',tburst
		write (6,*) '              Mass of stars formed during last Gyr  = ',tlast1
		if (ampr > 0.) then
			write (6,*) '              Mass ratio burst/subyacent population = ',ampr,' = requested burst amplitude.'
			write (6,*) '              Mass ratio burst/subyacent population = ',tburst/(tstelm-tburst),' = burst amplitude. % difference with requested amplitude =',(tburst/(tstelm-tburst) -ampr)/ampr*100.
		else
			write (6,*) '              Mass ratio burst/subyacent population = ',tburst/tsubya,' = burst amplitude'
		endif
		write (6,*)
		write (6,*) '              Mass of stars in total population     = ',tstelm,'   at t = Tform       = ',tauf*1.e-09,' Gyr  (requested)'
		write (6,*) '              Mass of stars in total population     = ',tstelo,'   at t = Tform''      = ',tobs*1.e-09,' Gyr  (used)     <---'
		write (6,*) '              Mass of stars in total population     = ',tstelz,'   at t = Tform''-LTT  = ',tzob*1.e-09,' Gyr  (used)     <---'
		write (6,*) '                                        At z = zobs = ',zobs  ,'   light travel time  = ',tlt1,' Gyr  (requested)'
		write (6,*) '                                        At z =        ',znew  ,'                 LTT  = ',tlt2,' Gyr  (used)     <---'
		write (6,*) '                                              zform = ',zform
		write (6,*)
		write (aux,'(a)') '# Mass computed numerically from SFR in table below.'
		call s500('a',aux,0.)
		write (aux,'(a)') '#'
		call s500('a',aux,0.)
		write (aux,102) 'Mass of stars in subyacent population',tsubya
		call s500('a',aux,0.)
		write (aux,102) 'Mass of stars formed in burst        ',tburst
		call s500('a',aux,0.)
		write (aux,102) 'Mass of stars formed during last Gyr ',tlast1
		call s500('a',aux,0.)
		write (aux,'(a)') '#'
		call s500('a',aux,0.)
		if (ampr > 0.) then
!			write (aux,103) 'Mass ratio burst/subyacent population = ',ampr,' = requested burst amplitude.'
			write (aux,103) 'Mass ratio burst/subyacent population = ',tburst/(tstelm-tburst),' = burst amplitude. % difference with requested amplitude =',(tburst/(tstelm-tburst) -ampr)/ampr*100.
		else
			write (aux,103) 'Mass ratio burst/subyacent population',tburst/tsubya,' = burst amplitude.'
		endif
		call s500('a',aux,0.)
		write (aux,'(a)') '#'
		call s500('a',aux,0.)
		write (aux,102) 'Mass of stars in total population    ',tstelm,'   at t = Tform       = ',tauf*1.e-09,' Gyr  (requested)'
		call s500('a',aux,0.)
		write (aux,102) 'Mass of stars in total population    ',tstelo,'   at t = Tform''      = ',tobs*1.e-09,' Gyr  (used)     <---'
		call s500('a',aux,0.)
		write (aux,102) 'Mass of stars in total population    ',tstelz,'   at t = Tform''-LTT  = ',tzob*1.e-09,' Gyr  (used)     <---'
		call s500('a',aux,0.)
		write (aux,105) '                         At z = zobs ',zobs  ,'   light travel time  = ',tlt1,' Gyr  (requested)'
		call s500('a',aux,0.)
		write (aux,105) '                         At z        ',znew  ,'                 LTT  = ',tlt2,' Gyr  (used)     <---'
		call s500('a',aux,0.)
		write (aux,105) '                               zform ',zform
		call s500('a',aux,0.)
		write (aux,'(a)') '#'
		call s500('a',aux,0.)
		write (aux,106) 'summary:',tauf,tstelm,tobs,tstelo,zform,zobs,znew,tzob,tstelz
		call s500('a',aux,0.)
		write (aux,'(a)') '#'
		call s500('a',aux,0.)
!		Write SFR properly
		write (aux,'(a)') '#    t(yr)           SFR (Mo/yr)'
		call s500('a',aux,0.)
		isfrc=jsfrz
		tauf=tzob
		do j=1,isfrc
		write (aux,*) time(j),usr_sfr(j)
		call s500('a',aux,0.)
		enddo
!		close (500)
100		format ('# ',a,' = ',f10.5,' Gyr')
107		format ('# ',a,' = ',f10.1,' Gyr')
101		format ('# ',a,' = ',f10.5)
102		format ('# ',a,' = ',1pe12.5,' Mo',a,0pf10.5,a)
103		format ('# ',a,' = ',f8.5,a,f6.3)
104		format ('# ',a,' = ',2a,f10.5)
105		format ('# ',a,' = ',f8.5,7x,a,0pf10.5,a)
106		format ('# ',a,1p4e14.5,0p3f10.5,1p2e14.5)
!		Read SFR from ascii file fort.500 written above and continue as in option 7
		io = 7
		tau=usrsfr(-500.)
		isingle=1
	endif
	last=0
	if (io.eq.0.or.io.eq.2.or.io.eq.7) return
17	write(6,'(x,a,f4.1,a,$)')'Make SFR = 0 at time > TCUT [',tcut*1.e-9,' Gyr] = '
	read (5,'(f10.0)',err=17,end=6) ttcut
	if (ttcut.gt.0.) then
		tcut=1.e9*ttcut
		if (io.eq.1.or.io.eq.4) then
			agas=exp(-tcut/tau)
		else
			agas=rgas(tcut)
		endif
		write (6,'(x,a,f6.4,a)') 'Unprocessed gas at TCUT = ',agas,' Mo'
	endif
	return
6	stop
	end

	Function rgas(tcut)

!	Computes amount of unprocessed gas remaining at t=tcut, not including
!	gas ejected by dying stars.

	real tfe(500)
	dt=0.05E9
	tt=-dt
	do i=1,500
	tt=tt+dt
	if (tt.ge.tcut) goto 1
	tfe(i)=sfr(tt)
	enddo
1	rgas=1.-trapez(tfe,i-1,dt)
	if (rgas.lt.0.) rgas=0.
	return
	end

	SUBROUTINE GET_EPSILON(IO)

!	Gets fraction of ejected gas to be recycled in stars = epsilon

	include 'recycle.dec'

	write (6,'(1x,a)') 'Epsilon = fraction of ejected gas to be recycled in stars = '
	write (6,'(1x,a)') 'Values from 0.001 to 1 have been explored'
	write (6,'(1x,a)') 'Epsilon = 0.001 reproduces old_galaxev mu_SFR=0.50 model'
	write (6,'(1x,a)') 'Epsilon > 1 emulates gas infall'
	write (6,'(1x,a)') 'Epsilon < 0 emulates galactic wind'
1	write (6,'(1x,a,$)') 'epsilon = '
	read (5,'(f10.0)',err=1,end=2) epsilon
	if (epsilon.eq.0.) io=4
	lgas=0
	return
2	stop
	end

	FUNCTION AGE_MODEL(TX,ZOBS,ZNEW,ZFORM,TLT1,TLT2)

!	Returns last time step to be used in csp_galaxev integration for Chen et al. SFH model
!	Last time step is the closest value of tb(i) to TX

!	Variables
	include 'jb.dec'
	include 'csp.dec'

!	Check for zobs > 0; Cosmology: data h/70./,omega/0.30/,omega_lambda/0.70/
	h0=70.
!	Obtain cosmological constant and parameter q
	clambda=cosmol_c(h0,0.30,0.70,q)
	if (zobs > 0.) then
		tuni=t(h0,q,0.00,clambda)	! age of universe at z = 0
		tobs=t(h0,q,zobs,clambda)	! age of universe at z = zobs
		tlt1=(tuni-tobs)*1.E9		! light travel time from z = 0 to z=zobs
		tobs=tx-tlt1			! age of galaxy at z = zobs
	else
		tlt1=0.       			! light travel time from z = 0
		tobs=tx				! requested age of galaxy at z = 0
	endif
!	Find closest age to t = tobs in array tb
	nfinal = kfinal(tobs)
	if (tb(nfinal) < tobs) tb(nfinal) = tobs
	if (tb(nfinal) > tobs) tb(nfinal) = tobs
!	Age of model at i = nfinal
	age_model= tb(nfinal)
!	Store age of galaxy (used) at z = 0.
!	Redshift corresponding to LTT = tobs-tb(nfinal) in Gyr
	if (age_model < tx) then
		tlt1  = tlt1*1.E-9
		tlt2  = (tx-age_model)*1.E-9
		znew  = zx(tlt2,h0,q,clambda)
	else
		tlt2  = 0.
		znew  = 0.
		zform = zx(tx*1.E-9,h0,q,clambda)
		if (zform == -2.) zform = 99.99999
	endif
	return
	end

	INTEGER FUNCTION KFINAL(TX)

!	Returns i for time step tb(i) closest in value to TX
!	Integration in csp_galaxev is performed up to this value for Chen et al. SFH model

!	Variables
	include 'jb.dec'
	include 'csp.dec'

!	Find closes time step to t = TX
	kfinal=0
	do i=0,nsteps-1
	if (tb(i) <= tx) then
		kfinal = i
	endif
	enddo

!	Refine position of age tb(i) closest to tx
	if (abs(tb(kfinal+1)-tx) < abs(tb(kfinal)-tx)) kfinal=kfinal+1
	return
	end

	subroutine delete_files(name,iw,iop)

c	Writes command file to delete some files produced by program bc97_galaxev

c	Array declaration
	character*(*) name

c	Open command file
	close (91)
	open (91,file='bc03.rm',status='unknown',access='append')

c	Check type of file
	if (abs(iw).eq.1238.or.abs(iw).eq.6528) then
c		low resolution mode
		ires=0
	elseif (iw.eq.9000) then
c		various resolution modes called by downgrade_resolution
		ires=-2
	elseif (iw.lt.0) then
c		high resolution mode called by sub_mix_stelib
		ires=-1
	elseif (iw.eq.9848.or.iw.eq.11288.or.iw.eq.20305) then
c		high resolution mode called by sub_mix_stelib_pickles
		ires=-3
	elseif (iw.eq.4367.or.iw.eq.6700.or.iw.eq.15011) then
c		high resolution mode (hrs) called by any program
		ires=+1
	else
c		high resolution mode in general
		ires=+2
	endif

c	Write delete file command
	if (ires.eq.0) then
c		Keep only *.?color, *.1ABmag, and *.ised files in _lr_ mode
		write (91,'(a)') '# Delete _lr_ lsindx files.'
		call chaext(name,'?lsindx_ffn',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'?lsindx_sed',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'?lsindx_sed_lick_system',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'8lsindx_sed_fluxes',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
	elseif (ires.eq.-2) then
c		Keep only *.1color, *.2color, *.1ABmag, *.?lsindx_sed, and *.ised files
		write (91,'(a)') '# Delete *.?color files.'
		call chaext(name,'3color',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'4color',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		write (91,'(a)') '# Delete *.?lsindx_ffn files and similar.'
		call chaext(name,'?lsindx_ffn',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'?lsindx_sed_lick_system',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'8lsindx_sed_fluxes',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
	elseif (ires.eq.-1) then
c		Delete or rename *_hrs_* files after usage by sub_mix_stelib
		write (91,'(a)') '# Delete or rename _hrs_ color and lsindx files.'
		call chaext(name,'?color',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'1ABmag',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'?lsindx_ffn',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'?lsindx_sed',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'ised',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'6lsindx_sed_lick_system',nn)
		j=index(name,'_hrs_')
		write (91,'(5a)') 'mv -f ',name(1:largo(name)),' ',name(1:j+2),name(j+4:largo(name))
		call chaext(name,'7lsindx_sed_lick_system',nn)
		write (91,'(5a)') 'mv -f ',name(1:largo(name)),' ',name(1:j+2),name(j+4:largo(name))
		call chaext(name,'8lsindx_sed_fluxes',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
c		write (91,'(3a)') 'rm -f ',name(1:j+2),name(j+4:largo(name))
	elseif (ires.eq.-3) then
c		Delete excess files produced by sub_mix_stelib_pickles
		write (91,'(a)') '# Delete excess files produced by sub_mix_stelib_pickles'
		call chaext(name,'3color',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'4color',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'5color',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'?lsindx_ffn',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'?lsindx_sed',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'?lsindx_sed_lick_system',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'8lsindx_sed_fluxes',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		write (91,'(2a)') 'rm -f bc2003_lr_p?_*'
	elseif (ires.eq.+1) then
c		Delete or rename *_hrs_* color files after created by bc97_galaxev
		write (91,'(a)') '# Delete _hrs_ color and 8lsindx files.'
		call chaext(name,'?color',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'1ABmag',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
		call chaext(name,'8lsindx_sed_fluxes',nn)
		write (91,'(2a)') 'rm -f ',name(1:largo(name))
	elseif (ires.eq.+2) then
		write (91,'(a)') '# Delete 8lsindx file.'
		call chaext(name,'8lsindx_sed_fluxes',nn)
c		write (91,'(2a)') 'rm -f ',name(1:largo(name))
	endif
	if (iop.ne.0) then
		! Delete *.5color file for non SSP's
		! write (91,'(a)') '# Delete 5color file for non SSP''s.'
		! call chaext(name,'5color',nn)
		! write (91,'(2a)') 'rm -f ',name(1:largo(name))
	endif
	return
	end

	PROGRAM BIG_CSP_GALAXEV

!	Computes spectral energy distribution as a function of time for a
!	Composite Stellar Population (CSP) by performing a convolution integral
!	of the spectral energy distributions for a Single Stellar Population SSP
!	with the chosen Star Formation Rate (SFR).

!	Modified in Toulouse: 6/8/97 to include both convolution of sed and spectral indices

!	Modified version of csp_galaxev to allow for large SFH files entered by user.
!	GBA, August 1st, 2013

!	Array declarations
	include 'jb.dec'
	include 'csp.dec'
	character ans,name*256,save*256,aux*512,atlas
	logical stelib
	real w(imw),h(imw)
	real tauv,mu_d,tv,fext,fi(40),fc(40),ta(0:jts)
	real snr(0:jts),pnr(0:jts), bh(0:jts), sn(0:jts), wd(0:jts), rm(0:jts)
	real bol(0:jts),str(0:jts), sf(0:jts),evf(0:jts),gas(0:jts),gal(0:jts),xml(0:jts),xdp(0:jts)
	real fxu(0:jts),fxg(0:jts),fxr(0:jts),fxi(0:jts),fxz(0:jts),fxk(0:jts),tofr(0:jts),bolmr(0:jts)
	real ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwa,mwla
	common /w_ages/ fxu,fxg,fxr,fxi,fxz,fxk,ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwa,mwla
	data ihrd/0/,atlas/' '/

!	Check if correct filter file is in use.
	j=ifilter()
	if (j.eq.0) then
		write (6,'(2a)') char(7),'Please assign correct filter file'
		write (6,'(2a)') char(7),'Use command: stdfilt'
		stop
	endif

!	Ask for file name
	save='_'
1	call copyright(6)
2	l=margo(save)
	write (6,'(x,3a,$)') 'BC_GALAXEV SSP sed in file [',save(1:l),'] = '
	read (5,'(a)',end=10) name
	if (largo(name).eq.0) then
		name=save
	else
!		Check if interpolation in metallicity of SSP is requested
		call interpolate_ssp(name)
	endif
	call s500('k','',5.)
	call chaext(name,'ised',mm)
	iread=0
	if (name.ne.save) iread=1
!	lr=index(name,'_lr_')
	open (1,file=name,form='unformatted',status='old',err=3)
	close (1)
	jdef=jjdef(name)

!       Ask for dust attenuation parameters
        write (6,'(/x,a,$)')   'Include attenuation by dust? Y/[N] '
        read (5,'(a)',end=10) ans
        if (ans.ne.'y'.and.ans.ne.'Y') then
           tauv=0.
	   mu_d=0.
        else
13         write (6,'(/x,a)')     '[using simple 2-component model of Charlot & Fall (2000)]'
           write (6,'(x,a,$)') 'Enter total effective attenuation optical depth: tau_V [1.0] = '
!          read (5,'(f10.0)',err=13,end=10) tauv
           read (5,'(a)',end=10) aux
	   if (largo(aux).eq.0) then
                tauv=1.
           else
                read (aux,*,err=13) tauv
           endif
14         write (6,'(x,a,$)') 'Enter fraction of tau_V arising from the ambient ISM: mu [0.3] = '
!          read (5,'(f10.0)',err=14,end=10) mu_d
	   read (5,'(a)',end=10) aux
           if (largo(aux).eq.0) then
                mu_d=0.3
           else
                read (aux,*,err=14) mu_d
           endif
	   write (6,'(x,a,f7.4)') '...using tau_V = ',tauv
	   write (6,'(x,a,f7.4)') '            mu = ',mu_d
        endif
!	write (501,*) tauv,mu_d
	call s500('f','',tauv)
	call s500('f','',mu_d)

!	Open input sed file (read again, tb modified in case of truncated SFR)
!	if (iread.ne.0) then
	   save=name
	   close (1)

!	   Check length of records (needed in Linux)
	   open (1,file=name,form='unformatted',status='old',err=3)
	   read (1)
	   read (1)
	   read (1,err=55) inl,(h(i),i=1,inl),inx
!	   write (6,*) inl,inx
	   imx=1
	   goto 56
55	   imx=0
56	   close (1)
	   open (1,file=name,form='unformatted',status='old',err=3)
!	   Read basic parameters from SSP input file
	   read (1) nsteps,(tb(i),i=0,nsteps-1),ml,mu,iseg,
     &	   (xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),
     &	   totm,totn,avs,jo,tauo,id,tcut,ttt,ttt,ttt,id,id,igw,stelib

	   if (jo.ne.0) then
	      write (6,'(x,a$)')'File does not contain an SSP. Proceed Y/[N] ? '
	      read (5,'(a)',end=10) ans
	      if (ans.ne.'y'.and.ans.ne.'Y') goto 1
	   endif
!	   Read sed from SSP file
	   write (6,'(2a)') ' Reading file ',name
	   read (1) inl,(w(i),i=1,inl)
	   do n=0,nsteps-1
	   if (imx.gt.0) then
		read (1) inl,(fl(i,n),i=1,inl),inx,(fl(i,n),i=inl+1,inl+inx)
	   else
		read (1) inl,(fl(i,n),i=1,inl)
		inx=0
	   endif
!          Attenuate by dust if requested (use Charlot & Fall, 2000, ApJ, 539, 718)
           if (tauv.gt.0.) then
              if (tb(n).le.1.e7) then
                 tv=tauv
              else
                 tv=mu_d*tauv
              endif
              do i=1,inl
                fl(i,n)=fl(i,n)*fext(w(i),tv)
              enddo
           endif
	   enddo
	   inw=inl+inx
	   write (6,*) inl,' wavelength points per record'
	   write (6,*) inx,' spectral index points per record'
	   write (6,*) inw,' total points per record'
	   write (6,*) nsteps,' time steps'
	   read (1,end=4) nsteps,(bflx(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(strm(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(sf(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(evfl(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(snbr(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(pnbr(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(bhtn(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(sntn(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(wdtn(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(rmtm(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(tofr(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(bolmr(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(gasms(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(galms(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(rml(i),i=0,nsteps-1)
	   read (1,end=4) nsteps,(rdp(i),i=0,nsteps-1)
	   do i=0,nsteps-1 ; toff(i)  = tofr(i) ; enddo
	   do i=0,nsteps-1 ; bolms(i) = bolmr(i) ; enddo
4	   close (1)

!	   Store flux in the u, g, r, i, z, and K bands for each SSP age in order
!	   to compute the flux weighted age of the composite population.
!		filter = 120 SDSS Camera u Response Function, airmass = 1.3 (June 2001)
!		filter = 121 SDSS Camera g Response Function, airmass = 1.3 (June 2001)
!		filter = 122 SDSS Camera r Response Function, airmass = 1.3 (June 2001)
!		filter = 123 SDSS Camera i Response Function, airmass = 1.3 (June 2001)
!		filter = 124 SDSS Camera z Response Function, airmass = 1.3 (June 2001)
!		filter =  57 IR K filter + Palomar 200 IR detectors + atmosphere.57
5	   write (6,'(/x,a,$)') 'Compute flux weighted age in the galaxy rest frame at z [0] = '
	   read (5,'(f12.0)',err=5,end=10) z
!	   read (5,*,err=5,end=10) z
	   do n=0,nsteps-1
	   do i=1,inl
	   h(i)=fl(i,n)
	   enddo
!	   In the observer frame use the value of z entered above
!	   zu = z
!	   In the galaxy restframe use z = 0
	   zu = 0.
	   fxu(n) = filter_n(120,w,h,inl,zu,kerr)
	   fxg(n) = filter_n(121,w,h,inl,zu,kerr)
	   fxr(n) = filter_n(122,w,h,inl,zu,kerr)
	   fxi(n) = filter_n(123,w,h,inl,zu,kerr)
	   fxz(n) = filter_n(124,w,h,inl,zu,kerr)
	   fxk(n) = filter_n( 57,w,h,inl,zu,kerr)
	   enddo

!	endif

!	Ask for SFR
	call sfr_0_b(1,z)

!	Define time steps to compute new sed, for instance:
!	tbeg=2.5E9 ; tend= 3.5e9 ; tstp=5.0e6 ; msteps=1+(tend-tbeg)/tstp ; do n=0,msteps-1 ; ta(n)=tbeg+n*tstp ; enddo
!	tbeg=2.5E9 ; tend= 3.5e9 ; tstp=1.0e6 ; msteps=1+(tend-tbeg)/tstp ; do n=0,msteps-1 ; ta(n)=tbeg+n*tstp ; enddo
	tbeg=0.0E9 ; tend=14.0e9 ; tstp=1.0e6 ; msteps=1+(tend-tbeg)/tstp ; do n=0,msteps-1 ; ta(n)=tbeg+n*tstp ; enddo
	write (6,*) msteps,' time steps in new grid, from:',ta(0),' to',ta(msteps-1)

!	Expand time scale if required
!	if ((io.ne.2.and.tcut.lt.20.E9).or.(io.eq.2.and.tcut.gt.2.E9)) call expand_time_steps
	if ((io.ne.2.and.tcut.lt.20.E9).or.(io.eq.2                 )) call expand_time_steps
	if (io.eq.7) call add_time_steps

!	Ask for output file name. Open files.
!	Write time scale, IMF, and wavelength scale in output file
	lun=-1
	ioption=99
	call name_sed(lun,jun,kdist,ihrd,ioption,jdef,ldef,ml,mu,name,atlas)

!	Compute convolution integral, rest frame colors, and write results for CSP
	if (isingle == 0) then
!		Use for standard csp models
		nstart = 0
		nfinal = msteps-1
		write (lun) msteps,(ta(i),i=0,msteps-1),ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,io,tau,id,tau,tau,1.,1.,id,id,igw,stelib
	else
!		Use for Chen et al. SFH model
		call s500('r',name,0.)
		nfinal=kfinal(tsng)
		nstart = nfinal
		write (lun) 1,tb(nfinal),ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,io,tau,id,tau,tau,1.,1.,id,id,igw,stelib
	endif
	write (lun) inl,(w(i),i=1,inl)
	do n=nstart,nfinal
	age=ta(n)
	if (io.gt.0) then
!		Perform convolution with chosen SFR
		call convolve_tx(h,age,bol(n),str(n),evf(n),snr(n),pnr(n),bh(n),sn(n),wd(n),rm(n),gas(n),gal(n),xml(n),xdp(n))
		call file_w_ages(io,name,zu,age,w,h,inl,ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,mwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwla)
	else
!		Interpolate in log t input SSP model at this age
		if (age <= tb(0)) then
			i=1
			a=0.
		elseif (age >= tb(nsteps-1)) then
			i=nsteps
			a=0.
		else
			call locate(tb,nsteps-1,age,i)
			if (tb(i-1) > 0.) then
				a = alog10(age/tb(i-1))/alog10(tb(i)/tb(i-1))
			else
				a = age/tb(i)
			endif
		endif
		b=1.-a
		do l=1,inw
		h(l)     = b*fl(l,i-1)   + a*fl(l,i)
		enddo
		bol(n)   = b*bflx(i-1)   + a*bflx(i)
		str(n)   = b*strm(i-1)   + a*strm(i)
		evf(n)   = b*evfl(i-1)   + a*evfl(i)
		snr(n)   = b*snbr(i-1)   + a*snbr(i)
		pnr(n)   = b*pnbr(i-1)   + a*pnbr(i)
		bh (n)   = b*bhtn(i-1)   + a*bhtn(i)
		sn (n)   = b*sntn(i-1)   + a*sntn(i)
		wd (n)   = b*wdtn(i-1)   + a*wdtn(i)
		rm (n)   = b*rmtm(i-1)   + a*rmtm(i)
		toff(n)  = b*tofr(i-1)   + a*tofr(i)
		bolms(n) = b*bolmr(i-1)  + a*bolmr(i)
		gas(n)   = b*gasms(i-1)  + a*gasms(i)
		gal(n)   = b*galms(i-1)  + a*galms(i)
		xml(n)   = b*rml(i-1)    + a*rml(i)
		xdp(n)   = b*rdp(i-1)    + a*rdp(i)
!		write (6,*) age,b,i-1,tb(i-1),a,i,tb(i)
!		read (5,*)
	endif
!	Compute galaxy mass
	do i=1,n
!	sf(n)=sfr(tb(n))
	sf(n)=sfr(ta(n))	! just for new time scale in big_csp_galaxev
	enddo
!	galmass=gal_mass(io,tb(n),sf(n))
	galmass=gal_mass(io,ta(n),sf(n))

!	Store sed. Report standard colors and Guy Worthey Spectral indices
	if (isingle == 0 .or. n == nfinal) then
		write (lun) inl,(h(i),i=1,inl),inx,(h(i),i=inl+1,inl+inx)
		call rf_color(io,age,w,h,inl,lun,bol(n),str(n),sf(n),evf(n),snr(n),pnr(n),bh(n),sn(n),wd(n),rm(n),toff(n),bolms(n),gas(n),gal(n),xml(n),xdp(n))
!		Guy Worthey Spectral indices
		inx2=inx/2
		do i=1,inx2
		fi(i)=h(inl+i)
		fc(i)=h(inl+inx2+i)
		enddo
		igw=0
!		call gw_indices(tb(n),fi,fc,lun,igw)
		call gw_indices(ta(n),fi,fc,lun,igw)
	endif

!	Report percent done
	if (n.gt.1) call percent(6,n,nfinal,'BIG_CSP_GALAXEV ' // name(1:nargo(name)))
	enddo

!	Add time behaviour of various quantities
	if (isingle == 0) then
		write (lun) msteps,(  bol(i),i=0,msteps-1)
		write (lun) msteps,(  str(i),i=0,msteps-1)
		write (lun) msteps,(   sf(i),i=0,msteps-1)
		write (lun) msteps,(  evf(i),i=0,msteps-1)
		write (lun) msteps,(  snr(i),i=0,msteps-1)
		write (lun) msteps,(  pnr(i),i=0,msteps-1)
		write (lun) msteps,(   bh(i),i=0,msteps-1)
		write (lun) msteps,(   sn(i),i=0,msteps-1)
		write (lun) msteps,(   wd(i),i=0,msteps-1)
		write (lun) msteps,(   rm(i),i=0,msteps-1)
		write (lun) msteps,( toff(i),i=0,msteps-1)
		write (lun) msteps,(bolms(i),i=0,msteps-1)
		write (lun) msteps,(  gas(i),i=0,msteps-1)
		write (lun) msteps,(  gal(i),i=0,msteps-1)
		write (lun) msteps,(  xml(i),i=0,msteps-1)
		write (lun) msteps,(  xdp(i),i=0,msteps-1)
	endif

!	Write command file to delete unwanted files
	call delete_files(name,inl,1)
	call file_w_ages(-1,name,zu,age,w,h,inl,ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,mwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwla)
	goto 1

3	write (6,'(x,5a)') char(7),'File ',name(1:largo(name)),' not found',char(7)
	goto 2
10	end

        REAL FUNCTION FEXT(X,TV)
        real x,tv,tau

        fext=1.

        if (tv.eq.0.) return

        tau=tv*( (5500./x)**0.7 )
        fext=exp(-tau)

        return
        end

	SUBROUTINE DEGRADE_TO_CONSTANT_RESOLUTION(X,Y,N,S,S0,YS)

c	Degrades high resolution sed in (x,y) to a lower resolution
c	(of constant sigma S in wavelength) by applying a gaussian broadening function.

c	S0 = resolution (sigma) in Angstrom of input sed.

c	Returns smoothed spectrum in array (x,ys)

c	Array declaration
	real x(n),y(n),ys(n),s0(n),u(10000),g(10000)

c	Number of sigmas to perform integration
	m=6

c	Compute resulting sigma
	do i=1,n
	sigma=s
	if (sigma.le.s0(i)) then
c		write (6,*) 'sigma < sigma_model',sigma,s0(i)
c		stop
		ys(i)=y(i)
	else
		sigma=sqrt(sigma**2-s0(i)**2)
		xmax=x(i)+m*sigma
		call locate(x,n,xmax,i1)
		m2=i1+1
		m1=2*i-m2
c		write (81,*) i,x(i),sigma,xmax,m1,m2
		if (m1.lt.1) m1=1
		if (m2.gt.n) m2=n
		if (m2-m1+1.lt.10) then
			ys(i)=y(i)
		else
			k=0
			do j=m1,m2
			k=k+1
			u(k)=x(j)
			g(k)=y(j)*gauss(x(j),x(i),sigma)
			enddo
			ys(i)=trapz1(u,g,k)
		endif
	endif
	enddo
	return
	end

	FUNCTION BH_IX_SED(J,X,F,N)

c	Computes value of Brodie and Hanes (1986) index J directly from sed
c	Follows procedure outlined by Brodie and Hanes (1986, ApJ 300, 258)
c	See their eqs. 1-2, and Table 2 in pag. 260.

c	J = Index identification
c	X = wavelength scale
c	F = flux scale (sed)
c	N = dimension of X, F
c	BH_IX_SED = index measured directly from sed.

c	Array declaration
	character*40 idxlbl
	real x(n),f(n),w(4)
	parameter (jid=35)
	integer iim(jid)
	real ffb(jid),ffr(jid),ffc(jid),ffl(jid)
	common /fluxes/ iim,ffb,ffr,ffc,ffl

c	Define wavelength range for selected index
	if (j.eq.1) then
		idxlbl = 'Delta (UV Blanketing)'
		w(1) = 3800.
		w(2) = 4000.
		w(3) = 4000.
		w(4) = 4200.
c		Mean flux through red window
       		fr=trapz3(x,f,n,w(3),w(4),ierr)
c		Mean flux through blue window
       		fb=trapz3(x,f,n,w(1),w(2),ierr)
c		Compute index 1
		bh_ix_sed = 2.5 * alog10(fr/fb)
		return
	elseif (j.eq.2) then
		idxlbl = 'H10 (Balmer line)'
		w(1) = 3785.
		w(2) = 3795.
		w(3) = 3810.
		w(4) = 3825.
	elseif (j.eq.3) then
		idxlbl = 'H9 (Balmer line)'
		w(1) = 3810.
		w(2) = 3825.
		w(3) = 3850.
		w(4) = 3865.
	elseif (j.eq.4) then
		idxlbl = 'Hpsi (Balmer line)'
		w(1) = 3865.
		w(2) = 3885.
		w(3) = 3910.
		w(4) = 3925.
	elseif (j.eq.5) then
		idxlbl = 'CN (UV cyanogen)'
		w(1) = 3785.
		w(2) = 3810.
		w(3) = 3910.
		w(4) = 3925.
	elseif (j.eq.6) then
		idxlbl = 'HK index (Ca II H and K lines)'
		w(1) = 3910.
		w(2) = 3925.
		w(3) = 3995.
		w(4) = 4015.
	elseif (j.eq.7) then
		idxlbl = 'Hdelta (Balmer line)'
		w(1) = 4075.
		w(2) = 4090.
		w(3) = 4125.
		w(4) = 4140.
	elseif (j.eq.8) then
		idxlbl = 'Ca (Ca I line)'
		w(1) = 4200.
		w(2) = 4215.
		w(3) = 4245.
		w(4) = 4260.
	elseif (j.eq.9) then
		idxlbl = 'G (CH G band)'
		w(1) = 4275.
		w(2) = 4285.
		w(3) = 4315.
		w(4) = 4325.
	elseif (j.eq.10) then
		idxlbl = 'Hgamma (Balmer line)'
		w(1) = 4315.
		w(2) = 4325.
		w(3) = 4360.
		w(4) = 4375.
	elseif (j.eq.11) then
		idxlbl = 'Hbeta (Balmer line)'
		w(1) = 4800.
		w(2) = 4830.
		w(3) = 4890.
		w(4) = 4920.
	elseif (j.eq.12) then
		idxlbl = 'Mg (Mg b triplet)'
		w(1) = 5125.
		w(2) = 5150.
		w(3) = 5195.
		w(4) = 5220.
	elseif (j.eq.13) then
		idxlbl = 'MH (Mg b + MgH)'
		w(1) = 4740.
		w(2) = 4940.
		w(3) = 5350.
		w(4) = 5550.
	elseif (j.eq.14) then
		idxlbl = 'FC (Fe I + Ca I)'
		w(1) = 5225.
		w(2) = 5250.
		w(3) = 5280.
		w(4) = 5305.
	elseif (j.eq.15) then
		idxlbl = 'Na (Na D lines)'
		w(1) = 5385.
		w(2) = 5865.
		w(3) = 5920.
		w(4) = 5950.
	elseif (j.eq.16) then
		idxlbl = 'FTC (Fe I + TiO + Ca I)'
		w(1) = 5950.
		w(2) = 6100.
		w(3) = 6330.
		w(4) = 6480.
	elseif (j.eq.17) then
		idxlbl = 'Halpha (Balmer line)'
		w(1) = 6480.
		w(2) = 6615.
		w(3) = 6575.
		w(4) = 6610.
	else
		write (6,*) 'Undefined BH index'
		bh_ix_sed = 999.99
	endif

c	Compute index according to BH definition
c	Mean flux through blue window
       	fb=trapz3(x,f,n,w(1),w(2),ierr)/(w(2)-w(1))
c	Mean flux through red window
       	fr=trapz3(x,f,n,w(3),w(4),ierr)/(w(4)-w(3))
c	Mean flux through central window
       	fc=trapz3(x,f,n,w(2),w(3),ierr)/(w(3)-w(2))
c	Compute index
	bh_ix_sed = 1.0 - 2.0*fc/(fb+fr)

c	Store values for HK index (Ca II H and K lines)
	if (j.eq.6) then
		iim(35)=1
		ffb(35)=fb
		ffr(35)=fr
		ffc(35)=fc
c		fl is not defined for this index
c		ffl(35)=fl
		ffl(35)=0.
	endif
	return
	end

	FUNCTION GAUSS(X,X0,SIGMA)

c	Returns value of gaussian function normalized to area = 1

c	Normalization constant
	data a/0./
	if (a.eq.0) then
		pi=4.*atan(1.)
		a=1./sqrt(2.*pi)
	endif
        c=a/sigma
        gauss=c*exp(-(x-x0)**2/sigma**2/2)
!	write (998,*) x,x0,a,sigma,c
        return
        end

	SUBROUTINE NAME_SED(LUN,JUN,KDIST,IHRD,IOPTION,JDEF,LDEF,ML,MU,EVOFILE,ATLAS)

!	Selects options and builds output file names

!	Array declaration
	parameter (nb=20,nph=20)
	logical done
	real ml,mu
	include 'stelib.dec'
        common /vazdekis/ jvaz,xmu
	character atlas,evofile*(*),phase(nph)*7,fract(nb)*4,stage(nb)*5,savefile*512,imf(-1:24)*7,tempfile*512,subdir*512,auxname*16

!	data phase/'ms','sgb','rgb','hb','agb','dcspn','cspn', 'wd',     'ccb', 'tpagb','coolg','coold'/
!	data phase/'ms','sgb','rgb','hb','agb','Orich','Crich','SWphase','cspn','wd',   'ccb',  'other'/
!	Modified to include WR stars (Dec 2013) Corrected Apr. 2017.
	data phase/'ms','sgb','rgb','hb','agb','Orich','Crich','Orich2','Crich2','SWphase','cspn','wd','ccb','other','WNL','WNE','WC','WO','WR','hotsed'/

!	data fract/'H'  , 'Ks','22','27','U','B','V','R','I','J','K','L','BOL'/
!	data fract/'I25','I60','22','27','U','B','V','R','I','J','K','L','BOL'/
!	data fract/'14' , '17','22','27','U','B','V','R','I','J','K','L','BOL'/
!	Modified to include IRAC and MIPS filters (July 2013)
	data fract/'14' , '17','22','27','U','B','V','R','I','J','K','L','I3p5','I4p5','I5p7','I7p9','M24','M70','M160','BOL'/

!	data stage/'nH'  ,'nKs' ,'n22','n27','nU','nB','nV','nR','nI','nJ','nK','nL','nBOL'/
!	data stage/'nI25','nI60','n22','n27','nU','nB','nV','nR','nI','nJ','nK','nL','nBOL'/
!	data stage/'n14' ,'n17' ,'n22','n27','nU','nB','nV','nR','nI','nJ','nK','nL','nBOL'/
!	Modified to include IRAC and MIPS filters (July 2013)
	data stage/'n14' ,'n17' ,'n22','n27','nU','nB','nV','nR','nI','nJ','nK','nL','nI3p5','nI4p5','nI5p7','nI7p9','nM24','nM70','nM160','nBOL'/

!	Various IMF's options
	data imf /'chab','chab','kroup','KROUP','salp','scalo','SCALO','mi_sc','ktg93','kenn', 'leque','ferra','piott','carig','thIMF','myIMF','vxpxx','Schab','Skroup','SKROUP','Ssalp',5*'NumIMF'/

!	Use to file name of models with IMF populated stochastically
	include 'stochnam.dec'

!	Check for Vazdekis IMF
	if (jvaz > 0) then
		write (imf(15)(2:),'(f4.2)') xmu
		imf(15)(3:3) = 'p'
	endif

!	Check for subdirectory at begining of name
	if (lun.eq.-99)	then
		do i=largo(evofile),1,-1
		if (evofile(i:i).eq.'/') then
			subdir=evofile(1:i)
			goto 2
		endif
		enddo
	endif

!	Ask for file name (if not entered in command line)
2	if (lun.lt.0) then
		evofile=' '
		call getenv('PREFIX',tempfile)
		if (largo(tempfile).eq.0) tempfile='op'
		if (stelib) then
			if (ngsl > 0) then
				tempfile=tempfile(1:largo(tempfile)) // '_lrs_hngsl'
			elseif (hires == 3 .and. qran) then
				tempfile=tempfile(1:largo(tempfile)) // '_hr_rmiles'	! Miles only (or pure Miles) including random errors in stellar parameters
			elseif (hires == 3) then
				tempfile=tempfile(1:largo(tempfile)) // '_hr_pmiles'	! Miles only (or pure Miles)
			elseif (hires == 4) then
				tempfile=tempfile(1:largo(tempfile)) // '_hr_smiles'	! Synthetic Miles
			elseif (hires == 5) then
				tempfile=tempfile(1:largo(tempfile)) // '_hrs_indous'	! IndoUS only (or pure IndoUS)
			elseif (hires == 6) then
				tempfile=tempfile(1:largo(tempfile)) // '_hrx_mastar'	! Miles + Tlusty UV
			! elseif (hires == 6) then
			! 	tempfile=tempfile(1:largo(tempfile)) // '_hrt_miles'	! Miles + Tlusty UV
			! elseif (hires == 7) then
			! 	tempfile=tempfile(1:largo(tempfile)) // '_hrl_miles'	! Miles + Tlusty + Leitherer et al. UV
			! elseif (hires == 8) then
			! 	tempfile=tempfile(1:largo(tempfile)) // '_hrw_miles'	! Miles + Tlusty + Smith et al. WR models
			elseif (hires == 9) then
				tempfile=tempfile(1:largo(tempfile)) // '_hrx_miles'	! Extended Miles=Miles+Tlusty+Leitherer+WR
			else
				tempfile=tempfile(1:largo(tempfile)) // '_hrs_stelib'
			endif
		else
			if (abs(ioption).ge.15.and.abs(ioption).le.19) then
				if (ioption.gt.0) then
					tempfile=tempfile(1:largo(tempfile)) // '_lr_bpgs'
				else
					tempfile=tempfile(1:largo(tempfile)) // '_lr_jacoby'
				endif
				if (abs(ioption).eq.15) then
					ioption = -62
				elseif (abs(ioption).eq.16) then
					ioption = -162
				elseif (abs(ioption).eq.17) then
					ioption = -96
					tempfile(1:6)='cb2007'
				elseif (abs(ioption).eq.18) then
					ioption = -107
					tempfile(1:6)='cb2009'
				elseif (abs(ioption).eq.19) then
					ioption = -117
					tempfile(1:6)='cb2009'
				endif
			elseif (abs(ioption).ge.5.and.abs(ioption).le.10) then
				if (ioption.gt.0) then
					tempfile=tempfile(1:largo(tempfile)) // '_lr_pickles_fir'
				else
					if (atlas.eq.'f') then
						tempfile=tempfile(1:largo(tempfile)) // '_lr_fanelli_pickles_fir'
					elseif (atlas.eq.'F') then
						tempfile=tempfile(1:largo(tempfile)) // '_lr_fanelli_pickles_irtf_fir'
					else
						write (6,*) 'Unknown option for Pickles extended atlas: ',atlas
						stop
					endif
				endif
				if (abs(ioption).eq.5) then
					ioption = -62
				elseif (abs(ioption).eq.6) then
					ioption = -162
				elseif (abs(ioption).eq.7) then
					ioption = -96
					tempfile(1:6)='cb2007'
!				elseif (abs(ioption).eq.8) then
!					ioption = -107
!					tempfile(1:6)='cb2009'
!				elseif (abs(ioption).eq.9) then
!					ioption = -117
!					tempfile(1:6)='cb2009'
!				elseif (abs(ioption).eq.10) then
!					ioption = -217
!					tempfile(1:6)='cb2010'
!				elseif (abs(ioption).eq.11) then
!					ioption = -317
!					tempfile(1:6)='cb2013'
				elseif (abs(ioption).eq.8) then
					ioption = -410
					tempfile(1:6)='cb2018'
				elseif (abs(ioption).eq.9) then
					ioption = -411
					tempfile(1:6)='cb2018'
				elseif (abs(ioption).eq.10) then
					ioption = -412
					tempfile(1:6)='cb2018'
				endif
			else
				if (galaxev) tempfile=tempfile(1:largo(tempfile)) // '_lr_BaSeL'
			endif
		endif

     	  if (ioption.gt.99) then
	  	tempfile=tempfile(1:largo(tempfile)) // '_p000_'
     	  	ii=index(tempfile,'_p000_')+2
     	  	kk=index(tempfile,    '0_')
		write (tempfile(ii:ii+2),'(i3)') ioption
     	  elseif (ioption.ge.91.and.ioption.le.96) then
!		Solution to handle Garching and BaSTI tracks
		if (.not.basti) then
	  		tempfile=tempfile(1:largo(tempfile)) // '_M0_'
     	  		ii=index(tempfile,'_M0_')+2
		else
	  		tempfile=tempfile(1:largo(tempfile)) // '_B0_'
     	  		ii=index(tempfile,'_B0_')+2
		endif
		kk=index(tempfile,    '0_')
		write (tempfile(ii:ii),'(i1)') abs(ioption)-90
		tempfile(1:6) = 'cb2007'
     	  elseif (ioption.gt.10) then
	  	tempfile=tempfile(1:largo(tempfile)) // '_p00_'
     	  	ii=index(tempfile,'_p00_')+2
     	  	kk=index(tempfile,   '0_')
		write (tempfile(ii:ii+1),'(i2)') ioption
     	  elseif (ioption.gt.0) then
	  	tempfile=tempfile(1:largo(tempfile)) // '_p0_'
     	  	ii=index(tempfile,'_p0_')+2
     	  	kk=index(tempfile,  '0_')
		write (tempfile(ii:ii),'(i1)') ioption
     	  elseif (ioption.gt.-10) then
	  	tempfile=tempfile(1:largo(tempfile)) // '_m0_'
     	  	ii=index(tempfile,'_m0_')+2
     	  	kk=index(tempfile,  '0_')
		write (tempfile(ii:ii),'(i1)') abs(ioption)
     	  elseif (ioption.gt.-99) then
	  	tempfile=tempfile(1:largo(tempfile)) // '_m00_'
     	  	ii=index(tempfile,'_m00_')+2
     	  	kk=index(tempfile,   '0_')
		write (tempfile(ii:ii+1),'(i2)') abs(ioption)
     	  elseif (ioption.gt.-800) then
	  	tempfile=tempfile(1:largo(tempfile)) // '_m000_'
     	  	ii=index(tempfile,'_m000_')+2
     	  	kk=index(tempfile,    '0_')
		write (tempfile(ii:ii+2),'(i3)') abs(ioption)
     	  endif

!	  Check for mass loss option
	  if     (massloss.eq.-2) then
	  		diewssvl=' '
			massloss=0				! Distorted Schultheis models
	  elseif (massloss.eq.-1) then
			tempfile=tempfile(1:kk) // 't_'		! Distorted IRTF + Aringer et al. C-star models
			diewssvl=tempfile(ii-1:kk+1)
			massloss=0
	  elseif (massloss.eq.10) then
			tempfile=tempfile(1:kk) // 'f_'		! IRTF + Aringer et al. C-star model, dustfree sed''s used as input for Dusty code (added in CB10 and CB13 models)
			diewssvl=tempfile(ii-1:kk+1)
	  elseif (massloss.eq.1) then
			tempfile=tempfile(1:kk) // 'n_'		!    1 x instantaneous normal mass loss rate from tracks
			diewssvl=tempfile(ii-1:kk+1)
	  elseif (massloss.eq.2) then
			tempfile=tempfile(1:kk) // 'p_'		!   10 x instantaneous normal low mass loss rate extrapolated from refereed paper figure
			diewssvl=tempfile(ii-1:kk+1)
	  elseif (massloss.eq.3) then
			tempfile=tempfile(1:kk) // 'q_'		!    5 x instantaneous normal low mass loss rate extrapolated from refereed paper figure
			diewssvl=tempfile(ii-1:kk+1)
	  elseif (massloss.eq.4) then
			tempfile=tempfile(1:kk) // 'r_'		!    2 x instantaneous normal low mass loss rate extrapolated from refereed paper figure
			diewssvl=tempfile(ii-1:kk+1)
	  elseif (massloss.eq.5) then
			tempfile=tempfile(1:kk) // 'm_'		! 1/10 x instantaneous normal low mass loss rate extrapolated from refereed paper figure
			diewssvl=tempfile(ii-1:kk+1)
	  elseif (massloss.eq.6) then
			tempfile=tempfile(1:kk) // 'i_'		! 2/10 x instantaneous normal low mass loss rate extrapolated from refereed paper figure
			diewssvl=tempfile(ii-1:kk+1)
	  elseif (massloss.eq.7) then
			tempfile=tempfile(1:kk) // 'j_'		! 5/10 x instantaneous normal low mass loss rate extrapolated from refereed paper figure
			diewssvl=tempfile(ii-1:kk+1)
	  elseif (massloss.eq.11) then
			tempfile=tempfile(1:kk) // 'na_'	!    1 x average normal mass loss rate from tracks
			diewssvl=tempfile(ii-1:kk+2)
	  elseif (massloss.eq.12) then
			tempfile=tempfile(1:kk) // 'pa_'	!   10 x average normal low mass loss rate extrapolated from refereed paper figure
			diewssvl=tempfile(ii-1:kk+2)
	  elseif (massloss.eq.13) then
			tempfile=tempfile(1:kk) // 'qa_'	!    5 x average normal low mass loss rate extrapolated from refereed paper figure
			diewssvl=tempfile(ii-1:kk+2)
	  elseif (massloss.eq.14) then
			tempfile=tempfile(1:kk) // 'ra_'	!    2 x average normal low mass loss rate extrapolated from refereed paper figure
			diewssvl=tempfile(ii-1:kk+2)
	  elseif (massloss.eq.15) then
			tempfile=tempfile(1:kk) // 'ma_'	! 1/10 x average normal low mass loss rate extrapolated from refereed paper figure
			diewssvl=tempfile(ii-1:kk+2)
	  elseif (massloss.eq.16) then
			tempfile=tempfile(1:kk) // 'ia_'	! 2/10 x average normal low mass loss rate extrapolated from refereed paper figure
			diewssvl=tempfile(ii-1:kk+2)
	  elseif (massloss.eq.17) then
			tempfile=tempfile(1:kk) // 'ja_'	! 5/10 x average normal low mass loss rate extrapolated from refereed paper figure
			diewssvl=tempfile(ii-1:kk+2)
	  elseif (massloss.eq.21) then
			tempfile=tempfile(1:kk) // 'nh_'	!    1 x hybrid normal mass loss rate from tracks
			diewssvl=tempfile(ii-1:kk+2)
!	Superseded
!	  elseif (massloss.eq.-2) then
!			tempfile=tempfile(1:kk) // 'p2_'  !   10 x normal low mass loss rate extrapolated from non-refereed paper Fig 2
!			diewssvl=tempfile(ii-1:kk+1)
!	  elseif (massloss.eq.-3) then
!			tempfile=tempfile(1:kk) // 'q2_'  !    5 x normal low mass loss rate extrapolated from non-refereed paper Fig 2
!			diewssvl=tempfile(ii-1:kk+1)
!	  elseif (massloss.eq.-4) then
!			tempfile=tempfile(1:kk) // 'r2_'  !    2 x normal low mass loss rate extrapolated from non-refereed paper Fig 2
!			diewssvl=tempfile(ii-1:kk+1)
!	  elseif (massloss.eq.-5) then
!			tempfile=tempfile(1:kk) // 'm2_'  ! 1/10 x normal low mass loss rate extrapolated from non-refereed paper Fig 2
!			diewssvl=tempfile(ii-1:kk+1)
!	  elseif (massloss.eq.-6) then
!			tempfile=tempfile(1:kk) // 'i2_'  ! 2/10 x normal low mass loss rate extrapolated from non-refereed paper Fig 2
!			diewssvl=tempfile(ii-1:kk+1)
!	  elseif (massloss.eq.-7) then
!			tempfile=tempfile(1:kk) // 'j2_'  ! 5/10 x normal low mass loss rate extrapolated from non-refereed paper Fig 2
!			diewssvl=tempfile(ii-1:kk+1)
!
!	  elseif (massloss.eq.-8) then
!			tempfile=tempfile(1:kk) // 's_'  ! No mass loss, Schultheis sed''s at all phases positions 261:275
!			diewssvl=tempfile(ii-1:kk+1)
!	  elseif (massloss.eq.8) then
!			tempfile=tempfile(1:kk) // 'b_'  ! black body seds (only March 07 option)
!			diewssvl=tempfile(ii-1:kk+1)
!	  elseif (massloss.eq.-1) then
!			tempfile=tempfile(1:kk) // 'k_'  ! use Basel (Kurucz) for TP-AGB stars (only March 07 option)
!	  		diewssvl=' '
!			massloss=0
	  endif

	  if (ioption.eq.99) then
	     ioption=0
	  else
	     tempfile=tempfile(1:largo(tempfile)) // imf(jdef)(1:largo(imf(jdef))) // popprm(1:largo(popprm)) //'_ssp'
!	     Add chi2 subfix to stelib model if kfit=2
	     if (kfit.eq.2) then
		tempfile=tempfile(1:largo(tempfile)) // '_chi2'
	     endif
	  endif

!	  Check if Padova 2007+ tracks are selected ( = Padova 1994/2000/2007/2008 + Marigo 2007/2008 TP-AGB)
	  call check2007(tempfile,cb07)

!	  Write file name in 2016 style
	  call name2016(tempfile)

!	  Store tempfile in variable popprm in case option to write "cmd" file (Theo B.) has been requested
!	  popprm = tempfile
	  if (largo(popprm) > 0) popprm = tempfile

!	  Check if IMF mass limits have been changed from default
	  if (ldef.ne.0) then
		auxname='_ML0000_MU00000'
     	  	ii=index(auxname,'_ML0000_')+3
!		Write value of ML
		if (ml.lt.10) then
			write (auxname(ii:ii+3),'(f4.2)') ml
		elseif (ml.lt.100) then
			write (auxname(ii:ii+3),'(f4.1)') ml
		else
			write (auxname(ii:ii+3),'(f4.0)') ml
		endif
!		Write value of MU
		if (mu.ge.100) then
			write (auxname(ii+7:ii+11),'(f5.1)') mu
		elseif (mu.ge.10) then
			write (auxname(ii+8:ii+11),'(f4.1)') mu
		elseif (mu.ge.1) then
			write (auxname(ii+9:ii+11),'(f3.1)') mu
		endif
!		write (auxname(ii+7:ii+9),'(i3)') int(mu)
11     	  	ii=index(auxname(1:largo(auxname)),' ')
		if (ii.gt.0) then
			auxname(ii:ii)='0'
			goto 11
		endif
12		ii=index(auxname(1:largo(auxname)),'.')
		if (ii.gt.0) then
			auxname(ii:ii)='p'
			goto 12
		endif
		if (auxname /= '_ML0p10_MU100p0') then
			if (auxname(:7) == '_ML0p10') then
				auxname = auxname(8:)
				ii = index(auxname,'p0')
				if (ii > 0) auxname = auxname(:ii-1)
			endif
!			tempfile=tempfile(1:largo(tempfile)) // auxname    ! old style = cb2018_z004_chab_hr_xmilesi_ssp_ML0p10_MU600p0.ised
			ii = index(tempfile,'_')
			ii = index(tempfile(ii+1:),'_') + ii
			ii = index(tempfile(ii+1:),'_') + ii
			tempfile = tempfile(:ii-1) // trim(auxname) // tempfile(ii:)
		endif
		if (jvaz == 0) then
			ii = index(tempfile,'p00')
			if (ii > 0) tempfile = tempfile(:ii-1) // tempfile(ii+3:)
			ii = index(tempfile,'p0')
			if (ii > 0) tempfile = tempfile(:ii-1) // tempfile(ii+2:)
		endif
	  endif
	  if (lun.eq.-2) then
!		Option number entered as first argument of command line
		write (6,'(/1x,a,i4)') 'Using Option: ',ioption
		evofile=tempfile
	  elseif (lun.ne.-99) then
	      if (ioption.ne.0) then
		  if (index(tempfile,'NumIMF') > 0) then
!			Correct file name for Stochastic IMF read from file:
			ii = index(tempfile,'NumIMF') + 5
			jj = index(tempfile,'yr') + 1
			ll = index(tempfile,'single') + 5
			if (ll > 5) then
				tempfile = tempfile(:ii) // tempfile(jj+1:ll) // tempfile(ii+1:jj) // tempfile(ll+1:)
			endif
			! if (jdef == 24) then
			! 	tempfile = tempfile(:ii-6) // trim(bpimf) // tempfile(ii+1:)
			! 	call no_bl(tempfile)
			! elseif (jdef >= 20) then
			if (jdef >= 20) then
				tempfile(ii-largo(bpimf)+1:ii) = bpimf
				!ii=index(tempfile,'BF') + 10
				ii=index(tempfile,'_lr_') - 1
				if (ii <= 0) ii=index(tempfile,'_hr_') - 1
				if (ii <= 0) ii=index(tempfile,'_hrx_') - 1
				!all system ('/bin/mv -f fort.668      ' // tempfile(:ii) // '.binned_imf')
				call system ('/bin/rm -f fort.668')
				call system ('/bin/mv -f fort.776      ' // tempfile(:ii) // '.stat')
				inquire (file='fort.777',exist=done)
				if (done) then
					if (tempfile(ii-3:ii) == 'BF_0') then
						call system ('/bin/rm -f fort.777')
					else
						call system ('/bin/mv -f fort.777      ' // tempfile(:ii) // '.bp')
					endif
					call system ('/bin/mv -f fort.778      ' // tempfile(:ii) // '.allstrs')
					call system ('/bin/mv -f fort.779      ' // tempfile(:ii) // '.allsngl')
					call system ('/bin/cp -f random.seed12 ' // tempfile(:ii) // '.random.seed12')
				endif
			endif
		  endif
		  write (6,'(/1x,a,i4,3a,$)') 'Using Option: ',ioption,'. Output file name (',tempfile(1:margo(tempfile)),') = '
		  if (largo(popprm) > 0 .and. jdef < 20) then
!			Build file name to store stochastic imf
			ii = index(tempfile,'_z') + 1
			jj = index(tempfile,'yr') + 1
			if (index(tempfile,'IMF') > 0) then
				if (index(tempfile,'NumIMF') > 0) then
					kk = index(tempfile,'IMF') - 3
				elseif (index(tempfile,'S2plIMF') > 0) then
					kk = index(tempfile,'IMF') - 4
				endif
				subdir = tempfile(kk:jj) // '.binned_imf'
			else
				kk = index(tempfile,'_S') + 1
				if (kk == 1 ) kk = index(tempfile,'_Num') + 1
				auxname = tempfile(ii:kk-2)
				subdir  = tempfile(kk:jj)
				ii = index(subdir,'_')
				subdir = subdir(:ii) // trim(auxname) // subdir(ii:largo(subdir)) // '.binned_imf'
			endif
			open (668,file=subdir,status='unknown',form='unformatted')
			if (wrimf) then
				ii = index(subdir,'.binned_imf')
				subdir = subdir(:ii) // 'unbinned_imf'
				open (669,file=subdir,status='unknown',form='formatted')
				! write file name in temporary file
				write (679,'(a)') trim(subdir)
			endif
		  endif
	      else
		  write (6,'(/1x,a,$)') 'Output file name = '
	      endif
	      read (5,'(a)',end=1) evofile
              if (largo(evofile) == 0) then
			evofile=tempfile
	      elseif (largo(evofile) == 1) then
			evofile='junk'
	      endif
	      call mixfilenames(tempfile,evofile,ioption)
	  else
	      evofile=subdir(1:largo(subdir)) // tempfile
	  endif
	  write (6,'(/1x,2a )') 'Generic file name for model = ',evofile(1:margo(evofile))
        else
          	write (6,'(/1x,2a )') 'Generic file name for model = ',evofile(1:margo(evofile))
        endif
	savefile=evofile
	if (jun.eq.-987) return
	lun=7
	jun=lun+14

!	File to write sed
	nm = -1 + index(evofile,'.ised')
	if (nm < 0) then
		evofile = evofile(1:largo(evofile)) // '.ised'
	else
		call chaext(evofile,'ised',nm)
	endif
	close (lun)
	open (lun,file=evofile,form='unformatted',status='unknown')

!	Open files to write model colors (14 files: lun+1 - lun+14)
	call open_color_files(lun,evofile)
	if (wrimf) then
		write (679,'(a)') trim(evofile)
		close (679)
	endif

!	Check for more files to open
	if (kdist.eq.0) then
		evofile=savefile
		return
	endif

!	Open files to write sed''s of each stellar group (20 files: lun+15 - lun+34)
	if (kdist == 1 .or. kdist == 3) then
		do i=1,nph
		evofile=savefile(1:largo(savefile)) // '_' // phase(i)
		evofile= evofile(1:largo(evofile))  // '.ised'
!		call chaext(evofile,'ised',nm)
		close (lun+14+i)
!		write (6,*) 'i,lun,lun+14+i =',i,lun,lun+14+i,' ',evofile(1:largo(evofile))
		open (lun+14+i,file=evofile,form='unformatted',status='unknown')
		enddo
		evofile=savefile
	endif

!	Open files to write % contribution of each stellar phase (26 files: lun+31 - lun+56)
	if (kdist.eq.2.or.kdist.eq.3) then
		do i=1,nb
		call chaext(evofile,fract(i),nm)
		close (lun+30+i)
!		write (6,*) 'i,lun,lun+30+i =',i,lun,lun+30+i,' ',evofile(1:largo(evofile))
		open (lun+30+i,file=evofile,status='unknown')
       		call file_header(lun+30+i,evofile,0)
		write (lun+30+i,105) fract(i)(1:4)
105		format ('#log-age-yr  %MS        %SGB       %RGB       %CHeB      %AGB       %TP-AGB    %CSPN      %WD        %CCB       %NO-NAME   TOTAL-',a)   
		enddo
		do i=1,nb
		call chaext(evofile,stage(i),nm)
		close (lun+30+nb+i)
!		write (6,*) 'i,lun,lun+30+nb+i =',i,lun,lun+30+nb+i,' ',evofile(1:largo(evofile))
		open (lun+30+nb+i,file=evofile,status='unknown')
       		call file_header(lun+30+nb+i,evofile,0)
		write (lun+30+nb+i,106) stage(i)(2:4)
106		format ('#log-age-yr    nMS   nSGB   nRGB   nCHeB   nAGB  nCSPN    nWD   nCCB  nTRPH   NMS   NSGB   NRGB   NCHeB   NAGB  NCSPN    NWD   NCCB  NTRPH ',1x,a)
		enddo
	endif
	l=index(evofile,'.legus') - 1
	if (kdist.eq.4) then
!		l=index(evofile,'.') - 1
		evofile=evofile(1:l) // '_msOB.ised'
!		write (6,*) 'jun+1 =',jun+1,' ',evofile(1:largo(evofile))
		open (jun+1,file=evofile,form='unformatted',status='unknown')
		evofile=evofile(1:l) // '_msOBA.ised'
!		write (6,*) 'jun+2 =',jun+2,' ',evofile(1:largo(evofile))
		open (jun+2,file=evofile,form='unformatted',status='unknown')
		evofile=evofile(1:l) // '_rest.ised'
!		write (6,*) 'jun+3 =',jun+3,' ',evofile(1:largo(evofile))
		open (jun+3,file=evofile,form='unformatted',status='unknown')
	elseif (kdist.eq.5) then
!		l=index(evofile,'.') - 1
!		evofile=evofile(1:l) // '_ms.ised'
		evofile=evofile(1:l) // '_hm.ised'
!		write (6,*) 'jun+1 =',jun+1,' ',evofile(1:largo(evofile))
		open (jun+1,file=evofile,form='unformatted',status='unknown')
!		evofile=evofile(1:l) // '_mms.ised'
		evofile=evofile(1:l) // '_lm.ised'
!		write (6,*) 'jun+2 =',jun+2,' ',evofile(1:largo(evofile))
		open (jun+2,file=evofile,form='unformatted',status='unknown')
		evofile=evofile(1:l) // '.mass_contr'
!		write (6,*) 'lun+17 =',lun+17,' ',evofile(1:largo(evofile))
		open (lun+17,file=evofile,form='formatted',status='unknown')
		call file_header(lun+17,evofile,0)
		write (lun+17,'(a)') '#    (1)       (2)         (3)         (4)         (5)         (6)         (7)'
		write (lun+17,'(a)') '#'
		write (lun+17,'(a)') '#log-age-yr  Mass_high   Mass_low    Mass_tot      Mcut        M*_up       M*_low'
	elseif (kdist.eq.6) then
!		l=index(evofile,'.') - 1
		evofile=evofile(1:l) // '_coll_merged_3_5.ised'
!		write (6,*) 'jun+1 =',jun+1,' ',evofile(1:largo(evofile))
		open (jun+1,file=evofile,form='unformatted',status='unknown')
		evofile=evofile(1:l) // '_coll_merged_6_7.ised'
!		write (6,*) 'jun+2 =',jun+2,' ',evofile(1:largo(evofile))
		open (jun+2,file=evofile,form='unformatted',status='unknown')
		evofile=evofile(1:l) // '_coll_merged_3_5.indx'
!		write (6,*) 'jun+3 =',jun+3,' ',evofile(1:largo(evofile))
		open (jun+3,file=evofile,form='unformatted',status='unknown')
		evofile=evofile(1:l) // '_coll_merged_6_7.indx'
!		write (6,*) 'jun+4 =',jun+4,' ',evofile(1:largo(evofile))
		open (jun+4,file=evofile,form='unformatted',status='unknown')
	endif

	evofile=savefile
	return
1	stop
	end

	SUBROUTINE OPEN_COLOR_FILES(LUN,EVOFILE)

!	Open files to write colors and other model properties

	character evofile*(*)
	include 'stelib.dec'
        common /vazdekis/ jvaz,xmu

        ! Check if model is for Vazdekis et al. (1996) IMF
	if (jvaz == 0) then
		i = index(evofile,'_v')
		if (i > 0 .and. evofile(i+3:i+3) == 'p' .and. evofile(i+6:i+6) == '_') jvaz =1
	endif

!	File to write spectral indices computed from fits (1-13)
!	write (6,*) 'lun,lun+6 =',lun,lun+6,' ',evofile(1:largo(evofile))
	call chaext(evofile,'6lsindx_ffn',nm)
       	close (lun+6)
       	open (lun+6,file=evofile,status='unknown')
       	call file_header(lun+6,evofile,0)
	write (lun+6,'(a)') '#    (1)       (2)      (3)      (4)      (5)      (6)      (7)      (8)      (9)      (10)     (11)     (12)     (13)     (14)     (15)     (16)     (17)     (18)     (19)     (20)     (21)     (22)'
	write (lun+6,'(a)') '#'
	write (lun+6,'(a)') '# Index_No.      1:       2:       3:       4:       5:       6:       7:       8:       9:      10:      11:      12:      13:      14:      15:      16:      17:      18:      19:      20:      21:'
	write (lun+6,'(a)') '# log-age      CN_1     CN_2   Ca4227    G4300   Fe4383   Ca4455   Fe4531   Fe4668    Hbeta   Fe5015     Mg_1     Mg_2     Mg-b   Fe5270   Fe5335   Fe5406   Fe5709   Fe5782     Na-D    TiO_1    TiO_2'
	write (lun+6,'(a)') '#   (yr)      (mag)    (mag)     (A)      (A)      (A)      (A)      (A)      (A)      (A)      (A)     (mag)    (mag)     (A)      (A)      (A)      (A)      (A)      (A)      (A)     (mag)    (mag)'

!	File to write spectral indices measured from sed (1-13)
!	write (6,*) 'lun,lun+8 =',lun,lun+8,' ',evofile(1:largo(evofile))
	call chaext(evofile,'6lsindx_sed',nm)
       	close (lun+8)
       	open (lun+8,file=evofile,status='unknown')
       	call file_header(lun+8,evofile,0)
	write (lun+8,'(a)') '#    (1)       (2)      (3)      (4)      (5)      (6)      (7)      (8)      (9)      (10)     (11)     (12)     (13)     (14)     (15)     (16)     (17)     (18)     (19)     (20)     (21)     (22)'
	write (lun+8,'(a)') '#'
	write (lun+8,'(a)') '# Index_No.      1:       2:       3:       4:       5:       6:       7:       8:       9:      10:      11:      12:      13:      14:      15:      16:      17:      18:      19:      20:      21:'
	write (lun+8,'(a)') '# log-age      CN_1     CN_2   Ca4227    G4300   Fe4383   Ca4455   Fe4531   Fe4668    Hbeta   Fe5015     Mg_1     Mg_2     Mg-b   Fe5270   Fe5335   Fe5406   Fe5709   Fe5782     Na-D    TiO_1    TiO_2'
	write (lun+8,'(a)') '#   (yr)      (mag)    (mag)     (A)      (A)      (A)      (A)      (A)      (A)      (A)      (A)     (mag)    (mag)     (A)      (A)      (A)      (A)      (A)      (A)      (A)     (mag)    (mag)'

!	File to write spectral indices measured from sed transformed to lick system(1-13)
!	write (6,*) 'lun,lun+11 =',lun,lun+11,' ',evofile(1:largo(evofile))
	call chaext(evofile,'6lsindx_sed_lick_system',nm)
	close (lun+11)
	open (lun+11,file=evofile,status='unknown')
	call file_header(lun+11,evofile,0)
	write (lun+11,'(a)') '#    (1)      (2)     (3)     (4)     (5)     (6)     (7)     (8)     (9)     (10)    (11)    (12)    (13)    (14)    (15)    (16)    (17)    (18)    (19)    (20)    (21)    (22)'
	write (lun+11,'(a)') '#'
	write (lun+11,'(a)') '# Index_No.     1:      2:      3:      4:      5:      6:      7:      8:      9:     10:     11:     12:     13:     14:     15:     16:     17:     18:     19:     20:     21:'
	write (lun+11,'(a)') '# log-age     CN_1    CN_2  Ca4227   G4300  Fe4383  Ca4455  Fe4531  Fe4668   Hbeta  Fe5015    Mg_1    Mg_2    Mg-b  Fe5270  Fe5335  Fe5406  Fe5709  Fe5782    Na-D   TiO_1   TiO_2'
	write (lun+11,'(a)') '#   (yr)     (mag)   (mag)    (A)     (A)     (A)     (A)     (A)     (A)     (A)     (A)    (mag)   (mag)    (A)     (A)     (A)     (A)     (A)     (A)     (A)    (mag)   (mag)'

!	File to write spectral indices computed from fits (14-26)
!	write (6,*) 'lun,lun+7 =',lun,lun+7,' ',evofile(1:largo(evofile))
	call chaext(evofile,'7lsindx_ffn',nm)
       	close (lun+7)
       	open (lun+7,file=evofile,status='unknown')
       	call file_header(lun+7,evofile,0)
	write (lun+7,'(a)') '#    (1)          (2)        (3)        (4)        (5)        (6)'
	write (lun+7,'(a)') '#'
	write (lun+7,'(a)') '# Index_No.      WO-1:      WO-2:      WO-3:      WO-4:      GC-1:'
	write (lun+7,'(a)') '# log-age      HdeltaA    HgammaA    HdeltaF    HgammaF    D(4000)'
	write (lun+7,'(a)') '#   (yr)          (A)        (A)        (A)        (A)         . '

!	File to write spectral indices measured from sed (14-26)
!	write (6,*) 'lun,lun+9 =',lun,lun+9,' ',evofile(1:largo(evofile))
	call chaext(evofile,'7lsindx_sed',nm)
	close (lun+9)
	open (lun+9,file=evofile,status='unknown')
	call file_header(lun+9,evofile,0)
	write (lun+9,'(a)') '#    (1)        (2)      (3)      (4)      (5)      (6)      (7)       (8)        (9)        (10)      (11)      (12)      (13)      (14)      (15)'
	write (lun+9,'(a)') '#'
	write (lun+9,'(a)') '# Index_No.    WO-1:    WO-2:    WO-3:    WO-4:    GC-1:    4000A    DTT-Ca1    DTT-Ca2    DTT-Ca3   DTT-MgI     DM-04     DM-04     DM-04       BH:'
	write (lun+9,'(a)') '# log-age    HdeltaA  HgammaA  HdeltaF  HgammaF  D(4000)    B4_VN   CaII8498   CaII8542   CaII8662   MgI8807   H8_3889   H9_3835  H10_3798     BH-HK'
	write (lun+9,'(a)') '#   (yr)        (A)      (A)      (A)      (A)       .        .         (A)        (A)        (A)       (A)       (A)       (A)       (A)        (A)'

!	File to write spectral indices measured from sed transformed to lick system(14-26)
!	write (6,*) 'lun,lun+12 =',lun,lun+12,' ',evofile(1:largo(evofile))
	call chaext(evofile,'7lsindx_sed_lick_system',nm)
	close (lun+12)
	open (lun+12,file=evofile,status='unknown')
	call file_header(lun+12,evofile,0)
	write (lun+12,'(a)') '#    (1)        (2)      (3)      (4)      (5)      (6)      (7)       (8)        (9)        (10)      (11)      (12)      (13)      (14)      (15)'
	write (lun+12,'(a)') '#'
	write (lun+12,'(a)') '# Index_No.    WO-1:    WO-2:    WO-3:    WO-4:    GC-1:    4000A    DTT-Ca1    DTT-Ca2    DTT-Ca3   DTT-MgI     DM-04     DM-04     DM-04       BH:'
	write (lun+12,'(a)') '# log-age    HdeltaA  HgammaA  HdeltaF  HgammaF  D(4000)    B4_VN   CaII8498   CaII8542   CaII8662   MgI8807   H8_3889   H9_3835  H10_3798     BH-HK'
	write (lun+12,'(a)') '#   (yr)        (A)      (A)      (A)      (A)       .        .         (A)        (A)        (A)       (A)       (A)       (A)       (A)        (A)'

!	File to write Fanelli et al. UV spectral indices
!	write (6,*) 'lun,lun+87 =',lun,lun+87,' ',evofile(1:largo(evofile))
	call chaext (evofile,'8lsindx_sed',nm)
	close (lun+87)
	open (lun+87,file=evofile,status='unknown')
	call file_header(lun+87,evofile,0)
	write (lun+87,'(a)') '#'
	write (lun+87,'(a)') '#'
	write (lun+87,'(a)') '#    (1)        (2)        (3)        (4)        (5)        (6)        (7)        (8)        (9)        (10)       (11)       (12)       (13)       (14)       (15)       (16)       (17)       (18)       (19)       (20)       (21)       (22)'
	write (lun+87,'(a)') '#'
	write (lun+87,'(a)') '# log_t(yr)    BL1302      SiIV      BL1425     Fe1453    CIV1548a   CIV1548c   CIV1548e    BL1617     BL1664     BL1719     BL1853    FeII2402    BL2538    FeII2609     MgII       MgI       Mgwide      FeI       BL3096     CIVabs     HeIIems'

!	File to write fluxes used to compute spectral indices
!	write (6,*) 'lun,lun+10 =',lun,lun+10,' ',evofile(1:largo(evofile))
	call chaext(evofile,'9lsindx_sed_fluxes',nm)
       	close (lun+10)
       	open (lun+10,file=evofile,form='formatted',status='unknown')
       	call file_header(lun+10,evofile,0)
	write (lun+10,'(a)') '# log-age   Nx  Im   Flux_Blue   Flux_Red    Flux_Ctrl   Flux_Line       Index'

!	Open file .3color to write colors and other model properties
!	write (6,*) 'lun,lun+3 =',lun,lun+3,' ',evofile(1:largo(evofile))
	call chaext(evofile,'3color',nm)
	close (lun+3)
       	open (lun+3,file=evofile,status='unknown')
       	call file_header(lun+3,evofile,0)
	!rite (lun+3,'(a)') '#    (1)        (2)      (3)       (4)        (5)         (6)       (7)      (8)       (9)         (10)      (11)        (12)        (13)        (14)        (15)        (16)        (17)        (18)'
	!rite (lun+3,'(a)') '#'
       	!rite (lun+3,'(a)') '#log-age-yr    B4000     B4_VN   B4_SDSS      B912        NLy      NHeI      NHeII  NHeII/NLy       Mbol    Bol_Flux    SNR/yr/Lo    N(BH)       N(NS)     PNBR/yr/Lo    N(WD)    M(Remnants)   Lx(Lo)'
	!rite (lun+3,'(a)') '#    (1)        (2)      (3)       (4)        (5)         (6)       (7)      (8)       (9)       (10)        (11)        (12)        (13)        (14)        (15)        (16)        (17)        (18)        (19)        (20)'
	!rite (lun+3,'(a)') '#'
       	!rite (lun+3,'(a)') '#log-age-yr    B4000     B4_VN   B4_SDSS      B912        NLy      NHeI      NHeII  NHeII/NLy    SNe/yr     PISNe/yr    RegSNe/yr   IaSNe/yr  FailedSNe/yr   N(BH)       N(NS)      PNBR/yr      N(WD)     M(Remnants)   Lx(Lo)'
	write (lun+3,'(a)') '#    (1)       (2)     (3)      (4)      (5)        (6)      (7)      (8)      (9)      (10)        (11)        (12)        (13)        (14)        (15)        (16)        (17)        (18)        (19)'
	write (lun+3,'(a)') '#'
	write (lun+3,'(a)') '#log-age-yr   B4000    B4_VN  B4_SDSS    B912       NLy      NHeI    NHeII  NHeII/NLy   SNe/yr     PISNe/yr    RegSNe/yr   IaSNe/yr  FailedSNe/yr  PNBR/yr      N(BH)       N(NS)       N(WD)       Lx(Lo)'

!	Open file .4color to write colors and other model properties
!	write (6,*) 'lun,lun+4 =',lun,lun+4,' ',evofile(1:largo(evofile))
	call chaext(evofile,'4color',nm)
	close (lun+4)
	open (lun+4,file=evofile,status='unknown')
       	call file_header(lun+4,evofile,0)
	write (lun+4,'(a)') '#    (1)       (2)       (3)       (4)        (5)       (6)          (7)          (8)          (9)         (10)         (11)           (12)        (13)        (14)        (15)        (16)        (17)'
	write (lun+4,'(a)') '#                                                                                                                      M*_tot='
	write (lun+4,'(a)') '#log-age-yr    Mbol      Bmag      Vmag      Kmag      M*_liv     M_remnants    M_ret_gas    M_galaxy      SFR/yr    M*_liv+M_rem   M*_tot/Lb   M*_tot/Lv   M*_tot/Lk   M*_liv/Lb   M*_liv/Lv   M*_liv/Lk'

!	Open file .5color to write colors and other model properties
!	write (6,*) 'lun,lun+5 =',lun,lun+5,' ',evofile(1:largo(evofile))
	call chaext(evofile,'5color',nm)
	close (lun+5)
	open (lun+5,file=evofile,status='unknown')
       	call file_header(lun+5,evofile,0)
	write (lun+5,'(a)') '#    (1)       (2)         (3)          (4)          (5)          (6)          (7)          (8)'
	write (lun+5,'(a)') '#                                                                          Total Mass   Total Dust'
	write (lun+5,'(a)') '#log-age-yr    Mbol    b(t)*''s/yr   B(t)/yr/Lo  Turnoff_mass   BPMS/BMS     Loss Rate   Prod. Rate'

!	Open file .1VEGAmag to write Vega magnitudes
!	write (6,*) 'lun,lun+1 =',lun,lun+1,' ',evofile(1:largo(evofile))
	call chaext(evofile,'1VEGAmag',nm)
	close (lun+1)
	open (lun+1,file=evofile,status='unknown')
	call file_header(lun+1,evofile,0)
	write (lun+1,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)       (7)       (8)       (9)       (10)      (11)      (12)      (13)      (14)      (15)      (16)      (17)'
	write (lun+1,'(a)') '#'
	write (lun+1,'(a)') '#log-age-yr    Mbol       U         B2        B3        V         Rc        Ic        R         I         J         K         L        PalJ      PalH      PalK       K'''

!	Open file .2VEGAmag to write Vega magnitudes
!	write (6,*) 'lun,lun+2 =',lun,lun+2,' ',evofile(1:largo(evofile))
	call chaext(evofile,'2VEGAmag',nm)
	close (lun+2)
	open (lun+2,file=evofile,status='unknown')
	call file_header(lun+2,evofile,0)
	write (lun+2,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)       (7)       (8)       (9)       (10)      (11)      (12)      (13)      (14)      (15)      (16)      (17)'
	write (lun+2,'(a)') '#'
	write (lun+2,'(a)') '#log-age-yr    Mbol      Vmag     2MASSJ    2MASSH   2MASSKs   IRAC3.5   IRAC4.5   IRAC5.7   IRAC7.9    IRAS12    IRAS25    IRAS60   IRAS100    MIPS24    MIPS70   MIPS160'

!	Open files to write AB mag (SDSS, CFHT MegaCam, and GALEX)
!	write (6,*) 'lun,lun+13 =',lun,lun+13,' ',evofile(1:largo(evofile))
	call chaext(evofile,'1ABmag',nm)
	close (lun+13)
	open (lun+13,file=evofile,status='unknown')
	call file_header(lun+13,evofile,0)
	write (lun+13,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)          (7)       (8)       (9)       (10)      (11)      (12)      (13)      (14)      (15)      (16)         (17)      (18)         (19)      (20)      (21)         (22)         (23)'
	write (lun+13,'(a)') '#             <---------------- SDSS AB mag --------------->       <---------------------- CFHT MegaCam 1st and 3rd generation filters AB mag -------------------->       2Mass    CFHT Ks      <---------------- GALEX AB mag and flux --------------->'
	write (lun+13,'(a)') '#log-age-yr     u         g         r         i         z            u1        u3        g1        g3        r1        r3        i2        i3        z1        z3           H         Ks          FUV       NUV      F(FUV)       F(NUV)       F(1500A)'

!	Open file to write HST WFC and ACS bands in ABmag
!	write (6,*) 'lun,lun+88 =',lun,lun+88,' ',evofile(1:largo(evofile))
	call chaext(evofile,'2ABmag',nm)
	close (lun+88)
	open (lun+88,file=evofile,status='unknown')
	call file_header(lun+88,evofile,0)
	write (lun+88,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)       (7)        (8)       (9)      (10)      (11)      (12)      (13)      (14)      (15)      (16)      (17)      (18)      (19)      (20)      (21)      (22)      (23)      (24)      (25)      (26)      (27)      (28)      (29)      (30)      (31)      (32)      (33)'
	write (lun+88,'(a)') '#             <------------------------------------------- HST WFC3 UVIS1 LEGUS ABmag ------------------------------------------->    <----------------------------------- HST WFC3 ABmag --------------------------------->    <------------------------------------------- HST ACS WFC ABmag ------------------------------------------>'
	write (lun+88,'(a)') '#log-age-yr    F225w     F275w     F336w     F438w     F547m     F555w     F606w     F625w     F656n     F657n     F658n     F814w     F110W     F125W     F160W     F225W     F336W    FR388N     F438W     F555W     F814W     F220w     F250w     F330w     F410w     F435w     F475w     F555w     F606w     F625w     F775w     F814w'

	return
	end

	function jjdef(name)

!	Returns the value of jdef corresponding to the IMF selected in name

!	Array declaration
	character name*(*),imf(-1:18)*6
        common /vazdekis/ jvaz,xmu
	data imf /'chab','chab','kroup','KROUP','salp','scalo','SCALO','mi_sc','ktg93','kenn', 'leque','ferra','piott','carig','thIMF','myIMF','vxpxx','Schab','Skroup','Ssalp'/

!	Check for Vazdekis IMF
	if (jvaz > 0) then
		write (imf(15)(2:),'(f4.2)') xmu
		imf(15)(3:3) = 'p'
	endif

!	Get jjdef
	do jjdef=0,18
	k=index(name,imf(jjdef)(1:largo(imf(jjdef))))
	if (k.gt.0) return
	enddo
	write (6,*) 'Unknown IMF coding in this file name'
	jjdef=15
	return
	end

	subroutine check2007(name,cb07)
	
!	Check if Padova tracks are selected ( = Padova 1994/2000/2007/2008)
!	Check if Weiss 2008 tracks are selected
!	Modifies file name accordingly

	logical cb07
	character*(*) name
        character  a94(7)*3,b94(7)*3
!	character  a00(6)*4,b00(6)*4
!	character  a20(6)*3,b20(6)*4
!	character  a07(8)*4,b07(8)*3
        character  a08(10)*4,b08(10)*3
        character  a08b(10)*4,b08b(10)*3
        character  a10(10)*4,b10(10)*3
        character  a13(17)*4,a14(17)*4,a15(17)*4,a16(17)*4,a17(17)*4,b13(17)*9
        character  w07(6)*2,v07(6)*6
        character  w08(12)*4,v08(12)*6
        character  w09(12)*4,v09(12)*6

!	CB2007 models
	data a94/'m92', 'm93', 'm94', 'm95', 'm96', 'm97', 'm98'/
	data b94/'m22', 'm32', 'm42', 'm52', 'm62', 'm72', 'm82'/

!	CB2009 models (calibrated TP-AGB)
	data a08b/'m100','m101','m102','m103','m104','m105','m106','m107','m108','m109'/
	data b08b/ 'c00', 'c02', 'c12', 'c22', 'c32', 'c42', 'c52', 'c62', 'c72', 'c82'/

!	CB2009 models (uncalibrated TP-AGB)
	data a08 /'m110','m111','m112','m113','m114','m115','m116','m117','m118','m119'/
	data b08 / 'u00', 'u02', 'u12', 'u22', 'u32', 'u42', 'u52', 'u62', 'u72', 'u82'/

!	CB2010 models
	data a10 /'m210','m211','m212','m213','m214','m215','m216','m217','m218','m219'/
	data b10 / 'o00', 'o02', 'o12', 'o22', 'o32', 'o42', 'o52', 'o62', 'o72', 'o82'/

!	CB2013 models
	data b13 /'z0000y230','z0001y249','z0002y249','z0005y249','z001y250','z002y252','z004y256','z006y259','z008y263','z010y267','z014y273','z017y279','z020y284','z030y302','z040y321','z050y339','z060y356'/
	data a13 /     'm300',     'm301',     'm302',     'm303',    'm304',    'm305',    'm306',    'm307',    'm308',    'm309',    'm310',    'm311',    'm312',    'm313',    'm314',    'm315',    'm316'/  ! SET 1
!	CB2019 models
	data a14 /     'm400',     'm401',     'm402',     'm403',    'm404',    'm405',    'm406',    'm407',    'm408',    'm409',    'm410',    'm411',    'm412',    'm413',    'm414',    'm415',    'm416'/  ! VW PAGB
	data a15 /     'm500',     'm501',     'm502',     'm503',    'm504',    'm505',    'm506',    'm507',    'm508',    'm509',    'm510',    'm511',    'm512',    'm513',    'm514',    'm515',    'm516'/  ! MB PAGB
!	CB2021 models
	data a16 /     'm600',     'm601',     'm602',     'm603',    'm604',    'm605',    'm606',    'm607',    'm608',    'm609',    'm610',    'm611',    'm612',    'm613',    'm614',    'm615',    'm616'/  ! VW PAGB
	data a17 /     'm700',     'm701',     'm702',     'm703',    'm704',    'm705',    'm706',    'm707',    'm708',    'm709',    'm710',    'm711',    'm712',    'm713',    'm714',    'm715',    'm716'/  ! MB PAGB

!	Coelho et al models
	data w07/    'M1',     'M2',     'M3',     'M4',     'M5',     'M6'/
	data v07/'p00p00', 'p00p04', 'm05p00', 'm05p04', 'p02p00', 'p02p04'/

!	Coelho et al models
	data w08/  'm181',   'm182',   'm183',   'm184',   'm185',   'm186',   'm187',   'm188',   'm189',   'm190',   'm191',   'm192'/
	data v08/'m10p00', 'm13p04', 'm10p04', 'm05p00', 'm08p04', 'm05p04', 'p00p00', 'm03p04', 'p02p00', 'm01p04', 'p00p04', 'p02p04'/

!	Coelho et al models
	data w09/  'm281',   'm282',   'm283',   'm284',   'm285',   'm286',   'm287',   'm288',   'm289',   'm290',   'm291',   'm292'/
	data v09/'m10p00', 'm13p04', 'm10p04', 'm05p00', 'm08p04', 'm05p04', 'p00p00', 'm03p04', 'p02p00', 'm01p04', 'p00p04', 'p02p04'/

!	Store in common model option
	common /model/ kopt

!	Look for different option numbers to correct file name
	kopt=3
	cb07=.false.
	do i=1,7
	j=index(name,a94(i))
	if (j.gt.0) then
		name(j:j+2) = b94(i)
		name(1:2) = 'cb'
		name(6:6) = '7'
		cb07=.true.
		kopt=7
		return
	endif
	enddo
	do i=1,10
	j=index(name,a08(i))
	if (j.gt.0) then
		name(j:j+2) = b08(i)
		name(1:2) = 'cb'
		name(6:6) = '9'
		name(j+3:)=name(j+4:)
		cb07=.true.
		return
	endif
	enddo
	do i=1,10
	j=index(name,a08b(i))
	if (j.gt.0) then
		name(j:j+2) = b08b(i)
		name(1:2) = 'cb'
		name(6:6) = '9'
		name(j+3:)=name(j+4:)
		cb07=.true.
		return
	endif
	enddo
	do i=1,10
	j=index(name,a10(i))
	if (j.gt.0) then
		name(j:j+2) = b10(i)
		name(1:2) = 'cb'
		name(5:6) = '10'
		name(j+3:)=name(j+4:)
		cb07=.true.
		kopt=0
		return
	endif
	enddo
	do i=1,15
	j=index(name,a13(i))
	if (j.gt.0) then
		js=index(name,'_ssp')
		name(11:) = b13(i) // name(j+4:js-1) // name(7:j-1) // 'ssp'
		name(1:10) = 'cb2013_s1_'
		call no_bl(name)
		cb07=.true.
		kopt=13
		return
	endif
	enddo
	do i=1,17
	j=index(name,a14(i))
	if (j.gt.0) then
		js=index(name,'_ssp')
		name(11:) = b13(i) // name(j+4:js-1) // name(7:j-1) // 'ssp'
		name(1:10) = 'cb2013_s2_'
		call no_bl(name)
!		write (6,*)
!		write (6,*) 'Old style file name: ',trim(name)
		name(1:10) = 'bc2019_   '		! Vassiliadis & Wood (1994) WD tracks with 2020 version of PoWR models
		call no_bl(name)
		k = index(name,'y')
		if (name(k+4:k+4) /= '_') then
			name(k:k+4) = '     '		! No need for Y abundance in file name, nor "n" character related to TP-AGB choice
		else
			name(k:k+3) = '     '		! No need for Y abundance in file name
		endif
		call no_bl(name)
		cb07=.true.
		kopt=13
		return
	endif
	enddo
	do i=1,17
	j=index(name,a15(i))
	if (j.gt.0) then
		js=index(name,'_ssp')
		name(11:) = b13(i) // name(j+4:js-1) // name(7:j-1) // 'ssp'
		name(1:10) = 'cb2013_s2_'
		call no_bl(name)
!		write (6,*)
!		write (6,*) 'Old style file name: ',trim(name)
		name(1:10) = 'cb2019_   '		! Miller-Bertolami WD tracks with 2018 version of PoWR models
		call no_bl(name)
		k = index(name,'y')
		if (name(k+4:k+4) /= '_') then
			name(k:k+4) = '     '		! No need for Y abundance in file name, nor "n" character related to TP-AGB choice
		else
			name(k:k+3) = '     '		! No need for Y abundance in file name
		endif
		call no_bl(name)
		cb07=.true.
		kopt=13
		return
	endif
	enddo
	do i=1,17
	j=index(name,a16(i))
	if (j.gt.0) then
		js=index(name,'_ssp')
		name(11:) = b13(i) // name(j+4:js-1) // name(7:j-1) // 'ssp'
		name(1:10) = 'bc2021_   '		! Vassiliadis & Wood (1994) WD tracks with 2020 version of PoWR models
		call no_bl(name)
		k = index(name,'y')
		if (name(k+4:k+4) /= '_') then
			name(k:k+4) = '     '		! No need for Y abundance in file name, nor "n" character related to TP-AGB choice
		else
			name(k:k+3) = '     '		! No need for Y abundance in file name
		endif
		call no_bl(name)
		cb07=.true.
		kopt=13
		return
	endif
	enddo
	do i=1,17
	j=index(name,a17(i))
	if (j.gt.0) then
		js=index(name,'_ssp')
		name(11:) = b13(i) // name(j+4:js-1) // name(7:j-1) // 'ssp'
		call no_bl(name)
		name(1:10) = 'cb2021_   '		! Miller-Bertolami WD tracks with 2018 version of PoWR models
		call no_bl(name)
		k = index(name,'y')
		if (name(k+4:k+4) /= '_') then
			name(k:k+4) = '     '		! No need for Y abundance in file name, nor "n" character related to TP-AGB choice
		else
			name(k:k+3) = '     '		! No need for Y abundance in file name
		endif
		call no_bl(name)
		cb07=.true.
		kopt=13
		return
	endif
	enddo
	do i=1,6
	j=index(name,w07(i))
	if (j.gt.0) then
                name(j+6:)=name(j+2:)
		name(j:j+5) = v07(i)
		name(1:2) = 'bc'
		name(6:6) = '7'
		cb07=.true.
		kopt=7
		return
	endif
	enddo
	do i=1,12
	j=index(name,w08(i))
	if (j.gt.0) then
		name(j+6:)=name(j+4:)
!		name(j+10:)=name(j+4:)
		name(j:j+5) = v08(i)
!		name(j:j+9) = v08(i)
		name(1:2) = 'bc'
		name(6:6) = '9'
		name = 'c' // name
		cb07=.true.
		return
	endif
	enddo
	do i=1,12
	j=index(name,w09(i))
	if (j.gt.0) then
		name(j+6:)=name(j+4:)
!		name(j+10:)=name(j+4:)
		name(j:j+5) = v09(i)
!		name(j:j+9) = v09(i)
		name(1:2) = 'bc'
		name(5:6) = '12'
		name = 'c' // name
		cb07=.true.
		return
	endif
	enddo
!	write (6,*) 'Unmodified name: ',name(1:largo(name))
	return
	end

	SUBROUTINE NAME2016(A)

!	Changes bc03 and cb07 files name from old to new style (2016)

!	Variables
	character(*) a,b*512

	if (a == 'bc2003_p99_') return
	if ( index(a,'bc2003') > 0 .or. index(a,'cb2007') > 0 ) then
		i = index(a,'2_')-2
		j = index(a,'_ssp')
		if (a(i:i+1) == 'm2') then
			b = a(:6) //  '_z0001'
		elseif (a(i:i+1) == 'm3') then
			b = a(:6) //  '_z0004'
		elseif (a(i:i+1) == 'm4') then
			b = a(:6) //  '_z004'
		elseif (a(i:i+1) == 'm5') then
			b = a(:6) //  '_z008'
		elseif (a(i:i+1) == 'm6') then
			b = a(:6) //  '_z020'
		elseif (a(i:i+1) == 'm7') then
			b = a(:6) //  '_z050'
		elseif (a(i:i+1) == 'm8') then
			b = a(:6) //  '_z100'
		else
			return
		endif
!		write (6,*)
!		write (6,*) 'Old style file name: ',trim(a)
		b = trim(b) // a(i+3:j) // a(8:i-1) // a(j+1:)
		a = b
	else
		return
	endif
	end

	! Open file .1color to write colors and other model properties
	! write (6,*) 'lun,lun+1 =',lun,lun+1,' ',evofile(1:largo(evofile))
	! call chaext(evofile,'1color',nm)
	! close (lun+1)
	! open (lun+1,file=evofile,status='unknown')
	! call file_header(lun+1,evofile,0)
	! write (lun+1,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)        (7)       (8)       (9)      (10)      (11)      (12)      (13)      (14)      (15)'
	! write (lun+1,'(a)') '#'
	! write (lun+1,'(a)') '#log-age-yr    Mbol      Umag      Bmag      Vmag      Kmag      14-V      17-V      22-V      27-V       U-J       J-F       F-N       U-B       B-V'

	! Open file .2color to write colors and other model properties
	! write (6,*) 'lun,lun+2 =',lun,lun+2,' ',evofile(1:largo(evofile))
	! call chaext(evofile,'2color',nm)
	! close (lun+2)
	! open (lun+2,file=evofile,status='unknown')
	! call file_header(lun+2,evofile,0)
	! write (lun+2,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)       (7)        (8)       (9)      (10)      (11)      (12)      (13)      (14)      (15)'
	! write (lun+2,'(a)') '#'
	! write (lun+2,'(a)') '#log-age-yr    Rmag     J2Mmag     Kmag      V-R       V-I       V-J       V-K        R-I       J-H       H-K      V-K''      V-Ks    (J-H)2M   (J-Ks)2M'
	! write (lun+2,'(a)') '#log-age-yr    Rmag     J2Mmag     Kmag      V-R       V-I       V-J       V-K        R-I       J-H       H-K      V-K''      V-J2M     V-H2M    V-Ks2M'

	! Open file to write IR colors (IRAC, IRAS, MIPS)
	! write (6,*) 'lun,lun+14 =',lun,lun+14,' ',evofile(1:largo(evofile))
	! call chaext(evofile,'9color',nm)
	! close (lun+14)
	! open (lun+14,file=evofile,status='unknown')
	! call file_header(lun+14,evofile,0)
	! write (lun+14,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)       (7)        (8)       (9)      (10)      (11)      (12)      (13)       (14)         (15)'
	! write (lun+14,'(a)') '#                                                                                                                                    Total Mass   Total Dust'
	! write (lun+14,'(a)') '#log-age-yr    Kmag     K-I3.5  I3.5-I4.5 I4.5-I5.7 I5.7-I7.9 I7.9-I12   I12-I25   I25-I60  I60-I100   M24-M70  M70-M160 I100-M160   Loss Rate    Prod. Rate'

	! 1ABmag old header
	! write (lun+13,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)          (7)       (8)       (9)       (10)      (11)      (12)      (13)         (14)      (15)      (16)         (17)         (18)            (19)      (20)      (21)      (22)      (23)'
	! write (lun+13,'(a)') '#             <---------------- SDSS AB mag --------------->       <---------------------- CFHT MegaCam AB mag --------------------->      <---------------- GALEX AB mag and flux --------------->       <---- CFHT New Megaprime Filters AB mag ----->'
	! write (lun+13,'(a)') '#log-age-yr     u         g         r         i         z            u         g         r         i         y         z         Ks          FUV       NUV      F(FUV)       F(NUV)       F(1500A)          u''        g''        r''        i''        z'''
	! write (lun+13,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)          (7)       (8)       (9)       (10)      (11)      (12)      (13)      (14)      (15)      (16)         (17)         (18)      (19)      (20)         (21)         (22)'
	! write (lun+13,'(a)') '#             <---------------- SDSS AB mag --------------->       <---------------------- CFHT MegaCam 1st and 3rd generation filters AB mag -------------------->      CFHT Ks      <---------------- GALEX AB mag and flux --------------->'
	! write (lun+13,'(a)') '#log-age-yr     u         g         r         i         z            u1        u3        g1        g3        r1        r3        i2        i3        z1        z3           Ks          FUV       NUV      F(FUV)       F(NUV)       F(1500A)'

	! Open file to write HST WFPC2 + Johnson colors (requested by RAGL)
	! write (6,*) 'lun,lun+87 =',lun,lun+87,' ',evofile(1:largo(evofile))
	! call chaext(evofile,'wfpc2_johnson_color',nm)
	! close (lun+87)
	! open (lun+87,file=evofile,status='unknown')
	! call file_header(lun+87,evofile,0)
	! write (lun+87,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)       (7)       (8)       (9)       (10)      (11)      (12)      (13)      (14)      (15)      (16)      (17)      (18)'
	! write (lun+87,'(a)') '#'
	! write (lun+87,'(a)') '#log-age-yr    Vmag    V-F300w   V-F300rl  V-F336w   V-F439w   V-F450w   V-F555w   V-F606w   V-F675w   V-F814w     V-U       V-B       V-R       V-I       V-J       V-K       V-L'

	! Open file to write UVIS1 LEGUS colors (Aida Wofford) 2014
	! write (6,*) 'lun,lun+88 =',lun,lun+88,' ',evofile(1:largo(evofile))
	! call chaext(evofile,'wfc3_uvis1_legus_ABmag',nm)
	! close (lun+88)
	! open (lun+88,file=evofile,status='unknown')
	! call file_header(lun+88,evofile,0)
	! write (lun+88,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)       (7)        (8)       (9)      (10)      (11)      (12)      (13)'
	! write (lun+88,'(a)') '#'
	! write (lun+88,'(a)') '#log-age-yr    F225w     F275w     F336w     F438w     F547m     F555w     F606w     F625w     F656n     F657n     F658n     F814w'
	! write (lun+88,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)       (7)        (8)       (9)      (10)      (11)      (12)      (13)'
	! write (lun+88,'(a)') '#'
	! write (lun+88,'(a)') '#log-age-yr    F225w     F275w     F336w     F438w     F547m     F555w     F606w     F625w     F656n     F657n     F658n     F814w,    F110W     F125W     F160W     F225W     F336W    FR388N     F438W     F555W     F814W,    F220w     F250w     F330w     F410w     F435w     F475w     F555w     F606w     F625w     F775w     F814w'

	! Open file to write WFC3 colors
	! write (6,*) 'lun,lun+84 =',lun,lun+84,' ',evofile(1:largo(evofile))
	! call chaext(evofile,'wfc3_ABmag',nm)
	! close (lun+84)
	! open (lun+84,file=evofile,status='unknown')
	! call file_header(lun+84,evofile,0)
	! write (lun+84,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)       (7)        (8)       (9)      (10)'
	! write (lun+84,'(a)') '#'
	! write (lun+84,'(a)') '#log-age-yr    F110W     F125W     F160W     F225W     F336W    FR388N     F438W     F555W     F814W'

	! Open file to write HST ACS colors
	! write (6,*) 'lun,lun+86 =',lun,lun+86,' ',evofile(1:largo(evofile))
	! call chaext(evofile,'acs_wfc_ABmag',nm)
	! close (lun+86)
	! open (lun+86,file=evofile,status='unknown')
	! call file_header(lun+86,evofile,0)
	! write (lun+86,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)       (7)        (8)       (9)      (10)      (11)      (12)'
	! write (lun+86,'(a)') '#'
	! write (lun+86,'(a)') '#log-age-yr    F220w     F250w     F330w     F410w     F435w     F475w     F555w     F606w     F625w     F775w     F814w'

	! Open file to write WFC3.UVIS1 colors (Rupali Chandar) 2011
	! write (6,*) 'lun,lun+85 =',lun,lun+85,' ',evofile(1:largo(evofile))
	! !all chaext(evofile,'wfc3_uvis1_color',nm)
	! call chaext(evofile,'wfc3_uvis1_ABmag',nm)
	! close (lun+85)
	! open (lun+85,file=evofile,status='unknown')
	! call file_header(lun+85,evofile,0)
	! !rite (lun+85,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)       (7)        (8)       (9)      (10)      (11)      (12)      (13)      (14)      (15)      (16)      (17)      (18)'
	! !rite (lun+85,'(a)') '#'
	! !rite (lun+85,'(a)') '#log-age-yr    Vmag      Kmag    V-F225w   V-F336w   V-F438w   V-F547m   V-F555w   V-F606w   V-F625w   V-F656n   V-F657n   V-F658n   V-F814w   log Nly     Mt/Lb     Mt/Lv     Mt/Lk'
	! write (lun+85,'(a)') '#    (1)       (2)       (3)       (4)       (5)       (6)       (7)        (8)       (9)      (10)      (11)      (12)      (13)      (14)      (15)'
	! write (lun+85,'(a)') '#'
	! write (lun+85,'(a)') '#log-age-yr    F225w     F336w     F390w     F438w     F475w     F547m     F555w     F606w     F625w     F656n     F657n     F658n     F775w     F814w'

        FUNCTION TRAPZ3(X,Y,N,X1,X2,IERR)

c	Especially written to compute spectral indices in the Lick System

c       Finds area below SED y(x) from x=X1 to x =X2
c       X1 and X2 are not necessarily values of x(i)
c       but must fulfill X1>=x(1) and X2<=x(n)

c	Routine TRAPZ2   is used for high resolution seds (1 A sampling)
c	Routine TRAPZ_LR is used for low  resolution seds (> 1 A sampling)

c       Array declaration
        real x(n),y(n)

c	Check for wavelength scale
c	The following wavelength scales are in use in BC03 models
c	Low Res pure LBC library:         1221 wavelength points
c	Low res extended Pickles library: 6505 wavelength points
c	High Res pure STELIB library:     6700 wavelength points
c	High Res STELIB + LBC library:    6900 wavelength points
c	High Res STELIB+IUE+LBC library: 11288 wavelength points

c	Total number of points are not fed to this routine
c	if (n.lt.6600) then
c	Determine wavelength step
	dx=x(2)-x(1)
	if (dx.gt.5.) then
c		Low resolution sed
c		write (6,*) 'Using trapz_lr:',x(1),x(2),dx
		trapz3=trapz_lr(x,y,n,x1,x2,ierr)
	else
c		High resolution sed
c		write (6,*) 'Using trapz2:',x(1),x(2),dx
		trapz3=trapz2(x,y,n,x1,x2,ierr)
	endif
	return
	end

	FUNCTION GW_IX_SED_LICK_SYSTEM(J,X,F,N,IGW,ISM)

c	Compute Lick index J value in the Lick system.
c	Stelib sed (x,f) is transformed previously to the
c	Lick system if ISM=0 and then the index is computed

c	array declaration
	real x(n),f(n),shift(25)
!	real y2(16000)
!	save y2

c       Transform input sed to Lick/IDS system and store seds
c	UPDATED NOV 8, 2008
c	Input sed is assumed to be already degraded to Lick IDS spectral resolution
c	if (ism.eq.0) then
c        	call lick_system(x,f,n,y2)
c		ism=1
c		do i=1,n
c		y2(i)=f(i)
c		enddo
c	endif

c	Define median shift obtained from STELIB(smoothed) - LICK
c	i.e., to transform to Lick System, subtract shift to value
c	obtained from smoothed stelib sed

c	November 2002 version (STELIB wavelength scale uncorrected for radial velocity)
c	I used routine trapz2 for integration of line indices
c	shift( 1) = -0.0101
c	shift( 2) = -0.0068
c	shift( 3) = -0.0704
c	shift( 4) = -0.0048
c	shift( 5) =  0.3649
c	shift( 6) = -0.1808
c	shift( 7) = -0.2267
c	shift( 8) =  0.3792
c	shift( 9) =  0.1065
c	shift(10) =  0.2799
c	shift(11) = -0.0210
c	shift(12) = -0.0188
c	shift(13) = -0.0634
c	shift(14) =  0.0424
c	shift(15) = -0.0864
c	shift(16) =  0.0762
c	shift(17) =  0.0236
c	shift(18) =  0.0097
c	shift(19) = -0.0393
c	shift(20) =  0.0032
c	shift(21) =  0.0037
c	shift(22) =  0.9586
c	shift(23) = -0.8760
c	shift(24) =  0.1282
c	shift(25) = -0.2813

c	April 2003 version (STELIB wavelength scale corrected for radial velocity)
c	Changed to routine trapz3 for integration of line indices
c	sigma = FWHM/2.0000 (wrong)
c	shift( 1) = -0.0106
c	shift( 2) = -0.0079
c	shift( 3) = -0.0891
c	shift( 4) = -0.0135
c	shift( 5) =  0.3401
c	shift( 6) = -0.1877
c	shift( 7) = -0.2389
c	shift( 8) =  0.3413
c	shift( 9) =  0.1110
c	shift(10) =  0.3286
c	shift(11) = -0.0208
c	shift(12) = -0.0188
c	shift(13) = -0.0416
c	shift(14) =  0.0765
c	shift(15) = -0.0217
c	shift(16) =  0.1154
c	shift(17) =  0.0068
c	shift(18) =  0.0080
c	shift(19) = -0.0034
c	shift(20) =  0.0028
c	shift(21) =  0.0035
c	shift(22) =  0.9580
c	shift(23) = -0.8710
c	shift(24) =  0.1758
c	shift(25) = -0.3096

c	August 2003 version (STELIB wavelength scale corrected for radial velocity)
c	Changed to routine trapz3 for integration of line indices
c	sigma = FWHM/2.3548
	shift( 1) = -0.0107
	shift( 2) = -0.0012
	shift( 3) = -0.0187
	shift( 4) =  0.0543
	shift( 5) =  0.5247
	shift( 6) = -0.1342
	shift( 7) = -0.1204
	shift( 8) =  0.4260
	shift( 9) =  0.1269
	shift(10) =  0.4657
	shift(11) = -0.0197
	shift(12) = -0.0179
	shift(13) =  0.0264
	shift(14) =  0.1740
	shift(15) =  0.0720
	shift(16) =  0.2040
	shift(17) =  0.0267
	shift(18) =  0.0420
	shift(19) =  0.0117
	shift(20) =  0.0029
	shift(21) =  0.0038
	shift(22) =  0.8330
	shift(23) = -0.8895
	shift(24) =  0.2019
	shift(25) = -0.2922

c	Compute index J using lick system (smoothed) sed
c	Apply median shift for the index
	if (j.le.25) then
c		gw_ix_sed_lick_system=gw_ix_sed(j,x,y2,n,igw)-shift(j)
		gw_ix_sed_lick_system=gw_ix_sed(j,x,f,n,igw)-shift(j)
	else
c		Lick system transformation only for indices 1 to 25
		gw_ix_sed_lick_system=gw_ix_sed(j,x,f,n,igw)
	endif
	return
	end

	SUBROUTINE GW_INDICES(T,FI,FC,LUN,IGW)

c	Computes spectral indices from the fluxes FI and FC using fitting functions
c	Worthey and Ottaviani indices added June 2002, indices 22 to 25.
c	Writes down the answers

c	Array declarations
	parameter (jid=26)
	real gwix(jid)
	real fi(jid),fc(jid),dw(jid)
	integer ix(jid)
	include 'gwparam.dec'
	data igwcall/0/,dw/jid*0./,ix/jid*0/

	if (t.eq.0.) return

c	Fill arrays
	if (igwcall.eq.0) then
		do j=1,25
		if (igw.eq.0) then
			call gw_etal_dat(j)
		else
			call gw_thesis_dat(j)
		endif
		dw(j)=w(6)-w(5)
		ix(j)=im
		enddo
		igwcall=1
	endif

c	Compute indices (G Worthey)
	do j=1,25
	if (ix(j).eq.0) then
		gwix(j)=dw(j)*(1.-fi(j)/fc(j))
	else
		
		gwix(j)=-2.5*alog10(fi(j)/fc(j))
	endif
c	if (j.eq.1) write (49,*) tl,fi(j),fc(j),fi(j)/fc(j)
	enddo

c	Compute 4000 A break, according to Gorgas and Cardiel procedure
c	d4000=fc(jid)/fi(jid)
	gwix(jid)=fc(jid)/fi(jid)

	tl=alog10(t)
!	write (lun+6,100) tl,(gwix(j),j= 1, 13)
	write (lun+6,100) tl,(gwix(j),j= 1, 21)
!	write (lun+7,101) tl,(gwix(j),j=14,jid)
	write (lun+7,101) tl,(gwix(j),j=22,jid)
100	format (f10.6,21f9.4)
!101	format (f10.6,8f8.3,5f12.3)
101	format (f10.6,1x,5f11.4)
	return
	end

      real*4 function dl(h,q,z)
c.....
c	  Computes luminosity distance corresponding to a redshift z.
c	  Uses Mattig formulae for qo both 0 and non 0
c	  Revised January 1991 to implement cosmolgical constant
c	Ho in km/sec/Mpc
c	******DL is in Mpc******
c.....
      implicit none
c     include 'cosmo2.dec'
      real*4 h, q, z, d1, d2
c......
      real*4 aa, bb, epsr, s, s0, funl
      real*4 dd1, dd2, omega0
      logical success
      integer npts
      external funl
      common /cosm/ omega0
c.....
      if (z.le.0.) then
c	10 pc
	dl=1.e-5
      	return
      endif

      if (q .eq. 0) then
      dl = ((3.e5 * z) * (1 + (z / 2.))) / h
      else if (q .gt. 0.) then
      d1 = (q * z) + ((q - 1.) * (sqrt(1. + ((2. * q) * z)) - 1.))
      d2 = ((h * q) * q) / 3.e5
      dl = d1 / d2
      else if (q .lt. 0.) then
         omega0 = (2. * (q + 1.)) / 3.
         aa = 1.
         bb = 1. + z
         success=.false.
         s0=1.e-10
         npts=0
         do while (.not.success)
             npts=npts+1
             call midpnt(funl,aa,bb,s,npts)
             epsr=abs(s-s0)/s0
             if (epsr.lt.1.e-4) then
                success=.true.
             else
                s0=s
             endif
         enddo
         dd1=s
	 dd2 = (3.e5 * (1. + z)) / (h * sqrt(omega0))
	 dl = dd1 * dd2
      end if
c.....
      return
      end
c=======================================================================
      real*4 function funl(x)
c.... For non-zero cosmological constant
      real*4 x, omega0, omegainv
      common /cosm/ omega0
      omegainv = 1. / omega0
      funl = 1. / sqrt(((x ** 3.) + omegainv) - 1.)
      return
      end
c=======================================================================

	Program ZEROPOINT

c	Finds zeropoint for filter pair (I,J)

	write (6,*) 'Return zero point for any filter pair.'
	write (6,*) 'To compute color, use functions zerop_n and color_n'
	write (6,*)

1	write (6,'(x,a,$)') 'Enter filter pair = i,j = '
	read (5,*,end=2,err=1) i,j
	zp=zerop_n(i,j)
	write (6,100) zp
	goto 1
100	format (35x,'Zero Point = ',f8.5/)
2	end

	SUBROUTINE EVOL_ISED(KL,Z,H0,Q0,CLAMBDA,Y,ICALL,LAST)

c	New version 4-JULY-2003, includes cosmological constant clambda

c...	Returns (in array Y) the rest frame s.e.d. observed at redshift Z
c...	A linear interpolation is performed between two adjacents s.e.d.s
c...	It is assumed that Z=0 corresponds to s.e.d. in file record KL.
c...	ICALL must be set to zero the first time the routine is called.

	include 'read_ised.dec'
	Real y(imw),zz(2000)
	Save zz,tg,ageuni
	last=0
	if (icall.eq.0) then
		icall=1
		ageuni=T(h0,q0,0.,clambda)
		tg=ta(kl)
		write (6,*)
		do k=1,kl
		call percent(6,k,kl,'EVOL_ISED')
		i1=kl-k+1
		t1=(tg-ta(i1))*1.e-9
		zz(i1)=ZX(t1,h0,q0,clambda)
		enddo
	endif
		
	do k=1,kl-1
	i1=kl-k+1
	if (zz(i1).le.z.and.z.lt.zz(i1-1)) goto 1
	enddo
	if (z.eq.zz(1)) then
		i1=1
		i2=1
		a1=1.
		a2=0.
		goto 3
	endif
c	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c	If z > zz(i1), use first sed in model (=> no evolution at this z)
c	Modified as suggested by Rogier Windhorst to allow high z
c	colors to be computed. This means that after the t=0
c	sed from galaxev is used, only the k-correction will be
c	computed (no more evolution possible because galaxy
c	did not exist at higher z''s)
c	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	last=1
	i1=1
	i2=1
	i1=2
	i2=2
	a1=1.
c	write (6,'(/x,a,f6.2,a,f6.2,a/)') '***   z =',z,' >',zz(1),', using t = 0 sed (no evolution)   ***'
	goto 2
1	i2=i1-1
	tx=ageuni-T(h0,q0,z,clambda)
	t1=(tg-ta(i1))*1.e-9
	t2=(tg-ta(i2))*1.e-9
	a1=(t2-tx)/(t2-t1)
2	a2=1.-a1
3	do i=1,iw
	y(i)=a1*f(i,i1)+a2*f(i,i2)
	enddo
	return
	end

	FUNCTION ZK(KZ,ZF)
c	Returns redshift used at step kz
	if (kz.le.21) then
		zk =  0.000 + (kz  -1)*0.005
	elseif (kz.le.97) then
		zk =  0.100 + (kz -21)*0.025
	elseif (kz.le.177) then
		zk =  2.000 + (kz -97)*0.100
	else
		zk = 10.000 + (kz-177)*0.020
	endif
	if (zk.gt.zf) zk=zf
	return
	end

	FUNCTION EW_BALMER(X,Y,N,H)

c	Computes equivalent width of the H_betha, H_gamma and H_delta lines
c	Computes the average of these 3 values

	real x(n),y(n),w(2000),z(2000),h(3)
	integer ip(3),im(3),io(3)
c	data icall/0/,ip/4,3,4/,im/4,10,4/,io/3*0/
	data icall/0/,ip/4,3,4/,im/4,10,4/,io/3*0/

c	Find position of Balmer lines
	ew_balmer=0.
	if (icall.eq.0) then
		icall=1
		do i=1,n
c		H_delta
		if (x(i).le.4100.) io(1)=i
c		H_gamma
		if (x(i).le.4340.) io(2)=i
c		H_betha
		if (x(i).ge.4860.) then
			io(3)=i
			goto 1
		endif
		enddo
1		if (n.gt.3500) then
c			High resolution mode
			call locate (x,n,4060.,im(1))
			im(1)=io(1)-im(1)
			call locate (x,n,4140.,ip(1))
			ip(1)=ip(1)-io(1)
			im(2)=16
			ip(2)=16
			call locate (x,n,4820.,im(3))
			im(3)=io(3)-im(3)
			call locate (x,n,4900.,ip(3))
			ip(3)=ip(3)-io(3)
		endif
	endif

c	Compute equivalent widths
	ew_balmer=0.
	do k=1,3
	i1=io(k)-im(k)
	i2=io(k)+ip(k)
	i=0
	do j=i1,i2
	a=(x(i2)-x(j))/(x(i2)-x(i1))
	fc=a*y(i1)+(1.-a)*y(i2)
	i=i+1
	w(i)=x(j)
	z(i)=1.-y(j)/fc
	enddo
	if (k.eq.2) then
c		Supress G-band (make profile symmetrical)
		if (n.lt.3500) then
c			G & S atlas
			w(1)=w(7)
			z(1)=z(14)
			w(2)=w(8)
			z(2)=z(13)
			do i=3,8
			w(i)=w(i+6)
			z(i)=z(i+6)
			enddo
			i=8
		else
c			High Resolution
			do l=1,12
			z(l)=z(33-l+1)
			enddo
		endif
	endif
	h(k)=trapz1(w,z,i)
	if (h(k).lt.0.) h(k)=0.
	ew_balmer=ew_balmer+h(k)
	enddo
	ew_balmer=ew_balmer/3.
	return
	end

	INTEGER FUNCTION NARGU(ARG)

c	Count how many time steps have been introduced in string arg

c	Variables
	character*(*) arg,buf*1024

c	Procedure
	i = 0
	l=largo(arg)
	if (l.eq.0) then
		nargu=0
		return
	endif
	if (arg(l:l).eq.',') arg(l:l)=' '
	buf=arg
	do while (index(buf,',').gt.0)
	i=i+1
	buf=buf(index(buf,',')+1:)
	enddo
	nargu=i+1
	return
	end

	REAL FUNCTION MF_IX_SED(J,X,F,N)

	! Computes value of Fanelli et al. UV index J directly from sed
	! Follows procedure outlined by Trager at el. (1998, ApJS 116, 1)
	! See their eq. 1-3, pag. 5.

	! J = Index identification
	! X = wavelength scale
	! F = flux scale (sed)
	! N = dimension of X, F

	! Array declaration
	character*40 idxlbl
	real x(n),f(n)
	real w(6),u(10000),z(10000)

	! Equation of straight line joining (wb,fb) and (wr,fr)
	fc(v) = ( (wr-v)*fb + (v-wb)*fr ) / (wr-wb)

	! Find wavelength points everytime to allow calls to this routine in
	! the same program using different wavelength arrays.
	! Get Parameters
	call mf_dat(j,w,idxlbl)

	! Compute mean height inside blue pseudo continuum band
       	fb=trapz3(x,f,n,w(1),w(2),ierr)/(w(2)-w(1))
	wb=(w(1)+w(2))/2.
	if (ierr.ne.0) then
		mf_ix_sed = -99.
		return
	endif

	! Compute mean height inside red pseudo continuum band
       	fr=trapz3(x,f,n,w(5),w(6),ierr)/(w(6)-w(5))
	wr=(w(5)+w(6))/2.
	if (ierr.ne.0) then
		mf_ix_sed = -99.
		return
	endif

	! Compute equivalent width according to eq. (2) of
	! Trager at el. (1998, ApJS 116, 1)
	! Locate central band in array x: w(3) and w(4)
       	call locate (x,n,w(3),i1)
       	call locate (x,n,w(4),i2)
	! Fill in auxiliary array from i1-5 to i2+5 with ratio f/fc
	nu=0
	do i=i1-5,i2+5
	nu=nu+1
	u(nu)=x(i)
	if (fc(x(i)) <= 0.) then
		mf_ix_sed = -98.
		return
	endif
	z(nu)=f(i)/fc(x(i))
	enddo
	! Compute integral of ratio f(i)/fc(x(i)) from w(3) to w(4)
       	fm=trapz3(u,z,nu,w(3),w(4),ierr)
	if (ierr.ne.0) then
		mf_ix_sed = -99.
		return
	endif

	! Compute index
	if (fm > 1000.) then
		mf_ix_sed = -97.
	elseif (fm < 0.) then
		mf_ix_sed = -96.
	elseif (fm == 0.) then
		mf_ix_sed = -95.
	else
		mf_ix_sed = w(4) - w(3) - fm
	endif
	return
	end

	SUBROUTINE ke_Nfilt_correction(kf,x,y,n,z,h0,q0,lun,nmag)

c	Compute apparent magnitude in nmag filters contained in array kf

c	Array declarations
	include 'filter.dec'
	include 'cosmo.dec'
	character*1024 aux
	integer kf(nmag)
	real x(n),y(n),f0(50),f1mag(50),f1magAB(50)
	data icall/0/
	save f0

c	Report cosmology, selected filters, etc.
	if (icall.eq.0) then
		icall=1
		write (lun,100)      h,omega,omega_lambda,q,clambda,tu,ttg,zf
		write (lun  ,'(a)') '# Meaning of printed variables (see Tables 5 and 6 of bc03.ps for details):'
		write (lun  ,'(a)') '#   z        = redshift (z=0 entry in table corresponds to a distance of 10 pc)'
		write (lun  ,'(a)') '#   ltt      = light travel time from z=0 to z in Gyr'
		write (lun  ,'(a)') '#   tz       = age of galaxy at redshit = z'
		write (lun  ,'(a)') '#   dm       = cosmological distance modulus in magnitude units'
		write (lun  ,'(a)') '#   m_ev     = apparent magnitude M_ev(z) + dm(z) in each filter (Vega system)'
		write (lun  ,'(a)') '#'
		write (lun+1,100)    h,omega,omega_lambda,q,clambda,tu,ttg,zf
		write (lun+1,'(a)') '# Meaning of printed variables (see Tables 5 and 6 of bc03.ps for details):'
		write (lun+1,'(a)') '#   z        = redshift (z=0 entry in table corresponds to a distance of 10 pc)'
		write (lun+1,'(a)') '#   ltt      = light travel time from z=0 to z in Gyr'
		write (lun+1,'(a)') '#   tz       = age of galaxy at redshit = z'
		write (lun+1,'(a)') '#   dm       = cosmological distance modulus in magnitude units'
		write (lun+1,'(a)') '#   m_ev     = apparent magnitude M_ev(z) + dm(z) in each filter (AB system)'
		write (lun+1,'(a)') '#'
		write (lun,'(a,19x,3x,50i9)') '# Filter:',(kf(i),i=1,nmag)
		write (lun+1,'(a,19x,3x,50i9)') '# Filter:',(kf(i),i=1,nmag)
		write (lun,101) ('   m_ev  ',i=1,nmag)
		write (lun+1,101) ('   m_ev  ',i=1,nmag)
		write (lun,102) ('   mag   ',i=1,nmag)
		write (lun+1,102) ('   ABmag ',i=1,nmag)
		write (aux,103) (i+4,i=1,nmag)
		l=largo(aux)
		aux(l:l)=' '
		l=largo(aux)
		write (lun,'(a)') aux(1:l)
		write (lun+1,'(a)') aux(1:l)
	endif
100     format ('# Cosmology: Ho = ',f4.0,2x,'Omega =',f5.2,2x,'Omega_lambda =',f5.2,2x,'qo = ',f7.4,2x,
     *          'Lambda =',1pE10.3,2x,'tu = ',0pf5.2,' Gyr',2x,'tg = ',f5.2,' Gyr', 2x,' zf = ',f6.2/'#')
101	format ('#  z      LTT     tz      dm      ',50a) 
102	format ('#         Gyr     Gyr     mag     ',50a)
c103	format ('# (1)     (2)     (3)     (4)   ',50(5x,'(',i2,')'))
103	format ('# (1)     (2)     (3)     (4)        (',50(i2,')     ('))

c	Compute cosmological distance modulus.
	dm=dismod(h0,q0,z)

c	Compute light travel time from z=0 to z
	tl=tu-t(h0,q0,z,clambda)
	tz=ttg-tl

c	If z=0, compute zero points
	if (z.eq.0.) then
c		Compute zero points in filters in array kf(i)
		do i=1,nmag
		f0(i)=vega_0p_n(kf(i))
		enddo
	endif

c	Compute magnitudes at this redshift
	do i=1,nmag
c	Compute absolute magnitude in filters in array kf(i) (Vega system)
	f1_ev   = f0(i) - 2.5*alog10(filter_n(kf(i),x,y,n,z,kerr))
c	Compute absolute AB magnitude in filters in array kf(i)
	ABf1_ev = AB_mag(kf(i),x,y,n,z)
c	Compute apparent magnitudes
	f1mag(i)    = f1_ev   + dm
	f1magAB(i)  = ABf1_ev + dm
	enddo

c	Write results
	if (z.eq.0.) then
		write (lun,  108) z,tl,tz,dm,(f1mag(i),i=1,nmag)
		write (lun+1,108) z,tl,tz,dm,(f1magAB(i),i=1,nmag)
	else
		write (lun,  109) z,tl,tz,dm,(f1mag(i),i=1,nmag)
		write (lun+1,109) z,tl,tz,dm,(f1magAB(i),i=1,nmag)
	endif
108	format ('#',f5.3,3f8.3,3x,100f9.4)
109	format (f6.3,3f8.3,3x,100f9.4)
	return
	end

	subroutine dattim(ifile,k,a)

c	Prints current time and date at center of page

	character a,date*24
	call fdate(date)
	if (a.eq.'s'.or.a.eq.'S') then
		write (ifile,100) date
100		format ('#',22x,a)
	elseif (a.eq.'l'.or.a.eq.'L') then
		write (ifile,101) date
101		format ('#',53x,a)
	endif
	return
	end

	FUNCTION SIGMA_INDOUS(X)

c	Returns resolution (sigma) of IndoUS library at wavelength X in A.
c	Fit provided by the P. Coelho as FWHM vs lambda.

c	compute FWHM = d at wavelength X
	if (x.lt.3600.) then
c		d = 1.6
c		Updated 26/5/06 by Paula
		d = 1.57
	else
c		d = 2.15 - 1.54E-4*x
c		Updated 26/5/06 by Paula
		d = 1.92 - 9.84E-05*x
	endif
	c=2.*sqrt(2.*alog(2.))
	sigma_indous=d/c
	return
	end

	FUNCTION FWHM_INDOUS(X)

c	Returns resolution (FWHM) of IndoUS library at wavelength X in A.
c	Fit provided by the P. Coelho as FWHM vs lambda.

c	compute FWHM = d at wavelength X
	if (x.lt.3600.) then
c		d = 1.6
c		Updated 26/5/06 by Paula
		d = 1.57
	else
c		d = 2.15 - 1.54E-4*x
c		Updated 26/5/06 by Paula
		d = 1.92 - 9.84E-05*x
	endif
	fwhm_indous=d
	return
	end

	FUNCTION FWHM_IDS(X)

c	Returns FWHM at wavelength X(A) according to Table 8 of
c	Worthey and Ottaviani (1997, ApJS, 111, 377)

c	Data points from Table 8
	parameter (nw=5)
	real w(nw),f(nw),linear
	data w/4000.,4400.,4900.,5400.,6000./
	data f/ 11.5,  9.2,  8.4,  8.4,  9.8/

c	Interpolate at wavelength X
	icall=0
	if (x.le.w(1)) then
		fwhm_ids=f(1)
	elseif (x.ge.w(nw)) then
		fwhm_ids=f(5)
	else
		icall=0
		fwhm_ids=linear(x,w,f,nw,icall)
	endif
	return
	end

	SUBROUTINE DEGRADE_RESOLUTION(X,Y,N,FWHMS,XS,YS,NS)

c	Degrades STELIB sed in (x,y) to lower resolution sed by applying a
c	gaussian broadening function. The FWHM of the gaussian is supposed
c	to be constant (= FWHM) as a function of wavelength.

c	Returns smoothed spectrum in array (x,ys)

c	Array declaration
	real x(n),y(n),xs(n),ys(n),u(1000),g(1000)

c	Check if fwhms = 0
	if (fwhms.le.0) then
		ns=n
		do i=1,ns
		xs(i)=x(i)
		ys(i)=y(i)
		enddo
		return
	endif

c	Number of sigmas to perform integration
	m=6

c	FWHM of STELIB seds = 3 A (Leborgne et al. 2002)
	fwhm_stelib = 3.

c	Perform smoothing
	fwhm2 = fwhms**2 - fwhm_stelib**2
	fwhm  = sqrt(fwhm2)

c	Note: FWHM = 2*sqrt[2*ln(2)]*sigma = 2.3548*sigma
	sigma=fwhm/2.3548
	do i=1,n
	xmax=x(i)+m*sigma
	call locate(x,n,xmax,i1)
	m2=i1+1
	m1=2*i-m2
	if (m1.lt.1) m1=1
	if (m2.gt.n) m2=n
	k=0
	do j=m1,m2
	k=k+1
	u(k)=x(j)
	g(k)=y(j)*gauss(x(j),x(i),sigma)
	enddo
	ys(i)=trapz1(u,g,k)
	xs(i)=x(i)
	enddo

c	Suppress points at both ends of smoothed sed
	k=fwhms
c	Not really
	k=0
	ns=0
	do i=1+k,n-k
	ns=ns+1
	xs(ns)=xs(i)
	ys(ns)=ys(i)
	enddo

	return
	end

	PROGRAM FLUX_EVOLUTION

c	Computes apparent magnitude vs z, color vs z, and e+k and k-correction
c	in user selected filters for BC GALAXEV evolving model sed''s
c	The user selects the filter(s) to use from the list in filters.log
c	The user enters values for the cosmological parameters

	include 'read_ised.dec'
	include 'filter.dec'
	include 'cosmo.dec'
	include 'SSP_13.dec'

	character file*96,name*96,ext*24,ext1*4,ext2*4
	integer kf(2)
	real yz(imw),xaux(24)
	data lun/26/,file/' '/,kf/0,0/
c	Cosmology:
	data h/70./,omega/0.30/,omega_lambda/0.70/

c	Check if correct filter file is in use.
	j=ifilter()
	if (j.eq.0) then
		write (6,'(2a)') char(7),'Please assign correct filter file'
		stop
	endif

c	Welcome user
	write (6,*)
	write (6,'(x,a)') 'Galaxy Spectral Evolution Library (GALAXEV)'
	write (6,'(x,a)') 'UNIX Version (C) 1995-2013 - G. Bruzual and S. Charlot - All Rights Reserved'

c	Ask for Ho, Omega, and Omega_lambda
	write (6,'(/x,a,f4.0,a,f5.3,a,$)') 'Enter cosmological parameters'
3	write (6,'(x,a,f4.0,a,f5.3,a,f5.3,a,$)')  'Enter Ho [',h,'], Omega [',omega,'], Omega_lambda [',omega_lambda,'] = '
	call nread(xaux,nc,*9,*10)
	if (nc.gt.0.) then
		h=xaux(1)
		omega=xaux(2)
		omega_lambda=xaux(3)
	endif
c	Omega is now entered bu the user
c	omega=1.-omega_lambda

c	Obtain cosmological constant and q
	clambda=cosmol_c(h,omega,omega_lambda,q)

c	Age of the universe and maximum age for galaxies (rounded off)
	tu=t(h,q,0.,clambda)
	tg=int(tu)*1.E9

c	Ask for galaxy age
	write (6,*)
	write (6,'(x,a,f6.2,a  )') 'Age of this universe  = tu =',tu,' Gyr'
2	write (6,'(x,a,f6.2,a,$)') 'Enter age of galaxy today = tg [',tg*1.e-9,' Gyr] = '
	call qread(ttg,nc,*8,*10)
	if (nc.gt.0.) tg=ttg*1.E9
	ttg=tg*1.E-9
	zf=zx(ttg,h,q,clambda)

c	Report cosmology
	write (6,'(/x,a)') 'Cosmological model in use:'
	write (6,100) h,omega,omega_lambda,q,clambda
100	format (' Ho = ',f4.0,3x,'Omega =',f5.2,3x,'Omega_lambda =',f5.2,3x,'qo = ',
     *            f7.4,3x,'Lambda =',1pE10.3)
	write (6,101) tu,ttg,zf
101	format (' tu = ',f5.2,' Gyr',3x,'tg = ',f5.2,' Gyr', 3x,' zf = ',f6.2)

c	Ask for *.ised file name
	write (6,*)
1	write (6,'(x,3a,$)') 'BC_GALAXEV model sed in file [',file(1:largo(file)),'] = '
	read (5,'(a)',end=10) name
	call chaext(name,'ised',nn)
	file=name
c	Read *.ised file
	call read_ised(file,tg,kl,kerr)
	if (kerr.ne.0) goto 1

c	Read filter file
	call filter0
c	Read A0Vsed
	call readA0V

c	Ask for filter number
4	write (6,'(/x,a,$)') 'Compute flux through filter number = '
	read (5,'(2i10)',err=7,end=10) kf(1)
	if (kf(1).le.0.or.kf(1).gt.nf) then
		write (6,'(x,a,i5,a)') 'Error in filter number',kf(1),'. Please try again'
		goto 4
	else
		imag=1
		write (6,'(/x,a)') 'Selected filter: '
		write (6,'(x,i5,x,a)') kf(1),fid(kf(1))
	endif

c	Build output file name and write header into it
	ext1='F000'
	mf=kf(1)
	if (mf.lt.10) then
		write (ext1(4:4),'(i1)') mf
	elseif (mf.lt.100) then
		write (ext1(3:4),'(i2)') mf
	elseif (mf.le.nf) then
		write (ext1(2:4),'(i3)') mf
	endif
	ext='flux_' // ext1
	call chaext(name,ext,nn)
	open (lun,file=name,form='formatted',status='unknown')
	call file_header(lun,file,1)
	write (lun,102) h,omega,omega_lambda,q,clambda,tu,ttg,zf
	write (lun,'(a)') '#                               <-- observer frame -->'
	write (lun,'(a,2i12)') '# Filter:                ',kf(1),kf(1)
	write (lun,'(a)') '#  k     z      LTT     tz        Weff       Flambda'
	write (lun,'(a)') '#               Gyr     Gyr        A          flux'
	write (lun,'(a)') '# (1)   (2)     (3)     (4)       (5)         (6)'
102	format ('# Cosmology: Ho = ',f4.0,2x,'Omega =',f5.2,2x,'Omega_lambda =',f5.2,2x,'qo = ',f7.4,2x,
     *          'Lambda =',1pE10.3,2x,'tu = ',0pf5.2,' Gyr',2x,'tg = ',f5.2,' Gyr', 2x,' zf = ',f6.2/'#')
	write (6,'(/x,2a)') 'Output written to file: ',name(1:largo(name))

c	Compute magnitudes
	write (6,'(/x,a)') 'Computing flux...'
	icall=0
	do kz=1,120000
	z=zk(kz,zf)
	call evol_ised(kl,z,h,q,clambda,yz,icall,last)
	if (last.ne.0) goto 10
	if (z.eq.zf) goto 10
c	Compute light travel time from z=0 to z
	tl=tu-t(h,q,z,clambda)
	tz=ttg-tl
	fx = effective_flux(kf(1),w,yz,iw,z,xeff)
	if (z.eq.0) then
		write (lun,103) kz,z,tl,tz,xeff,fx
103		format ('#',i3,f8.3,2f8.3,f12.2,1pe14.4)
	else
		write (lun,104) kz,z,tl,tz,xeff,fx
104		format (    i4,f8.3,2f8.3,f12.2,1pe14.4)
	endif
	if (z.ge.4.775) then
		write (74,*) kz,z
		do i=1,iw
		write (73,*) kz,z,w(i),yz(i)
		enddo
	endif
	enddo
	close (lun)
	goto 10
7	write (6,'(x,a)') 'Error in filter number. Please try again'
	goto 4
8	write (6,'(x,a)') 'Error in galaxy age. Please try again'
	goto 2
9	write (6,'(x,a)') 'Error in parameters. Please try again'
	goto 3
10	end

	SUBROUTINE SMTHPL(Y,NP,NA)

c	SMOOTHS OUT ARRAY Y BY A MEAN RUNNING AVERAGE OF NA POINTS.
c	TAKES CARE OF BORDER EFFECTS.
c	NP IS THE TOTAL NUMBER OF POINTS IN THE ARRAY. WORKS FOR UP TO
c	200000 POINTS.
c	RETURNS SMOOTHED ARRAY INTO SAME ARRAY.

	REAL Y(NP),BUF(200000)
	NB=NA/2
	DO I=1,NB
	BUF(I)=AVERAG(Y,I,I-1)
	M=NP-I+1
	BUF(M)=AVERAG(Y,M,I-1)
	ENDDO
	I1=NB+1
	I2=NP-NB
	DO I=I1,I2
	BUF(I)=AVERAG(Y,I,NB)
	ENDDO
	DO I=1,NP
	Y(I)=BUF(I)
	ENDDO
	RETURN
	END

	FUNCTION AVERAG(Y,I,J)
c	TAKES AVERAGE OF (2*J+1) POINTS OF ARRAY Y CENTERED ON Y(I)
	REAL Y(20000)
	AVERAG=0.
	L1=I-J
	L2=I+J
	DO L=L1,L2
	AVERAG=AVERAG+Y(L)
	ENDDO
	AVERAG=AVERAG/(2*J+1.)
	RETURN
	END

	PROGRAM DOWNGRADE_RESOLUTION

c	Downgrades spectral resolution of _hr_ *.ised files in the optical range

c	Applies either a gaussian smoothing, rebinning or velocity dispersion

c	Array declaration
        parameter (jb=3)
	include 'csp.dec'
        character name*256,save*256,aux*256
	logical stelib
        real t(jts),x(imw),y(imw),w(imw),z(imw),shigh(imw)
        real snr(0:jts),pnr(0:jts),bh(0:jts),sn(0:jts),wd(0:jts),rm(0:jts)
        real str(0:jts),sf(0:jts),evf(0:jts)
!	real bol(0:jts)
	data save/' '/

c	Check if correct filter file is in use.
	j=ifilter()
	if (j.eq.0) then
		write (6,'(2a)') char(7),'Please assign correct filter file'
		write (6,'(2a)') char(7),'Use command: stdfilt'
		stop
	endif

c	Ask for file name
1	call copyright(6)
2	write (6,'(x,3a,$)') 'BC_GALAXEV *.ised in file [',save(1:largo(save)),'] = '
	read (5,'(a)',end=10) save
	if (largo(save).gt.0) name=save
	call chaext(name,'ised',nm)
	open (11,file=name,form='unformatted',status='old',err=9)
c	Read basic parameters from input file
	read (11) ks,(t(i),i=1,ks),ml,mu,iseg,
     &  (xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),
     &  totm,totn,avs,io,tauo,id,tcut,ttt,ttt,ttt,id,id,igw,stelib
	read (11) n,(x(i),i=1,n)

c	Check if _lr_, _hrs_, or _hr_ model
	if (n < 2100 ) then		! BaSeL lr model
!	if (n.lt.6900.and.n.ne.5112) then
!		Wrong kind of model (5112 allows for Miles models)
		write (6,*)
		write (6,*) 'The file you have entered does not correspond to a high resolution model. Please try again.'
		write (6,*)
		close (11)
		goto 2
	endif

c	Choose smoothing option
	write (6,*)
	write (6,'(x,a)') 'Options to downgrade spectral resolution of sed''s in range from 3300 to 9300 A:'
	write (6,'(x,a)')  'Choose: 1 = Rebin sed''s'
	write (6,'(x,a)')  '        2 = Apply gaussian broadening function'
	write (6,'(x,a)')  '        3 = Stellar velocity dispersion'
	write (6,'(x,a)')  '        4 = From IndoUS to STELIB resolution'
3	write (6,'(x,a,$)')'Choice: '
	read (5,'(i10)',err=3,end=10) iop
	write (6,*)
	save=name
	i=index(name,'.')-1
	if (iop.eq.1) then
c		Rebin sed
		write (6,'(x,a)')   'Sample bin widths =  5 A to rebin to the Pickles library wavelength scale'
		write (6,'(x,a)')   '                    20 A to rebin to the BaSeL wavelength scale'
4		write (6,'(x,a,$)') 'Enter bin width   = '
		read (5,*,err=4,end=10) dw
		name=name(1:i) // '_rb_xxxx'
		if (dw.lt.10.) then
			write (name(i+5:),'(i1,a)') int(dw),'A  ' 
		elseif (dw.lt.100.) then
			write (name(i+5:),'(i2,a)') int(dw),'A ' 
		elseif (dw.lt.1000.) then
			write (name(i+5:),'(i3,a)') int(dw),'A' 
		endif
	elseif (iop.eq.2) then
c		Apply gaussian broadening function
		write (6,'(x,a)')   'Sample FWHM = 10 A to approximate the Pickles library spectral resolution'
		write (6,'(x,a)')   '              20 A to approximate the BaSeL spectral resolution'
		write (6,'(x,a)')   '              -1 A to approximate the Lick/IDS spectral resolution (Worthey and Ottaviani 1997)'
5		write (6,'(x,a,$)') 'Enter FWHM  = '
		read (5,*,err=5,end=10) fw
		name=name(1:i) // '_gb_xxxx'
		if (fw.eq.-1.) then
			write (name(i+5:),'(a)') 'lick' 
		elseif (fw.lt.10.) then
			write (name(i+5:),'(i1,a)') int(fw),'A  ' 
		elseif (fw.lt.100.) then
			write (name(i+5:),'(i2,a)') int(fw),'A ' 
		elseif (fw.lt.1000.) then
			write (name(i+5:),'(i3,a)') int(fw),'A' 
		endif
	elseif (iop.eq.3) then
c		Compute effects of stellar velocity dispersion on spectral resolution
6		write (6,'(x,a,$)') 'Enter sigma for velocity dispersion (km/s) = '
		read (5,'(f10.0)',err=6,end=10) sigma
		name=name(1:i) // '_vd_sigma_xxxx'
		if (sigma.ge.1000.) then
			write (name(i+11:),'(i4)') nint(sigma)
		elseif (sigma.ge.100.) then
			write (name(i+11:),'(i3,a)') nint(sigma),' '
		elseif (sigma.ge.10.) then
			write (name(i+11:),'(i2,a)') nint(sigma),'  '
		elseif (sigma.ge.0.) then
			write (name(i+11:),'(i1,a)') nint(sigma),'   '
		else
			write (6,*) 'Invalid value of sigma: ',sigma
			goto 6
		endif
	elseif (iop.eq.4) then
c		Downgrades from IndoUS to Stelib spectral resolution
c		Compute sigma as a function of wavelength
		m=n
		do ir=1,n
		w(ir)=x(ir)
		shigh(ir)=sigma_indous(x(ir))
		enddo
		name=name(1:i) // '_stelib_res'
	else
		write (6,*) 'Wrong option. Please try again.'
		goto 3
	endif

c	Open output files
	write (6,*)
	write (6,'(x,3a,$)') 'Generic output file name [',name(1:largo(name)),'] = '
	read (5,'(a)',end=10) aux
	if (largo(aux).gt.0) name=aux
c	Open ascii files for output
	lun=20
	call open_color_files(lun,name)
c	Open binary file and write basic data
	call chaext(name,'ised',nn)
	open (lun,file=name,form='unformatted',status='unknown')
       	write (lun) ks,(t(i),i=1,ks),ml,mu,iseg,
     &		    (xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),
     &		    totm,totn,avs,io,tauo,id,tcut,ttt,ttt,ttt,id,id,igw,stelib
	igw=0
	stelib=.true.

c	Do required task
	do k=1,ks
	read (11) n,(y(i),i=1,n),inx,(y(i),i=n+1,n+inx)
	if (iop.eq.1) then
		call rebin_sed(x,y,n,dw,w,z,m)
	elseif (iop.eq.2) then
		call gbfun_sed(x,y,n,fw,w,z,m)
	elseif (iop.eq.3) then
		call vdsig_sed(x,y,n,sigma,w,z,m)
	elseif (iop.eq.4) then
c		Transform to Stelib resolution
c		FWHM = 3. A
		d=3.
		c=2.*sqrt(2.*alog(2.))
		slow=d/c
		call degrade_to_constant_resolution(x,y,n,slow,shigh,z)
	endif
	if (k.eq.1) write (lun) m,(w(i),i=1,m),inx,(y(i),i=n+1,n+inx)
	write (lun) m,(z(i),i=1,m),inx,(y(i),i=n+1,n+inx)
        call rf_color(1,t(k),w,z,m,lun,1.E6,str(k),sf(k),evf(k),snr(k),pnr(k),bh(k),sn(k),wd(k),rm(k),toff(k),bolms(k),gasms(k),galms(k))
        if (k.gt.1) call percent(6,k,ks,'DOWNGRADE_RESOLUTION ' // name(1:nargo(name)))
	enddo

c	Add remaining records
	read (11,end=8) m,(bflx(i),i=1,m)
	write (lun) m,(bflx(i),i=1,m)
	read (11,end=8) m,(strm(i),i=1,m)
	write (lun) m,(strm(i),i=1,m)
	read (11,end=8) m,(sf(i),i=1,m)
	write (lun) m,(sf(i),i=1,m)
	read (11,end=8) m,(evfl(i),i=1,m)
	write (lun) m,(evfl(i),i=1,m)
	read (11,end=8) m,(snbr(i),i=1,m)
	write (lun) m,(snbr(i),i=1,m)
	read (11,end=8) m,(pnbr(i),i=1,m)
	write (lun) m,(pnbr(i),i=1,m)
	read (11,end=8) m,(bhtn(i),i=1,m)
	write (lun) m,(bhtn(i),i=1,m)
	read (11,end=8) m,(sntn(i),i=1,m)
	write (lun) m,(sntn(i),i=1,m)
	read (11,end=8) m,(wdtn(i),i=1,m)
	write (lun) m,(wdtn(i),i=1,m)
	read (11,end=8) m,(rmtm(i),i=1,m)
	write (lun) m,(rmtm(i),i=1,m)
	read (11,end=8) m,(toff(i),i=1,m)
	write (lun) m,(toff(i),i=1,m)
	read (11,end=8) m,(bolms(i),i=1,m)
	write (lun) m,(bolms(i),i=1,m)
	read (11,end=8) m,(gasms(i),i=1,m)
	write (lun) m,(gasms(i),i=1,m)
	read (11,end=8) m,(galms(i),i=1,m)
	write (lun) m,(galms(i),i=1,m)
8	close (11)
	close (lun)
c	Delete unwanted files
	call delete_files(name,9000,1)
	i=index(name,'.')-1
	write (6,'(/x,2a)') 'Finished building model: ',name(1:i)
	name=save
	goto 1
9       write (6,'(x,3a)') 'File ',name(1:largo(name)),' not found. Please try again.'
        goto 2
10      end

	SUBROUTINE REBIN_SED(X,Y,N,DW,W,Z,M)

c	Rebin STELIB sed (X,Y,N) in optical range to desired width (DW A)
c	Rebinned sed is returned in (W,Z,M)

c	Array declaration
	real x(n),y(n),w(n),z(n)

c	Rebinning in wavelength range from w0 to near 9290 A
c	Setup parameters
	if (dw.le.5) then
		w0=3325.
		wf=9295.
		wl=3322.
	else
		w0=3330.
		wf=9290.
		wl=3322.
	endif
	if (n > 8000) then		! xmiless hr sed
		w0 = 1000.
		wl = 1000.-dw
	endif

c	Up to wl, keep original sed
	m=0
	do j=1,n
	if (x(j) <= wl) then
		m=m+1
		w(m)=x(j)
		z(m)=y(j)
	endif	
	enddo

c	Build rebinned sed from w0 to 9290 A
	do j=1,n
	if (w0 <= wf) then
		m=m+1
		w(m)=w0
		z(m)=trapzq(x,y,n,w0-dw/2.,w0+dw/2.,ierr)/dw
		w0=w0+dw
	endif
	enddo

c	Above last w0, keep original sed
	do j=1,n
	if (x(j) >= w0) then
		m=m+1
		w(m)=x(j)
		z(m)=y(j)
	endif
	enddo
	return
	end

	SUBROUTINE GBFUN_SED(X,Y,N,FWHMS,W,Z,M)

c	Degrades resolution of sed in (X,Y,N) by applying a gaussian broadening function
c	The FWHM of the gaussian is assumed to be constant (= FWHM) with wavelength.
c	Resulting sed is returned in (W,Z,M)

c	Array declaration
	real x(n),y(n),w(n),z(n)

c	Degrade the sed
	if (fwhms.eq.-1.) then
c		Transform to Lick/IDS spectral resolution
		do i=1,n
		w(i)=x(i)
		enddo
		m=n
		call lick_system(x,y,n,z)
	else
		call degrade_resolution(x,y,n,fwhms,w,z,m)
	endif

!	Check for type of sed
	w0=3322.
	if (n > 8000) w0 = 1000.		! xmiless hr sed

c	Up to w0, keep original sed
	m=0
	do j=1,n
	if (x(j) <= w0) then
		m=m+1
		w(m)=x(j)
		z(m)=y(j)
	endif	
	enddo

c	Above 9290 A keep original sed
	w0=9290.
c	Find position K corresponding to w0 in array X
	call locate(x,n,w0,k)
	m=k+1
	do j=1,n
	if (x(j).gt.w0) then
		m=m+1
		w(m)=x(j)
		z(m)=y(j)
	endif
	enddo
	return
	end

	SUBROUTINE VDSIG_SED(X,Y,N,SIGMA,W,Z,M)

c	Degrades resolution of sed in (X,Y,N) introducing the stellar velocity dispersion
c	Resulting sed is returned in (W,Z,M)

c	Array declaration
	parameter (kw=25000)
	real x(n),y(n),w(kw),z(kw)

c	Compute new sed
	do i=1,n
	w(i)=x(i)
	z(i)=y(i)
	enddo
	m=n
	call gaussian_v_disp(w,z,m,sigma)

!	Check for type of sed
	w0=3330.
	if (n > 8000) w0 = 1000.		! xmiless hr sed

c	Up to w0, keep original sed
	if (x(1) <= w0) then
		m=0
		do j=1,n
		if (x(j).le.w0) then
			m=m+1
			w(m)=x(j)
			z(m)=y(j)
		endif	
		enddo
	endif

c	Above 9290 A keep original sed
	w0=9290.
	if (x(n).gt.w0) then
c		Find position k corresponding to w0 in array X
		call locate(x,n,w0,k)
		m=k+1
		do j=1,n
		if (x(j).gt.w0) then
			m=m+1
			w(m)=x(j)
			z(m)=y(j)
		endif
		enddo
	endif
	return
	end

	FUNCTION TRAPEZ(Y,N,DX)
c	FINDS AREA BELOW CURVE (X,Y) ACCORDING TO TRAPEZOIDAL RULE.
c	ASSUMES EQUAL SPACING DX BETWEEN N POINTS.
	REAL Y(N)
	TRAPEZ=0.
	IF (N.LE.1) RETURN
	TRAPEZ=(Y(1) + Y(N))*DX/2.
	IF (N.EQ.2) RETURN
	A=0.	
	DO I=2,N-1
	A = A + Y(I)
	ENDDO
	TRAPEZ = TRAPEZ + A*DX
	RETURN
	END

      SUBROUTINE LOCATE(XX,N,X,J)
      DIMENSION XX(N)
      JL=0
      JU=N+1
10    IF(JU-JL.GT.1)THEN
        JM=(JU+JL)/2
        IF((XX(N).GT.XX(1)).EQV.(X.GT.XX(JM)))THEN
          JL=JM
        ELSE
          JU=JM
        ENDIF
      GO TO 10
      ENDIF
      J=JL
      RETURN
      END

      SUBROUTINE LOCATE8_SUB(XX,N,X,J)
      REAL*8 X,XX(N)
      JL=0
      JU=N+1
10    IF(JU-JL.GT.1)THEN
        JM=(JU+JL)/2
        IF((XX(N).GT.XX(1)).EQV.(X.GT.XX(JM)))THEN
          JL=JM
        ELSE
          JU=JM
        ENDIF
      GO TO 10
      ENDIF
      J=JL
      RETURN
      END

      INTEGER FUNCTION ILOCATE(XX,N,X)
      DIMENSION XX(N)
      JL=0
      JU=N+1
10    IF(JU-JL.GT.1)THEN
        JM=(JU+JL)/2
        IF((XX(N).GT.XX(1)).EQV.(X.GT.XX(JM)))THEN
          JL=JM
        ELSE
          JU=JM
        ENDIF
      GO TO 10
      ENDIF
      ILOCATE=JL
      RETURN
      END

	REAL FUNCTION XCLOSEST(X,XX,N,J)
	DIMENSION XX(N)
	integer ilocate
	! Returns closest value to X in array XX
	j = ilocate(xx,n,x)
	if (j == n) then
		return
	elseif (abs(x-xx(j)) < abs(x-xx(j+1))) then
		xclosest = xx(j)
	else
		xclosest = xx(j+1)
		j=j+1
	endif
	return
	end

      INTEGER FUNCTION ALOCATE(XX,N,X)
      ! Alphanumeric (adapted by GBA from Numerical Recipes SORT2)
      CHARACTER*(*) XX(N),X
      JL=0
      JU=N+1
10    IF(JU-JL.GT.1)THEN
        JM=(JU+JL)/2
        IF((XX(N).GT.XX(1)).EQV.(X.GT.XX(JM)))THEN
          JL=JM
        ELSE
          JU=JM
        ENDIF
      GO TO 10
      ENDIF
      ALOCATE=JL
      RETURN
      END

	FUNCTION GC_D4000_FIT(X,Y,N,TEFF,GLOG,FEH,FL,FR)

c	Computes 4000 A break amplitude according to the algorithm written
c	by Javier Gorgas and Nicolas Cardiel (GC), based on fitting functions.

c	Needs Teff, log g, and [Fe/H] for star of sed (x,y)

c	Returns value of fl = F(4000-) and fr = F(4000+)
c	D4000 = fr/fl

	real x(n),y(n),w(2000),z(2000)
!	save i1,i2
	save i3,i4
	data icall/0/

c	Find wavelength points
	gc_d4000_fit=0.
c	if (icall.eq.0) then
c		To allow different x scales in same program, always locate
c		icall=1

c		call locate (x,n,4050.,i1)
c		call locate (x,n,4250.,i2)
c		i2=i2+1

		call locate (x,n,3750.,i3)
		call locate (x,n,3950.,i4)
		i4=i4+1

c	endif

c	Transform to Fnu units
c	i=0
c	do j=i1,i2
c	i=i+1
c	w(i)=x(j)
c	z(i)=y(j)*x(j)**2
c	enddo
c	fr=trapz1(w,z,i)/(x(i2)-x(i1))

c	Compute F(4000-)
	i=0
	do j=i3,i4
	i=i+1
	w(i)=x(j)
	z(i)=y(j)*x(j)**2
	enddo
	fl=trapz1(w,z,i)/(x(i4)-x(i3))

c	Compute break amplitude (= findex) according to Gorgas and Cardiel
	call eff_d4000(teff,glog,feh,findex,eindex,iflag)

c	Compute F(4000+)
	fr=fl*findex
	gc_d4000_fit=findex

	return
	end

	FUNCTION GC_D4000_OBS(X,Y,N)

c	Measures 4000 A break from sed according to J. Gorgas and N. Cardiel

	parameter (jid=35)
	real x(n),y(n),w(11000),z(11000)
	save i1,i2,i3,i4
c	Common to store fluxes
	integer iim(jid)
	real ffb(jid),ffr(jid),ffc(jid),ffl(jid)
        common /fluxes/ iim,ffb,ffr,ffc,ffl
	data icall/0/

c	Find wavelength points
	gc_d4000_obs=0.
	if (icall.eq.0) then
c		To allow different x scales in same program, always locate
c		icall=1

		call locate (x,n,4050.,i1)
		call locate (x,n,4250.,i2)
		i2=i2+1

		call locate (x,n,3750.,i3)
		call locate (x,n,3950.,i4)
		i4=i4+1

	endif

c	Transform to Fnu units
c	Compute F(4000+)
	i=0
	do j=i1,i2
	i=i+1
	w(i)=x(j)
	z(i)=y(j)*x(j)**2
	enddo
	fr=trapz1(w,z,i)/(x(i2)-x(i1))

c	Compute F(4000-)
	i=0
	do j=i3,i4
	i=i+1
	w(i)=x(j)
	z(i)=y(j)*x(j)**2
	enddo
	fl=trapz1(w,z,i)/(x(i4)-x(i3))

c	Compute break amplitude
	gc_d4000_obs=fr/fl

c	Store fluxes for future use
	iim(30)=-1
	ffb(30)=fl
	ffr(30)=fr
	ffc(30)=gc_d4000_obs
	ffl(30)=gc_d4000_obs

	return
	end

c-----------------------------------------------------------------------------
c Version 02/12/98
c-----------------------------------------------------------------------------
c Program to evaluate the D4000 index using the empirical fitting functions
c from Gorgas, Cardiel, Pedraz, Gonzalez (1998, A&A Suppl., in preparation)
c
c INPUT:
c       t = effective temperature, in K                      (REAL)
c       g = logarithm (base 10) of the surface gravity       (REAL)
c       z = metallicity ([Fe/H])                             (REAL)
c  (A value higher or equal to 99 in g or z in input means that this 
c    parameter is unknown. In same cases, an index value can still be 
c    computed. T<=0 means that temperature is unknown) 
c  
c
c OUTPUT:
c       findex = index value                                 (REAL)
c       eindex = error in the index value                    (REAL)
c       iflag = indicates sucess of the functions:           (INTEGER)
c              0 -> OK
c              1 -> extrapolation to high temperatures
c              2 -> extrapolation to low temperatures
c              3 -> extrapolation in g (uncertain value)
c             -1 -> Error (no Teff)
c             -2 -> Error (z needed)
c             -3 -> Error (g needed)
c             -5 -> Error

      subroutine eff_d4000(t,g,z,findex,eindex,iflag)
      implicit none
      integer iflag
      real t,g,z,findex,eindex
      
      integer i,j
      real thet,x,findex0,eindex0
      real ctcg,ctcd,ctd,errt,errw
      double precision theta,thetaz,theta2,theta2z,xh(25)
      double precision ccg(25,25),ccd(25,25),cw(25,25),ch(25,25),cg(25)
      double precision cd(25,25),dumt,xh2(25)
      double precision fcg(25),fcd(25),fw(25),fh(25),fg(25),fd(25)
      double precision srcg,srcd,vh,srw,srh,dx,srg,xfg,srfg,srd,fw1
      double precision sri,fi(25),ci(25,25)
      logical nog,noz

c-----------------------------------------------------------------------
c Coefficients and Variance-covariance matrices:

c For hot stars
      srh=0.4615183238D-01
      fh(1)=0.6548051838D+00
      fh(2)=0.1340106583D+01
      ch(1,1)=0.2313283739D+00
      ch(1,2)=-0.4761853888D+00
      ch(2,2)=0.1142256111D+01

c For warm stars
      srw=0.3422608269D-01
      fw(1)=0.1822983515D+01
      fw(2)=-0.5068388040D+00
      cw(1,1)=0.1663359277D+02
      cw(1,2)=-0.2414081677D+02
      cw(2,2)=0.3519089299D+02
      errw=0.159526188D-01
      fw1= 1.4428544D+00
c For hot supergiants
      sri=0.7879815732D-01
      fi(1)=0.8613232907D+00
      fi(2)=0.1848690037D+01
      ci(1,1)=0.1731426778D+00
      ci(1,2)=-0.8470102471D+00
      ci(2,2)=0.7135431404D+01

c For cool giants:
      ctcg=0.9
      srcg=0.1309941549D+00
      fcg(1)=-0.5664970674D+01
      fcg(2)=0.9278637462D+01
      fcg(4)=-0.3273398709D+01
      fcg(5)=0.7322437356D+01
      fcg(7)=-0.3080110968D+01
      fcg(16)=-0.3694125492D+01
      data ((ccg(i,j),j=1,6),i=1,6)/0.1424049628D+03,-0.2516045719D+03,
     c 0.8616301985D+02,-0.1533506540D+03,0.1102731351D+03,
     c 0.6779636477D+02,0.D0,0.4460123942D+03,-0.1534799668D+03,
     c 0.2742738641D+03,-0.1961177449D+03,-0.1217490895D+03,0.D0,0.D0,
     c 0.3013629553D+03,-0.5639211958D+03,0.6795204379D+02,
     c 0.2608696279D+03,0.D0,0.D0,0.D0,0.1060365074D+04,
     c -0.1219393397D+03,-0.4926576419D+03,0.D0,0.D0,0.D0,0.D0,
     c 0.8652160543D+02,0.5435617680D+02,0.D0,0.D0,0.D0,0.D0,0.D0,
     c 0.2298069839D+03/

c For cool dwarfs:
      ctcd=0.9
      srcd=0.1647942839D+00
      fcd(1)=-0.8153624600D+01
      fcd(2)=0.1344994016D+02
      fcd(4)=-0.1706301430D+02
      fcd(5)=0.3811728640D+02
      fcd(7)=-0.4768742248D+01
      fcd(16)=-0.2068889239D+02
      data ((ccd(i,j),j=1,6),i=1,6)/0.1482840358D+03,-0.3158204285D+03,
     c 0.1389514149D+02,-0.2538831761D+02,0.1668009227D+03,
     c 0.1078900852D+02,0.D0,0.6745000058D+03,-0.3087237636D+02,
     c 0.5813276884D+02,-0.3571841966D+03,-0.2581987859D+02,0.D0,0.D0,
     c 0.1950227161D+04,-0.4230766254D+04,0.1667832891D+02,
     c 0.2278759127D+04,0.D0,0.D0,0.D0,0.9188955680D+04,
     c -0.3219517176D+02,-0.4955197523D+04,0.D0,0.D0,0.D0,0.D0,
     c 0.1896456546D+03,0.1480236474D+02,0.D0,0.D0,0.D0,0.D0,0.D0,
     c 0.2675388494D+04/

c For cold giants
      srg=0.2107104366D+00
      fg(1)=0.9524702185D+01
      fg(2)=-0.4093622777D+01
      cg(1)=0.1861588935D+01
      cg(2)=0.2986724620D+01
      xfg=0.1301180D+01
      srfg=0.1310919D+00

c For cold dwarfs
      ctd=1.15
      srd=0.1868498444D+00
      fd(1)=-0.2908460064D+01
      fd(2)= 0.6534652942D+01
      fd(7)=-0.2975879712D+01
      data ((cd(i,j),j=1,3),i=1,3)/0.2490535985D+03,-0.3573457710D+03,
     c 0.1258060822D+03,0.D0,0.5155536330D+03,-0.1824972759D+03,0.D0,
     c 0.D0,0.6497403497D+02/

c-----------------------------------------------------------------------

      nog=.false.
      noz=.false.
      if(g.ge.99.) nog=.true.
      if(z.ge.99.) noz=.true.

      iflag=0
      findex=0.
      eindex=0.
      if(t.le.0.) then
         iflag=-1
         return
      end if

c Program works in theta (=5040/Teff)
      theta=5040.D0/dble(t)
      thet=real(theta)
c Now, it prepares coefficients for error evaluation
      thetaz=theta*dble(z)
      theta2=theta*theta
      theta2z=theta2*dble(z)
      xh(1)=1.D0
      xh(2)=theta
      xh(3)=dble(z)
      xh(4)=thetaz
      xh(5)=theta2
      xh(6)=theta2z
      dumt=0.8D+00
      xh2(1)=1.D0
      xh2(2)=dumt
      xh2(3)=dble(z)
      xh2(4)=dumt*dble(z)
      xh2(5)=dumt*dumt
      xh2(6)=dumt*dumt*dble(z)
 
c Hot supergiants
      if(thet.le.0.7) then
         if(g.lt.(3.456933-1.221595*thet)) then
            if(t.lt.0.19) iflag=1
            findex=real(fi(1)+fi(2)*theta*theta*theta)
            xh(2)=theta*theta*theta
            call comperr(2,xh,ci,vh)
            eindex=real(sri*dsqrt(vh))
            return
         end if
      end if

c Theta=(0.127,0.6326)
c Not known dependence on g or z
c Even is theta is lower, the program extrapolates.
      if(thet.le.0.6326) then
         if(t.lt.0.127) iflag=1
         findex=real(fh(1)+fh(2)*theta)
         call comperr(2,xh,ch,vh)
         eindex=real(srh*dsqrt(vh))
         return
      end if
      
c Theta=(0.6326,0.75)
      if(thet.le.0.75) then
         findex=real(fw(1)+fw(2)*theta)
         call comperr(2,xh,cw,vh)
         eindex=real(srw*dsqrt(vh))
         return
      end if

      if(nog) then
         if(thet.le.0.8) then
            findex=real(fw(1)+fw(2)*theta)
            call comperr(2,xh,cw,vh)
            eindex=real(srw*dsqrt(vh))
            return
         else
            iflag=-3
            return
         end if
      end if

c Giants (logg < 3.5)
      if(g.le.3.5) then
c Theta=(0.75,1.3)
         if(thet.lt.real(xfg)) then
c If there is no value of z,g it cannot compute the index, except for theta 
c below 0.8
            if(noz) then
               if(thet.le.0.8) then
                  findex=real(fw(1)+fw(2)*theta)
                  call comperr(2,xh,cw,vh)
                  eindex=real(srw*dsqrt(vh))
                  return
               else
                  iflag=-2
                  return
               end if
            end if
            if(thet.ge.0.8) then
               findex=ctcg+real(dexp(fcg(1)+fcg(2)*theta+fcg(4)*dble(z)+
     c           fcg(5)*thetaz+fcg(7)*theta2+fcg(16)*theta2z))
               call comperr(6,xh,ccg,vh)
               errt=real(srcg*dsqrt(vh))
c This is the error in the mean index for these atm. par. If we wanted the 
c expected error for one measurement we should compute:
c               errt=sigres*sqrt(1+vh)
               eindex=errt*(findex-ctcg)
c If theta is between 0.75 and 0.8 we interpolate between this value and the 
c constant value of warm stars at theta=0.75 (0.
            else
               dumt=0.8D+00
               findex=ctcg+real(dexp(fcg(1)+fcg(2)*dumt+fcg(4)*dble(z)+
     c           fcg(5)*dumt*dble(z)+fcg(7)*dumt*dumt+fcg(16)*dumt*dumt*
     c           dble(z)))
               call comperr(6,xh2,ccg,vh)
               errt=real(srcg*dsqrt(vh))
               eindex=errt*(findex-ctcg)
               x=(thet-0.75)/0.05
               findex=real(fw1)*(1.-x)+findex*x
               eindex=errw*(1.-x)+eindex*x
            end if
         else
c Theta=(1.3,1.72) for giants
            findex=real(fg(1)+fg(2)*theta)
            dx=theta-xfg
	    eindex=real(dsqrt(srg*srg*(dx**2)*cg(1)+
     c        srfg*srfg*(1.D0-dx*cg(2))**2))
            if(g.gt.1.5) iflag=3
            if(thet.gt.1.73) iflag=2
         end if
         if(g.le.3.) then
            return
         else
            findex0=findex
            eindex0=eindex
         end if
      end if

c Dwarfs (logg > 3.)
      if(g.gt.3.) then
c Theta=(0.75,1.07)
c Cambiar lo siguiente:
         if(thet.le.1.0757) then
c If there is no value of z it cannot compute the index, except for theta 
c below 0.8
            if(noz) then
               if(thet.le.0.8) then
                  findex=real(fw(1)+fw(2)*theta)
                  call comperr(2,xh,cw,vh)
                  eindex=real(srw*dsqrt(vh))
                  return
               else
                  iflag=-2
                  return
               end if
            end if
            if(thet.ge.0.8) then
               findex=ctcd+real(dexp(fcd(1)+fcd(2)*theta+fcd(4)*dble(z)+
     c           fcd(5)*thetaz+fcd(7)*theta2+fcd(16)*theta2z))
               call comperr(6,xh,ccd,vh)
               errt=real(srcd*dsqrt(vh))
               eindex=errt*(findex-ctcd)
c If theta is between 0.75 and 0.8 we interpolate between this value and the 
c constant value (for 0.6-0.75) 
            else
               dumt=0.8D+00
               findex=ctcd+real(dexp(fcd(1)+fcd(2)*dumt+fcd(4)*dble(z)+
     c           fcd(5)*dumt*dble(z)+fcd(7)*dumt*dumt+fcd(16)*dumt*dumt*
     c           dble(z)))
               call comperr(6,xh2,ccd,vh)
               errt=real(srcd*dsqrt(vh))
               eindex=errt*(findex-ctcd)
               x=(thet-0.75)/0.05
               findex=real(fw1)*(1.-x)+findex*x
               eindex=errw*(1.-x)+eindex*x
            end if
         else
c Theta=(1.08,1.84) for dwarfs
            findex=ctd+real(dexp(fd(1)+fd(2)*theta+fd(7)*theta2))
            xh(3)=xh(5)
            call comperr(3,xh,cd,vh)
            errt=real(srd*dsqrt(vh))
            eindex=errt*(findex-ctd)
            if(g.lt.4.) iflag=3
            if(thet.gt.1.84) iflag=2
         end if
         if(g.ge.3.5) then
            return
         else
c Here we interpolate between this value and the one computed for giants 
c (this applies when log g is between 3.0 and 3.5):
            x=(g-3.)/0.5
            findex=findex0*(1.-x)+findex*x
            eindex=eindex0*(1.-x)+eindex*x
            return
         end if
      end if
c Error: No value was computed
      iflag=-5
      return

      end
c
c
c
      subroutine comperr(n,x,c,v)
      implicit none

      integer n
      double precision x(25),v,c(25,25)

      integer i,j
!     integer n1,n2,n3,n4
      double precision x1(25,25),x2(25,25),temp(25,25),fin(25,25)

c First it reconstructs the whole v-c matrix
      
      do i=2,n
         do j=1,i-1
            c(i,j)=c(j,i)
         end do
      end do

      do j=1,n
         x1(1,j)=x(j)
         x2(j,1)=x(j)
      end do

      call multmatrix(x1,c,temp,1,n,n,n)

      call multmatrix(temp,x2,fin,1,n,n,1)
      v=fin(1,1)

      return
      end

c Subroutine to multiply matrices
c Input: a -> matrix n1 x n2
c        b -> matrix n3 x n4
c n2 must be equal to n3
c Input : n1,n2,n3,n4 (integers, dimensions of matrices)
c Output: c -> matrix n1 x n4
c In the main program matrices must be defined as double precision with 
c   dimensions 25x25
 
      subroutine multmatrix(a,b,c,n1,n2,n3,n4)
      implicit none

      integer n1,n2,n3,n4
      integer i,j,k
      double precision a(25,25),b(25,25),c(25,25)

      if(n2.ne.n3) then
         write(6,*) 'Error in matrix dimensions'
         stop
      end if
      
      do i=1,n1
         do j=1,n4
            c(i,j)=0.D0
            do k=1,n2
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do

      return
      end

	Program zmag

c	Returns galaxy magnitude in a given filter at redshift z for chosen cosmological model

c	Array declarations required in program calling function FMAG
	character file*128,filtid*64
	real k_corr_0,k_ABcorr_0,k_corr_z,k_ABcorr_z,xk_buff(2)
        common /mag/ file,icall,h,omega,omega_lambda,clambda,q,tu,tgal,tl,tz,zf,dm,filtid,
     *  f_ev,f_rf,f_ne,f_ne_0,ABf_ev,ABf_rf,ABf_ne,ABf_ne_0,k_corr_0,k_ABcorr_0,k_corr_z,k_ABcorr_z,
     *  ek_corr,ek_ABcorr,xk_buff

c	Meaning of variables in call to function fmag (see Tables 5 and 6 of bc03.ps for details):
c	  z		= redshift to compute apparent magnitude
c	  kf		= number of filter chosen to compute galaxy magnitude
c	  fmag		= apparent magnitude M_ev(z) + dm(z) in filter kf (Vega system)
c	  fmagAB	= apparent AB magnitude M_ev(z) + dm(z) in filter kf (AB system)
c	  iwrite	= print screen output (iwrite > 0)

c	Meaning of variables in common /mag/
c	  file		= BC GALAXEV *.ised model file name
c	  icall		= 0 when calling function for the first time
c	  h		= Hubble constant (Km/s/Mpc)
c	  omega		= density parameter
c	  omega_lambda	= density parameter associated to cosmological constant
c	  clambda     	= cosmological constant
c	  q		= deceleration parameter
c	  tu		= age of the universe in this cosmology
c	  tgal		= age of galaxy today
c	  tl		= light travel time from z=0 to z
c	  tz		= age of galaxy at redshift z
c	  zf		= redshift of galaxy formation
c	  dm		= cosmological distance modulus in magnitude units
c	  filtid	= filter identification
c	  f_ev   	= M_ev(z) in filter kf (Vega system)
c	  f_rf   	= M_rf(z) in filter kf (Vega system)
c	  f_ne   	= M_ne(z) in filter kf (Vega system)
c	  f_ne_0 	= M_ne(0) in filter kf (Vega system)
c	  ABf_ev   	= AB M_ev(z) in filter kf (AB system)
c	  ABf_rf   	= AB M_rf(z) in filter kf (AB system)
c	  ABf_ne   	= AB M_ne(z) in filter kf (AB system)
c	  ABf_ne_0 	= AB M_ne(0) in filter kf (AB system)
c         k_corr_z      = k-correction in filter kf computed from sed at redshift z (Vega system)
c         k_corr_0      = k-correction in filter kf computed from sed at redshift 0 (Vega system)
c         k_ABcorr_z    = k-correction in filter kf computed from sed at redshift z (AB system)
c         k_ABcorr_0    = k-correction in filter kf computed from sed at redshift 0 (AB system)
c	  ek_corr   	= (e+k)-correction in filter kf (Vega system)
c	  ek_ABcorr 	= (e+k)-correction in filter kf (AB system)

c	Array declarations specific to this program
	character name*128,aux*24
	real xaux(3)
	data icall/0/

c	Default values
c	Default model
	data file/'bc2003_hr_m62_chab_ssp.ised'/
c	Cosmology:
	data h/70./,omega/0.30/,omega_lambda/0.70/,z/0./,zl/0./
c	Default filter
	kf=15

c	Compute parameters derived from predefined parameters
c	Obtain cosmological constant and paramter q
1	clambda=cosmol_c(h,omega,omega_lambda,q)

c       Age of the universe and maximum age for galaxy (rounded off)
        tu=t(h,q,0.,clambda)
        tgal=int(tu)*1.E9
        zf=zx(tgal*1.E-9,h,q,clambda)

c	Write predefined parameters
2	write (6,*)
	write (6,*) 'Predefined parameters:'
	write (6,*)
	write (6,'(2a)')       ' Set 1 -> BC03 model in file:       ',file(1:largo(file))
	write (6,'(a,f6.2,a)') ' Set 2 -> Hubble constant H0:       ',h,' Km/s/Mpc'
	write (6,'(a,f6.2)')   '          Omega:                    ',omega
	write (6,'(a,f6.2)')   '          Omega_lambda:             ',omega_lambda
	write (6,'(a,1pe10.2)')'            Lambda:                 ',clambda
	write (6,'(a,f6.2)')   '            Parameter q:            ',q
	write (6,'(a,f7.3,a)') '            Age of the universe:    ',tu,' Gyr'
	write (6,'(a,f7.3,a)') ' Set 3 -> Age of galaxy today:      ',tgal*1.E-9,' Gyr'
	write (6,'(a,f7.3,a)') '            z of galaxy formation:  ',zf

3	write (6,*)
	write (6,'(x,a)') 'Enter redshift (z) and filter to compute magnitude'
	write (6,'(x,a)') '       To modify parameters in Set N, enter z = -N'
	write (6,'(/x,a,f6.3,a,i3,a,$)') 'Enter z, filter number [',z,',',kf,'] = '
	read (5,'(a)',err=31,end=10) aux
c	Decode z and kf
	if (largo(aux).gt.0) then
		i=index(aux,',')
		if (i.eq.0) then
			read (aux,*,err=31) z
		elseif (i.eq.1) then
			read (aux(2:),*,err=31) xp
		elseif (i.gt.1) then
			read (aux,*,err=31) z,xp
		endif
	else
		xp=kf
	endif
c	read (5,'(2f10.0)',err=31,end=10) z,xp
	goto 32
31	write (6,'(x,a)') 'Error in selection. Please try again'
	goto 3
32	if (xp.gt.0) kf=nint(xp)

	if (z.lt.0) then
		if (z.eq.-1.) then
c			Ask for *.ised file name
			write (6,'(/x,3a,$)') 'BC_GALAXEV model sed in file [',file(1:largo(file)),'] = '
			read (5,'(a)',end=10) name
			if (largo(name).gt.0) then
        			call chaext(name,'ised',nn)
        			file=name
			endif
			z=zl
			icall=0
			goto 2
		elseif (z.eq.-2.) then
c			Ask for Ho, Omega, and Omega_lambda
			write (6,'(/x,a,f4.0,a,f5.3,a,$)') 'Enter cosmological parameters'
4			write (6,'(x,a,f4.0,a,f5.3,a,f5.3,a,$)')  'Enter Ho [',h,'], Omega [',omega,'], Omega_lambda [',omega_lambda,'] = '
			call nread(xaux,nc,*5,*10)
			if (nc.gt.0.) then
				h=xaux(1)
				omega=xaux(2)
				omega_lambda=xaux(3)
			endif
			z=zl
			goto 1
5			write (6,'(x,a)') 'Error in cosmological parameters. Please try again'
			goto 4
		elseif (z.eq.-3.) then
c			Ask for galaxy age
			write (6,'(/x,a,f6.2,a  )') 'Age of this universe  = tu =',tu,' Gyr'
6			write (6,'(x,a,f6.2,a,$)') 'Enter age of galaxy [',tgal*1.e-9,' Gyr] = '
			call qread(ttg,nc,*7,*10)
			write (6,'(x,a,$)')        '        at redshift [0.000] = '
			call qread(zg,mc,*7,*10)
			if (mc.gt.0) then
				tl=tu-t(h,q,zg,clambda)
			else
				tl=0.
			endif
			if (nc.gt.0.) then
				tgal=(tl+ttg)*1.E9
				zf=zx(tgal*1.E-9,h,q,clambda)
			endif
			z=zl
			icall=0
			goto 2
7			write (6,'(x,a)') 'Error in galaxy age. Please try again'
			goto 6
		endif
	else
c		Compute required magnitude
		iwrite=1
		xmag = FMAG(z,kf,fmagAB,iwrite)
		zl=z
		goto 2
	endif
10      end

      SUBROUTINE SORT(N,RA)
      DIMENSION RA(N)
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
        ELSE
          RRA=RA(IR)
          RA(IR)=RA(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
      GO TO 10
      END

      SUBROUTINE DSORT(N,RA)

c     Double precision version

      Integer*8 N
      Real*8 RA(N),RRA

      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
        ELSE
          RRA=RA(IR)
          RA(IR)=RA(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
      GO TO 10
      END

      SUBROUTINE ISORT(N,RA)
      INTEGER RA(N),RRA
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
        ELSE
          RRA=RA(IR)
          RA(IR)=RA(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
      GO TO 10
      END

        FUNCTION USRSFR(TP)
 
c	Returns SFR computed according to usr defined SFR(t) read from file.
 
c	Array declarations
	character namex*256,buf*128
	include 'jb.dec'
	include 'csp.dec'
	real xbuf(10)
	data isfrc/0/
 
c	Read file if first time that function is called
	if (tp < 0.) isfrc=0
	if (isfrc.eq.0) then
		if (tp == -1.) then
                	read (5,'(a)',end=10) namex
		else
!			Read sfr from file fort.500 in the Chen et al. option
!			namex = 'fort.500'
			namex = 'internal buffer'
			isfrc=0
			do i=8,nsfrp
			call r500(i,'a',buf,zap)
			if (i<0) goto 1
			if (buf(1:1) .ne. '#') then
				isfrc = isfrc + 1
                		read (buf,*,err=11) time(isfrc),usr_sfr(isfrc)
			endif
			enddo
		endif
                close (1)
                open (1,file=namex,status='old',err=10)
c		Check type of file
		if (index(namex,'4color').gt.0) then
c			Read columns 1 and 10 of *.4color file
			do i=1,30
			read (1,*)
			enddo
			do i=1,nsfrp
			read (1,*,end=1,err=11) xbuf
			time(i)=10.**xbuf(1)
			usr_sfr(i)=xbuf(10)
			isfrc=i
			enddo
		else
			isfrc=0
                	do i=1,nsfrp
			read (1,'(a)',end=1) buf
			if (buf(1:1) .ne. '#') then
!                		read (1,*,end=1,err=11) time(i),usr_sfr(i)
				isfrc = isfrc + 1
                		read (buf,*,err=11) time(isfrc),usr_sfr(isfrc)
			endif
	                enddo
		endif
1		close (1)
		write (6,*) isfrc,' data points read from file ',namex(1:largo(namex))
 
!		Add, if needed, a first point at age = 0, and a second point just before first usr point.
		if (time(1) > 0.) then
			do i=1,isfrc
			time(isfrc+3-i)    = time(isfrc+1-i)
			usr_sfr(isfrc+3-i) = usr_sfr(isfrc+1-i)
			enddo
			time(1) = 0.
			time(2) = 0.99995*time(3)
			usr_sfr(1)=0.
			usr_sfr(2)=0.
			isfrc=isfrc+2
		endif
		tcut=time(isfrc)
		write (6,*) isfrc,' data points in user defined SFR'
		write (6,*) 'Tcut = ',tcut

!		Check if tcut < 20 Gyr and add extra points
!		if (tp == -1. .and. tcut < tb(nsteps-1)) then
!			isfrc=isfrc+1
!			time(isfrc)=10.**(alog10(tcut)+0.00001)
!			usr_sfr(isfrc)=0.
!			write (6,*) isfrc,time(isfrc),usr_sfr(isfrc)
!		endif

!		Double check for repeated time steps
		do i=3,isfrc
		if (time(i) <= time(i-1)) then
			time(i) = 10.**(alog10(time(i-1))+0.00001)
		endif
		enddo

!		Add extra points to array tb
		if (isfrc <= jts-its) then
!			Add all points in array usr_sfr
			call add_points
		else
!			Find singular points in array usr_sfr
			call singular_points
		endif
!		write (6,*) isfrc,time(isfrc)

!		Total stellar mass
		tstelm=trapz1(time,usr_sfr,isfrc)
		write (6,*) 'Total mass formed in stars (Mo) =',tstelm
!		do i=1,isfrc
!		tstelm=trapz1(time,usr_sfr,i)
!		write (900,*) i,time(i),usr_sfr(i),tstelm
!		enddo
	endif
 
!	Interpolate SFR at time TP
	if (tp.lt.0.) then
		usrsfr=0.
	elseif (tp.eq.0.) then
		usrsfr=usr_sfr(1)
	elseif (tp.gt.time(isfrc)) then
		usrsfr=0.
	else
		call locate (time,isfrc,tp,i1)
		a1=(tp-time(i1))/(time(i1+1)-time(i1))
		usrsfr=a1*usr_sfr(i1+1)+(1.-a1)*usr_sfr(i1)
!		write (6,*) i1,tp,time(i1),time(i1+1),a1,usrsfr
	endif
        return
10	write (6,'(1x,2a)') 'File not found: ',namex(1:largo(namex))
	usrsfr=-100.
	return
11	write (6,'(1x,2a)') 'Error reading file: ',namex(1:largo(namex))
	usrsfr=-200.
	return
	end
 
	SUBROUTINE SINGULAR_POINTS
 
!	Finds singular points (peaks, maximum) in array usr_sfr(time)
 
!	Array declarations
	include 'jb.dec'
	include 'csp.dec'
	integer is(nsfrp)
 
!	Find maximum in SFR and points 1.5 times above smoothed sfr
	ic=0
	tmax=-1.e20
	imax=0
	do i=1,isfrc
	tadd(i)=usr_sfr(i)
	enddo
	call smthpl(tadd,isfrc,5)
	do i=1,isfrc
	r=usr_sfr(i)/tadd(i)
	if (r.gt.1.5) then
		do j=-2,2
		ic=ic+1
		is(ic)=i+j
		enddo
	endif
c	elseif (usr_sfr(i).gt.tmax) then
	if (usr_sfr(i).gt.tmax) then
		tmax=usr_sfr(i)
		imax=i
	endif
	enddo
	if (imax.eq.1.or.imax.eq.isfrc) then
c		Look for changes in slope
		call sfr_slope(imax)
	endif
	do i=-3,3
	ic=ic+1
	is(ic)=imax+i
	enddo
 
c	Store array tb in array tadd
	jadd=0
	do i=0,nsteps-1
	jadd=jadd+1
	tadd(jadd)=tb(i)
	enddo
 
c	Add time steps not included in tb(i)
	do i=1,ic
	if (is(i).ge.1) then
		tnew=time(is(i))
		dtmin=1.E10
		do n=0,nsteps-1
		dt=abs(tb(n)-tnew)
		if (dt.lt.dtmin) then
			dtmin=dt
			nmin=n
		endif
		enddo
c		write (6,*) i,tnew,tb(nmin),dtmin,dtmin/tb(nmin)
		if (dtmin/tb(nmin).gt.1.E-4) then
			jadd=jadd+1
			tadd(jadd)=tnew
		endif
	endif
	enddo
	eps=0.001
	call usort(jadd,tadd,eps)
 
c	Find time steps not included in array tb
	n=jadd
	do j=1,n
	do i=0,nsteps-1
	if (tadd(j).eq.tb(i)) then
		tadd(j)=-tadd(j)
	endif
	enddo
	enddo
	jadd=0
	do j=1,n
	if (tadd(j).gt.0.) then
		jadd=jadd+1
		tadd(jadd)=tadd(j)
	endif
	enddo
	if (jadd.gt.jts) then
		write (6,*) 'SINGULAR_POINTS: Too many time steps to add',jadd,'.  Maximum =',jts
		stop
	else
c		write (6,*) 'SINGULAR_POINTS: ',jadd,' points to add'
	endif
	return
	end
 
	SUBROUTINE SFR_SLOPE(I)
 
c	Finds points where derivative of array usr_sfr(time) changes abruptly
 
c	Array declarations
	include 'jb.dec'
	include 'csp.dec'
 
c	Find change of slope
	s1=(usr_sfr(3)-usr_sfr(2))/(alog10(time(3))-alog10(time(2)))
	do i=4,isfrc
	slope=(usr_sfr(i)-usr_sfr(i-1))/(alog10(time(i))-alog10(time(i-1)))
	d=abs((slope-s1)/s1)
	if (d.gt.1) return
	s1=slope
	enddo
	return
	end
 
	SUBROUTINE ADD_POINTS
 
c	Add points in array time(i) to array tb(i)
 
c	Array declarations
	include 'jb.dec'
	include 'csp.dec'
 
c	Store array tb in array tadd
	jadd=0
	do i=0,nsteps-1
	jadd=jadd+1
	tadd(jadd)=tb(i)
	enddo
 
c	Store array time in array tadd
	do i=1,isfrc
	jadd=jadd+1
	tadd(jadd)=time(i)
	enddo
 
c	Sort array tadd
	call usort(jadd,tadd)
 
c	Find time steps in array tadd not included in array tb
	n=jadd
	do j=1,n
	do i=0,nsteps-1
	if (tadd(j).eq.tb(i)) then
		tadd(j)=-tadd(j)
	endif
	enddo
	enddo
	jadd=0
	do j=1,n
	if (tadd(j).gt.0.) then
		jadd=jadd+1
		tadd(jadd)=tadd(j)
	endif
	enddo
	if (jadd.gt.jts) then
		write (6,*) 'ADD_POINTS: Too many time steps to add',jadd,'.  Maximum =',jts
		stop
	else
c		write (6,*) 'ADD_POINTS: ',jadd,' points to add'
	endif
	return
	end

	PROGRAM BIN_ISED

c	Converts *.ised file from ASCII to BINARY format

c	Array declarations
	logical stelib
	character id*80,id2*80,id3*80,name*256
	real ml,mu

c	Maximum number of wavelength points
	PARAMETER (imw=30000)
	real w(imw),h(imw),tb(0:500),f(100)

c	Array declaration for IMF data
	parameter (imf=10)
	real xx(imf),lm(imf),um(imf),baux(imf),cc(imf),cn(imf)

c       Ask for file name if not enterd in command line
	j=iargc()
	if (j.eq.0) then
		call copyright(6)
		write (6,'(x,a,$)') 'BC model *.ised in ASCII file = '
		read (5,'(a)',end=10) name
	else
		call getarg(1,name)
	endif

c	Read basic parameters from input file
	open  (2,file=name,form='formatted',status='old',err=3)
	read (2,*) nsteps,(tb(i),i=1,nsteps)
	read (2,*) ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg)
     	read (2,*) totm,totn,avs,jo,tau,   tau1,tau2,tau3,tau4,        iop,stelib
	read (2,'(a)') id
	read (2,'(a)') id2
	read (2,'(a)') id3
	write (6,*) nsteps,' time steps'

c	Write basic parameters to output file
	name=name(1:largo(name)-10) // 'ised'
	open (1,file=name,form='unformatted',status='unknown')
	write (1)       nsteps,(tb(i),i=1,nsteps),
     &		        ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),
     &			totm,totn,avs,jo,tau,id,tau1,tau2,tau3,tau4,id2,id3,iop,stelib

c	Read wavelength scale from input file and write to binary file
	read (2,*) inw,(w(i),i=1,inw)
	write (6,*) inw,' wavelength points per record'
	write (1)  inw,(w(i),i=1,inw)

c	Read sed's from ASCII file and write to binary file
	do n=1,nsteps
	read  (2,*) ik,(h(i),i=1,ik),ix,(f(i),i=1,ix)
	write (1)   ik,(h(i),i=1,ik),ix,(f(i),i=1,ix)
	enddo
c	Add 12 records after the sed's.
	do n=1,+12
	read  (2,*) ik,(h(i),i=1,ik)
	write (1)   ik,(h(i),i=1,ik)
	enddo
	write (6,*) ix,' fitting function fluxes per record'

c	Close files
	close (1)
	close (2)
	stop
c	goto 1
3       write (6,'(3a)') 'File ',name(1:largo(name)),' not found'
c	goto 1
10	end

        PROGRAM VEL_DISP

c	Applies gaussian velocity dispersion to all sed''s in *.ised file.
c	Computes line strength indices after smoothing sed.

c	Array declaration
        parameter (jb=2,jid=35)
	include 'csp.dec'
        character name*256,aux*9,library*10
	logical stelib
        real t(jts),x(imw),y(imw),w(imw),z(imw),gwx(jid),sf(0:jts)
!	real snr(0:jts),pnr(0:jts),bh(0:jts),sn(0:jts),wd(0:jts),rm(0:jts)
!	real bol(0:jts),str(0:jts),sf(0:jts),evf(0:jts)
c       Common to store fluxes used to compute indices
        integer iim(jid)
        real ffb(jid),ffr(jid),ffc(jid),ffl(jid)
        common /fluxes/ iim,ffb,ffr,ffc,ffl

c	Ask for file name
1       call copyright(6)
        write (6,'(x,a,$)') 'BC_GALAXEV SSP sed in file = '
	read (5,'(a)',end=10) name
2	write (6,'(x,a,$)') 'Sigma for velocity dispersion (km/s) = '
	read (5,'(f10.0)',err=2,end=10) sigma
	if (sigma.ge.100.) then
	  write (aux,'(a,i3)') '_sigma',nint(sigma)
	else
	  write (aux,'(a,i2)') '_sigma0',nint(sigma)
	endif
	call chaext(name,'ised',nm)
	open (1,file=name,form='unformatted',status='old')
c	Read basic parameters from SSP input file
	read (1) ks,(t(i),i=1,ks),ml,mu,iseg,
     &  (xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),
     &  totm,totn,avs,io,tauo,id,tcut,ttt,ttt,ttt,id,id,igw,stelib
	igw=0
	stelib=.false.
	read (1) n,(x(i),i=1,n)

c	Identify stellar library used in model
	imod=1
	if (n == 1238) then
!		BaSeL 3.1 _lr_ model. Nothing to do
		library = 'lr_BaSeL'
		write (6,*)
		write (6,*) 'You have entered a low resolution model *.ised file: ',library
		write (6,*) 'No velocity dispersion will be applied'
		close (1)
		goto 1
	elseif (n == 6700) then
!		Pure Stelib model
		library = 'hrs_stelib'
		imod=0
	elseif (n == 6917) then
!		Extended Stelib model. Smooth hr segment.
		library = 'hr_stelib'
		v1=3322.
		v2=9300.
	elseif (n == 4300) then
!		Pure Miles model
		library = 'hrs_miles'
		imod=0
	elseif (n == 12511) then
!		Extended Miles model. Smooth hr segment.
		library = 'hr_xmiles'
		v1=3550.
		v2=7400.
		v1=x(1)
		v2=9300.	! sed's have been extended with stelib
	elseif (n == 15011) then
		library = 'hrs_indous'
		imod=0
	elseif (n == 21243) then
		library = 'hr_indous'
!		Extended IndoUS model. Smooth hr segment.
		v1=3465.
		v2=9465.
	else
		write (6,*)
		write (6,*) 'You have entered an unknown type of model with',n,' points per record'
		write (6,*) 'Wavelength range:',x(1),x(n)
		close(1)
		goto 1
	endif

!	Proceed according to user choice
	if (imod == 1) then
!		_hr_ model. Smooth _hrs_ segment.
		write (6,*)
		write (6,*) 'You have entered a mixed low and high resolution model *.ised file: ',library
		write (6,*) 'Velocity dispersion will be applied to the high resolution segment'
		write (6,*) 'Low resolution part will be left untouched'
		do i=1,n
		if (x(i).le.v1) i1=i
		if (x(i).le.v2) i2=i
		enddo
	else
!		_hrs_ model. Smooth full sed.
		write (6,*)
		write (6,*) 'You have entered a pure high resolution model *.ised file: ',library
		write (6,*) 'Velocity dispersion will be applied to the full spectrum'
		write (6,*) 'Please ignore a few points at each end of the smoothed sed'
		v1=x(1)
		v2=x(n)
		i1=1
		i2=n
	endif
!	write (6,*) n,x(1),x(n)
!	write (6,*) i1,x(i1)
!	write (6,*) i2,x(i2)
	write (6,*)
	write (6,*) 'Spectral indices past',v2,' A cannot be computed'

c	Open output files
	i=index(name,'.')-1
	name=name(1:i) // aux(1:largo(aux))
	call chaext(name,'6lsindx_sed',nm)
	open (8,file=name,form='formatted',status='unknown')
	do i=1,27
	write (8,'(a,f10.0)') '# sigma = ',sigma
	enddo
	call chaext(name,'7lsindx_sed',nm)
	open (9,file=name,form='formatted',status='unknown')
	do i=1,27
	write (9,'(a,f10.0)') '# sigma = ',sigma
	enddo
	call chaext(name,'8lsindx_sed_fluxes',nm)
	open (10,file=name,form='formatted',status='unknown')
	do i=1,27
	write (10,'(a,f10.0)') '# sigma = ',sigma
	enddo
        write (8,801)
        write (8,802)
        write (8,803)
        write (8,804)
801     format ('# Index_No.     1:      2:      3:      4:      5:      6:      7:      8:      9:     ',
     *          '10:     11:     12:     13:')
802     format ('# log-age     CN_1    CN_2  Ca4227   G4300  Fe4383  Ca4455  Fe4531  Fe4668  H\\beta  ',
     *          'Fe5015    Mg_1    Mg_2    Mg-b')
803	format ('#   (yr)     (mag)   (mag)   (\\AA)   (\\AA)   (\\AA)   (\\AA)   (\\AA)   (\\AA)   ',
     *          '(\\AA)   (\\AA)   (mag)   (mag)   (\\AA)')
804	format ('#    (1)      (2)     (3)     (4)     (5)     (6)     (7)     (8)     (9)     (10)    ',
     *          '(11)    (12)    (13)    (14)')

        write (9,901)
        write (9,902)
        write (9,903)
        write (9,904)
901	format ('# Index_No.    14:     15:     16:     17:     18:     19:     20:     21:',
     *          '       WO-1:       WO-2:       WO-3:       WO-4:       GC-1:       4000A',
     *          '     DTT-Ca1     DTT-Ca2     DTT-Ca3     DTT-MgI       DM-04       DM-04       DM-04         BH:')
902	format ('# log-age   Fe5270  Fe5335  Fe5406  Fe5709  Fe5782    Na-D   TiO_1   TiO_2',
     *          '   H\\delta_A   H\\gamma_A   H\\delta_F   H\\gamma_F     D(4000)       B4_VN',
     *          '    CaII8498    CaII8542    CaII8662     MgI8807     H8_3889     H9_3835    H10_3798       BH-HK')
903	format ('#   (yr)     (\\AA)   (\\AA)   (\\AA)   (\\AA)   (\\AA)   (\\AA)   (mag)   (mag)',
     *          '       (\\AA)       (\\AA)       (\\AA)       (\\AA)          .           .',
     *          '        (\\AA)       (\\AA)       (\\AA)       (\\AA)       (\\AA)       (\\AA)       (\\AA)       (\\AA)')
904	format ('#    (1)      (2)     (3)     (4)     (5)     (6)     (7)     (8)     (9)',
     *          '         (10)        (11)        (12)        (13)        (14)        (15)',
     *          '        (16)        (17)        (18)        (19)        (20)        (21)        (22)        (23)')
	write (10,100)
100	format ('# log-age   Nx  Im   Flux_Blue   Flux_Red    Flux_Ctrl   Flux_Line       Index')

c	Open binary file to write new sed
	call chaext(name,'ised',nm)
	open (11,file=name,form='unformatted',status='unknown')
	write (11) ks,(t(i),i=1,ks),ml,mu,iseg,
     &  (xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),
     &  totm,totn,avs,io,tauo,id,tcut,ttt,ttt,ttt,id,id,igw,stelib
	write (11) n,(x(i),i=1,n)
	read   (1) n,(y(i),i=1,n),inx,(y(i),i=n+1,n+inx)
	write (11) n,(y(i),i=1,n),inx,(y(i),i=n+1,n+inx)

c	Smooth each sed in file and compute indices.
	do k=2,ks
	read (1) n,(y(i),i=1,n),inx,(y(i),i=n+1,n+inx)
	if (imod.eq.0) then
c		Smooth entire sed
		call gaussian_v_disp(x,y,n,sigma)
		write (11) n,(y(i),i=1,n),inx,(y(i),i=n+1,n+inx)
c		Compute Worthey indices plus other indices directly from smoothed sed
        	do j=1,jid
        	gwx(j)=gw_ix_sed(j,x,y,n,0)
        	enddo
	elseif (imod.eq.1) then
c		Smooth central segment
		j=0
		do i=i1,i2
		j=j+1
		w(j)=x(i)
		z(j)=y(i)
		enddo
		call gaussian_v_disp(w,z,j,sigma)
c		Ignore 10 smoothed points at each extreme to avoid border effects
		j2=j-10
		i3=i2-10
		write (11) n,(y(i),i=1,i1+9),(z(i),i=11,j2),(y(i),i=i3+1,n),inx,(y(i),i=n+1,n+inx)
c		Compute Worthey indices plus other indices directly from smoothed sed
        	do i=1,jid
        	gwx(i)=gw_ix_sed(i,w,z,j,0)
        	enddo
	endif

c       Write results for gwx(j)
	tl=alog10(t(k))
	write (8,105) tl,(gwx(j),j= 1,13)
        write (9,106) tl,(gwx(j),j=14,25),(gwx(j),j=30,31),(gwx(j),j=26,29),(gwx(j),j=32,jid)
        write (10,107) (tl,j,iim(j),ffb(j),ffr(j),ffc(j),ffl(j),gwx(j),j=1,jid)
105     format (f10.6,13f8.3)
106     format (f10.6,8f8.3,14f12.3)
107	format (f10.6,i4,i4,1p4e12.3,0pf12.3)
        enddo

c	Add remaining records
	read (1,end=4) m,(bflx(i),i=1,m)
	write (11) m,(bflx(i),i=1,m)
	read (1,end=4) m,(strm(i),i=1,m)
	write (11) m,(strm(i),i=1,m)
	read (1,end=4) m,(sf(i),i=1,m)
	write (11) m,(sf(i),i=1,m)
	read (1,end=4) m,(evfl(i),i=1,m)
	write (11) m,(evfl(i),i=1,m)
	read (1,end=4) m,(snbr(i),i=1,m)
	write (11) m,(snbr(i),i=1,m)
	read (1,end=4) m,(pnbr(i),i=1,m)
	write (11) m,(pnbr(i),i=1,m)
	read (1,end=4) m,(bhtn(i),i=1,m)
	write (11) m,(bhtn(i),i=1,m)
	read (1,end=4) m,(sntn(i),i=1,m)
	write (11) m,(sntn(i),i=1,m)
	read (1,end=4) m,(wdtn(i),i=1,m)
	write (11) m,(wdtn(i),i=1,m)
	read (1,end=4) m,(rmtm(i),i=1,m)
	write (11) m,(rmtm(i),i=1,m)
	read (1,end=4) m,(toff(i),i=1,m)
	write (11) m,(toff(i),i=1,m)
	read (1,end=4) m,(bolms(i),i=1,m)
	write (11) m,(bolms(i),i=1,m)
	read (1,end=4) m,(gasms(i),i=1,m)
	write (11) m,(gasms(i),i=1,m)
	read (1,end=4) m,(galms(i),i=1,m)
	write (11) m,(galms(i),i=1,m)
4	close (1)
	close (8)
	close (9)
	close (10)
	close (11)
c	Delete unwanted files
	call delete_files(name,n,1)
	goto 1
10	end

	SUBROUTINE GAUSSIAN_V_DISP(X,Y,N,SIGMA)

!	Applies a gaussian filter to the sed in (X,Y) to reproduce
!	the effect of the velocity dispersion of stars in a galaxy
!	Enter sigma in Km/s

!	Array declaration
	real x(n),y(n),z(50000),u(10000),g(10000)

!	If sigma = 0, return
	if (sigma.le.0.) return

!	Speed of light in Km/s
	c=3.00E5

!	Number of sigmas to deviate from v=0
	m=6

!	Copy array y to array z
	if (n.gt.50000) then
		write (6,*) 'Too many data points in GAUSSIAN_V_DISP:',n
		stop
	endif
	do i=1,n
	z(i)=y(i)
	enddo

	do i=1,n
	xmax=c*x(i)/(c-m*sigma)
	m2 = min(1 + ilocate(x,n,xmax),n)
	m1 = max(2*i-m2,1)
	mt = m2-m1+1
	if (mt > 10000) then
		write (6,*) 'Too many data points in GAUSSIAN_V_DISP:',m1,m2,mt
		stop
	elseif (m1 > 1 .and. x(m2) <= 8750.) then
		k=0
		do j=m2,m1,-1
		v=(x(i)/x(j)-1.)*c
		k=k+1
		u(k)=v
		g(k)=z(j)*gauss(v,0.,sigma)
		enddo
		y(i)=trapz1(u,g,k)
	endif
	enddo
	return
	end

	SUBROUTINE DARK_GALAXY(LUN,T)

	! Includes age record in output files indicating galaxy is still dark

	! Variables
	data icall/0/

	! Write age record
	if (icall == 0) then
		icall = 1
		write (lun+1 ,107) 0.
		write (lun+2 ,107) 0.
		write (lun+3 ,107) 0.
		write (lun+4 ,107) 0.
		write (lun+5 ,107) 0.
		write (lun+6 ,107) 0.
		write (lun+7 ,107) 0.
		write (lun+8 ,107) 0.
		write (lun+9 ,107) 0.
		write (lun+10,107)(0.,i=1,35)
		write (lun+11,107) 0.
		write (lun+12,107) 0.
		write (lun+13,107) 0.
		write (lun+87,107) 0.
		write (lun+88,107) 0.
		write (2002,  107) 0.
	endif
	if (t <= 0.) return
	tl = alog10(t)
	write (lun+1 ,107) tl
	write (lun+2 ,107) tl
	write (lun+3 ,107) tl
	write (lun+4 ,107) tl
	write (lun+5 ,107) tl
	write (lun+6 ,107) tl
	write (lun+7 ,107) tl
	write (lun+8 ,107) tl
	write (lun+9 ,107) tl
	write (lun+10,107)(tl,i=1,35)
	write (lun+11,107) tl
	write (lun+12,107) tl
	write (lun+13,107) tl
	write (lun+87,107) tl
	write (lun+88,107) tl
	write (2002,  107) tl
107	format ('#',f9.6,'    Dark galaxy')
	return
	end

		! write (lun+1 ,101) 0.,bolmag,umag,bmag,vmag,kmag,(col(i),i=1,9)
		! write (lun+2 ,101) 0.,rmag,jmag,kmag,            (col(i),i=10,20)
		! write (lun+14,108) 0.,     kmag,                 (col(i),i=21,31)
		! write (lun+87,108) 0.,vmag,                      (col(i),i=65,80)
		! write (lun+84,108) 0.,vmag,kmag,                 (col(i),i=32,42),cly,blr,vlr,klr
		! write (lun+85,108) 0.,vmag,kmag,                 (col(i),i=43,53),cly,blr,vlr,klr
		! write (lun+86,108) 0.,vmag,kmag,                 (col(i),i=54,64),cly,blr,vlr,klr
		! write (lun+88,108) 0.,vmag,kmag,                 (col(i),i=81,92),cly,blr,vlr,klr
		! write (lun+17,171) 0.,mabo(ic),mbel(ic),mabo(ic)+mbel(ic),mcut,rmup(ic),rmlo(ic)    ! Esto escribe los datos requeridos por Alba (opcion kdist = 5)

	! write (lun+1 ,101) tl,bolmag,umag,bmag,vmag,kmag,(col(i),i=1,9)
	! write (lun+2 ,101) tl,rmag,jmag,kmag,            (col(i),i=10,20)
	! write (lun+14,108) tl,     kmag,                 (col(i),i=21,31)
	! write (lun+87,108) tl,vmag,                      (col(i),i=65,80)
	! write (lun+84,108) tl,vmag,kmag,                 (col(i),i=32,42),cly,blr,vlr,klr
	! write (lun+85,108) tl,vmag,kmag,                 (col(i),i=43,53),cly,blr,vlr,klr
	! write (lun+86,108) tl,vmag,kmag,                 (col(i),i=54,64),cly,blr,vlr,klr
	! write (lun+88,108) tl,vmag,kmag,                 (col(i),i=81,92),cly,blr,vlr,klr
	! write (lun+17,171) tl,mabo(ic),mbel(ic),mabo(ic)+mbel(ic),mcut,rmup(ic),rmlo(ic)    ! Esto escribe los datos requeridos por Alba (opcion kdist = 5)
	! 101 format (f10.6,14f10.4,1pe13.4)
	! 171 format (f10.6,1p6e12.3)

	FUNCTION B4000(X,Y,N)

c	Returns 4000 A break amplitude for sed in (x,y)
c	The break is defined as the ratio of the average Fnu flux densities:
c	(4050-4250)/(3750-3950) (Bruzual (1983), Hamilton 1985 ApJ 297, 371).

	real x(n),y(n),w(10000),z(10000)
	data icall/0/
	save i1,i2,i3,i4,j1,j2
	b4000=0.

	IF (N.EQ.1206.or.N.EQ.1977) THEN

c		BC93 (G+S) wavelength scale
		if (icall.eq.0) then
			icall=1
			do i=1,n

c			if (x(i).eq.3770.) i1=i
c			if (x(i).eq.3800.) i2=i
c			if (x(i).eq.3890.) i3=i
c			if (x(i).eq.3920.) i4=i

			if (x(i).le.3761.) i1=i
			if (x(i).eq.3810.) i2=i
			if (x(i).eq.3850.) i3=i
			if (x(i).eq.3920.) i4=i

			if (x(i).eq.4050.) j1=i
			if (x(i).eq.4250.) then
				j2=i
				goto 1
			endif
			enddo
		endif

c		Transform to Fnu units
1		i=0
		do j=j1,j2
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fr=trapz1(w,z,i)/(x(j2)-x(j1))

		i=0
		do j=i1,i2
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fl1=trapz1(w,z,i)/(x(i2)-x(i1))
		
		i=0
		do j=i3,i4
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fl2=trapz1(w,z,i)/(x(i4)-x(i3))
	
		fl=(fl1+fl2)/2.
	
		b4000=fr/fl

	ELSE

c		General procedure
		if (icall.eq.0) then
c			To allow different wavelength scales in same code always locate
c			icall=1
			call locate (x,n,4050.,i1)
			call locate (x,n,4250.,i2)
			call locate (x,n,3750.,i3)
			call locate (x,n,3950.,i4)
			i2=i2+1
			i4=i4+1
		endif

c		Transform to Fnu units
		i=0
		do j=i1,i2
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fr=trapz1(w,z,i)/(x(i2)-x(i1))

		i=0
		do j=i3,i4
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fl=trapz1(w,z,i)/(x(i4)-x(i3))

		b4000=fr/fl

	ENDIF
	return
	end

	FUNCTION B4000VN(X,Y,N)

c	MPA definition, via S Charlot

c	Returns 4000 A break amplitude for sed in (x,y)
c	The break is defined as the ratio of the average Fnu flux densities:
c	(4050-4250)/(3750-3950) (Bruzual (1983), Hamilton 1985 ApJ 297, 371).

	parameter (jid=35)
	real x(n),y(n),w(10000),z(10000)
	save i1,i2,i3,i4,j1,j2
c	Common to store fluxes
	integer iim(jid)
	real ffb(jid),ffr(jid),ffc(jid),ffl(jid)
	common /fluxes/ iim,ffb,ffr,ffc,ffl
	data icall/0/
	b4000vn=0.

	IF (N.EQ.1206.or.N.EQ.1977) THEN

c		BC93 (G+S) wavelength scale
		if (icall.eq.0) then
			icall=1
			do i=1,n

c			if (x(i).eq.3770.) i1=i
c			if (x(i).eq.3800.) i2=i
c			if (x(i).eq.3890.) i3=i
c			if (x(i).eq.3920.) i4=i

			if (x(i).le.3761.) i1=i
			if (x(i).eq.3810.) i2=i
			if (x(i).eq.3850.) i3=i
			if (x(i).eq.3920.) i4=i

			if (x(i).eq.4050.) j1=i
			if (x(i).eq.4250.) then
				j2=i
				goto 1
			endif
			enddo
		endif

c		Transform to Fnu units
1		i=0
		do j=j1,j2
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fr=trapz1(w,z,i)/(x(j2)-x(j1))

		i=0
		do j=i1,i2
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fl1=trapz1(w,z,i)/(x(i2)-x(i1))
		
		i=0
		do j=i3,i4
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fl2=trapz1(w,z,i)/(x(i4)-x(i3))
	
		fl=(fl1+fl2)/2.
	
		b4000vn=fr/fl

	ELSE
c		General procedure
		if (icall.eq.0) then
c			To allow different wavelength scales in same code always locate
c			icall=1
			call locate (x,n,4000.,i1)
			call locate (x,n,4100.,i2)
			call locate (x,n,3850.,i3)
			call locate (x,n,3950.,i4)
			i2=i2+1
			i4=i4+1
		endif

c		Transform to Fnu units
		i=0
		do j=i1,i2
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fr=trapz1(w,z,i)/(x(i2)-x(i1))

		i=0
		do j=i3,i4
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fl=trapz1(w,z,i)/(x(i4)-x(i3))

		b4000vn=fr/fl

c		Store fluxes for future use
		iim(31)=-1
		ffb(31)=fl
		ffr(31)=fr
		ffc(31)=b4000vn
		ffl(31)=b4000vn

	ENDIF
	return
	end

	FUNCTION B4000_SDSS(X,Y,N)

c	Returns 4000 A break amplitude for sed in (x,y)
c	Uses definition by Stoughton et al. (Ap. J), for SDSS data

	real x(n),y(n),w(10000),z(10000)
	save i1,i2,i3,i4,j1,j2
	data icall/0/
	b4000_sdss=0.

	IF (N.EQ.1206.or.N.EQ.1977) THEN

c		BC93 (G+S) wavelength scale
		if (icall.eq.0) then
			icall=1
			do i=1,n

c			if (x(i).eq.3770.) i1=i
c			if (x(i).eq.3800.) i2=i
c			if (x(i).eq.3890.) i3=i
c			if (x(i).eq.3920.) i4=i

			if (x(i).le.3761.) i1=i
			if (x(i).eq.3810.) i2=i
			if (x(i).eq.3850.) i3=i
			if (x(i).eq.3920.) i4=i

			if (x(i).eq.4050.) j1=i
			if (x(i).eq.4250.) then
				j2=i
				goto 1
			endif
			enddo
		endif

c		Transform to Fnu units
1		i=0
		do j=j1,j2
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fr=trapz1(w,z,i)/(x(j2)-x(j1))

		i=0
		do j=i1,i2
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fl1=trapz1(w,z,i)/(x(i2)-x(i1))
		
		i=0
		do j=i3,i4
		i=i+1
		w(i)=x(j)
		z(i)=y(j)*x(j)**2
		enddo
		fl2=trapz1(w,z,i)/(x(i4)-x(i3))
	
		fl=(fl1+fl2)/2.
	
		b4000_sdss=fr/fl

	ELSE

c		General procedure
		if (icall.eq.0) then
c			To allow different wavelength scales in same code always locate
c			icall=1
			call locate (x,n,4051.,i1)
			call locate (x,n,4251.,i2)
			call locate (x,n,3751.,i3)
			call locate (x,n,3951.,i4)
			i2=i2+1
			i4=i4+1
		endif

c		Store in new array
		i=0
		do j=i1,i2
		i=i+1
		w(i)=x(j)

c		Transform to Fnu units
c		z(i)=y(j)*x(j)**2

		z(i)=y(j)
		enddo
		fr=trapz1(w,z,i)/(x(i2)-x(i1))

		i=0
		do j=i3,i4
		i=i+1
		w(i)=x(j)

c		Transform to Fnu units
c		z(i)=y(j)*x(j)**2

		z(i)=y(j)
		enddo
		fl=trapz1(w,z,i)/(x(i4)-x(i3))

		b4000_sdss=fr/fl

	ENDIF
	return
	end

	FUNCTION B4000VN3(X,Y,N)

c	Returns 4000 A break amplitude for sed in (x,y)

c	The break is defined as the ratio of the average Fnu flux densities:
c	(4050-4250)/(3750-3950) (Bruzual (1983), Hamilton 1985 ApJ 297, 371).

c	Narrow definition from MPA: the break is defined as the ratio of the
c	average Fnu flux densities: (4000-4100)/(3850-3950)

c	Array declaration
	real x(n),y(n),w(10000),z(10000)
	b4000vn=0.

c	Find length of sed to be transformed to Fnu
	call locate (x,n,3850.,i1)
	call locate (x,n,4100.,i2)

c	Transform to Fnu units
	i=0
	do j=i1-10,i2+10
	i=i+1
	w(i)=x(j)
	z(i)=y(j)*x(j)**2
	write (21,*) w(i),z(i),y(j)
	enddo

c	Compute average flux on the red side
	x1=4000.
	x2=4100.
	fr = trapz2(w,z,i,x1,x2,ierr)/(x2-x1)

c	Compute average flux on the blue side
	x1=3850.
	x2=3950.
	fb = trapz2(w,z,i,x1,x2,ierr)/(x2-x1)

c	Compute b4000
	b4000vn3=fr/fb
        write (6,*) fr,fb,b4000vn3
        write (21,*) fr,fb,b4000vn3

	return
	end

        REAL FUNCTION FEXT(X,TV)

	! Attenuation function used in Charlot and Fall (2000) model

        real x,tv,tau

        fext=1.

        if (tv.eq.0.) return

        tau=tv*( (5500./x)**0.7 )
        fext=exp(-tau)

        return
        end

	SUBROUTINE MIXFILENAMES(B,A,ioption)

	! Builds script to perform correct file assignments for program mix_stelib

	! Variables
	character*(*) a,b,c*512

	! Find first and third occurrence of character '_'
        c = trim(a) // '.ised'
	if (index(b,'BaSeL') > 0) then
		if (index(a,'BaSeL') == 0) then
			a = trim(a) // '_lr_BaSeL_ssp'
		endif
		i=index(a,'_lr')
		j=index(a(i+1:),'_')
		k=index(a(i+j+1:),'_')
		l=largo(a)
		c = a(:i) // 'lr_BaSeL' // a(i+j+k:l) // '.ised'
		open (120,file='mix_stelib.tmp')
		! Write script to use program mix_stelib
		! write (120,'(5a)') 'setenv name0  ',a(:i-1)
		! write (120,'(5a)') 'setenv name1  ',a(:i),'hrs_stelib' ,a(i+j+k:l),'.ised'
		! write (120,'(5a)') 'setenv name2  ',a(:i),'lr_BaSeL'   ,a(i+j+k:l),'.ised'
		! write (120,'(5a)') 'setenv name3  ',a(:i),'hr_stelib'  ,a(i+j+k:l),'.ised'
		! write (120,'(1a)') '#'
		! write (120,'(5a)') 'setenv name4  ',a(:i),'lrs_hngsl'  ,a(i+j+k:l),'.ised'
		! write (120,'(5a)') 'setenv name5  ',a(:i),'lr_BaSeL'   ,a(i+j+k:l),'.ised'
		! write (120,'(5a)') 'setenv name6  ',a(:i),'lr_xhngsl'  ,a(i+j+k:l),'.ised'
		! write (120,'(1a)') '#'
		! write (120,'(5a)') 'setenv name7  ',a(:i),'hrs_indous' ,a(i+j+k:l),'.ised'
		! write (120,'(5a)') 'setenv name8  ',a(:i),'lr_BaSeL'   ,a(i+j+k:l),'.ised'
		! write (120,'(5a)') 'setenv name9  ',a(:i),'hr_xindous' ,a(i+j+k:l),'.ised'
		! write (120,'(1a)') '#'
		! write (120,'(5a)') 'setenv name10 ',a(:i),'hrx_miles'  ,a(i+j+k:l),'.ised'
		! write (120,'(5a)') 'setenv name11 ',a(:i),'hr_stelib'  ,a(i+j+k:l),'.ised'
		! write (120,'(5a)') 'setenv name12 ',a(:i),'hr_xmiless' ,a(i+j+k:l),'.ised'
		! write (120,'(1a)') '#'
		! write (120,'(5a)') 'setenv name13 ',a(:i),'hrx_miles'  ,a(i+j+k:l),'.ised'
		! write (120,'(5a)') 'setenv name14 ',a(:i),'hr_xindous' ,a(i+j+k:l),'.ised'
		! write (120,'(5a)') 'setenv name15 ',a(:i),'er_xmilesi' ,a(i+j+k:l),'.ised'
		! write (120,'(1a)') '#'
		write (120,'(5a)') 'export  name1="',a(:i),'hrs_stelib' ,a(i+j+k:l),'.ised"'
		write (120,'(5a)') 'export  name2="',a(:i),'lr_BaSeL'   ,a(i+j+k:l),'.ised"'
		write (120,'(5a)') 'export  name3="',a(:i),'hr_stelib'  ,a(i+j+k:l),'.ised"'
		write (120,'(1a)') '#'
		write (120,'(5a)') 'export  name4="',a(:i),'lrs_hngsl'  ,a(i+j+k:l),'.ised"'
		write (120,'(5a)') 'export  name5="',a(:i),'lr_BaSeL'   ,a(i+j+k:l),'.ised"'
		write (120,'(5a)') 'export  name6="',a(:i),'lr_xhngsl'  ,a(i+j+k:l),'.ised"'
		write (120,'(1a)') '#'
		write (120,'(5a)') 'export  name7="',a(:i),'hrs_indous' ,a(i+j+k:l),'.ised"'
		write (120,'(5a)') 'export  name8="',a(:i),'lr_BaSeL'   ,a(i+j+k:l),'.ised"'
		write (120,'(5a)') 'export  name9="',a(:i),'hr_xindous' ,a(i+j+k:l),'.ised"'
		write (120,'(1a)') '#'
		write (120,'(5a)') 'export name10="',a(:i),'hrx_miles'  ,a(i+j+k:l),'.ised"'
		write (120,'(5a)') 'export name11="',a(:i),'hr_stelib'  ,a(i+j+k:l),'.ised"'
		write (120,'(5a)') 'export name12="',a(:i),'hr_xmiless' ,a(i+j+k:l),'.ised"'
		write (120,'(1a)') '#'
		write (120,'(5a)') 'export name13="',a(:i),'hrx_miles'  ,a(i+j+k:l),'.ised"'
		write (120,'(5a)') 'export name14="',a(:i),'hr_xindous' ,a(i+j+k:l),'.ised"'
		write (120,'(5a)') 'export name15="',a(:i),'hr_xmilesi' ,a(i+j+k:l),'.ised"'
		write (120,'(1a)') '#'
		write (120,'(5a)') 'export name16="',a(:i),'er_xmilesi' ,a(i+j+k:l),'.ised"'
		write (120,'(5a)') 'export name17="',a(:i),'er_xmilesi' ,a(i+j+k:l),'.all"'
		write (120,'(5a)') 'export name18="',a(:i),'ht_xmilesi' ,a(i+j+k:l),'.ised"'
		write (120,'(1a)') '#'
		write (120,'(a,i5,a)') 'export ioptn="',ioption,'"'
		write (120,'(1a)') '#'
		close (120)
	endif
	open (120,file='mix_stelib2.tmp')
	write (120,'(a)') 'export name0="' // trim(c) //'"'
	write (120,'(a,i5,a)') 'export ioptn="',ioption,'"'
	close (120)
	return
	end

	PROGRAM ADD_FILTERS

c	Modified 18-JUN-2003: G. Bruzual, CIDA
c		Changed input format to free format
c		First record is filter ID, with a '#' as the first character
c		Then follow 2 columns, lambda(A), R(lambda)
c		No need to know number of points in each response function

c	Modified 11-MAY-1999: G. Bruzual, CIDA
c		Filter response functions are stored in a binary file
c		as published, with no addition of extra points by interpolation.
c		The new version of the FILTER routine requires the filter
c		response function to be interpolated at each point in the
c		sed which is not a point in the filter response. All points in
c		the filter response are also used. The format of the binary
c		file was changed to reduce its size. Filters are stored
c		sequentially in r(i,k), k=1 => wavelength, k=2 => response
c		function. Information about starting point and number of
c		points per filter is kept in file, as well as filter id label.

c	Modified 09-JUN-1983: G. Bruzual
c		Program was modified on June-09-83 to include interpolation
c		of the filter response functions every 25 A only for those
c		filters for which the resulting number of points is .le. 250
c		and .gt. previous number of data points. A 25 A wavelength
c		step was found appropriate to compute synthetic colors with
c		the available stellar and galaxy s.e.d.''s.
c		For the IR filters a 50 A step is used.
c		For the L filter a 75 A step is used.

c	Written: 21-MAY-1983: G. Bruzual, Durham.

c	Produces a binary file with filter response functions.
c	The response functions are assumed to be in a formatted file.
c	The response functions are read into array r(i,j,k),
c	where j identifies the filter, i the data point, and k=1 => wavelength
c	scale, whereas k=2 => response function
c	Assumes up to mxft filters. The maximum number of points per
c	filter is mxwf, declared as parameters in filter.dec.

c	Array declaration
	include 'filter.dec'
	character ans,name*96,aux*128
	integer mp(0:mxft)
	real w1(naux),c1(naux)
	fid(0)=' '

c	Ask for input file
	write (6,'(x,a,$)') 'Filter response functions in (formatted) file = '
	read (5,'(a)',end=2) name
	write (6,'(x,a,$)') 'Normalize response functions to area = 1 (y or [n]) ? '
	read (5,'(a)',end=2) ans
	iarea=0
	if (ans.eq.'y'.or.ans.eq.'Y') iarea=1
	close (1)
	open (1,file=name,form='formatted',status='old')

c	Open filter log file
	close (3)
	open (3,file='filters.log',status='unknown')

c	Process input file
	nf=0
	ltot=0
	ktot=0
c	Read file
	do i=1,mxwp
	read (1,'(a)',end=1) aux
	if (aux(1:1).eq.'#') then
		mp(nf)=ktot
		nf=nf+1
		fid(nf)=aux(3:)
		ktot=0
	else
		ktot=ktot+1
		ltot=ltot+1
		read (aux,*) r(ltot,1),r(ltot,2)
		if (r(ltot,2).lt.0.) r(ltot,2)=0.
	endif
	enddo
1	mp(nf)=ktot
c	Define number of points per filter
	do i=1,nf
	np(i)=mp(i)
	if (i.eq.1) then
		ni(i)=1
	else
		ni(i)=ni(i-1)+np(i-1)
	endif
	nl(i)=ni(i)+np(i)-1
c	write (8,'(8i8)') i,np(i),ni(i),nl(i),ltot

c	Normalize filter, if requested
	if (iarea.gt.0) then
!		write (6,*) 'Normalizing to area = 1 filter',i
		l=0
		do k=ni(i),nl(i)
		l=l+1
		w1(l)=r(k,1)
		c1(l)=r(k,2)
		enddo
		area=trapz1(w1,c1,np(i))
		do k=ni(i),nl(i)
		r(k,2)=r(k,2)/area
		enddo
	endif
	write (6,101) i,fid(i),np(i)
	write (3,101) i,fid(i),np(i)
101	format (i4,1x,a,i6)
	enddo

c	Write output file
	write (6,'(/x,a,$)') 'Write binary file (y or [n]) ? '
	read (5,'(a)',end=2) ans
	if (ans.ne.'Y'.and.ans.ne.'y') stop 'Filter index in file filters.log'
	close (1)
	write (6,'(x,a,$)') 'Enter output (binary) file name = '
	read (5,'(a)',end=2) name
	open (1,file=name,form='unformatted',status='unknown')
c	write (1) nf,np,r
c	New format (11-MAY-1999)
	write (1) nf,(ni(i),i=1,nf),(nl(i),i=1,nf),(np(i),i=1,nf),
     &		(fid(i),i=0,nf),ltot,(r(i,1),i=1,ltot),(r(i,2),i=1,ltot)
	write (6,'(x,a)') 'Filter index in file: filters.log'
	stop 'Binary file written.'
2	end

	PROGRAM SEEFILTER

c	Writes an ASCII file with the response function of the
c	selected filters.

	include 'filter.dec'
	real x(5000),y(5000),z(5000)

	call FILTER0

	l1=0
	l2=0
1	write (6,100) 'Extract filter number = '
	read (5,101,err=1,end=10) n
	if (n <= 0) stop
100	format (1x,a,$)
101	format (i10)
	nt=np(n)
	l1=l1+3
	l2=l2+nt+2
	write (28,'(''# '',a,i4,2a)') 'Filter',n,': ',fid(n)(1:largo(fid(n)))
	write (28,'(''# '',i4,a,i4,a,i4)') nt,' data points. Lines',l1,' to',l2
	nt=0
	do i=ni(n),nl(n)
	nt=nt+1
	x(nt)=r(i,1)
	y(nt)=r(i,2)
	z(nt)=y(nt)*x(nt)
	write (28,102) x(nt),y(nt)
102	format (1p2e14.5)
	enddo
	area=trapz1(x,y,nt)
	weff=trapz1(x,z,nt)/area

	! Compute zeropoint
	Rvega = 1.6432E6 	! Radiis of Vega in km
	Dvega = 7.76 * 3.086E13	! Distance to Vega in km = 7.76 pc
	Dfact = (Rvega/Dvega)**2
	pi    = 4.*atan(1.)
	f1    = 3.631E-9/6.4829E-10
	f2    = 3.631E-9/6.4061E-10
	write (6,*) dfact,pi
	if (jread == 0) call readA0V
	do i=1,jread
	if (xa0v(i) > weff) then
		write (6,*) i,xa0v(i),ya0v(i),ya0v(i)*Dfact*pi*f1,ya0v(i)*Dfact*pi*f2,f1,f2
		goto 2
	endif
	enddo
2	f0 = filter(n,xa0v,ya0v,jread,0.,kerr) * dfact * pi / area * f1
	g0 = f_meanl(n,xa0v,ya0v,jread,0.,kerr) * dfact * pi * f2
	write (6,'(x,a,i4,2a)')      'Filter',n,': ',fid(n)
	write (6,'(x,a,1p2e12.4)')   'Range covered        = ',x(1),x(nt)
	write (6,'(x,a,1pe12.4)')    'Area below filter    = ',area
	write (6,'(x,a,1pe12.4)')    'Effective wavelength = ',weff
	write (6,'(x,a,1pe12.4,a )') 'Zero point-old       = ',f0,' ergs/s/cm**2/A'
	write (6,'(x,a,1pe12.4,a/)') 'Zero point-new       = ',g0,' ergs/s/cm**2/A'
	write (6,*) '------------------------------------------------------'
	write (9,'(x,a,i4,2a)')      'Filter',n,': ',fid(n)
	write (9,'(x,a,1p2e12.4)')   'Range covered        = ',x(1),x(nt)
	write (9,'(x,a,1pe12.4)')    'Area below filter    = ',area
	write (9,'(x,a,1pe12.4)')    'Effective wavelength = ',weff
	write (9,'(x,a,1pe12.4,a )') 'Zero point-old       = ',f0,' ergs/s/cm**2/A'
	write (9,'(x,a,1pe12.4,a/)') 'Zero point-new       = ',g0,' ergs/s/cm**2/A'
	write (9,*) '------------------------------------------------------'
	l1=l2
	goto 1
10	write (6,*) 'Output in files fort.28 and fort.9'
	end

	SUBROUTINE XREVERSE(X,N)

c	Reverses order of real array X

	real*4 x(n),y(1000000)
	nt=n+1
	do k=1,n
	nt=nt-1
	y(nt)=x(k)
	enddo
	do k=1,n
	x(k)=y(k)
	enddo
	return
	end

	SUBROUTINE XREVERSE8(X,N)

c	Reverses order of real*8 array X

	real*8 x(n),y(1000000)
	nt=n+1
	do k=1,n
	nt=nt-1
	y(nt)=x(k)
	enddo
	do k=1,n
	x(k)=y(k)
	enddo
	return
	end

	PROGRAM GALAXEVPL

	! Writes a formatted file with galaxy spectral energy distributions
	! stored in files *.ised

	! parameter (nw=40000,no=250,js=900)
	! parameter (nw=55000,no=250,js=221)
	parameter (nw=55000,no=500,js=500)
	character namech*256,ext*12,name2*256,save*256,argu*1024,id*80,xrgu*1024	! ,headcol*12
	integer n(no)
	real c(no),t(js),cnu(nw),aux(no),bux(js),h(nw),w(nw),f(nw,js),p(6)
	data save/' '/,aux/no*0./

	! Get file name from argument list or ask user for file name.
	! Extension "ised" added by code.
	ja = iargc()
	jn = ja
	jm = ja
	jw = ja
1	call copyright(6)
	write (6,*)
	write (6,'(1x,a)') 'GALAXEVPL: This program will write a formatted file with galaxy s.e.d.''s'
	write (6,'(1x,2a)') 'read from an unformatted *.ised file.'
11	if (jn > 0) then
		call getarg(1,namech)
	else
		write (6,'(/1x,3a,$)') 'Input file name [',save(1:margo(save)),'] (CTRL/D exits) = '
		read (5,'(a)',end=10) namech
		if (largo(namech) == 0) namech=save
	endif
	! call chaext(namech,'ised',mmm)
	! call chext(namech,'ised')
	if (index(namech,'.ised') == 0) namech = trim(namech) // '.ised' 
	save=namech

	! Open and read file
	write (6,'(/1x,2a)') 'Reading file: ',namech(1:largo(namech))
	close (1)
	open (1,file=namech,status='old',form='unformatted',err=25)
	! read (1) ks,(t(i),i=1,ks)
	read (1) ks,(t(i),i=1,ks),xml,xmu,iseg,(p,i=1,iseg),totm,totn,avs,io,tau,id
	! write (6,*) xml,xmu,iseg,totm,totn,avs,io,tau
	write (6,*) 'Model ID: ',id
	! write (lun) nsteps+1,0.,(tb(i),i=1,nsteps),ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,io,tau,id,tau,tau,1.,1.,id,id,-2,stelib
	! write (6,*) ks,(t(i),i=1,ks)
	read (1) iw,(w(i),i=1,iw)
	write (6,100) 'In this file there are',ks,' galaxy s.e.d.''s, from ',t(1),' to ',t(ks),' yr'
100	format (/1x,a,i7,a,1pe9.2,a,e9.2,a)
	write (6,102) w(1),w(iw),iw
102	format (/' Each sed covers from lambda = ',F6.1,' to ',1pe12.5,' A in ',I6,' steps.')

	! Get age of sed''s to be listed from argument list or ask user
2	if (jm.gt.1) then
		call getarg(2,argu)
	else
		write (6,'(/1x,a,$)') 'Enter age (in Gyr) of up to 250 sed''s (separated by commas) = '
		read (5,'(a)',end=10) argu
	endif
	! Found a problem with gfortran in reading more arguments that have been actually entered.
	! Use function nargu(argu) to count how many time steps have been entered
	if (argu == '-all' .or. argu == '-vall') then
		ngu = min(ks,no)
		do j=1,ngu
		! aux(j)=t(j)*1.E-09
		aux(j)=j
		enddo
		aux(1)=-1
	else
		ngu = nargu(argu)
		read (argu,*,err=27) (aux(j),j=1,ngu)
	endif

	! Find sed''s in model file with age closest to values requested
	ic=0
	if (aux(1).lt.0) then
		aux(1)=-aux(1)
		tfac=1.
	else
		tfac=1.E+09
	endif
	do i=1,ngu
	if (aux(i).eq.0.) then
		ic=ic+1
		aux(ic)=t(1)
		if (tfac.eq.1) aux(ic)=1
	elseif (aux(i).gt.0.) then
		ic=ic+1
		aux(ic)=aux(i)*tfac
	endif
	enddo
	! Sort array aux and suppress duplicate entries
        call usort(ic,aux)
	! Find corresponding record numbers
	do i=1,ic
	if (tfac.gt.1.) then
		do k=1,ks
		bux(k)=abs(aux(i)-t(k))
		enddo
		closest=rminim(bux,1,ks,kmin)
	else
		kmin=nint(aux(i))
	endif
	n(i)=kmin
	enddo

	! Get wavelength range to copy to ascii file from argument list or ask user
	! ip = Number of flux values to be printed
3	ip = iw
	! if (argu == '-all') then
		! w1=0.
		! w2=0.
		! w0=0.
		! f0=0.
		! z=0.
	! elseif (jw.gt.2) then
	if (jw > 2) then
		call getarg(3,argu)
		! read (argu,'(5f10.0)',err=26) w1,w2,w0,f0,z
		read (argu,*,err=26) w1,w2	!,w0,f0,z
	else
		write (6,*)
		write (6,*) 'Enter desired wavelength range = [W1,W2] (default: full range).'
		write (6,*) '     o If you want all s.e.d.''s scaled to flux = F0 at lambda = W0, enter the'
		write (6,*) '          desired values (default: no scaling)'
		write (6,*) '     o If you want the output as Fnu vs. lambda, enter W1 with a minus sign.'
		write (6,*) '     o If you want all s.e.d.''s scaled so that F0 is the flux measured through'
		write (6,*) '          filter N at redshift Z, enter W0 = -N'
		write (6,*)
		write (6,'(1x,a,$)') 'W1,W2,W0,F0,Z = '
		read (5,'(a)',end=10) xrgu
		w1=0.
		w2=0.
		w0=0.
		f0=0.
		z=0.
		if (largo(xrgu) > 0) then
			ngu = nargu(xrgu)
			if (ngu == 1) read (xrgu,*,err=26) w1
			if (ngu == 2) read (xrgu,*,err=26) w1,w2
			if (ngu == 3) read (xrgu,*,err=26) w1,w2,w0
			if (ngu == 4) read (xrgu,*,err=26) w1,w2,w0,f0
			if (ngu == 5) read (xrgu,*,err=26) w1,w2,w0,f0,z
		endif
		! read (5,'(5e20.0)',err=26,end=10) w1,w2,w0,f0,z
	endif

	! Perform required action in wavelength range and model flux
	i1=1
	i2=ip
	i0=0
	nu=0
	j0=0
	if (w0 < 0.) then
		j0=int(abs(w0))
		w0=0.
		g0=f0
		f0=0.
	endif
	if (w1 < 0.) nu=1
	w1=abs(w1)
	do i=1,ip
	cnu(i)=1.
	if (nu /= 0) cnu(i)=w(i)*w(i)*1.E-8/3.E10
	if (w(i) <= w0) i0=i
	if (w(i) <= w1) i1=i
	! if (w(i) <= w2) i2=i+1
	if (w(i) <= w2) i2=i
	enddo
	if (i1 >= i2) goto 26
	do j=1,ks
	read (1) ip,(h(i),i=1,ip)
	if (j0 > 0) call ynorm(j0,w,h,ip,z,g0)
	do i=1,ip
	f(i,j)=h(i)
	enddo
	enddo
	! If monochromatic normalization requested
	do i=1,ic
	if (f0 > 0.) then
		c(i)=f0/f(i0,n(i))/cnu(i0)
	else
		c(i)=1.
	endif
	enddo

	! Get output file name from argument list or ask user
	if (ja > 3) then
		call getarg(4,xrgu)
		if (index(xrgu,'default')>0) then
			ja=3
			argu='default'
		endif
	endif
	if (ja > 3) then
		call getarg(4,namech)
	else
		if (n(1) < 10) then
			write (ext,'(i1)') n(1)
		elseif (n(1) < 100) then
			write (ext,'(i2)') n(1)
		elseif (n(1) < 1000) then
			write (ext,'(i3)') n(1)
		elseif (n(1) < 10000) then
			write (ext,'(i4)') n(1)
		else
			ext='glxvpl'
		endif
		if (argu == 'default') then
			call chext(namech,ext)
		elseif (argu == '-all') then
			if (ja > 2) then
				call getarg(3,namech)
			else
				call chext(namech,'all')
			endif
		elseif (argu == '-vall') then
			if (ja > 2) then
				call getarg(3,namech)
			else
				call chext(namech,'vall')
			endif
		else
			call chext(namech,ext)
			write (6,'(/1x,3a,$)') 'Default output file name [',trim(namech),'], or enter your own = '
			read (5,'(a)',end=10) name2
			if (largo(name2) > 0) namech=name2
		endif
	endif

	! Open file and write requested columns
	close (2)
	open (2,file=namech,form='formatted',status='unknown')
	if (argu == '-vall') then
		write (6,'(x,a)') 'List next to the flux the value from column J of file I:'
		write (6,'(x,a)') '            1 = *.1color'
		write (6,'(x,a)') '            2 = *.2color'
		write (6,'(x,a)') '            3 = *.3color'
		write (6,'(x,a)') '            4 = *.4color'
		write (6,'(x,a)') '            5 = *.5color'
		write (6,'(x,a)') '            6 = *.9color'
		write (6,'(x,a)') '            7 = *.1ABmag'
4		write (6,'(x,a,$)') 'Enter I,J = '
		read (5,'(2i10)',err=4,end=10) i,j
		if     (i == 1) then
			ext = '1color'
		elseif (i == 2) then
			ext = '2color'
		elseif (i == 3) then
			ext = '3color'
		elseif (i == 4) then
			ext = '4color'
		elseif (i == 5) then
			ext = '5color'
		elseif (i == 6) then
			ext = '9color'
		elseif (i == 7) then
			ext = '1ABmag'
		else
			write (6,*) 'Option I =',i,' not implemented'
			stop
		endif
		name2=namech
		call chext(name2,ext)
		open(666,file=name2)
		! Read header
		do l=1,30
		read (666,*)
		enddo
		do l=1,220
		read (666,*) (aux(l),k=1,j),bux(l)
		enddo
		close (666)
		write (6,*)
		write (6,105) 'Output file name = ',trim(namech),'Input file name  = ',trim(save)
		write (6,1051) '3rd column lists = ',trim(name2),', Columns =',j,j+1
		write (2,105) 'Output file name = ',trim(namech),'Input file name  = ',trim(save)
		write (2,1051) '3rd column lists = ',trim(name2),', Columns =',j,j+1
		write (2,'(a)') '#'
		write (2,'(a)') '#  Age(yr)   Lambda(A)   Flux       Prop(J)    Prop(J+1)   Rec'
		! Add column for t=0, the same as for the first record
		do j=1,ic
		do i=i1,i2
		if (j == 1) then
			write (2,1091) t(n(1)),w(i),c(1)*cnu(i)*f(i,n(1)),aux(1),bux(1),j-1
		else
			write (2,1091) t(n(j)),w(i),c(j)*cnu(i)*f(i,n(j)),aux(j-1),bux(j-1),j-1
		endif
		enddo
		enddo
	else
		write (6,*)
		write (2,105) 'Input file name  = ',trim(save),'Output file name = ',trim(namech)
		write (2,107) (  n(j) ,j=1,ic)
		write (2,106) (   j+1 ,j=1,ic)
		write (2,1081)('      at    ',j=1,ic)
		write (2,1082) (t(n(j)),j=1,ic)
		write (6,*)
		write (6,105) 'Input file name  = ',trim(save),'Output file name = ',trim(namech)
		write (6,'(/1x,i4,2a)') ic,' columns written to file: ',trim(namech)
		do i=i1,i2
		write (2,109) w(i),(c(j)*cnu(i)*f(i,n(j)),j=1,ic)
		enddo
	endif
105	format ('# ',2a)
1051	format ('# ',3a,2i4)
106	format ('# Column',500I12)
107	format ('# Record',500I12)
1081	format ('# SED(Lo/A) ',500a)
1082	format ('# Lambda(A) ',1p500E12.5)
109	format (1PE12.6,1P500E12.5)
1091	format (1P3E11.4,2e12.4,i4)
	write (6,'(/1x,a)') '-------------------------------------------------------------------'
	if (iargc().gt.0) stop
	j=0
	goto 1

	! Error messages
25	write (6,'(1x,3a/)') 'File ',namech(1:largo(namech)),' not found. Please try again.'
	jn=0
	goto 11
26	write (6,'(1x,a/)') 'Error entering wavelengths. Please try again.'
	jw=0
	goto 3
27	write (6,'(1x,a/)') 'Error entering age of model. Please try again.'
	jm=0
	goto 2
10	end

	CHARACTER*12 FUNCTION HEADCOL(T)
	! Writes age in suitable format for fits file column header
	headcol=''
	if (t == 0) then
		write (headcol,100) 0.,0
	else
		! Get exponent
		l=int(alog10(t))
		! Process age
		tx = t*10.**(-l)
		if (l<10) then
			write (headcol,100) tx,l
		else
			write (headcol,101) 10.*tx,l-1
		endif
	endif
100	format(2x,'t',f5.3,'E',i1,'yr')
101	format(2x,'t',f5.2,'E',i1,'yr')
	i = index(headcol,'.')
	headcol(i:i) = 'p'
	return
	end

	FUNCTION LDOT(S)

!	Returns position of last dot "." in array S

!	Variables
	character*(*) s

!	Finds last dot in array s
	j=index(s,'.')
	ldot = j
	if (ldot>0) then
		do while (j>0)
		j=index(s(ldot+1:),'.')
		ldot=ldot+j
		enddo
	else
		s=trim(s) // '.'
		ldot = len(trim(s))
	endif
	return
	end

	SUBROUTINE CHEXT(S,E)

!	Changes extension to filename s

!	Variables
	character*(*) s,e

!	Finds last dot in array s
	s(ldot(s)+1:)=e
	return
	end

	SUBROUTINE CHAEXT(S,E,N)

!	Changes extension to filename s

!	Variables
	character*(*) s,e

!	Use function chext
	call chext(s,e)
	return
	end

!	SUBROUTINE OLD_CHAEXT(S,E,N)

!	Changes extension (suffix) to filename s
!	SUN/FORTRAN version. G. Bruzual. 08-NOV-1988

!	character*(*) s,e
!	l=len(s)
!	k=len(e)
!	ib=largo(s)	
!	id=0
!	if (n >= 0) then
!!		Finds last dot in array s
!		do i=ib-1,1,-1
!		if (s(i:i).eq.'.') then
!			id=i
!			if (s(i+1:i+1).eq.'/') id=ib
!			goto 1
!		endif
!		enddo
!	endif
!1	if (id.eq.0) id=ib+1
!	s(id:id)='.'
!	if (id+k.gt.l) k=l-id
!	do i=1,k
!	s(id+i:id+i)=e(i:i)
!	enddo
!	n=id+k
!	do i=id+k+1,l
!	s(i:i)=' '
!	enddo
!	return
!	end

	SUBROUTINE COPYRIGHT(JUN)
	data icount/0/
	lun=abs(jun)
	write (lun,*)
	write (lun,'(x,a)') 'Galaxy Spectral Evolution Library (GALAXEV)'
	write (lun,'(x,a)') 'UNIX Version (C) 1995-2020 - G. Bruzual and S. Charlot - All Rights Reserved'
	write (lun,*)
	if (jun.lt.0) return
	icount=icount+1
	write (lun,'(x,a,i3)') 'Computing model No.',icount
	write (lun,*)
	return
	end

	PROGRAM INTERPOLATE_ISED

	! Writes to standard output interpolated *.ised file at requested ages

	! Array declarations
	parameter (nw=25000,no=250)
	character name*1024,argu*2048
	real tx(no),x(nw),y(nw),z(nw,no)

	! Get argument list
        jn = iargc()
	if (jn > 1) then
		! Get file name from argument list
		call getarg(1,name)
		call chaext(name,'ised',m)
		! Read requested ages
                call getarg(2,argu)
                ngu = nargu(argu)
                read (argu,*,err=1) (tx(j),j=1,ngu)
		! Call interpolation routine and store sed's
		do j=1,ngu
		call intrp_ised(name,tx(j),x,y,n)
		do i=1,n
		z(i,j) = y(i)
		enddo
		enddo
		write (6,100) name(1:largo(name))
		write (6,101) (j+1,j=1,ngu)
		write (6,102) (tx(j),j=1,ngu)
		write (6,103) ('    Flux   ',j=1,ngu)
		do i=1,n
		! if (x(i) >= 3540. .and. x(i) <= 7000.1 ) then		! nr = narrow range = Miles range requested by Sebastian Sanchez
		! if (x(i) >= 3540. .and. x(i) <= 10000. ) then		! mr = medium range requested by Sebastian Sanchez
		  if (x(i) >= 2000. .and. x(i) <= 11000. ) then		! fr = full range of MaStar spectra, extended to UV
			write (6,104) x(i),(z(i,j),j=1,ngu)
		endif
		enddo
100		format ('# File: ',a)
101		format ('# Column  ',250I11)
102		format ('# Age(yr)     ',1p250E11.3)
103		format ('# Lambda(A)   ',250a)
104		format (1pe14.6,250e11.4)
		stop
	endif
1	write (6,*) 'Command line usage:'
	write (6,*) 'interpolate_ised   filename    t(1),t(2),t(3),...          (enter ages t(1),t(2),t(3),...  in yr)'
	end

	PROGRAM MM_EVOLUTION

c	Computes apparent magnitude vs z through several filters
c	The user selects the filter(s) to use from the list in filters.log
c	The user enters values for the cosmological parameters

	include 'read_ised.dec'
	include 'filter.dec'
	include 'cosmo.dec'
	include 'SSP_13.dec'

c	Variables
	character file*128,name*128,ext*24,argu*1024
	integer kf(50)
	real yz(imw),xaux(24)
	data lun/26/,file/' '/,kf/50*0/
c	Cosmology:
	data h/70./,omega/0.30/,omega_lambda/0.70/

c	Check if correct filter file is in use.
	j=ifilter()
	if (j.eq.0) then
		write (6,'(2a)') char(7),'Please assign correct filter file'
		stop
	endif

c	Welcome user
	write (6,*)
	write (6,'(x,a)') 'Galaxy Spectral Evolution Library (GALAXEV)'
	write (6,'(x,a)') 'UNIX Version (C) 1995-2013 - G. Bruzual and S. Charlot - All Rights Reserved'

c	Ask for Ho, Omega, and Omega_lambda
	write (6,'(/x,a,f4.0,a,f5.3,a,$)') 'Enter cosmological parameters'
3	write (6,'(x,a,f4.0,a,f5.3,a,f5.3,a,$)')  'Enter Ho [',h,'], Omega [',omega,'], Omega_lambda [',omega_lambda,'] = '
	call nread(xaux,nc,*9,*10)
	if (nc.gt.0.) then
		h=xaux(1)
		omega=xaux(2)
		omega_lambda=xaux(3)
	endif
c	Omega is now entered bu the user
c	omega=1.-omega_lambda

c	Obtain cosmological constant and q
	clambda=cosmol_c(h,omega,omega_lambda,q)

c	Age of the universe and maximum age for galaxies (rounded off)
	tu=t(h,q,0.,clambda)
	tg=int(tu)*1.E9

c	Ask for galaxy age
	write (6,*)
	write (6,'(x,a,f6.2,a  )') 'Age of this universe  = tu =',tu,' Gyr'
2	write (6,'(x,a,f6.2,a,$)') 'Enter age of galaxy today = tg [',tg*1.e-9,' Gyr] = '
	call qread(ttg,nc,*8,*10)
	if (nc.gt.0.) tg=ttg*1.E9
	ttg=tg*1.E-9
	zf=zx(ttg,h,q,clambda)

c	Report cosmology
	write (6,'(/x,a)') 'Cosmological model in use:'
	write (6,100) h,omega,omega_lambda,q,clambda
100	format (' Ho = ',f4.0,3x,'Omega =',f5.2,3x,'Omega_lambda =',f5.2,3x,'qo = ',
     *            f7.4,3x,'Lambda =',1pE10.3)
	write (6,101) tu,ttg,zf
101	format (' tu = ',f5.2,' Gyr',3x,'tg = ',f5.2,' Gyr', 3x,' zf = ',f6.2)

c	Ask for *.ised file name
	write (6,*)
1	write (6,'(x,3a,$)') 'BC_GALAXEV model sed in file [',file(1:largo(file)),'] = '
	read (5,'(a)',end=10) name
	call chaext(name,'ised',nn)
	file=name
c	Read *.ised file
	call read_ised(file,tg,kl,kerr)
	if (kerr.ne.0) goto 1

c	Read filter file
	call filter0
c	Read A0Vsed
	call readA0V

c	Ask for filter numbers
4	write (6,'(/x,a)')   'Enter up to 50 filters separated by commas.'
	write (6,'( x,a,i3,a,$)') 'Compute magnitude through filter numbers (1:',nf,') = '
	read (5,'(a)',end=10) argu
	ngu = nargu(argu)
	read (argu,*,err=4) (kf(j),j=1,ngu)
	do i=1,ngu
	if (kf(i).le.0.or.kf(i).gt.nf) then
		write (6,'(x,a,i5,a)') 'Error in filter number',kf(i),'. Please try again'
		goto 4
	endif
	enddo
	write (6,'(/x,a)') 'Selected filters: '
	do i=1,ngu
	write (6,'(x,i5,x,a)') kf(i),fid(kf(i))
	enddo

c	Build output file name and write header into it
	ext='multi_mag_vega'
	call chaext(name,ext,nn)
	open (lun,file=name,form='formatted',status='unknown')
	call file_header(lun,file,1)
	write (6,'(/x,2a)') 'Output written to file(s): ',name(1:largo(name))
	ext='multi_mag_AB'
	call chaext(name,ext,nn)
	open (lun+1,file=name,form='formatted',status='unknown')
	call file_header(lun+1,file,1)
	write (6,'( x,2a)') '                           ',name(1:largo(name))

c	Compute magnitudes
	write (6,'(/x,a)') 'Computing magnitudes/colors...'
	icall=0
	do kz=1,120000
	z=zk(kz,zf)
	call evol_ised(kl,z,h,q,clambda,yz,icall,last)
	if (last.ne.0) goto 10
       	call ke_nfilt_correction(kf,w,yz,iw,z,h,q,lun,ngu)
	if (z.eq.zf) goto 10
	enddo
	close (lun)
	goto 10
!7	write (6,'(x,a)') 'Error in filter number. Please try again'
!	goto 4
8	write (6,'(x,a)') 'Error in galaxy age. Please try again'
	goto 2
9	write (6,'(x,a)') 'Error in parameters. Please try again'
	goto 3
10	end

	subroutine percent(lun,i,n,label)

!	Reports percentage done

	character*(*) label,aux*2048
	common /kpercent/ ipcall,iplast,iphead,jc
	data ipcall/0/,iplast/0/,iphead/0/,jc/0/

	if (ipcall.eq.0) then
	  ipcall=1
	  iplast=0
	  iphead=1
	  jc=0
!	  aux = label(1:lastd(label)) // ':'
	  l = max(index(label,'.ised')-1,index(label,'.wfpc')-1)
	  if (l <= 0) l = largo(label)
	  aux = label(1:l) // ':'
	  write (lun,'(/x,a)') aux(1:l+1)
	  write (lun,'(a,i10,a)') ' % done: ...10...20...30...40...50...60...70...80...90..100 (',n,' steps)'
	  write (lun,'(a,$)')  	  '         '
	endif
	xi=i
	xn=n
	ip=nint(xi/xn*50)
	if (ip.gt.iplast) then
	  iplast=ip
	  write (lun,'(a,$)') '.'
	  call flush(lun)
!	  jc=jc+1
!	  if (jc.eq.(jc/10)*10) write (lun,*)
	endif
	if (i.ge.n) then
		ipcall=0
		iphead=0
		write (lun,*)
		write (lun,*)
	endif
	return
	end

	subroutine vpercent(lun,i,n,label)

!	Reports percentage done in vertical mode

	character*(*) label,aux*24
	common /kpercent/ ipcall,iplast,iphead,jc
!	data ipcall/0/,iplast/0/,iphead/0/,jc/0/

	if (ipcall.eq.0) then
	  ipcall=1
	  iplast=0
	  iphead=1
	  jc=0
	  aux = label(1:largo(label)) // ':'
	  write (lun,'(a)') aux(1:largo(aux))
	  write (lun,'(a,i5,a)') ' % done: ...  0  (',n,' steps left)'
!	  write (lun,'(a,i5,a)') ' % done: ... 10  (',n,' steps)'
!	  write (lun,'(a,$)') '         '
	endif
	xi=i
	xn=n
	ip=nint(xi/xn*50)
	if (ip.gt.iplast) then
	  iplast=ip
!	  write (lun,'(a,$)') '.'
	  jc=jc+1
	  if (jc.eq.(jc/5)*5) write (lun,'(a,i3,a,i4)') '         ...',2*jc,'    ',n-i
	  call flush(lun)
	endif
	if (i.ge.n) then
		ipcall=0
		iphead=0
		jc=0
!		write (lun,*)
!		write (lun,*)
	endif
	return
	end

	subroutine evpercent(lun,i,n,label)

!	Reports percentage done in vertical mode (en espaņol)

	character*(*) label,aux*24
	common /kpercent/ ipcall,iplast,iphead,jc
!	data ipcall/0/,iplast/0/,iphead/0/,jc/0/

	if (ipcall.eq.0) then
	  ipcall=1
	  iplast=0
	  iphead=1
	  jc=0
	  aux = label(1:largo(label)) // ':'
	  write (lun,'(a)') aux(1:largo(aux))
	  write (lun,'(a,i5,a)') ' % hecho: ...  0  (',n,' por hacer)'
!	  write (lun,'(a,i5,a)') ' % hecho: ... 10  (',n,' steps)'
!	  write (lun,'(a,$)') '         '
	endif
	xi=i
	xn=n
	ip=nint(xi/xn*50)
	if (ip.gt.iplast) then
	  iplast=ip
!	  write (lun,'(a,$)') '.'
	  jc=jc+1
	  if (jc.eq.(jc/5)*5) write (lun,'(a,i3,a,i4)') '          ...',2*jc,'    ',n-i
	  call flush(6)
	endif
	if (i.ge.n) then
		ipcall=0
		iphead=0
		jc=0
!		write (lun,*)
!		write (lun,*)
	endif
	return
	end

	subroutine dpercent(lun,i,n)

!	Reports percentage done. Uses '-' instead of '.'

	!character*(*) label,aux*2048
	common /kpercent/ ipcall,iplast,iphead,jc
	data ipcall/0/,iplast/0/,iphead/0/,jc/0/

	if (ipcall.eq.0) then
	  ipcall=1
	  iplast=0
	  iphead=1
	  jc=0
	  ! aux = label(1:lastd(label)) // ':'
	  ! l = max(index(label,'.ised')-1,index(label,'.wfpc')-1)
	  ! if (l <= 0) l = largo(label)
	  ! aux = label(1:l) // ':'
	  ! write (lun,'(/x,a)') aux(1:l+1)
	  ! write (lun,'(a,i10,a)') ' % done: ...10...20...30...40...50...60...70...80...90..100 (',n,' steps)'
	  ! write (lun,'(a,$)')  	  '         '
	  write (lun,'(a,$)') ' '
	endif
	xi=i
	xn=n
	ip=nint(xi/xn*200)
	if (ip.gt.iplast) then
	  iplast=ip
	  write (lun,'(a,$)') '-'
	  call flush(lun)
!	  jc=jc+1
!	  if (jc.eq.(jc/10)*10) write (lun,*)
	endif
	if (i.ge.n) then
		ipcall=0
		iphead=0
		write (lun,*)
	  	call flush(lun)
		! write (lun,*)
	endif
	return
	end

	SUBROUTINE RF_COLOR(IO,T,X,Y,INW,LUN,BOLFLUX,STRMASS,SF,EVFLUX,SNBR,PNBR,BH,SN,WD,RM,XM,BOLMS,GASMASS,GALMASS,TMLR,TDPR,SISSA20)

	! Array declarations
	parameter (nc=100,lb=2*nc,jid=35,its=400)
	logical sissa20
	character genfile*96,envfile*96,rfcolorfile*96,h(0:200)*15	! ,h(0:200)*24
	! Negative indices allow for mandatory colors
	integer p,n1(-4:nc),n2(-4:nc),no(lb),ly(6),kerr(nc)
	real zp(-4:nc),col(-4:nc),phot(0:200),f(200),w(200),s(200),snbr(0:4)
	real umag,bmag,rmag,jmag,kmag,bsun,vsun,ksun,blr1,vlr1,klr1,blr,vlr,klr,lx
	real x(inw),y(inw),fx(lb),balm(3),gwx(jid),gwl(jid),ab(0:70)
	real m_pn,m_hm,m_bh,m_ns,m_wd
	save no,ly,zp,sl,mb,nv,mc,kb,nb,v0,p,w,s
	include 'stelib.dec'
	include 'filter.dec'
	common /kpercent/ ipcall,iplast,iphead,jc
	! Common to store fluxes used to compute indices
	integer iim(jid)
	real ffb(jid),ffr(jid),ffc(jid),ffl(jid),mf_ix(21),mf_ix_sed
	common /fluxes/ iim,ffb,ffr,ffc,ffl
	common /massrem/ m_pn,m_hm,m_bh,m_ns,m_wd
	real*8 mabo(its),mbel(its),mcut,rmup(its),rmlo(its)
	common /topimf/ mabo,mbel,rmup,rmlo,mcut,ic
	data icall/0/,jcall/0/,ly/6*0/,last/0/
	! Define mandatory colors
	data n1/ 15,15,15,12,14, nc*0/
	data n2/125,57,84,13,15, nc*0/
        data j1,j2/1,21/
	data kerr/nc*0/,jfits/0/
	common /f1001/ mab,ab

	! Return if t = 0 (log t undefined)
	if (t <= 0.) return
	tl = alog10(t)

	! Check for zero flux sed
	if (bolflux <= 0.) then
		bolflux=trapz1(x,y,inw)
		if (bolflux <= 0.) return
	endif
	izero=0
	do i=1,inw
	if (y(i) > 0) then
		izero=izero+1
	endif
	enddo
	if (izero == 0) then
		! write (6,*) 'Exiting rf_color at t =',t,' because of zero flux'
		! return
		! To allow using .?color files with a single number of lines
		do i=1,inw
		y(i) = 1.E-33
		enddo
	endif

	! Compute galaxy mass and mass in gas (except for add_bursts io = 5)
	! if (io.ne.10) then
	! 	galmass=gal_mass(io,t,sf)
	! endif

	! Report what we are doing
	if (iphead == 0) then
		write (6,*)
		write (6,'(x,a/ )') 'Computing magnitudes, colours and indices'
		iphead=1
	endif

	! Compute Worthey and other indices directly from sed and in the Lick system
	ism=0
	do j=1,jid
	gwx(j)=gw_ix_sed(j,x,y,inw,0)
	gwl(j)=gw_ix_sed_lick_system(j,x,y,inw,0,ism)
	enddo

	! Compute Fanelli et al. indices
	do j=j1,j2
	! Indices 1 to 11 are below wavelength coverage of HNGSL
	mf_ix(j)=mf_ix_sed(j,x,y,inw)
	enddo

	! Check if number of points has changed
	if (inw <= last) then
	      ! write (6,*) 'Resetting:',inw,last
	      !	ireset=1
		last=inw
	endif

	if (icall.eq.0) then
		icall=1

		! Format of file modified 07/01/2003:
		! To avoid recompiling this routine the arrays n1,n2 of
		! up to nc elements each are now read from a file.
		! Get file name from environment variable RF_COLORS_ARRAYS
		envfile='RF_COLORS_ARRAYS'
		call getenv(envfile,rfcolorfile)
		close (1)
		open (1,file=rfcolorfile,status='old',form='formatted',err=2)
		! write (6,*) 'List of filters in file: ',rfcolorfile(1:largo(rfcolorfile))
		! Read one line of header
		read (1,'(a)') genfile
		! write (6,*) genfile(1:largo(genfile))
		kb=0
		! Read filter pairs
		do i=1,nc
		read (1,'(2i4)',err=10) n1(i),n2(i)
		kb=kb+1
		fx(kb)=n1(i)
		kb=kb+1
		fx(kb)=n2(i)
		enddo
10		mc=i-1
		close (1)
		! Add mandatory filters
		do i=-4,0
		kb=kb+1
		fx(kb)=n1(i)
		kb=kb+1
		fx(kb)=n2(i)
		enddo
		! Sort filters in numerical order
		call sort(kb,fx)
		! Find independent filters in arrays n1 and n2, and store in no
		nb=1
		no(1)=fx(1)
		do i=2,kb
		if (fx(i).gt.fx(i-1)) then
			nb=nb+1
			no(nb)=nint(fx(i))
		endif
		enddo
		! Get filter ID
		call filterid(fid)
		! nun=1002
		! nun=6
		! write (nun,'(x,a)') 'Selected filters (Vega mag):'
		! do i=1,nb
		! write (nun,'(i4,'': '',i4,3x,a)') i,no(i),fid(no(i))
		! enddo
		! write (nun,'(i3,a)') mc,' colors selected (Vega mag):'
		! do i=1,mc
		! write (nun,'(3i4,3x,3a)') i,n1(i),n2(i),trim(fid(n1(i))),' - ',trim(fid(n2(i)))
		! enddo

		! Log of solar luminosity
		sl=33.+alog10(3.826)

		! Read filter file and compute zero points
		! write (6,*)
		! write (6,*) 'Computing Zero Points:'
		! Compute V magnitude Vega zero point
		v0=vega_0p_n(15)
		do i=-4,mc
		zp(i)=zerop_n(n1(i),n2(i))

		! Fill arrays with filter numbers
		do j=1,nb
		if (n1(i).eq.no(j)) n1(i)=j
		if (n2(i).eq.no(j)) n2(i)=j
		if (no(j).eq.14) mb=j
		if (no(j).eq.15) nv=j
		enddo
		enddo

		! Find in array x the position of points used to define the continuum at Lyman alpha
		do i=1,inw
		if (x(i).le.1120.) ly(1)=i
		if (x(i).le.1140.) ly(2)=i
		if (x(i).le.1160.) ly(3)=i
		if (x(i).le.1280.) ly(4)=i
		if (x(i).le.1300.) ly(5)=i
		if (x(i).ge.1320.) then
			ly(6)=i
			goto 1
		endif

		enddo
	endif
1	continue

	! Compute AB magnitudes for SDSS and other bands
	! ireset=1
	call sdss_color(t,x,y,inw,lun,bolflux,sissa20)

	! Compute flux through each of nb filters
	do i=1,nb
	kerr(i)=0	! This is useful just in case the first sed in a model has zero fluxes for a given filter
	! 		! otherwise the flux through this filter is not computed at later ages.
	if (kerr(i).eq.0) then
		fx(i)=filter_n(no(i),x,y,inw,0.,kerr(i))
	else
		fx(i)=0.
	endif
	enddo

	! Compute colors in Vega system
	do i=-4,mc
	if (fx(n1(i)).gt.0..and.fx(n2(i)).gt.0.) then
		col(i)=zp(i)-2.5*alog10(fx(n1(i))/fx(n2(i)))
	! 	write (6,*) i,n1(i),kerr(n1(i)),n2(i),kerr(n2(i))
	else
		col(i)=-99.99
	! 	write (6,*) i,n1(i),kerr(n1(i)),fx(n1(i)),n2(i),kerr(n2(i)),fx(n2(i))
	endif
	enddo

	! Compute bolometric magnitude
	bolmag=4.75-2.5*alog10(bolflux)
	bolpms=bolflux-bolms
	if (bolms > 0.) then
		bolrat=bolpms/bolms
	else
		bolrat=0.
	endif

	! Compute V magnitude for a 1 Mo galaxy
	! It is -27.5 magnitudes brighter for a 1E11 Mo galaxy
	vmag=v0-2.5*alog10(fx(nv))

	! Compute U, B, R, K, and J2MASS magnitudes
	bmag=vmag+col( 0)
	umag=bmag+col(-1)
	rmag=vmag-col(-2)
	kmag=vmag-col(-3)
	jmag=vmag-col(-4)

	! Compute mass-to-visual-light ratio in solar units SUPERSEDED (Feb. 27, 2004).
	! Using a G2 V sed and the filters number 14 and 15
	! in the filter file, one derives:
	! 	fblue(sun) = 0.138Lo
	! 	fvis (sun) = 0.113Lo
	! This numbers apply only to the filters in this filter library.
	! Express blue and visual flux of model galaxy (also measured in
	! Lo) in units of the blue and visual flux of the sun:
	! fblu=fx(mb)/0.138
	! fvis=fx(nv)/0.113
	! fblu=filter(14,x,y,inw,0.)/0.138
	! fvis=filter(15,x,y,inw,0.)/0.113
	! Total mass in galaxy  = 1 Mo
	! Compute mass-to-visual-light ratio
	! blr=1./fblu
	! vlr=1./fvis
	! Compute stellar-mass-to--light ratios
	! blr=strmass/fblu
	! vlr=strmass/fvis

	! The solar absolute magnitudes for U,B,V,R,I,J,H,K were calibrated against the values
	! of Binney and Merrifield 1998, Galactic Astronomy, Table 2.1 (page 53), assuming
	! Bessell filters, and the offsets used to calibrate the entire set of filters.
	! Some values need checking - particularly those using UV filters (FOCA and Galex).
	! Taken from: http://mips.as.arizona.edu/~cnaw/sun.html

	! 	Filter	 B&M	 here	 difference
	! 	U	 5.61	 5.55	 0.06
	! 	B	 5.48	 5.45	 0.03
	! 	V	 4.83	 4.80	 0.03
	! 	R	 4.42	 4.46	 -0.04
	! 	I	 4.08	 4.11	 -0.03
	! 	J	 3.64	 3.67	 -0.02
	! 	H	 3.32	 3.33	 0.01
	! 	K	 3.28	 3.29	 0.01


	! Compute mass-to-visual-light ratio in solar units. Improved definition (Feb. 27, 2004).
	! Use solar absolute V and B magnitudes and (B-V)sun = 0.65
	vsun=4.80
	bsun=5.45
	ksun=3.29
	! M/L using the total mass in stars (M*), i.e. no remmnants
	blr1=strmass*10.**(0.4*(bmag-bsun))
	vlr1=strmass*10.**(0.4*(vmag-vsun))
	klr1=strmass*10.**(0.4*(kmag-ksun))
	! Modified Jan. 2011 to add mass of remmnants (rm = mBH + mNS + mWD)
	blr=(strmass+rm)*10.**(0.4*(bmag-bsun))
	vlr=(strmass+rm)*10.**(0.4*(vmag-vsun))
	klr=(strmass+rm)*10.**(0.4*(kmag-ksun))

	! Number of Lyman Continuum photons = Cly (log)
	! Flux in Lyman alpha from recombination theory
	! E(Lalpha) = 4.78E-13 * 33.1 * Nuv
	! log E = log(Nuv) -10.8 = cly -10.8
	! Number of Lyman continuum photons
	phly=clyman(x,y,inw)
	if (phly > 0.) then
		cly=sl+alog10(phly)
		fa=cly-10.8
	else
		cly=0.
		fa=0.
	endif

	! Number of Helium ionizing photons
	phe=chelium(x,y,inw,phe2)
	if (phe > 0.) then
		che=sl+alog10(phe)
	else
		che=0.
	endif
	if (phe2 > 0.) then
		che2=sl+alog10(phe2)
	else
		che2=0.
	endif
	! Ratio de He II to H I ionizing photons
	cher=che2-cly

	! Stellar continuum at Lyman alpha
	if (x(1).ge.1320.) then
		scly=0.
	else
		scly=(y(ly(1))+y(ly(2))+y(ly(3))+y(ly(4))+y(ly(5))+y(ly(6)))/6.
	endif
	if (scly.gt.0.) then
		fc=sl+alog10(scly)
	else
		fc=0.
	endif

	! Ly alpha equivalent width assuming that the continuum is the stellar continuum
	if (fa.gt.0..and.fc.gt.0.) then
		ew=10.**(fa-fc)
		ew2=phly/scly/10.**(10.8)
	else
		ew=0.
		ew2=0.
	endif

	! X ray luminosity (> 0 in models with X ray binaries)
	xlx = lx(x,y,inw)

	! Compute Mg2 index
	ymg2=ymag2(x,y,inw)

	! Compute 912 A break
	b9=b912(x,y,inw)

	! Compute 4000 A break
	b4=b4000(x,y,inw)

	! Compute narrow version of D4000
	b4_n=b4000vn(x,y,inw)

	! Compute SDSS version of D4000
	b4_s=b4000_sdss(x,y,inw)

	! Compute equivalent width of Balmer lines (Hgamma, Hdelta, Hbeta)
	ewbl=ew_balmer(x,y,inw,balm)

	! Compute bolometric magnitude
	bolmag=4.75-2.5*alog10(bolflux)

	! Compute specific flux, snbr, pnbr
	evf=evflux/bolflux
	! write (6,*) t,evflux,evf,xm

	! Compute SNR and PNR per unit Luminosity (superseded, Sept. 2021)
	! snr=snbr/bolflux
	! pnr=pnbr/bolflux

	! SFR/year
	! sf=sfr(t)

	! Compute quantities requested by C. Popescu
	! call popescu(tl,sf,x,y,inw)

	! Compute flux from 1500 to 2800A
	! it=0
	! do i=1,inw
	! if (x(i).ge.1500.0.and.x(i).le.2800.0) then
	! 	it=it+1
	! 	xx(it)=x(i)
	! 	yy(it)=y(i)
	! endif
	! enddo
	! fuv=trapz1(x,y,it)
	! write (9,*) tl, sf,fuv

	! Write results
	if (jcall == 0 .and. .not. sissa20) then
		! Write a record corresponding to t = 0 (use tl = 0 => 1 yr) for compatibility with number of time steps on SED
		! This record is a duplicate of next record
		jcall = 1
		write (lun+1 ,108) 0.,bolmag,(vmag-col(i),i=1,3),vmag,(vmag-col(i),i=4,14)
		write (lun+2 ,108) 0.,bolmag,vmag,(vmag-col(i),i=15,28)
		!rite (lun+3 ,102) 0.,b4,b4_n,b4_s,b9,cly,che,che2,cher,bolmag,bolflux,snr,snt,bh,sn,pnr,wd,rm,xlx
		!rite (lun+3 ,102) 0.,b4,b4_n,b4_s,b9,cly,che,che2,cher,bolmag,bolflux,snbr,bh,sn,pnbr,wd,rm,xlx
		!rite (lun+3 ,102) 0.,b4,b4_n,b4_s,b9,cly,che,che2,cher,snbr,bh,sn,pnbr,wd,rm,xlx
		write (lun+3 ,102) 0.,b4,b4_n,b4_s,b9,cly,che,che2,cher,snbr,pnbr,bh,sn,wd,xlx
		write (lun+4 ,103) 0.,bolmag,bmag,vmag,kmag,strmass,rm,gasmass,galmass,sf,strmass+rm,blr,vlr,klr,blr1,vlr1,klr1
		write (lun+5 ,104) 0.,bolmag,evflux,evf,xm,bolrat,tmlr,tdpr
		write (lun+8 ,105) 0.,(gwx(j),j= 1,21)
		write (lun+9 ,106) 0.,(gwx(j),j=22,25),(gwx(j),j=30,31),(gwx(j),j=26,29),(gwx(j),j=32,jid)
		write (lun+10,110)(0.,j,iim(j),ffb(j),ffr(j),ffc(j),ffl(j),gwx(j),j=1,jid)			! Store fluxes used to compute spectral indices
		write (lun+11,105) 0.,(gwl(j),j= 1,21)
		write (lun+12,106) 0.,(gwl(j),j=22,25),(gwl(j),j=30,31),(gwl(j),j=26,29),(gwl(j),j=32,jid)
		write (lun+87,107) 0.,(mf_ix(i),i=j1,j2)
	endif
	write (lun+1 ,108) tl,bolmag,(vmag-col(i),i=1,3),vmag,(vmag-col(i),i=4,14)
	write (lun+2 ,108) tl,bolmag,vmag,(vmag-col(i),i=15,28)
	!rite (lun+3 ,102) tl,b4,b4_n,b4_s,b9,cly,che,che2,cher,bolmag,bolflux,snr,snt,bh,sn,pnr,wd,rm,xlx
	!rite (lun+3 ,102) tl,b4,b4_n,b4_s,b9,cly,che,che2,cher,bolmag,bolflux,snbr,bh,sn,pnbr,wd,rm,xlx
	!rite (lun+3 ,102) tl,b4,b4_n,b4_s,b9,cly,che,che2,cher,snbr,bh,sn,pnbr,wd,rm,xlx
	write (lun+3 ,102) tl,b4,b4_n,b4_s,b9,cly,che,che2,cher,snbr,pnbr,bh,sn,wd,xlx
	write (lun+4 ,103) tl,bolmag,bmag,vmag,kmag,strmass,rm,gasmass,galmass,sf,strmass+rm,blr,vlr,klr,blr1,vlr1,klr1
	write (lun+5 ,104) tl,bolmag,evflux,evf,xm,bolrat,tmlr,tdpr
	write (lun+8 ,105) tl,(gwx(j),j= 1,21)
	write (lun+9 ,106) tl,(gwx(j),j=22,25),(gwx(j),j=30,31),(gwx(j),j=26,29),(gwx(j),j=32,jid)
	write (lun+10,110)(tl,j,iim(j),ffb(j),ffr(j),ffc(j),ffl(j),gwx(j),j=1,jid)				! Store fluxes used to compute spectral indices
	write (lun+11,105) tl,(gwl(j),j= 1,21)
	write (lun+12,106) tl,(gwl(j),j=22,25),(gwl(j),j=30,31),(gwl(j),j=26,29),(gwl(j),j=32,jid)
	write (lun+87,107) tl,(mf_ix(i),i=j1,j2)
!02	format (f10.6,3f10.4,1pe12.3,1x,0p4f10.4,2x,f10.4,1p12e12.4)
102	format (f10.6,3f9.4,1pe11.3,0p4f9.4,1p11e12.4)
103	format (f10.6,4f10.4,1p6e13.4,1x,6e12.4)
104	format (f10.6,f10.4,1p6e13.4)
105     format (f10.6,21f9.4)
106     format (f10.6,1x,6f9.4,3f11.4,4f10.4,f10.4)
107	format (f10.6,21f11.4)
108	format (f10.6,18f10.4)
110	format (f10.6,i4,i4,1p4e12.3,0pf12.4)

	! return					 ! comment this statement to get file fort.1000 written

	! Write temporary file fort.1000 with photometric magnitudes
	! Organize photometric magnitudes in order of wavelength to be included in fits file

	! Bands listed in file *.1VEGAmag: Mbol, U, B2, B3, V, Rc, Ic, R, I, J, K, L, PalJ, PalH, PalK, K'
	! Johnson UBV filters
	p =   0 ; phot(p) = bolmag         ;                h(p) = '           Mbol'  !  Mbol
	p = p+1 ; phot(p) = vmag - col( 1) ; f(p) =  12   ; h(p) = '      U_Johnson'  !  U
	p = p+1 ; phot(p) = vmag - col( 2) ; f(p) =  13   ; h(p) = '     B2_Johnson'  !  B2
	p = p+1 ; phot(p) = vmag - col( 3) ; f(p) =  14   ; h(p) = '     B3_Johnson'  !  B3
	p = p+1 ; phot(p) = vmag           ; f(p) =  15   ; h(p) = '      V_Johnson'  !  V
	! Cousins RI filters
	p = p+1 ; phot(p) = vmag - col( 4) ; f(p) =  84   ; h(p) = '      R_Cousins'  !  Rc
	p = p+1 ; phot(p) = vmag - col( 5) ; f(p) =  85   ; h(p) = '      I_Cousins'  !  Ic
	! Johnson RIJKL filters
	p = p+1 ; phot(p) = vmag - col( 6) ; f(p) =  32   ; h(p) = '      R_Johnson'  !  R
	p = p+1 ; phot(p) = vmag - col( 7) ; f(p) =  33   ; h(p) = '      I_Johnson'  !  I
	p = p+1 ; phot(p) = vmag - col( 8) ; f(p) =  34   ; h(p) = '      J_Johnson'  !  J
	p = p+1 ; phot(p) = vmag - col( 9) ; f(p) =  35   ; h(p) = '      K_Johnson'  !  K
	p = p+1 ; phot(p) = vmag - col(10) ; f(p) =  36   ; h(p) = '      L_Johnson'  !  L
	! Palomar JHK filters
	p = p+1 ; phot(p) = vmag - col(11) ; f(p) =  55   ; h(p) = '      J_Palomar'  !  PalJ
	p = p+1 ; phot(p) = vmag - col(12) ; f(p) =  56   ; h(p) = '      H_Palomar'  !  PalH
	p = p+1 ; phot(p) = vmag - col(13) ; f(p) =  57   ; h(p) = '      K_Palomar'  !  PalK
	! Cowie K' filter
	p = p+1 ; phot(p) = vmag - col(14) ; f(p) =  88   ; h(p) = '   Kprime_Cowie'  !  K'

	! Bands listed in file *.2VEGAmag: Mbol, Vmag, 2MASSJ, 2MASSH, 2MASSKs, IRAC3.5, IRAC4.5, IRAC5.7, IRAC7.9, IRAS12, IRAS25, IRAS60, IRAS100, MIPS24, MIPS70, MIPS160
	! 2Mass JHKs filters
	p = p+1 ; phot(p) = vmag - col(15) ; f(p) = 125   ; h(p) = '        J_2Mass'  !  J2MASS
	p = p+1 ; phot(p) = vmag - col(16) ; f(p) = 126   ; h(p) = '        H_2Mass'  !  H2MASS
	p = p+1 ; phot(p) = vmag - col(17) ; f(p) = 127   ; h(p) = '       Ks_2Mass'  ! Ks2MASS
	! IRAC filters
	p = p+1 ; phot(p) = vmag - col(18) ; f(p) = 128   ; h(p) = '      I3p6_IRAC'  ! IRAC3.5
	p = p+1 ; phot(p) = vmag - col(19) ; f(p) = 129   ; h(p) = '      I4p5_IRAC'  ! IRAC4.5
	p = p+1 ; phot(p) = vmag - col(20) ; f(p) = 130   ; h(p) = '      I5p7_IRAC'  ! IRAC5.7
	p = p+1 ; phot(p) = vmag - col(21) ; f(p) = 131   ; h(p) = '      I7p9_IRAC'  ! IRAC7.9
	! IRAS filters
	p = p+1 ; phot(p) = vmag - col(22) ; f(p) =  71   ; h(p) = '       I12_IRAS'  ! IRAS12 
	p = p+1 ; phot(p) = vmag - col(23) ; f(p) =  72   ; h(p) = '       I25_IRAS'  ! IRAS25 
	p = p+1 ; phot(p) = vmag - col(24) ; f(p) =  73   ; h(p) = '       I60_IRAS'  ! IRAS60 
	p = p+1 ; phot(p) = vmag - col(25) ; f(p) =  74   ; h(p) = '      I100_IRAS'  ! IRAS100
	! MIPS filters
	p = p+1 ; phot(p) = vmag + col(26) ; f(p) = 132   ; h(p) = '       M24_MIPS'  ! MIPS24 
	p = p+1 ; phot(p) = vmag + col(27) ; f(p) = 133   ; h(p) = '       M70_MIPS'  ! MIPS70 
	p = p+1 ; phot(p) = vmag - col(28) ; f(p) = 134   ; h(p) = '      M160_MIPS'  ! MIPS160

	! Bands listed in file *.1ABmag: u, g, r, i, z, u1, u3, g1, g3, r1, r3, i2, i3, z1, z3, H, Ks, FUV, NUV
	! SDSS filters (AB mag)
	p = p+1 ; phot(p) = ab( 0)         ; f(p) = 120   ; h(p) = '      u_SDSS_AB'  ! SDSS u AB mag
	p = p+1 ; phot(p) = ab( 1)         ; f(p) = 121   ; h(p) = '      g_SDSS_AB'  ! SDSS g AB mag
	p = p+1 ; phot(p) = ab( 2)         ; f(p) = 122   ; h(p) = '      r_SDSS_AB'  ! SDSS r AB mag
	p = p+1 ; phot(p) = ab( 3)         ; f(p) = 123   ; h(p) = '      i_SDSS_AB'  ! SDSS i AB mag
	p = p+1 ; phot(p) = ab( 4)         ; f(p) = 124   ; h(p) = '      z_SDSS_AB'  ! SDSS z AB mag
	! CFHT MegaCam filters (AB mag )
	p = p+1 ; phot(p) = ab( 5)         ; f(p) = 237   ; h(p) = '  u1_CFHT_MC_AB'  ! CFHT MC u1 AB mag
	p = p+1 ; phot(p) = ab( 6)         ; f(p) = 266   ; h(p) = '  u3_CFHT_MC_AB'  ! CFHT MC u3 AB mag
	p = p+1 ; phot(p) = ab( 7)         ; f(p) = 238   ; h(p) = '  g1_CFHT_MC_AB'  ! CFHT MC g1 AB mag
	p = p+1 ; phot(p) = ab( 8)         ; f(p) = 267   ; h(p) = '  g3_CFHT_MC_AB'  ! CFHT MC g3 AB mag
	p = p+1 ; phot(p) = ab( 9)         ; f(p) = 239   ; h(p) = '  r1_CFHT_MC_AB'  ! CFHT MC r1 AB mag
	p = p+1 ; phot(p) = ab(10)         ; f(p) = 268   ; h(p) = '  r3_CFHT_MC_AB'  ! CFHT MC r3 AB mag
	p = p+1 ; phot(p) = ab(11)         ; f(p) = 255   ; h(p) = '  i2_CFHT_MC_AB'  ! CFHT MC i2 AB mag
	p = p+1 ; phot(p) = ab(12)         ; f(p) = 269   ; h(p) = '  i3_CFHT_MC_AB'  ! CFHT MC i3 AB mag
	p = p+1 ; phot(p) = ab(13)         ; f(p) = 241   ; h(p) = '  z1_CFHT_MC_AB'  ! CFHT MC z1 AB mag
	p = p+1 ; phot(p) = ab(14)         ; f(p) = 270   ; h(p) = '  z3_CFHT_MC_AB'  ! CFHT MC z3 AB mag
	p = p+1 ; phot(p) = ab(15)         ; f(p) = 126   ; h(p) = '     H_2MASS_AB'  ! H_2MASS AB mag
	p = p+1 ; phot(p) = ab(16)         ; f(p) = 256   ; h(p) = '  Ks_CFHT_WC_AB'  ! CFHT WIRCam Ks AB mag
	! GALEX filters (AB mag)
	p = p+1 ; phot(p) = ab(17)         ; f(p) = 139   ; h(p) = '   FUV_GALEX_AB'  ! GALEX 1500 AB mag
	p = p+1 ; phot(p) = ab(18)         ; f(p) = 140   ; h(p) = '   NUV_GALEX_AB'  ! GALEX 2300 AB mag

	! Bands listed in file *.2ABmag: F225w, F275w, F336w, F438w, F547m, F555w, F606w, F625w, F656n, F657n, F658n, F814w,   
	!                                F110W, F125W, F160W, F225W, F336W, FR388N, F438W, F555W, F814W,
	!                                F220w, F250w, F330w, F410w, F435w, F475w, F555w, F606w, F625w, F775w, F814w
	! HST WFC3 UVIS1 LEGUS filters (AB mag)
	p = p+1 ; phot(p) = ab(39)	   ; f(p) = 242   ; h(p) = ' UVIS1_f225w_AB'  ! UVIS1 LEGUS f225w AB mag
	p = p+1 ; phot(p) = ab(40)	   ; f(p) = 243   ; h(p) = ' UVIS1_f275w_AB'  ! UVIS1 LEGUS f275w AB mag
	p = p+1 ; phot(p) = ab(41)	   ; f(p) = 244   ; h(p) = ' UVIS1_f336w_AB'  ! UVIS1 LEGUS f336w AB mag
	p = p+1 ; phot(p) = ab(42)	   ; f(p) = 245   ; h(p) = ' UVIS1_f438w_AB'  ! UVIS1 LEGUS f438w AB mag
	p = p+1 ; phot(p) = ab(43)	   ; f(p) = 246   ; h(p) = ' UVIS1_f547m_AB'  ! UVIS1 LEGUS f547m AB mag
	p = p+1 ; phot(p) = ab(44)	   ; f(p) = 247   ; h(p) = ' UVIS1_f555w_AB'  ! UVIS1 LEGUS f555w AB mag
	p = p+1 ; phot(p) = ab(45)	   ; f(p) = 248   ; h(p) = ' UVIS1_f606w_AB'  ! UVIS1 LEGUS f606w AB mag
	p = p+1 ; phot(p) = ab(46)	   ; f(p) = 249   ; h(p) = ' UVIS1_f625w_AB'  ! UVIS1 LEGUS f625w AB mag
	p = p+1 ; phot(p) = ab(47)	   ; f(p) = 250   ; h(p) = ' UVIS1_f656n_AB'  ! UVIS1 LEGUS f656n AB mag
	p = p+1 ; phot(p) = ab(48)	   ; f(p) = 251   ; h(p) = ' UVIS1_f657n_AB'  ! UVIS1 LEGUS f657n AB mag
	p = p+1 ; phot(p) = ab(49)	   ; f(p) = 252   ; h(p) = ' UVIS1_f658n_AB'  ! UVIS1 LEGUS f658n AB mag
	p = p+1 ; phot(p) = ab(50)	   ; f(p) = 253   ; h(p) = ' UVIS1_f814w_AB'  ! UVIS1 LEGUS f814w AB mag

	! HST WFC3 filters (AB mag)
	p = p+1 ; phot(p) = ab(30)	   ; f(p) = 197   ; h(p) = '  WFC3_F110W_AB'  ! WFC3 F110W AB mag
	p = p+1 ; phot(p) = ab(31)	   ; f(p) = 198   ; h(p) = '  WFC3_F125W_AB'  ! WFC3 F125W AB mag
	p = p+1 ; phot(p) = ab(32)	   ; f(p) = 199   ; h(p) = '  WFC3_F160W_AB'  ! WFC3 F160W AB mag
	p = p+1 ; phot(p) = ab(33)	   ; f(p) = 200   ; h(p) = '  WFC3_F225W_AB'  ! WFC3 F225W AB mag
	p = p+1 ; phot(p) = ab(34)	   ; f(p) = 201   ; h(p) = '  WFC3_F336W_AB'  ! WFC3 F336W AB mag
	p = p+1 ; phot(p) = ab(35)	   ; f(p) = 202   ; h(p) = ' WFC3_FR388N_AB'  ! WFC3 FR388N AB mag
	p = p+1 ; phot(p) = ab(36)	   ; f(p) = 203   ; h(p) = '  WFC3_F438W_AB'  ! WFC3 F438W AB mag
	p = p+1 ; phot(p) = ab(37)	   ; f(p) = 204   ; h(p) = '  WFC3_F555W_AB'  ! WFC3 F555W AB mag
	p = p+1 ; phot(p) = ab(38)	   ; f(p) = 205   ; h(p) = '  WFC3_F814W_AB'  ! WFC3 F814W AB mag

	! HST ACS wide filters (AB mag)
	p = p+1 ; phot(p) = ab(19)	   ; f(p) = 219   ; h(p) = 'ACSWFC_F220w_AB'  ! ACS WFC F220w AB mag
	p = p+1 ; phot(p) = ab(20)	   ; f(p) = 220   ; h(p) = 'ACSWFC_F250w_AB'  ! ACS WFC F250w AB mag
	p = p+1 ; phot(p) = ab(21)	   ; f(p) = 221   ; h(p) = 'ACSWFC_F330w_AB'  ! ACS WFC F330w AB mag
	p = p+1 ; phot(p) = ab(22)	   ; f(p) = 222   ; h(p) = 'ACSWFC_F410w_AB'  ! ACS WFC F410w AB mag
	p = p+1 ; phot(p) = ab(23)	   ; f(p) = 223   ; h(p) = 'ACSWFC_F435w_AB'  ! ACS WFC F435w AB mag
	p = p+1 ; phot(p) = ab(24)	   ; f(p) = 224   ; h(p) = 'ACSWFC_F475w_AB'  ! ACS WFC F475w AB mag
	p = p+1 ; phot(p) = ab(25)	   ; f(p) = 225   ; h(p) = 'ACSWFC_F555w_AB'  ! ACS WFC F555w AB mag
	p = p+1 ; phot(p) = ab(26)	   ; f(p) = 226   ; h(p) = 'ACSWFC_F606w_AB'  ! ACS WFC F606w AB mag
	p = p+1 ; phot(p) = ab(27)	   ; f(p) = 227   ; h(p) = 'ACSWFC_F625w_AB'  ! ACS WFC F625w AB mag
	p = p+1 ; phot(p) = ab(28)	   ; f(p) = 228   ; h(p) = 'ACSWFC_F775w_AB'  ! ACS WFC F775w AB mag
	p = p+1 ; phot(p) = ab(29)	   ; f(p) = 229   ; h(p) = 'ACSWFC_F814w_AB'  ! ACS WFC F814w AB mag

	! Write temporary file fort.1000 with photometric magnitudes to be inserted in fits file
	if (jfits == 0) then
		jfits = 1
		! Compute effective wavelength for each of the p filters
		do i=1,p
		s(i) = i
		area = areafilt(int(f(i)),w(i))
		enddo
		! Sort in increasing order of effective wavelength
		call sort2(p,w,s)
		write (1000, '(a,200(a16))') '# logage_yr',h(0),(h(int(s(i))),i=1,p)
		! Write a record corresponding to t = 0 (use tl = 0 => 1 yr) for compatibility with number of time steps on SED
		! This record is a duplicate of next record
		if (.not. sissa20) then
			write (1000,109) 0.,phot(0),(phot(int(s(i))),i=1,p)
		else
			if (t == 1.5E4) then
				write (1000,109) 0.,phot(0),(phot(int(s(i))),i=1,p)
			endif
		endif
		! do i=1,p
		! write (1001,112) 0.,phot(int(s(i))),w(int(s(i)))
		! enddo
	endif
	write (1000,109) tl,phot(0),(phot(int(s(i))),i=1,p)
	! do i=1,p
	! write (1001,112) tl,phot(int(s(i))),w(int(s(i)))
	! enddo
	return
2	write (6,*) 'Error opening file: ',rfcolorfile(1:largo(rfcolorfile))
109	format (f11.6,90f16.4)
!112	format (f10.6,f12.4,f12.1)
	stop
	end

	FUNCTION CLYMAN(X,Y,N)

!	Compute number of Lyman continuum photons in sed Y(X).
!	Assumes X is in Angstroms and Y in ergs/sec/Angstroms (physical flux)

!	variables
	real x(n),y(n)
	real*4 c,h,const,trapz1,w(200000),f(200000)
	save c,h,const
	data icall/0/,const/0./,wly/912./

!	compute proportionality constant
	if (icall.eq.0) then
		c=2.997925E10
		h=6.6262E-27
		const=1.0E-8/h/c
		icall=1
	endif

!	Find Lyman limit in sed and log(number of photons)
	if (x(1).ge.wly) then
		clyman=0.
		return
	endif
	do i=1,n
	if (x(i).lt.wly) then
		w(i)=x(i)
		f(i)=w(i)*y(i)
	elseif (x(i).eq.wly) then
		w(i)=x(i)
		f(i)=w(i)*y(i)
		goto 1
	elseif (x(i).gt.wly) then
		w(i)=wly
		f(i)=y(i-1)+(w(i)-x(i-1))*(y(i)-y(i-1))/(x(i)-x(i-1))
		f(i)=w(i)*f(i)
		goto 1
	endif
	enddo
1	clyman=const*trapz1(w,f,i)
	return
	end

	PROGRAM CSP_GALAXEV

	! Computes spectral energy distribution as a function of time for a
	! Composite Stellar Population (CSP) by performing a convolution integral
	! of the spectral energy distributions for a Single Stellar Population SSP
	! with the chosen Star Formation Rate (SFR).

	! Modified in Toulouse: 6/8/97 to include both convolution of sed and spectral indices

	! Array declarations
	parameter (jb=10)
	include 'csp.dec'
	character ans,name*256,save*256,aux*512,atlas,shell*32
	logical stelib
	real w(imw),h(imw)
	real tauv,mu_d,tv,fext,fi(40),fc(40),rsn(0:4)
	real snr(0:jts),pnr(0:jts), bh(0:jts), sn(0:jts), wd(0:jts), rm(0:jts), s1(0:jts), s2(0:jts), s3(0:jts), s4(0:jts)
	real bol(0:jts),str(0:jts), sf(0:jts),evf(0:jts),gas(0:jts),gal(0:jts),xml(0:jts),xdp(0:jts)
	real fxu(0:jts),fxg(0:jts),fxr(0:jts),fxi(0:jts),fxz(0:jts),fxk(0:jts)
	real ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwa,mwla
	common /w_ages/ fxu,fxg,fxr,fxi,fxz,fxk,ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwa,mwla
	data ihrd/0/,atlas/' '/

	! Check if correct filter file is in use.
	j=ifilter()
	if (j.eq.0) then
		write (6,'(2a)') char(7),'Please assign correct filter file'
		write (6,'(2a)') char(7),'Use command: stdfilt'
		stop
	endif

	! Ask for file name
	save='_'
1	call copyright(6)
2	l=margo(save)
	write (6,'(x,3a,$)') 'BC_GALAXEV SSP sed in file [',save(1:l),'] = '
	read (5,'(a)',end=10) name
	if (largo(name).eq.0) then
		name=save
	else
		! Check if interpolation in metallicity of SSP is requested
		call interpolate_ssp(name)
	endif
	call s500('k','',5.)
	call chaext(name,'ised',mm)
	iread=0
	if (name.ne.save) iread=1
	! lr=index(name,'_lr_')
	open (1,file=name,form='unformatted',status='old',err=3)
	close (1)
	jdef=jjdef(name)

	! Ask for dust attenuation parameters
	write (6,'(/x,a,$)') 'Include attenuation by dust? Y/[N] '
	read (5,'(a)',end=10) ans
	if (ans.ne.'y'.and.ans.ne.'Y') then
		tauv=0.
		mu_d=0.
	else
13		write (6,'(/x,a)')  '[using simple 2-component model of Charlot & Fall (2000)]'
		write (6,'(x,a,$)') 'Enter total effective attenuation optical depth: tau_V [1.0] = '
		! read (5,'(f10.0)',err=13,end=10) tauv
		read (5,'(a)',end=10) aux
		if (largo(aux).eq.0) then
			tauv=1.
		else
			read (aux,*,err=13) tauv
		endif
14		write (6,'(x,a,$)') 'Enter fraction of tau_V arising from the ambient ISM: mu [0.3] = '
		! read (5,'(f10.0)',err=14,end=10) mu_d
		read (5,'(a)',end=10) aux
		if (largo(aux).eq.0) then
			mu_d=0.3
		else
			read (aux,*,err=14) mu_d
		endif
		write (6,'(x,a,f7.4)') '...using tau_V = ',tauv
		write (6,'(x,a,f7.4)') '            mu = ',mu_d
	endif
	! write (501,*) tauv,mu_d
	call s500('f','',tauv)
	call s500('f','',mu_d)

	! Open input sed file (read again, tb modified in case of truncated SFR)
	! if (iread.ne.0) then
		save=name
		close (1)

		! Check length of records (needed in Linux)
		open (1,file=name,form='unformatted',status='old',err=3)
		read (1)
		read (1)
		read (1,err=55) inl,(h(i),i=1,inl),inx
		! write (6,*) inl,inx
		imx=1
		if (inx == 0) imx = 0
		goto 56
55		imx=0
56		close (1)
		open (1,file=name,form='unformatted',status='old',err=3)
		! Read basic parameters from SSP input file
		read (1) nsteps,(tb(i),i=0,nsteps-1),ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,jo,tauo,id,tcut,ttt,ttt,ttt,id,id,igw,stelib

		if (jo.ne.0) then
			write (6,*) 'jo =',jo
			write (6,'(x,a$)')'File does not contain an SSP. Proceed Y/[N] ? '
			read (5,'(a)',end=10) ans
			if (ans.ne.'y'.and.ans.ne.'Y') goto 1
		endif
		! Read sed from SSP file
		write (6,'(2a)') ' Reading file ',name
		read (1,err=15) inl,(w(i),i=1,inl),nbrite,kdef,sissa20
		! write (6,*) 'nbrite, kdef, sissa20 =',nbrite, kdef, sissa20
		goto 16
		! Old format model (nbrite = 0)
15		nbrite   = 0
		kdef    = 0
		sissa20 = .false.
16		do n=0,nsteps-1
		if (imx.gt.0) then
			read (1) inl,(fl(i,n),i=1,inl),inx,(fl(i,n),i=inl+1,inl+inx)
		else
			read (1) inl,(fl(i,n),i=1,inl)
			inx=0
		endif
		! Attenuate by dust if requested (use Charlot & Fall, 2000, ApJ, 539, 718)
		if (tauv.gt.0.) then
			if (tb(n).le.1.e7) then
				tv=tauv
			else
				tv=mu_d*tauv
			endif
			do i=1,inl
			fl(i,n)=fl(i,n)*fext(w(i),tv)
			enddo
		endif
		enddo
		inw=inl+inx
		write (6,*) inl,' wavelength points per record'
		write (6,*) inx,' spectral index points per record'
		write (6,*) inw,' total points per record'
		write (6,*) nsteps,' time steps'
		read (1,end=4) nsteps,( bflx(i),i=0,nsteps-1)
		read (1,end=4) nsteps,( strm(i),i=0,nsteps-1)
		read (1,end=4) nsteps,(   sf(i),i=0,nsteps-1)
		read (1,end=4) nsteps,( evfl(i),i=0,nsteps-1)
		read (1,end=4) nsteps,( snbr(i),i=0,nsteps-1)
		read (1,end=4) nsteps,( pnbr(i),i=0,nsteps-1)
		read (1,end=4) nsteps,( bhtn(i),i=0,nsteps-1)
		read (1,end=4) nsteps,( sntn(i),i=0,nsteps-1)
		read (1,end=4) nsteps,( wdtn(i),i=0,nsteps-1)
		read (1,end=4) nsteps,( rmtm(i),i=0,nsteps-1)
		read (1,end=4) nsteps,( toff(i),i=0,nsteps-1)
		read (1,end=4) nsteps,(bolms(i),i=0,nsteps-1)
		read (1,end=4) nsteps,(gasms(i),i=0,nsteps-1)
		read (1,end=4) nsteps,(galms(i),i=0,nsteps-1)
		read (1,end=4) nsteps,(  rml(i),i=0,nsteps-1)
		read (1,end=4) nsteps,(  rdp(i),i=0,nsteps-1)
		read (1,end=4) nsteps,(  sn1(i),i=0,nsteps-1)
		read (1,end=4) nsteps,(  sn2(i),i=0,nsteps-1)
		read (1,end=4) nsteps,(  sn3(i),i=0,nsteps-1)
		read (1,end=4) nsteps,(  sn4(i),i=0,nsteps-1)
4		close (1)

		! Store flux in the u, g, r, i, z, and K bands for each SSP age in order
		! to compute the flux weighted age of the composite population.
		!	filter = 120 SDSS Camera u Response Function, airmass = 1.3 (June 2001)
		!	filter = 121 SDSS Camera g Response Function, airmass = 1.3 (June 2001)
		!	filter = 122 SDSS Camera r Response Function, airmass = 1.3 (June 2001)
		!	filter = 123 SDSS Camera i Response Function, airmass = 1.3 (June 2001)
		!	filter = 124 SDSS Camera z Response Function, airmass = 1.3 (June 2001)
		!	filter =  57 IR K filter + Palomar 200 IR detectors + atmosphere.57
5		write (6,'(/x,a,$)') 'Compute flux weighted age in the galaxy rest frame at z [0] = '
		read (5,'(f12.0)',err=5,end=10) z
		! read (5,*,err=5,end=10) z
		do n=0,nsteps-1
		do i=1,inl
		h(i)=fl(i,n)
		enddo
		! In the observer frame use the value of z entered above
		! zu = z
		! In the galaxy restframe (as needed for Alfredo's JPAS fits) use z = 0
		zu = 0.
		fxu(n) = filter_n(120,w,h,inl,zu,kerr)
		fxg(n) = filter_n(121,w,h,inl,zu,kerr)
		fxr(n) = filter_n(122,w,h,inl,zu,kerr)
		fxi(n) = filter_n(123,w,h,inl,zu,kerr)
		fxz(n) = filter_n(124,w,h,inl,zu,kerr)
		fxk(n) = filter_n( 57,w,h,inl,zu,kerr)
		enddo

	! endif

	! Ask for SFR
	call sfr_0_b(1,z)

	! Expand time scale if required
	!f ((io.ne.2.and.tcut.lt.20.E9).or.(io.eq.2.and.tcut.gt.2.E9)) call expand_time_steps
	if ((io.ne.2.and.tcut.lt.20.E9).or.(io.eq.2                 )) call expand_time_steps
	if (io.eq.7) call add_time_steps
	
	! Ask for output file name. Open files.
	! Write time scale, IMF, and wavelength scale in output file
	lun=-1
	ioption=99
	call name_sed(lun,jun,kdist,ihrd,ioption,jdef,ldef,ml,mu,name,atlas)
	call file_w_ages(1,name,zu,1.,w,h,inl,ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,mwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwla)

	! Open temporay file to store output file name and kdef (needed to build fits file)
	open (2020,file='csp_fits.tmp')
	i = index(name,'.')
	if (index(shell(),'csh') > 0) then
		! csh in use
		write (2020,'(a)')    'setenv name0 ' // name(:i) // 'ised'
		write (2020,'(a,i5)') 'setenv ioptn ',kdef
	else
		! zsh or bash in use
		write (2020,'(a)')      'export name0="' // name(:i) //'ised"'
		write (2020,'(a,i5,a)') 'export ioptn="',kdef,'"'
	endif
	close (2020)
	! Write in file fort.2001 current time scale (needed to build fits file)
	write (2001,'(a)') '# age-yr'
	do i=0,nsteps-1
	write (2001,'(1pe12.5)') tb(i)
	enddo
	close (2001)

	! Compute convolution integral, rest frame colors, and write results for CSP
	if (isingle == 0) then
		! Use for standard csp models
		nstart = 0
		nfinal = nsteps-1
		!rite (lun) nsteps,(tb(i),i=0,nsteps-1),ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,io,tau,id,tau,tau,1.,1.,id,id,igw,stelib
		write (lun) nsteps,(tb(i),i=0,nsteps-1),ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,jo,tauo,id,tcut,ttt,ttt,ttt,id,id,igw,stelib
	else
		! Use for Chen et al. SFH model
		call s500('r',name,0.)
		nfinal=kfinal(tsng)
		nstart = nfinal
		write (lun) 1,tb(nfinal),ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),totm,totn,avs,io,tau,id,tau,tau,1.,1.,id,id,igw,stelib
		! do i=0,nsteps-1
		! if (tb(i) <= tauf) then
		! 	nfinal = i
		! endif
		! enddo
		! Refine position of age tb(i) closest to tauf
		! if (abs(tb(nfinal+1)-tauf) < abs(tb(nfinal)-tauf)) nfinal=nfinal+1
	endif
	write (lun) inl,(w(i),i=1,inl),nbrite,kdef,sissa20
	if (nbrite > 0 .and. sissa20) then
		! SISSA20 tracks with zero flux in first time steps
		! Here nbrite = ndark + 1 = first luminous record. Write ndark + 1 zero flux records, extra one for t = 0.
		do lb=0,nbrite-1
		! write (lun) inl,(0.,i=1,inl),inx,(0.,i=1,inx)
		call dark_galaxy(lun,tb(lb))
		enddo
	endif
	do n=nstart,nfinal
	if (io > 0) then
		call convolve_new(h,n,bol(n),str(n),evf(n),snr(n),pnr(n),bh(n),sn(n),wd(n),rm(n),gas(n),gal(n),xml(n),xdp(n),s1(n),s2(n),s3(n),s4(n))
		if (.not. sissa20) then
			call file_w_ages(io,name,zu,tb(n),w,h,inl,ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,mwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwla)
		else
			if (n > nbrite) then
				call file_w_ages(io,name,zu,tb(n),w,h,inl,ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,mwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwla)
			endif
		endif
	else
		do i=1,inl+inx
		h(i)=fl(i,n)
		enddo
		bol(n)=bflx(n)
		str(n)=strm(n)
		evf(n)=evfl(n)
		snr(n)=snbr(n)
		pnr(n)=pnbr(n)
		 bh(n)=bhtn(n)
		 sn(n)=sntn(n)
		 wd(n)=wdtn(n)
		 rm(n)=rmtm(n)
		gas(n)=gasms(n)
		gal(n)=galms(n)
		xml(n)=rml(n)
		xdp(n)=rdp(n)
		 s1(n)=sn1(n)
		 s2(n)=sn2(n)
		 s3(n)=sn3(n)
		 s4(n)=sn4(n)
	endif
	! Compute galaxy mass
	do i=1,n
	sf(n)=sfr(tb(n))
	enddo
	galmass=gal_mass(io,tb(n),sf(n))

	! Store sed. Report standard colors and Guy Worthey Spectral indices
	if (isingle == 0 .or. n == nfinal) then
		write (lun) inl,(h(i),i=1,inl),inx,(h(i),i=inl+1,inl+inx)
		rsn(0) = snr(n)
		rsn(1) = s1(n)
		rsn(2) = s2(n)
		rsn(3) = s3(n)
		rsn(4) = s4(n)
		call rf_color(io,tb(n),w,h,inl,lun,bol(n),str(n),sf(n),evf(n),rsn,pnr(n),bh(n),sn(n),wd(n),rm(n),toff(n),bolms(n),gas(n),gal(n),xml(n),xdp(n),sissa20)
		! Guy Worthey Spectral indices
		inx2=inx/2
		do i=1,inx2
		fi(i)=h(inl+i)
		fc(i)=h(inl+inx2+i)
		enddo
		igw=0
		if (.not. sissa20) then
			call gw_indices(tb(n),fi,fc,lun,igw)
		else
			if (n >= nbrite) then
				call gw_indices(tb(n),fi,fc,lun,igw)
			endif
		endif
	endif

	! Report percent done
	if (n > 1) call percent(6,n,nfinal,'CSP_GALAXEV ' // name(1:nargo(name)))
	enddo

	! Add time behaviour of various quantities
	if (isingle == 0) then
		write (lun) nsteps,(  bol(i),i=0,nsteps-1)
		write (lun) nsteps,(  str(i),i=0,nsteps-1)
		write (lun) nsteps,(   sf(i),i=0,nsteps-1)
		write (lun) nsteps,(  evf(i),i=0,nsteps-1)
		write (lun) nsteps,(  snr(i),i=0,nsteps-1)
		write (lun) nsteps,(  pnr(i),i=0,nsteps-1)
		write (lun) nsteps,(   bh(i),i=0,nsteps-1)
		write (lun) nsteps,(   sn(i),i=0,nsteps-1)
		write (lun) nsteps,(   wd(i),i=0,nsteps-1)
		write (lun) nsteps,(   rm(i),i=0,nsteps-1)
		write (lun) nsteps,( toff(i),i=0,nsteps-1)
		write (lun) nsteps,(bolms(i),i=0,nsteps-1)
		write (lun) nsteps,(  gas(i),i=0,nsteps-1)
		write (lun) nsteps,(  gal(i),i=0,nsteps-1)
		write (lun) nsteps,(  xml(i),i=0,nsteps-1)
		write (lun) nsteps,(  xdp(i),i=0,nsteps-1)
		write (lun) nsteps,(   s1(i),i=0,nsteps-1)
		write (lun) nsteps,(   s2(i),i=0,nsteps-1)
		write (lun) nsteps,(   s3(i),i=0,nsteps-1)
		write (lun) nsteps,(   s4(i),i=0,nsteps-1)
	endif

	! Write command file to delete unwnated files
	call delete_files(name,inl,1)
	call file_w_ages(-1,name,zu,tb(n),w,h,inl,ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,mwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwla)
	! goto 1
	stop

3	write (6,'(x,5a)') char(7),'File ',name(1:largo(name)),' not found',char(7)
	goto 2
10	end

	SUBROUTINE EXPAND_TIME_STEPS
 
c	Expands time scale as iequired for model with tcut < 20 Gyr
 
	include 'jb.dec'
	include 'csp.dec'
	real t(0:jts)
	real fxu(0:jts),fxg(0:jts),fxr(0:jts),fxi(0:jts),fxz(0:jts),fxk(0:jts)
	real ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwa,mwla
	common /w_ages/ fxu,fxg,fxr,fxi,fxz,fxk,ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwa,mwla
 
c	Build enlarged time scale
	k=-1
	do i=0,nsteps-1
	if (tb(i).le.tcut) then
		k=k+1
		last=i
		t(k)=tb(i)
		tlast=t(k)
		next=i+1
		tnext=tb(i+1)
	endif
	enddo
	m1=last
 
c	Add desired steps
	dt=0.002E9
	dt=0.002*tcut
	if (dt.lt.2.E6) dt=2.E6
	dt=dt/4.
	if (tlast < tcut) then
		k=k+1
		t(k)=tcut
		tlast=tcut
	endif
	do i=1,100000
	tlast=tlast+dt
	if (tlast.lt.tnext) then
		k=k+1
		t(k)=tlast
	endif
	if (i.eq.20) dt=dt*4.
	enddo
	k1=k+1
 
c	Add remaining steps
	do i=next,nsteps-1
	k=k+1
	t(k)=tb(i)
	enddo
 
c	Shift sed''s and other quantities for i>=next
	ks=nsteps-next
	do n=1,ks
	knew=k-n+1
	kold=nsteps-n
	do i=1,inw
	fl(i,knew)  = fl(i,kold)
	enddo
	bflx(knew)  = bflx(kold)
	strm(knew)  = strm(kold)
	evfl(knew)  = evfl(kold)
	snbr(knew)  = snbr(kold)
	pnbr(knew)  = pnbr(kold)
	bhtn(knew)  = bhtn(kold)
	sntn(knew)  = sntn(kold)
	wdtn(knew)  = wdtn(kold)
	rmtm(knew)  = rmtm(kold)
	gasms(knew) = gasms(kold)
	galms(knew) = galms(kold)
	fxu(knew)   = fxu(kold)
	fxg(knew)   = fxg(kold)
	fxr(knew)   = fxr(kold)
	fxi(knew)   = fxi(kold)
	fxz(knew)   = fxz(kold)
	fxk(knew)   = fxk(kold)
	enddo
	if (ks == 0) knew = k
	m2=knew

c	Interpolate SSP sed''s and other quantities at new time steps
	do n=m1+1,m2-1
	a=(t(m2)-t(n))/(t(m2)-t(m1))
	b=1.-a
	do i=1,inw
	fl(i,n)  = a*fl(i,m1)  + b*fl(i,m2)
	enddo
	bflx(n)  = a*bflx(m1)  + b*bflx(m2)
	strm(n)  = a*strm(m1)  + b*strm(m2)
	evfl(n)  = a*evfl(m1)  + b*evfl(m2)
	snbr(n)  = a*snbr(m1)  + b*snbr(m2)
	pnbr(n)  = a*pnbr(m1)  + b*pnbr(m2)
	bhtn(n)  = a*bhtn(m1)  + b*bhtn(m2)
	sntn(n)  = a*sntn(m1)  + b*sntn(m2)
	wdtn(n)  = a*wdtn(m1)  + b*wdtn(m2)
	rmtm(n)  = a*rmtm(m1)  + b*rmtm(m2)
	gasms(n) = a*gasms(m1) + b*gasms(m2)
	galms(n) = a*galms(m1) + b*galms(m2)
	fxu(n)   = a*fxu(m1)   + b*fxu(m2)
	fxg(n)   = a*fxg(m1)   + b*fxg(m2)
	fxr(n)   = a*fxr(m1)   + b*fxr(m2)
	fxi(n)   = a*fxi(m1)   + b*fxi(m2)
	fxz(n)   = a*fxz(m1)   + b*fxz(m2)
	fxk(n)   = a*fxk(m1)   + b*fxk(m2)
	enddo
 
c	Redefine time scale
	nsteps=k+1
	do i=0,nsteps-1
	tb(i)=t(i)
	enddo
 
	return
	end
 
	SUBROUTINE ADD_TIME_STEPS
 
c	Includes in basic time scale the singular time stpes in usr_sfr
 
	include 'jb.dec'
	include 'csp.dec'
	real t(0:nsfrp)
	real fxu(0:jts),fxg(0:jts),fxr(0:jts),fxi(0:jts),fxz(0:jts),fxk(0:jts)
	real ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwa,mwla
	common /w_ages/ fxu,fxg,fxr,fxi,fxz,fxk,ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwa,mwla
 
c	Verify if any point has to be added
	if (jadd.eq.0) return
	write (6,*) jadd,' time steps to add. Computing spectra at these new time steps.'
	
c	Add desired steps
	do j=1,jadd
	k=-1
	do i=0,nsteps-1
	k=k+1
	t(k)=tb(i)
	if (tb(i).lt.tadd(j).and.tadd(j).lt.tb(i+1)) then
		m1=i
                next=i+1
		ks=nsteps-next
 
c		Add remaining steps
		k=k+1
		t(k)=tadd(j)
        	do n=next,nsteps-1
		k=k+1
        	t(k)=tb(n)
        	enddo
c		if (k.ne.nsteps+1) then
c			write (6,*) 'wrong number of time steps',k,nsteps
c			stop
c		endif
 
c		Shift sed''s and other quantities for i>=next
		do n=1,ks
		knew=k-n+1
		kold=nsteps-n
		do l=1,inw
		fl(l,knew)  = fl(l,kold)
		enddo
		bflx(knew)  = bflx(kold)
		strm(knew)  = strm(kold)
		evfl(knew)  = evfl(kold)
		snbr(knew)  = snbr(kold)
		pnbr(knew)  = pnbr(kold)
		bhtn(knew)  = bhtn(kold)
		sntn(knew)  = sntn(kold)
		wdtn(knew)  = wdtn(kold)
		rmtm(knew)  = rmtm(kold)
		gasms(knew) = gasms(kold)
		galms(knew) = galms(kold)
		fxu(knew)   = fxu(kold)
		fxg(knew)   = fxg(kold)
		fxr(knew)   = fxr(kold)
		fxi(knew)   = fxi(kold)
		fxz(knew)   = fxz(kold)
		fxk(knew)   = fxk(kold)
		enddo
		m2=knew
 
c		Interpolate SSP sed''s and other quantities at new time steps
		n=m1+1
		a=(t(m2)-t(n))/(t(m2)-t(m1))
		b=1.-a
		do l=1,inw
		fl(l,n)  = a*fl(l,m1)  + b*fl(l,m2)
		enddo
		bflx(n)  = a*bflx(m1)  + b*bflx(m2)
		strm(n)  = a*strm(m1)  + b*strm(m2)
		evfl(n)  = a*evfl(m1)  + b*evfl(m2)
		snbr(n)  = a*snbr(m1)  + b*snbr(m2)
		pnbr(n)  = a*pnbr(m1)  + b*pnbr(m2)
		bhtn(n)  = a*bhtn(m1)  + b*bhtn(m2)
		sntn(n)  = a*sntn(m1)  + b*sntn(m2)
		wdtn(n)  = a*wdtn(m1)  + b*wdtn(m2)
		rmtm(n)  = a*rmtm(m1)  + b*rmtm(m2)
		gasms(n) = a*gasms(m1) + b*gasms(m2)
		galms(n) = a*galms(m1) + b*galms(m2)
		fxu(n)   = a*fxu(m1)   + b*fxu(m2)
		fxg(n)   = a*fxg(m1)   + b*fxg(m2)
		fxr(n)   = a*fxr(m1)   + b*fxr(m2)
		fxi(n)   = a*fxi(m1)   + b*fxi(m2)
		fxz(n)   = a*fxz(m1)   + b*fxz(m2)
		fxk(n)   = a*fxk(m1)   + b*fxk(m2)
 
c		Redefine time scale
		nsteps=nsteps+1
		do l=0,nsteps-1
		tb(l)=t(l)
		enddo
	endif
	enddo
	enddo
	return
	end

      SUBROUTINE SORT2(N,RA,RB)
      DIMENSION RA(N),RB(N)
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
          RRB=RB(L)
        ELSE
          RRA=RA(IR)
          RRB=RB(IR)
          RA(IR)=RA(1)
          RB(IR)=RB(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RB(1)=RRB
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20	IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            RB(I)=RB(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
        RB(I)=RRB
      GO TO 10
      END

      SUBROUTINE DSORT2(N,RA,RB)

c     Double Precision version

      Real*8 RRA,RRB,RA(N),RB(N)

      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
          RRB=RB(L)
        ELSE
          RRA=RA(IR)
          RRB=RB(IR)
          RA(IR)=RA(1)
          RB(IR)=RB(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RB(1)=RRB
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20	IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            RB(I)=RB(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
        RB(I)=RRB
      GO TO 10
      END

      SUBROUTINE ISORT2(N,RA,RB)

c     Integer version

      integer rra,RA(N)
      real    rrb,RB(N)

      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
          RRB=RB(L)
        ELSE
          RRA=RA(IR)
          RRB=RB(IR)
          RA(IR)=RA(1)
          RB(IR)=RB(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RB(1)=RRB
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20	IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            RB(I)=RB(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
        RB(I)=RRB
      GO TO 10
      END

      SUBROUTINE ISORT8(N,RA,RB)

      ! Integer*8 version

      integer*8 N
      integer*8 RRA,RA(N)
      integer*8 RRB,RB(N)

      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          RRA=RA(L)
          RRB=RB(L)
        ELSE
          RRA=RA(IR)
          RRB=RB(IR)
          RA(IR)=RA(1)
          RB(IR)=RB(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            RA(1)=RRA
            RB(1)=RRB
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20	IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(RA(J).LT.RA(J+1))J=J+1
          ENDIF
          IF(RRA.LT.RA(J))THEN
            RA(I)=RA(J)
            RB(I)=RB(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        RA(I)=RRA
        RB(I)=RRB
      GO TO 10
      END

	PROGRAM ASCII_ISED

c	Writes *.ised file in ASCII format

c	Array declarations
	logical stelib
	character id*80,id2*80,id3*80,name*256

c	Maximum number of wavelength points
	PARAMETER (imw=100000)
	real w(imw),h(imw),tb(0:500),f(100)

c	Array declaration for IMF data
	parameter (imf=10)
	real ml,mu,xx(imf),lm(imf),um(imf),baux(imf),cc(imf),cn(imf)

c	Ask for file name if not enterd in command line
	j=iargc()
        if (j.eq.0) then
		call copyright(6)
		write (6,'(x,a,$)') 'BC model *.ised file = '
		read (5,'(a)',end=10) name
	else
		call getarg(1,name)
		call chaext(name,'ised',nn)
		write (6,*)
		write (6,*) 'Input file:  ',name(1:largo(name))
	endif

c	Read basic parameters from input file
	open (1,file=name,form='unformatted',status='old',err=3)
	read  (1)       nsteps,(tb(i),i=1,nsteps),
     &		        ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),
     &			totm,totn,avs,jo,tau,id,tau1,tau2,tau3,tau4,id2,id3,iop,stelib
	write (6,*)     nsteps,' time steps'

c	Read wavelength scale from input file and write to ASCII file
	read  (1)       inw,(w(i),i=1,inw)
	write (6,'(i8,a,f10.2,a,f14.2,a)')     inw,' wavelength points per record, from',w(1),' to',w(inw),' A'

c	Write basic parameters to output file
	name=name(1:largo(name)) // '_ASCII'
	open  (2,file=name,form='formatted',status='unknown')
	write (2,*) nsteps,(tb(i),i=1,nsteps)
	write (2,*) ml,mu,iseg,(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg)
     	write (2,*) totm,totn,avs,jo,tau,   tau1,tau2,tau3,tau4,        iop,stelib
	write (2,'(a)') id
	write (2,'(a)') id2
	write (2,'(a)') id3

c	Write wavelength scale to binary file
	write (2,*) inw,(w(i),i=1,inw)

c	Read sed''s from input file and write to ASCII file
c	Include fluxes for fitting functions
	do n=1,nsteps
	read  (1,err=1)   ik,(h(i),i=1,ik),ix,(f(i),i=1,ix)
1	write (2,*)       ik,(h(i),i=1,ik),ix,(f(i),i=1,ix)
	enddo
	write (6,*)     ik,' spectral fluxes per record,', ix,' fitting function fluxes per record'
c	Copy 12 records after the sed''s.
	do n=1,12
	read  (1,end=4)   ik,(h(i),i=1,ik)
	write (2,*)       ik,(h(i),i=1,ik)
	enddo
	write (6,*)  12,' extra records,',ik,' points each.'
4	write (6,*) 'Output file:  ',name(1:largo(name))
	write (6,*)

c	Close files
	close (1)
	close (2)
	stop
c	goto 1
3	write (6,'(3a)') 'File ',name(1:largo(name)),' not found'
c	goto 1
10	end

	FUNCTION TRAPZ2(X,Y,N,X1,X2,IERR)

c	Finds area below y(x) from x=X1 to x =X2
c	X1 and X2 are not necessarily values of x(i)
c	but must fulfill X1>=x(1) and X2<=x(n)

c	Array declaration
	real x(n),y(n)
	data jerr1,jerr2/2*0/

	TRAPZ2=0.
	ierr=0.

!	Check for values outside valid range
	if (x1 < x(1)) then
		if (jerr1.eq.0) then
			write (6,*) 'TRAPZ2: X1 outside valid range:',x1,x(1),x(n),n
			jerr1=1
		endif
		ierr=1
		return
!		stop
	elseif (x1 == x(1)) then
		i1 = 1
	else
!		Find first element in array X above X1
		do i=1,n
		if (x(i) > x1) then
			i1=i
!			Find by interpolation values of Y1=y(X1)
			Y1 = ( (x(i1)-x1)*y(i1-1) + (x1-x(i1-1))*y(i1) ) / (x(i1)-x(i1-1))
!			Add area from x(i1-1) to X1
			trapz2=trapz2+(x(i1)-x1)*(Y1+y(i1))/2.
			goto 1
		endif
		enddo
	endif
1	if (x2 > x(n)) then
		if (jerr2.eq.0) then
			write (6,*) 'TRAPZ2: X2 outside valid range:',x2,x(1),x(n),n
			jerr2=1
		endif
		ierr=2
		return
!		stop
	elseif (x2 == x(n)) then
		i2 = n
	else
!		Find last element in array X below X2
		do i=i1,n
		if (x(i) > x2) then
			i2=i-1
!			Find by interpolation values of Y2=y(X2)
			Y2 = ( (x(i2+1)-x2)*y(i2) + (x2-x(i2))*y(i2+1) ) / (x(i2+1)-x(i2))
!			Add area from x(i2) to X2
			trapz2=trapz2+(x2-x(i2))*(Y2+y(i2))/2.
			goto 2
		endif
		enddo
	endif

	! Compute area from x(i1) to x(i2)
2	do i=i1+1,i2
	trapz2=trapz2+(x(i)-x(i-1))*(y(i)+y(i-1))/2.
	enddo 
 	! write (6,*) 'TRAPZ2: using = ',i1+1,i2,x(i1),x(i2),i2-i1,' points',trapz2
	return
	end

	function irec_check(lun,a)

c	Get record length in *.ised file

	character*(*) a

c	Open and read file
	close (lun)
	open (lun,file=a,form='unformatted',status='old',err=3)
	read (lun)
	read (lun)
	read (lun,err=1) inl,(fl,i=1,inl),inx
!	write (6,*) 'irec_check: ',inl,inx
	irec_check=inx
	goto 2
1	irec_check=0
2	close (lun)
	return
3	write (6,'(2a)') 'File not found: ',a(1:largo(a))
	stop
	end

	FUNCTION CHABIMF(ALO,AUP,M1,M2,STARMASS,XHMEND)

	! Returns number of stars in range from M1 to M2 for Chabrier (2001) IMF
	! Returns the mass in stars from M1 to M2
	! ALO and AUP are the lower and upper cutoffs of the IMF, which is normalized to 1 Mo over this range

	implicit real (A-H,O-Z)
	real*8 m1,m2,starmass

	common /fmlog/xml,sigmac,anormlog
	common /fmlin/anormlin

	! ******************************************************
	!                  - Adjustable parameters -
	! 
	!     Lower and upper masses for the entire mass
	!     integration of the IMF: alo, aup
	!     Index "alpha=1+x" in the power-law part > 1 Msol
	!            dn/dm propto m**(-alpha)
	!      alpha=2.3
	! ******************************************************

	! Added by GBA (SP, July 13 2019) to compute log normal IMF's with different xhmend
	! XHMEND = slope X at the high mass end of IMF ( alpha = 1+xhmend)
	alpha = 1.+xhmend		! standard values xhmend = 1.30, alpha = 2.30

	xml=-1.1
	sigmac=0.69
	call chabint(alo,aup,alpha)    ! calculates the normalization
	al1=1.-alpha
	al2=2.-alpha
	anorm=anormlin/log(10.)
	v1log=anormlog*exp(-xml**2/2./sigmac**2)
	! print*,'normlog, normlin',anormlog,anormlin
	! print*,'norm @ 1 Msol',v1log,anormlin
	if(v1log /= anormlin) then
		print*,'normalization pb in routine chabimf!'
		stop
	endif

	if (m2 <= m1) then
		chabimf=0.
		starmass=0.
		return
	endif

	IF(m1.LE.1.0) THEN
		if(m2.LE.1.0) then
			vnum=chabnum(m1,m2)     ! number-density
			vmas=chabmas(m1,m2)     ! mass-density
		else
			alim=1.0
			vnum=chabnum(m1,dble(alim))+anorm/al1*(m2**al1-1.0)
			vmas=chabmas(m1,dble(alim))+anorm/al2*(m2**al2-1.0)
		endif
	ELSE
		vnum=anorm/al1*(m2**al1-m1**al1)
		vmas=anorm/al2*(m2**al2-m1**al2)
	ENDIF

	chabimf=vnum
	starmass=vmas

	return
	end

      SUBROUTINE CHABINT(alo,aup,alpha)
**************************************************************************
**    chabmas calculates the normalization such that
**        [int m.(dn/dm)dm = 1]  from m=alo to m=aup
**************************************************************************
      implicit real (A-H,O-Z)
      common /fmlog/xml,sigmac,anormlog
      common /fmlin/anormlin

      pi=4.*atan(1.)
      cte2=exp(-xml**2/sigmac**2/2.)
      al2=2.-alpha
      clin=cte2/al2*(aup**al2-1.)
      if(aup.LE.1.) clin=0.

      sigmacp=sigmac*log(10.)
      xmlp=xml*log(10.)
      cte1=exp(xmlp+sigmacp**2/2.)
      x1=-(xmlp+sigmacp**2)/sqrt(2.)/sigmacp
      xlo=(log10(alo)*log(10.)-(xmlp+sigmacp**2))/sqrt(2.)/sigmacp
      clog=cte1*sqrt(2.*pi)/2.*sigmacp
     !       *  (erf(x1) - erf(xlo))

      anorm=1./(clog+clin)
      anormlog=anorm*log(10.)     ! cte de la partie lognormal
      anormlin=anormlog*cte2         ! cte de la partie loi de puissance

      return
      end

      FUNCTION CHABNUM(xmin,xmax)
**************************************************************************
**                         *    IMF Chabrier   *
**    chabnum returns [int (dn/dm)dm]  from m=xmin to m=xmax
*************************************************************************
      implicit real (A-H,O-Z)
	real*8 xmin,xmax
c	real*8 y1,y2,de
	include 'chabimf.dec'
      common /fmlog/xml,sigmac,anormlog

c	check mass range
	if (xmax.le.xmin) then
		chabnum=0.
		return
	else
		pi=4.*atan(1.)
c		Modified by GBA, April 19, 2003
c		chabnum=anormlog * sqrt(2.*pi)/2.*sigmac
c    !		*( erf((log10(xmax)-xml)/sqrt(2.)/sigmac )
c    !		-  erf((log10(xmin)-xml)/sqrt(2.)/sigmac ) )
		y1 =  (dlog10(xmax*1.D00)-xml)/sqrt(2.)/sigmac
		y2 =  (dlog10(xmin*1.D00)-xml)/sqrt(2.)/sigmac
		de =  erf(y1) - erf(y2)
		chabnum=anormlog * sqrt(2.*pi)/2.*sigmac * de
		return
	endif
	end

      FUNCTION CHABMAS(xmin,xmax)
**************************************************************************
**                         *    IMF Chabrier   *
**    chabmas returns [int m.(dn/dm)dm]  from m=xmin to m=xmax
*************************************************************************
      implicit real (A-H,O-Z)
	real*8 xmin,xmax
c	real*8 y1,y2,de
	include 'chabimf.dec'
      common /fmlog/xml,sigmac,anormlog

c	Check mass range
	if (xmax.le.xmin) then
		chabmas=0.
		return
	else
		pi=4.*atan(1.)
		sigmacp=log(10.)*sigmac
		xmlp=xml*log(10.)
		anormp=anormlog/log(10.)
		cte=exp(xmlp+sigmacp**2/2.)
c		Modified by GBA, April 19, 2003
c		x1=(log10(xmin)*log(10.)-(xmlp+sigmacp**2))/sqrt(2.)/sigmacp
c		x2=(log10(xmax)*log(10.)-(xmlp+sigmacp**2))/sqrt(2.)/sigmacp
c		chabmas=anormp*cte*sqrt(2.*pi)/2.*sigmacp * (erf(x2) - erf(x1))
		y1=(dlog10(xmin*1.D00)*dlog(10.D00)-(xmlp+sigmacp**2))/sqrt(2.)/sigmacp
		y2=(dlog10(xmax*1.D00)*dlog(10.D00)-(xmlp+sigmacp**2))/sqrt(2.)/sigmacp
		de=erf(y2) - erf(y1)
		chabmas=anormp * cte * sqrt(2.*pi)/2.*sigmacp * de
		return
	endif
	end

	SUBROUTINE CONVOLVE_NEW(Y,IC,BOL,STR,EVF,SNR,PNR,BH,SN,WD,RM,GS,GL,MR,DP,S1,S2,S3,S4)

!	Written by G. Bruzual on 25-March-1999

!	Uses different approach from previous versions. The SFR is
!	used as given (from t=0 to t=age) and the SSP spectra are
!	interpolated at required age. This allows for arbitrarily
!	short bursts to be described correctly.

!	Computes sed at age tb(k) by performing convolution integral
!	of the sed for a SSP and the chosen SFR using trapezoidal rule

!	Convolution integral according to trapezoidal rule

!	BOL = convolved bolometric flux at age tb(k)
!	STR = convolved total mass in stars at age tb(k)
!	EVF = convolved evolutionary flux at age tb(k)
!	SNR = convolved Super Nova rate at age tb(k)
!	PNR = convolved PN birth rate at age tb(k)
!	BH  = convolved total number of BH at age tb(k)
!	SN  = convolved total number of NS at age tb(k)
!	WD  = convolved total number of WD at age tb(k)
!	RM  = convolved total mass in Remnants at age tb(k)
!	MR  = convolved mass loss rate at age tb(k)
!	DP  = convolved dust production rate at age tb(k)
!	S1  = convolved pair instability SN rate at age tb(k)
!	S2  = convolved regular SN rate at age tb(k)
!	S3  = convolved type Ia SN rate at age tb(k)
!	S4  = convolved failed SN rate at age tb(k)

!	Array declaration
	include 'jb.dec'
	include 'csp.dec'
	real y(imw),taux(100000)
	real fxu(0:jts),fxg(0:jts),fxr(0:jts),fxi(0:jts),fxz(0:jts),fxk(0:jts)
	real ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwa,mwla
	common /w_ages/ fxu,fxg,fxr,fxi,fxz,fxk,ufwa,gfwa,rfwa,ifwa,zfwa,kfwa,ufwla,gfwla,rfwla,ifwla,zfwla,kfwla,mwa,mwla

!	Modified by G. Bruzual on 24/9/93 to include common /totgas/ where
!	the total mass in gas (new + recycled) vs time is stored. This
!	quantity is used in models with SFR which recycles gas.
	include 'recycle.dec'

!	Clear buffers
	bol=0.
	str=0.
	evf=0.
	snr=0.
	pnr=0.
	bh=0.
	sn=0.
	wd=0.
	rm=0.
	gs=0.
	gl=0.
	mr=0.
	dp=0.
	s1=0.
	s2=0.
	s3=0.
	s4=0.
	ufwa=0.
	gfwa=0.
	rfwa=0.
	ifwa=0.
	zfwa=0.
	kfwa=0.
	ufwla=0.
	gfwla=0.
	rfwla=0.
	ifwla=0.
	zfwla=0.
	kfwla=0.
	mwa=0.
	mwla=0.
	duwa=0.
	dgwa=0.
	drwa=0.
	diwa=0.
	dzwa=0.
	dkwa=0.
	dmwa=0.
	do j=1,inw
	y(j)=0.
	enddo

!	Build time scale for accurate integration
	kt=0
	age=tb(ic)
	do k=0,ic
	kt=kt+1
	taux(kt)=age-tb(k)
	kt=kt+1
	taux(kt)=tb(k)
	enddo
!	Add more time steps under option 7 (user sfr entered in table)
	if (io.eq.7) then
		do i=1,isfrc
		if (age.ge.time(i)) then
			kt=kt+1
			taux(kt)=age-time(i)
		endif
		kt=kt+1
		taux(kt)=time(i)
		enddo
	endif
!       Add more steps if tcut.lt.20.E9
	if (age.gt.tcut.and.tcut.lt.20.E9) then
		do k=0,ic
		if (tb(k).le.tcut) last=k
		enddo
		tlast=tb(last)
		tnext=tb(last+1)
        	dt=0.0005*tcut
        	do i=1,100000
	        tlast=tlast+dt
		if (tlast.gt.tnext) goto 2
		kt=kt+1
		taux(kt)=age-tlast
		kt=kt+1
		taux(kt)=tlast
		enddo
	endif
2	call sort(kt,taux)
!	Suppress duplicate entries below tb(ic)
	kn=1
	do k=2,kt
	if (taux(k).le.tb(ic).and.taux(k).gt.taux(k-1)) then
		kn=kn+1
		taux(kn)=taux(k)
	endif
	enddo
	if (kn.eq.1) return
!	Suppress duplicate entries
	call usort(kn,taux)
!	Write in reverse order
	call xreverse(taux,kn)

!	Compute weights to assign to each sed and compute convolution integral
!	do k=0,ic
	do k=1,kn
!	sr=sfr(tb(k))
	sr=sfr(age-taux(k))
	if (sr.gt.0.) then
		if (k.eq.1) then
!			dt=tb(k+1)-tb(k)
			dt=taux(1)-taux(2)
		elseif (k.eq.kn) then
!			dt=tb(ic)-tb(ic-1)
			dt=taux(kn-1)-taux(kn)
		else
!			dt=tb(k+1)-tb(k-1)
			dt=taux(k-1)-taux(k+1)
		endif
		w=sr*dt/2.
		if (io.eq.0) w=1.
!		tx=age-tb(k)
		tx=taux(k)
		do j1=0,ic
		if (tx.eq.tb(j1)) then
!			Used sed and other quantities at tx = age-tb(k)
			do m=1,inw
			y(m)=y(m)+w*fl(m,j1)
			enddo
			bol = bol + w*bflx(j1)
			str = str + w*strm(j1)
			evf = evf + w*evfl(j1)
			snr = snr + w*snbr(j1)
			pnr = pnr + w*pnbr(j1)
			sn  = sn  + w*sntn(j1)
			bh  = bh  + w*bhtn(j1)
			wd  = wd  + w*wdtn(j1)
			rm  = rm  + w*rmtm(j1)
			gs  = gs  + w*gasms(j1)
			gl  = gl  + w*galms(j1)
			mr  = mr  + w*rml(j1)
			dp  = dp  + w*rdp(j1)
			s1  = s1  + w*sn1(j1)
			s2  = s2  + w*sn2(j1)
			s3  = s3  + w*sn3(j1)
			s4  = s4  + w*sn4(j1)
			ufwa  = ufwa  + w*fxu(j1)*tb(j1)
			gfwa  = gfwa  + w*fxg(j1)*tb(j1)
			rfwa  = rfwa  + w*fxr(j1)*tb(j1)
			ifwa  = ifwa  + w*fxi(j1)*tb(j1)
			zfwa  = zfwa  + w*fxz(j1)*tb(j1)
			kfwa  = kfwa  + w*fxk(j1)*tb(j1)
			ufwla = ufwla + w*fxu(j1)*tlog(tb(j1))
			gfwla = gfwla + w*fxg(j1)*tlog(tb(j1))
			rfwla = rfwla + w*fxr(j1)*tlog(tb(j1))
			ifwla = ifwla + w*fxi(j1)*tlog(tb(j1))
			zfwla = zfwla + w*fxz(j1)*tlog(tb(j1))
			kfwla = kfwla + w*fxk(j1)*tlog(tb(j1))
			mwa   = mwa   + w*tb(j1)
			mwla  = mwla  + w*tlog(tb(j1))
			duwa  = duwa  + w*fxu(j1)
			dgwa  = dgwa  + w*fxg(j1)
			drwa  = drwa  + w*fxr(j1)
			diwa  = diwa  + w*fxi(j1)
			dzwa  = dzwa  + w*fxz(j1)
			dkwa  = dkwa  + w*fxk(j1)
			dmwa  = dmwa  + w
			goto 1
		endif
		if (tx.ge.tb(j1).and.tx.lt.tb(j1+1)) then
			j2=j1+1
			if (tb(j1).gt.0.) then
				a=alog10(tx/tb(j1))/alog10(tb(j2)/tb(j1))
			else
				a=tx/tb(j2)
			endif
			b=1.-a
			wa=w*a
			wb=w*b
!			Interpolate sed and other quantities at tx = age-tb(k)
			do m=1,inw
			y(m)=y(m)+wb*fl(m,j1)+wa*fl(m,j2)
			enddo
			bol = bol + wb*bflx(j1)  + wa*bflx(j2)
			str = str + wb*strm(j1)  + wa*strm(j2)
			evf = evf + wb*evfl(j1)  + wa*evfl(j2)
			snr = snr + wb*snbr(j1)  + wa*snbr(j2)
			pnr = pnr + wb*pnbr(j1)  + wa*pnbr(j2)
			sn  = sn  + wb*sntn(j1)  + wa*sntn(j2)
			bh  = bh  + wb*bhtn(j1)  + wa*bhtn(j2)
			wd  = wd  + wb*wdtn(j1)  + wa*wdtn(j2)
			rm  = rm  + wb*rmtm(j1)  + wa*rmtm(j2)
			gs  = gs  + wb*gasms(j1) + wa*gasms(j2)
			gl  = gl  + wb*galms(j1) + wa*galms(j2)
			mr  = mr  + wb*rml(j1)   + wa*rml(j2)
			dp  = dp  + wb*rdp(j1)   + wa*rdp(j2)
			s1  = s1  + wb*sn1(j1)   + wa*sn1(j2)
			s2  = s2  + wb*sn2(j1)   + wa*sn2(j2)
			s3  = s3  + wb*sn3(j1)   + wa*sn3(j2)
			s4  = s4  + wb*sn4(j1)   + wa*sn4(j2)
			ufwa  = ufwa  + wb*fxu(j1)*tb(j1) + wa*fxu(j2)*tb(j2)
			gfwa  = gfwa  + wb*fxg(j1)*tb(j1) + wa*fxg(j2)*tb(j2)
			rfwa  = rfwa  + wb*fxr(j1)*tb(j1) + wa*fxr(j2)*tb(j2)
			ifwa  = ifwa  + wb*fxi(j1)*tb(j1) + wa*fxi(j2)*tb(j2)
			zfwa  = zfwa  + wb*fxz(j1)*tb(j1) + wa*fxz(j2)*tb(j2)
			kfwa  = kfwa  + wb*fxk(j1)*tb(j1) + wa*fxk(j2)*tb(j2)
			ufwla = ufwla + wb*fxu(j1)*tlog(tb(j1)) + wa*fxu(j2)*tlog(tb(j2))
			gfwla = gfwla + wb*fxg(j1)*tlog(tb(j1)) + wa*fxg(j2)*tlog(tb(j2))
			rfwla = rfwla + wb*fxr(j1)*tlog(tb(j1)) + wa*fxr(j2)*tlog(tb(j2))
			ifwla = ifwla + wb*fxi(j1)*tlog(tb(j1)) + wa*fxi(j2)*tlog(tb(j2))
			zfwla = zfwla + wb*fxz(j1)*tlog(tb(j1)) + wa*fxz(j2)*tlog(tb(j2))
			kfwla = kfwla + wb*fxk(j1)*tlog(tb(j1)) + wa*fxk(j2)*tlog(tb(j2))
			mwa   = mwa   + wb*tb(j1)               + wa*tb(j2)
			mwla  = mwla  + wb*tlog(tb(j1))         + wa*tlog(tb(j2))
			duwa  = duwa  + wb*fxu(j1) + wa*fxu(j2)        
			dgwa  = dgwa  + wb*fxg(j1) + wa*fxg(j2)        
			drwa  = drwa  + wb*fxr(j1) + wa*fxr(j2)        
			diwa  = diwa  + wb*fxi(j1) + wa*fxi(j2)        
			dzwa  = dzwa  + wb*fxz(j1) + wa*fxz(j2)        
			dkwa  = dkwa  + wb*fxk(j1) + wa*fxk(j2)        
			dmwa  = dmwa  + wb + wa
			goto 1
		endif
		enddo
		write (6,*) 'Problem interpolating tx,j1 = ',tx,j1
		stop
	endif
1	continue
	enddo

!	Compute flux weighted age and log age returned in common
	ufwa  = ufwa/duwa
	gfwa  = gfwa/dgwa
	rfwa  = rfwa/drwa
	ifwa  = ifwa/diwa
	zfwa  = zfwa/dzwa
	kfwa  = kfwa/dkwa
	mwa   = mwa /dmwa
	ufwla = ufwla/duwa
	gfwla = gfwla/dgwa
	rfwla = rfwla/drwa
	ifwla = ifwla/diwa
	zfwla = zfwla/dzwa
	kfwla = kfwla/dkwa
	mwla  = mwla /dmwa

!	Store amount of processed gas
	if (io.eq.1) then
		str=amin1(1.,str)
!		unprocessed gas so far
		ugas=exp(-age/tau)
!		processed gas = gas formed into stars - mass in stars - remnants
		prgas = 1. - ugas - str - rm
		if (prgas.lt.0.) prgas=0.
!		lgas=ic+1
		lgas=lgas+1
		so(lgas)=prgas
		to(lgas)=age
	endif
	return
	end

	FUNCTION TLOG(T)

!	avoids log of 0

	if (t <= 0.) then
		tlog = 0.
	else
		tlog = alog10(t)
	endif
	return
	end

	CHARACTER*32 FUNCTION SHELL()

	! Returns current shell

	! Variables
	implicit none
	character*32 csh,zsh

	! Get shell name from environment
        call getenv('SHELL',zsh)
        call getenv('shell',csh)
        shell = trim(csh) // trim(zsh)
	return
	end

	real*4 function cosmol_c(h,omega,omega_lambda,q)

c	Returns cosmological constant = cosmol_c and parameter q

c       Omega is entered by the user
c       omega=1.-omega_lambda

c       Cosmological constant
        cosmol_c=omega_lambda/(3.*h**2)

c       Compute q=q0
        if (omega_lambda.eq.0.) then
                q=omega/2.
        else
                q=(3.*omega/2.) - 1.
        endif
	return
	end

      SUBROUTINE midpnt(func,a,b,s,n)
      INTEGER n
      REAL a,b,s,func
      EXTERNAL func
      INTEGER it,j
      REAL ddel,del,sum,tnm,x
      if (n.eq.1) then
        s=(b-a)*func(0.5*(a+b))
      else
        it=3**(n-2)
        tnm=it
        del=(b-a)/(3.*tnm)
        ddel=del+del
        x=a+0.5*del
        sum=0.
        do 11 j=1,it
          sum=sum+func(x)
          x=x+ddel
          sum=sum+func(x)
          x=x+del
11      continue
        s=(s+(b-a)*sum/tnm)/3.
      endif
      return
      END

	SUBROUTINE LICK_SYSTEM(X,Y,N,YS)

c	Transforms sed in (x,y) to Lick/IDS system by applying a gaussian
c	broadening function to artificially simulate the Lick/IDS spectral
c	resolution. The FWHM of the gaussian as a function of wavelength is
c	given in Table 8 of Worthey and Ottaviani (1997, ApJS, 111, 377)

c	Returns smoothed spectrum in array (x,ys)

c	Array declaration
	real x(n),y(n),ys(n),u(10000),g(10000)

c	Number of sigmas to perform integration
	m=6

c	FWHM of STELIB seds = 3 A (Leborgne et al. 2002)
	fwhm_stelib = 3.

c	Perform smoothing
	do i=1,n
	fwhm2 = fwhm_ids(x(i))**2 - fwhm_stelib**2
	fwhm  = sqrt(fwhm2)

c       Note: FWHM = 2*sqrt[2*ln(2)]*sigma = 2.3548*sigma
	sigma=fwhm/2.3548

	xmax=x(i)+m*sigma
	call locate(x,n,xmax,i1)
	m2=i1+1
	m1=2*i-m2
	if (m1.lt.1) m1=1
	if (m2.gt.n) m2=n
	k=0
	do j=m1,m2
	k=k+1
	u(k)=x(j)
	g(k)=y(j)*gauss(x(j),x(i),sigma)
	enddo
	ys(i)=trapz1(u,g,k)
	enddo
	return
	end

	SUBROUTINE READ_ISED(file,tg,k0,ierr)

c	Reads galaxy s.e.d.s = output file from program GALAXEV.
c	Returns K0 = record number at which galaxy age = TG.

c	The array and common declaration are in file 'read_ised.dec'
	include 'read_ised.dec'
	include 'SSP_4.dec'
	include 'SSP_13.dec'
	logical stelib
	character*(*) file

c	Open and read file *.ised
	open (2,file=file,form='unformatted',status='old',err=1)
c	Read time scale and model parameters
	read (2,err=1) ks,(ta(i),i=1,ks),ml,mu,iseg,
     &	(xx(i),lm(i),um(i),baux(i),cn(i),cc(i),i=1,iseg),
     &	totm,totn,avs,jo,tauo,id,tcut,ttt,ttt,ttt,id,id,igw,stelib
c	Read wavelength scale
	read (2) iw,(w(i),i=1,iw)
c	Read model sed
	do k=1,ks
	read (2) iw,(f(i,k),i=1,iw)
	enddo

c	Determine records bracketing age tg
	do k=1,ks-1
	if (tg.ge.ta(k).and.tg.lt.ta(k+1)) then
		a=(tg-ta(k))/(ta(k+1)-ta(k))
		b=1.-a
		k0=k+1
		do i=1,iw
		f(i,k0)=a*f(i,k)+b*f(i,k0)
		enddo
		ta(k0)=tg
!		write (6,100) k0,ta(k0)
!100		format (' Exit READ_ISED. Last record: ',i3,' Age = ',1pe12.4)
		close (2)
		ierr=0
		return
	endif
	enddo
1	write (6,'(x,3a)') 'File ',file(1:largo(file)),' not found. Please try again'
	ierr=1
	return
	end
